diff -pruN 2.0.1-1/android/app/build.gradle 2.1.0-1/android/app/build.gradle
--- 2.0.1-1/android/app/build.gradle	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/build.gradle	2021-01-15 21:35:50.000000000 +0000
@@ -1,6 +1,6 @@
 apply plugin: 'com.android.application'
 apply plugin: 'kotlin-android'
-apply plugin: 'kotlin-android-extensions'
+apply plugin: 'kotlin-parcelize'
 apply plugin: 'kotlin-kapt'
 
 def rootCMakeLists = "../../CMakeLists.txt"
@@ -24,7 +24,7 @@ android {
         applicationId "com.metallic.chiaki"
         minSdkVersion 21
         targetSdkVersion 30
-        versionCode 9
+        versionCode 10
         versionName chiakiVersion
         externalNativeBuild {
             cmake {
@@ -38,6 +38,9 @@ android {
             }
         }
     }
+    buildFeatures {
+        viewBinding true
+    }
     compileOptions {
         sourceCompatibility JavaVersion.VERSION_1_8
         targetCompatibility JavaVersion.VERSION_1_8
@@ -61,6 +64,7 @@ android {
         }
     }
 
+
     Properties properties = new Properties()
     def propertiesFile = file("../local.properties")
     if (propertiesFile.exists()) {
@@ -86,27 +90,22 @@ tasks.withType(org.jetbrains.kotlin.grad
     }
 }
 
-androidExtensions {
-    // for @Parcelize
-    experimental = true
-}
-
 dependencies {
     implementation fileTree(dir: 'libs', include: ['*.jar'])
     implementation "org.jetbrains.kotlin:kotlin-stdlib-jdk7:$kotlin_version"
-    implementation 'androidx.appcompat:appcompat:1.1.0'
-    implementation 'androidx.core:core-ktx:1.2.0'
-    implementation 'androidx.constraintlayout:constraintlayout:1.1.3'
+    implementation 'androidx.appcompat:appcompat:1.2.0'
+    implementation 'androidx.core:core-ktx:1.3.2'
+    implementation 'androidx.constraintlayout:constraintlayout:2.0.4'
     implementation 'androidx.recyclerview:recyclerview:1.1.0'
-    implementation 'androidx.preference:preference:1.1.0'
-    implementation 'com.google.android.material:material:1.1.0-beta02'
+    implementation 'androidx.preference:preference:1.1.1'
+    implementation 'com.google.android.material:material:1.2.1'
     implementation 'androidx.lifecycle:lifecycle-extensions:2.2.0'
     implementation 'androidx.lifecycle:lifecycle-viewmodel-ktx:2.2.0'
     implementation 'androidx.lifecycle:lifecycle-reactivestreams:2.2.0'
-    implementation "io.reactivex.rxjava2:rxjava:2.2.12"
+    implementation "io.reactivex.rxjava2:rxjava:2.2.20"
     implementation "io.reactivex.rxjava2:rxkotlin:2.4.0"
     implementation 'io.reactivex.rxjava2:rxandroid:2.1.1'
-    def room_version = "2.2.4"
+    def room_version = "2.2.6"
     implementation "androidx.room:room-runtime:$room_version"
     kapt "androidx.room:room-compiler:$room_version"
     implementation "androidx.room:room-ktx:$room_version"
diff -pruN 2.0.1-1/android/app/src/main/AndroidManifest.xml 2.1.0-1/android/app/src/main/AndroidManifest.xml
--- 2.0.1-1/android/app/src/main/AndroidManifest.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/AndroidManifest.xml	2021-01-15 21:35:50.000000000 +0000
@@ -5,6 +5,7 @@
 
     <uses-permission android:name="android.permission.INTERNET" />
     <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
+    <uses-permission android:name="android.permission.VIBRATE" />
 
     <application
         android:allowBackup="true"
diff -pruN 2.0.1-1/android/app/src/main/cpp/chiaki-jni.c 2.1.0-1/android/app/src/main/cpp/chiaki-jni.c
--- 2.0.1-1/android/app/src/main/cpp/chiaki-jni.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/cpp/chiaki-jni.c	2021-01-15 21:35:50.000000000 +0000
@@ -133,6 +133,7 @@ typedef struct android_chiaki_session_t
 	jmethodID java_session_event_connected_meth;
 	jmethodID java_session_event_login_pin_request_meth;
 	jmethodID java_session_event_quit_meth;
+	jmethodID java_session_event_rumble_meth;
 	jfieldID java_controller_state_buttons;
 	jfieldID java_controller_state_l2_state;
 	jfieldID java_controller_state_r2_state;
@@ -140,6 +141,20 @@ typedef struct android_chiaki_session_t
 	jfieldID java_controller_state_left_y;
 	jfieldID java_controller_state_right_x;
 	jfieldID java_controller_state_right_y;
+	jfieldID java_controller_state_touches;
+	jfieldID java_controller_state_gyro_x;
+	jfieldID java_controller_state_gyro_y;
+	jfieldID java_controller_state_gyro_z;
+	jfieldID java_controller_state_accel_x;
+	jfieldID java_controller_state_accel_y;
+	jfieldID java_controller_state_accel_z;
+	jfieldID java_controller_state_orient_x;
+	jfieldID java_controller_state_orient_y;
+	jfieldID java_controller_state_orient_z;
+	jfieldID java_controller_state_orient_w;
+	jfieldID java_controller_touch_x;
+	jfieldID java_controller_touch_y;
+	jfieldID java_controller_touch_id;
 
 	AndroidChiakiVideoDecoder video_decoder;
 	AndroidChiakiAudioDecoder audio_decoder;
@@ -178,6 +193,14 @@ static void android_chiaki_event_cb(Chia
 			free(reason_str);
 			break;
 		}
+		case CHIAKI_EVENT_RUMBLE:
+			E->CallVoidMethod(env, session->java_session,
+							  session->java_session_event_rumble_meth,
+							  (jint)event->rumble.left,
+							  (jint)event->rumble.right);
+			break;
+		default:
+			break;
 	}
 
 	(*global_vm)->DetachCurrentThread(global_vm);
@@ -296,6 +319,7 @@ JNIEXPORT void JNICALL JNI_FCN(sessionCr
 	session->java_session_event_connected_meth = E->GetMethodID(env, session->java_session_class, "eventConnected", "()V");
 	session->java_session_event_login_pin_request_meth = E->GetMethodID(env, session->java_session_class, "eventLoginPinRequest", "(Z)V");
 	session->java_session_event_quit_meth = E->GetMethodID(env, session->java_session_class, "eventQuit", "(ILjava/lang/String;)V");
+	session->java_session_event_rumble_meth = E->GetMethodID(env, session->java_session_class, "eventRumble", "(II)V");
 
 	jclass controller_state_class = E->FindClass(env, BASE_PACKAGE"/ControllerState");
 	session->java_controller_state_buttons = E->GetFieldID(env, controller_state_class, "buttons", "I");
@@ -305,6 +329,22 @@ JNIEXPORT void JNICALL JNI_FCN(sessionCr
 	session->java_controller_state_left_y = E->GetFieldID(env, controller_state_class, "leftY", "S");
 	session->java_controller_state_right_x = E->GetFieldID(env, controller_state_class, "rightX", "S");
 	session->java_controller_state_right_y = E->GetFieldID(env, controller_state_class, "rightY", "S");
+	session->java_controller_state_touches = E->GetFieldID(env, controller_state_class, "touches", "[L"BASE_PACKAGE"/ControllerTouch;");
+	session->java_controller_state_gyro_x = E->GetFieldID(env, controller_state_class, "gyroX", "F");
+	session->java_controller_state_gyro_y = E->GetFieldID(env, controller_state_class, "gyroY", "F");
+	session->java_controller_state_gyro_z = E->GetFieldID(env, controller_state_class, "gyroZ", "F");
+	session->java_controller_state_accel_x = E->GetFieldID(env, controller_state_class, "accelX", "F");
+	session->java_controller_state_accel_y = E->GetFieldID(env, controller_state_class, "accelY", "F");
+	session->java_controller_state_accel_z = E->GetFieldID(env, controller_state_class, "accelZ", "F");
+	session->java_controller_state_orient_x = E->GetFieldID(env, controller_state_class, "orientX", "F");
+	session->java_controller_state_orient_y = E->GetFieldID(env, controller_state_class, "orientY", "F");
+	session->java_controller_state_orient_z = E->GetFieldID(env, controller_state_class, "orientZ", "F");
+	session->java_controller_state_orient_w = E->GetFieldID(env, controller_state_class, "orientW", "F");
+
+	jclass controller_touch_class = E->FindClass(env, BASE_PACKAGE"/ControllerTouch");
+	session->java_controller_touch_x = E->GetFieldID(env, controller_touch_class, "x", "S");
+	session->java_controller_touch_y = E->GetFieldID(env, controller_touch_class, "y", "S");
+	session->java_controller_touch_id = E->GetFieldID(env, controller_touch_class, "id", "B");
 
 	chiaki_session_set_event_cb(&session->session, android_chiaki_event_cb, session);
 	chiaki_session_set_video_sample_cb(&session->session, android_chiaki_video_decoder_video_sample, &session->video_decoder);
@@ -373,7 +413,8 @@ JNIEXPORT void JNICALL JNI_FCN(sessionSe
 JNIEXPORT void JNICALL JNI_FCN(sessionSetControllerState)(JNIEnv *env, jobject obj, jlong ptr, jobject controller_state_java)
 {
 	AndroidChiakiSession *session = (AndroidChiakiSession *)ptr;
-	ChiakiControllerState controller_state = { 0 };
+	ChiakiControllerState controller_state;
+	chiaki_controller_state_set_idle(&controller_state);
 	controller_state.buttons = (uint32_t)E->GetIntField(env, controller_state_java, session->java_controller_state_buttons);
 	controller_state.l2_state = (uint8_t)E->GetByteField(env, controller_state_java, session->java_controller_state_l2_state);
 	controller_state.r2_state = (uint8_t)E->GetByteField(env, controller_state_java, session->java_controller_state_r2_state);
@@ -381,6 +422,34 @@ JNIEXPORT void JNICALL JNI_FCN(sessionSe
 	controller_state.left_y = (int16_t)E->GetShortField(env, controller_state_java, session->java_controller_state_left_y);
 	controller_state.right_x = (int16_t)E->GetShortField(env, controller_state_java, session->java_controller_state_right_x);
 	controller_state.right_y = (int16_t)E->GetShortField(env, controller_state_java, session->java_controller_state_right_y);
+	jobjectArray touch_array = E->GetObjectField(env, controller_state_java, session->java_controller_state_touches);
+	size_t touch_array_len = (size_t)E->GetArrayLength(env, touch_array);
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	{
+		if(i < touch_array_len)
+		{
+			jobject touch = E->GetObjectArrayElement(env, touch_array, i);
+			controller_state.touches[i].x = (uint16_t)E->GetShortField(env, touch, session->java_controller_touch_x);
+			controller_state.touches[i].y = (uint16_t)E->GetShortField(env, touch, session->java_controller_touch_y);
+			controller_state.touches[i].id = (int8_t)E->GetByteField(env, touch, session->java_controller_touch_id);
+		}
+		else
+		{
+			controller_state.touches[i].x = 0;
+			controller_state.touches[i].y = 0;
+			controller_state.touches[i].id = -1;
+		}
+	}
+	controller_state.gyro_x = E->GetFloatField(env, controller_state_java, session->java_controller_state_gyro_x);
+	controller_state.gyro_y = E->GetFloatField(env, controller_state_java, session->java_controller_state_gyro_y);
+	controller_state.gyro_z = E->GetFloatField(env, controller_state_java, session->java_controller_state_gyro_z);
+	controller_state.accel_x = E->GetFloatField(env, controller_state_java, session->java_controller_state_accel_x);
+	controller_state.accel_y = E->GetFloatField(env, controller_state_java, session->java_controller_state_accel_y);
+	controller_state.accel_z = E->GetFloatField(env, controller_state_java, session->java_controller_state_accel_z);
+	controller_state.orient_x = E->GetFloatField(env, controller_state_java, session->java_controller_state_orient_x);
+	controller_state.orient_y = E->GetFloatField(env, controller_state_java, session->java_controller_state_orient_y);
+	controller_state.orient_z = E->GetFloatField(env, controller_state_java, session->java_controller_state_orient_z);
+	controller_state.orient_w = E->GetFloatField(env, controller_state_java, session->java_controller_state_orient_w);
 	chiaki_session_set_controller_state(&session->session, &controller_state);
 }
 
diff -pruN 2.0.1-1/android/app/src/main/cpp/video-decoder.c 2.1.0-1/android/app/src/main/cpp/video-decoder.c
--- 2.0.1-1/android/app/src/main/cpp/video-decoder.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/cpp/video-decoder.c	2021-01-15 21:35:50.000000000 +0000
@@ -26,29 +26,34 @@ ChiakiErrorCode android_chiaki_video_dec
 	return chiaki_mutex_init(&decoder->codec_mutex, false);
 }
 
-void android_chiaki_video_decoder_fini(AndroidChiakiVideoDecoder *decoder)
+static void kill_decoder(AndroidChiakiVideoDecoder *decoder)
 {
-	if(decoder->codec)
+	chiaki_mutex_lock(&decoder->codec_mutex);
+	decoder->shutdown_output = true;
+	ssize_t codec_buf_index = AMediaCodec_dequeueInputBuffer(decoder->codec, 1000);
+	if(codec_buf_index >= 0)
 	{
-		chiaki_mutex_lock(&decoder->codec_mutex);
-		decoder->shutdown_output = true;
-		ssize_t codec_buf_index = AMediaCodec_dequeueInputBuffer(decoder->codec, -1);
-		if(codec_buf_index >= 0)
-		{
-			CHIAKI_LOGI(decoder->log, "Video Decoder sending EOS buffer");
-			AMediaCodec_queueInputBuffer(decoder->codec, (size_t)codec_buf_index, 0, 0, decoder->timestamp_cur++, AMEDIACODEC_BUFFER_FLAG_END_OF_STREAM);
-			AMediaCodec_stop(decoder->codec);
-			chiaki_mutex_unlock(&decoder->codec_mutex);
-			chiaki_thread_join(&decoder->output_thread, NULL);
-		}
-		else
-		{
-			CHIAKI_LOGE(decoder->log, "Failed to get input buffer for shutting down Video Decoder!");
-			AMediaCodec_stop(decoder->codec);
-			chiaki_mutex_unlock(&decoder->codec_mutex);
-		}
-		AMediaCodec_delete(decoder->codec);
+		CHIAKI_LOGI(decoder->log, "Video Decoder sending EOS buffer");
+		AMediaCodec_queueInputBuffer(decoder->codec, (size_t)codec_buf_index, 0, 0, decoder->timestamp_cur++, AMEDIACODEC_BUFFER_FLAG_END_OF_STREAM);
+		AMediaCodec_stop(decoder->codec);
+		chiaki_mutex_unlock(&decoder->codec_mutex);
+		chiaki_thread_join(&decoder->output_thread, NULL);
 	}
+	else
+	{
+		CHIAKI_LOGE(decoder->log, "Failed to get input buffer for shutting down Video Decoder!");
+		AMediaCodec_stop(decoder->codec);
+		chiaki_mutex_unlock(&decoder->codec_mutex);
+	}
+	AMediaCodec_delete(decoder->codec);
+	decoder->codec = NULL;
+	decoder->shutdown_output = false;
+}
+
+void android_chiaki_video_decoder_fini(AndroidChiakiVideoDecoder *decoder)
+{
+	if(decoder->codec)
+		kill_decoder(decoder);
 	chiaki_mutex_fini(&decoder->codec_mutex);
 }
 
@@ -56,6 +61,16 @@ void android_chiaki_video_decoder_set_su
 {
 	chiaki_mutex_lock(&decoder->codec_mutex);
 
+	if(!surface)
+	{
+		if(decoder->codec)
+		{
+			kill_decoder(decoder);
+			CHIAKI_LOGI(decoder->log, "Decoder shut down after surface was removed");
+		}
+		return;
+	}
+
 	if(decoder->codec)
 	{
 #if __ANDROID_API__ >= 23
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/common/Preferences.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/common/Preferences.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/common/Preferences.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/common/Preferences.kt	2021-01-15 21:35:50.000000000 +0000
@@ -68,11 +68,26 @@ class Preferences(context: Context)
 		get() = sharedPreferences.getBoolean(onScreenControlsEnabledKey, true)
 		set(value) { sharedPreferences.edit().putBoolean(onScreenControlsEnabledKey, value).apply() }
 
-	val touchpadOnlyEnabledKey get() = resources.getString(R.string.preferences_touchpad_only_key)
+	val touchpadOnlyEnabledKey get() = resources.getString(R.string.preferences_touchpad_only_enabled_key)
 	var touchpadOnlyEnabled
 		get() = sharedPreferences.getBoolean(touchpadOnlyEnabledKey, false)
 		set(value) { sharedPreferences.edit().putBoolean(touchpadOnlyEnabledKey, value).apply() }
 
+	val rumbleEnabledKey get() = resources.getString(R.string.preferences_rumble_enabled_key)
+	var rumbleEnabled
+		get() = sharedPreferences.getBoolean(rumbleEnabledKey, true)
+		set(value) { sharedPreferences.edit().putBoolean(rumbleEnabledKey, value).apply() }
+
+	val motionEnabledKey get() = resources.getString(R.string.preferences_motion_enabled_key)
+	var motionEnabled
+		get() = sharedPreferences.getBoolean(motionEnabledKey, true)
+		set(value) { sharedPreferences.edit().putBoolean(motionEnabledKey, value).apply() }
+
+	val buttonHapticEnabledKey get() = resources.getString(R.string.preferences_button_haptic_enabled_key)
+	var buttonHapticEnabled
+		get() = sharedPreferences.getBoolean(buttonHapticEnabledKey, true)
+		set(value) { sharedPreferences.edit().putBoolean(buttonHapticEnabledKey, value).apply() }
+
 	val logVerboseKey get() = resources.getString(R.string.preferences_log_verbose_key)
 	var logVerbose
 		get() = sharedPreferences.getBoolean(logVerboseKey, false)
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/lib/Chiaki.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/lib/Chiaki.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/lib/Chiaki.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/lib/Chiaki.kt	2021-01-15 21:35:50.000000000 +0000
@@ -3,8 +3,7 @@ package com.metallic.chiaki.lib
 import android.os.Parcelable
 import android.util.Log
 import android.view.Surface
-import kotlinx.android.parcel.IgnoredOnParcel
-import kotlinx.android.parcel.Parcelize
+import kotlinx.parcelize.Parcelize
 import java.lang.Exception
 import java.net.InetSocketAddress
 import kotlin.math.abs
@@ -91,7 +90,7 @@ private class ChiakiNative
 		@JvmStatic external fun sessionStart(ptr: Long): Int
 		@JvmStatic external fun sessionStop(ptr: Long): Int
 		@JvmStatic external fun sessionJoin(ptr: Long): Int
-		@JvmStatic external fun sessionSetSurface(ptr: Long, surface: Surface)
+		@JvmStatic external fun sessionSetSurface(ptr: Long, surface: Surface?)
 		@JvmStatic external fun sessionSetControllerState(ptr: Long, controllerState: ControllerState)
 		@JvmStatic external fun sessionSetLoginPin(ptr: Long, pin: String)
 		@JvmStatic external fun discoveryServiceCreate(result: CreateResult, options: DiscoveryServiceOptions, javaService: DiscoveryService)
@@ -150,6 +149,14 @@ class ChiakiLog(val levelMask: Int, val
 
 private fun maxAbs(a: Short, b: Short) = if(abs(a.toInt()) > abs(b.toInt())) a else b
 
+private val CONTROLLER_TOUCHES_MAX = 2 // must be the same as CHIAKI_CONTROLLER_TOUCHES_MAX
+
+data class ControllerTouch(
+	var x: UShort = 0U,
+	var y: UShort = 0U,
+	var id: Byte = -1 // -1 = up
+)
+
 data class ControllerState constructor(
 	var buttons: UInt = 0U,
 	var l2State: UByte = 0U,
@@ -157,26 +164,40 @@ data class ControllerState constructor(
 	var leftX: Short = 0,
 	var leftY: Short = 0,
 	var rightX: Short = 0,
-	var rightY: Short = 0
+	var rightY: Short = 0,
+	private var touchIdNext: UByte = 0U,
+	var touches: Array<ControllerTouch> = arrayOf(ControllerTouch(), ControllerTouch()),
+	var gyroX: Float = 0.0f,
+	var gyroY: Float = 0.0f,
+	var gyroZ: Float = 0.0f,
+	var accelX: Float = 0.0f,
+	var accelY: Float = 1.0f,
+	var accelZ: Float = 0.0f,
+	var orientX: Float = 0.0f,
+	var orientY: Float = 0.0f,
+	var orientZ: Float = 0.0f,
+	var orientW: Float = 1.0f
 ){
 	companion object
 	{
 		val BUTTON_CROSS 		= (1 shl 0).toUInt()
 		val BUTTON_MOON 		= (1 shl 1).toUInt()
-		val BUTTON_BOX 		= (1 shl 2).toUInt()
-		val BUTTON_PYRAMID 	= (1 shl 3).toUInt()
+		val BUTTON_BOX 			= (1 shl 2).toUInt()
+		val BUTTON_PYRAMID 		= (1 shl 3).toUInt()
 		val BUTTON_DPAD_LEFT 	= (1 shl 4).toUInt()
 		val BUTTON_DPAD_RIGHT	= (1 shl 5).toUInt()
-		val BUTTON_DPAD_UP 	= (1 shl 6).toUInt()
+		val BUTTON_DPAD_UP 		= (1 shl 6).toUInt()
 		val BUTTON_DPAD_DOWN 	= (1 shl 7).toUInt()
-		val BUTTON_L1 		= (1 shl 8).toUInt()
-		val BUTTON_R1 		= (1 shl 9).toUInt()
+		val BUTTON_L1 			= (1 shl 8).toUInt()
+		val BUTTON_R1 			= (1 shl 9).toUInt()
 		val BUTTON_L3			= (1 shl 10).toUInt()
 		val BUTTON_R3			= (1 shl 11).toUInt()
-		val BUTTON_OPTIONS 	= (1 shl 12).toUInt()
+		val BUTTON_OPTIONS		= (1 shl 12).toUInt()
 		val BUTTON_SHARE 		= (1 shl 13).toUInt()
-		val BUTTON_TOUCHPAD	= (1 shl 14).toUInt()
+		val BUTTON_TOUCHPAD		= (1 shl 14).toUInt()
 		val BUTTON_PS			= (1 shl 15).toUInt()
+		val TOUCHPAD_WIDTH: UShort = 1920U
+		val TOUCHPAD_HEIGHT: UShort = 942U
 	}
 
 	infix fun or(o: ControllerState) = ControllerState(
@@ -186,8 +207,102 @@ data class ControllerState constructor(
 		leftX = maxAbs(leftX, o.leftX),
 		leftY = maxAbs(leftY, o.leftY),
 		rightX = maxAbs(rightX, o.rightX),
-		rightY = maxAbs(rightY, o.rightY)
+		rightY = maxAbs(rightY, o.rightY),
+		touches = touches.zip(o.touches) { a, b -> if(a.id >= 0) a else b }.toTypedArray(),
+		gyroX = gyroX,
+		gyroY = gyroY,
+		gyroZ = gyroZ,
+		accelX = accelX,
+		accelY = accelY,
+		accelZ = accelZ,
+		orientX = orientX,
+		orientY = orientY,
+		orientZ = orientZ,
+		orientW = orientW
 	)
+
+	override fun equals(other: Any?): Boolean
+	{
+		if(this === other) return true
+		if(javaClass != other?.javaClass) return false
+
+		other as ControllerState
+
+		if(buttons != other.buttons) return false
+		if(l2State != other.l2State) return false
+		if(r2State != other.r2State) return false
+		if(leftX != other.leftX) return false
+		if(leftY != other.leftY) return false
+		if(rightX != other.rightX) return false
+		if(rightY != other.rightY) return false
+		if(touchIdNext != other.touchIdNext) return false
+		if(!touches.contentEquals(other.touches)) return false
+		if(gyroX != other.gyroX) return false
+		if(gyroY != other.gyroY) return false
+		if(gyroZ != other.gyroZ) return false
+		if(accelX != other.accelX) return false
+		if(accelY != other.accelY) return false
+		if(accelZ != other.accelZ) return false
+		if(orientX != other.orientX) return false
+		if(orientY != other.orientY) return false
+		if(orientZ != other.orientZ) return false
+		if(orientW != other.orientW) return false
+
+		return true
+	}
+
+	override fun hashCode(): Int
+	{
+		var result = buttons.hashCode()
+		result = 31 * result + l2State.hashCode()
+		result = 31 * result + r2State.hashCode()
+		result = 31 * result + leftX
+		result = 31 * result + leftY
+		result = 31 * result + rightX
+		result = 31 * result + rightY
+		result = 31 * result + touchIdNext.hashCode()
+		result = 31 * result + touches.contentHashCode()
+		result = 31 * result + gyroX.hashCode()
+		result = 31 * result + gyroY.hashCode()
+		result = 31 * result + gyroZ.hashCode()
+		result = 31 * result + accelX.hashCode()
+		result = 31 * result + accelY.hashCode()
+		result = 31 * result + accelZ.hashCode()
+		result = 31 * result + orientX.hashCode()
+		result = 31 * result + orientY.hashCode()
+		result = 31 * result + orientZ.hashCode()
+		result = 31 * result + orientW.hashCode()
+		return result
+	}
+
+	fun startTouch(x: UShort, y: UShort): UByte? =
+		touches
+			.find { it.id < 0 }
+			?.also {
+				it.id = touchIdNext.toByte()
+				it.x = x
+				it.y = y
+				touchIdNext = ((touchIdNext + 1U) and 0x7fU).toUByte()
+			}?.id?.toUByte()
+
+	fun stopTouch(id: UByte)
+	{
+		touches.find {
+			it.id >= 0 && it.id == id.toByte()
+		}?.let {
+			it.id = -1
+		}
+	}
+
+	fun setTouchPos(id: UByte, x: UShort, y: UShort): Boolean
+		= touches.find {
+			it.id >= 0 && it.id == id.toByte()
+		}?.let {
+			val r = it.x != x || it.y != y
+			it.x = x
+			it.y = y
+			r
+		} ?: false
 }
 
 class QuitReason(val value: Int)
@@ -204,6 +319,7 @@ sealed class Event
 object ConnectedEvent: Event()
 data class LoginPinRequestEvent(val pinIncorrect: Boolean): Event()
 data class QuitEvent(val reason: QuitReason, val reasonString: String?): Event()
+data class RumbleEvent(val left: UByte, val right: UByte): Event()
 
 class CreateError(val errorCode: ErrorCode): Exception("Failed to create a native object: $errorCode")
 
@@ -259,7 +375,12 @@ class Session(connectInfo: ConnectInfo,
 		event(QuitEvent(QuitReason(reasonValue), reasonString))
 	}
 
-	fun setSurface(surface: Surface)
+	private fun eventRumble(left: Int, right: Int)
+	{
+		event(RumbleEvent(left.toUByte(), right.toUByte()))
+	}
+
+	fun setSurface(surface: Surface?)
 	{
 		ChiakiNative.sessionSetSurface(nativePtr, surface)
 	}
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/main/DisplayHostRecyclerViewAdapter.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/main/DisplayHostRecyclerViewAdapter.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/main/DisplayHostRecyclerViewAdapter.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/main/DisplayHostRecyclerViewAdapter.kt	2021-01-15 21:35:50.000000000 +0000
@@ -3,6 +3,7 @@
 package com.metallic.chiaki.main
 
 import android.util.Log
+import android.view.LayoutInflater
 import android.view.View
 import android.view.ViewGroup
 import android.view.animation.AnimationUtils
@@ -16,8 +17,8 @@ import com.metallic.chiaki.common.Discov
 import com.metallic.chiaki.common.DisplayHost
 import com.metallic.chiaki.common.ManualDisplayHost
 import com.metallic.chiaki.common.ext.inflate
+import com.metallic.chiaki.databinding.ItemDisplayHostBinding
 import com.metallic.chiaki.lib.DiscoveryHost
-import kotlinx.android.synthetic.main.item_display_host.view.*
 
 class DisplayHostDiffCallback(val old: List<DisplayHost>, val new: List<DisplayHost>): DiffUtil.Callback()
 {
@@ -42,10 +43,10 @@ class DisplayHostRecyclerViewAdapter(
 			diff.dispatchUpdatesTo(this)
 		}
 
-	class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView)
+	class ViewHolder(val binding: ItemDisplayHostBinding): RecyclerView.ViewHolder(binding.root)
 
 	override fun onCreateViewHolder(parent: ViewGroup, viewType: Int)
-			= ViewHolder(parent.inflate(R.layout.item_display_host))
+		= ViewHolder(ItemDisplayHostBinding.inflate(LayoutInflater.from(parent.context), parent, false))
 
 	override fun getItemCount() = hosts.count()
 
@@ -53,7 +54,7 @@ class DisplayHostRecyclerViewAdapter(
 	{
 		val context = holder.itemView.context
 		val host = hosts[position]
-		holder.itemView.also {
+		holder.binding.also {
 			it.nameTextView.text = host.name
 			it.hostTextView.text = context.getString(R.string.display_host_host, host.host)
 			val id = host.id
@@ -87,7 +88,7 @@ class DisplayHostRecyclerViewAdapter(
 					else -> R.drawable.ic_console
 				}
 			)
-			it.setOnClickListener { clickCallback(host) }
+			it.root.setOnClickListener { clickCallback(host) }
 
 			val canWakeup = host.registeredHost != null
 			val canEditDelete = host is ManualDisplayHost
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/main/MainActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/main/MainActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/main/MainActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/main/MainActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -17,52 +17,54 @@ import com.metallic.chiaki.R
 import com.metallic.chiaki.common.*
 import com.metallic.chiaki.common.ext.putRevealExtra
 import com.metallic.chiaki.common.ext.viewModelFactory
+import com.metallic.chiaki.databinding.ActivityMainBinding
 import com.metallic.chiaki.lib.ConnectInfo
 import com.metallic.chiaki.lib.DiscoveryHost
 import com.metallic.chiaki.manualconsole.EditManualConsoleActivity
 import com.metallic.chiaki.regist.RegistActivity
 import com.metallic.chiaki.settings.SettingsActivity
 import com.metallic.chiaki.stream.StreamActivity
-import kotlinx.android.synthetic.main.activity_main.*
 
 class MainActivity : AppCompatActivity()
 {
 	private lateinit var viewModel: MainViewModel
 
+	private lateinit var binding: ActivityMainBinding
 	private var discoveryMenuItem: MenuItem? = null
 
 	override fun onCreate(savedInstanceState: Bundle?)
 	{
 		super.onCreate(savedInstanceState)
-		setContentView(R.layout.activity_main)
+		binding = ActivityMainBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 
 		title = ""
-		setSupportActionBar(toolbar)
+		setSupportActionBar(binding.toolbar)
 
-		floatingActionButton.setOnClickListener {
-			expandFloatingActionButton(!floatingActionButton.isExpanded)
+		binding.floatingActionButton.setOnClickListener {
+			expandFloatingActionButton(!binding.floatingActionButton.isExpanded)
 		}
-		floatingActionButtonDialBackground.setOnClickListener {
+		binding.floatingActionButtonDialBackground.setOnClickListener {
 			expandFloatingActionButton(false)
 		}
 
-		addManualButton.setOnClickListener { addManualConsole() }
-		addManualLabelButton.setOnClickListener { addManualConsole() }
+		binding.addManualButton.setOnClickListener { addManualConsole() }
+		binding.addManualLabelButton.setOnClickListener { addManualConsole() }
 
-		registerButton.setOnClickListener { showRegistration() }
-		registerLabelButton.setOnClickListener { showRegistration() }
+		binding.registerButton.setOnClickListener { showRegistration() }
+		binding.registerLabelButton.setOnClickListener { showRegistration() }
 
 		viewModel = ViewModelProvider(this, viewModelFactory { MainViewModel(getDatabase(this), Preferences(this)) })
 			.get(MainViewModel::class.java)
 
 		val recyclerViewAdapter = DisplayHostRecyclerViewAdapter(this::hostTriggered, this::wakeupHost, this::editHost, this::deleteHost)
-		hostsRecyclerView.adapter = recyclerViewAdapter
-		hostsRecyclerView.layoutManager = LinearLayoutManager(this)
+		binding.hostsRecyclerView.adapter = recyclerViewAdapter
+		binding.hostsRecyclerView.layoutManager = LinearLayoutManager(this)
 		viewModel.displayHosts.observe(this, Observer {
-			val top = hostsRecyclerView.computeVerticalScrollOffset() == 0
+			val top = binding.hostsRecyclerView.computeVerticalScrollOffset() == 0
 			recyclerViewAdapter.hosts = it
 			if(top)
-				hostsRecyclerView.scrollToPosition(0)
+				binding.hostsRecyclerView.scrollToPosition(0)
 			updateEmptyInfo()
 		})
 
@@ -76,19 +78,19 @@ class MainActivity : AppCompatActivity()
 	{
 		if(viewModel.displayHosts.value?.isEmpty() ?: true)
 		{
-			emptyInfoLayout.visibility = View.VISIBLE
+			binding.emptyInfoLayout.visibility = View.VISIBLE
 			val discoveryActive = viewModel.discoveryActive.value ?: false
-			emptyInfoImageView.setImageResource(if(discoveryActive) R.drawable.ic_discover_on else R.drawable.ic_discover_off)
-			emptyInfoTextView.setText(if(discoveryActive) R.string.display_hosts_empty_discovery_on_info else R.string.display_hosts_empty_discovery_off_info)
+			binding.emptyInfoImageView.setImageResource(if(discoveryActive) R.drawable.ic_discover_on else R.drawable.ic_discover_off)
+			binding.emptyInfoTextView.setText(if(discoveryActive) R.string.display_hosts_empty_discovery_on_info else R.string.display_hosts_empty_discovery_off_info)
 		}
 		else
-			emptyInfoLayout.visibility = View.GONE
+			binding.emptyInfoLayout.visibility = View.GONE
 	}
 
 	private fun expandFloatingActionButton(expand: Boolean)
 	{
-		floatingActionButton.isExpanded = expand
-		floatingActionButton.isActivated = floatingActionButton.isExpanded
+		binding.floatingActionButton.isExpanded = expand
+		binding.floatingActionButton.isActivated = binding.floatingActionButton.isExpanded
 	}
 
 	override fun onStart()
@@ -105,7 +107,7 @@ class MainActivity : AppCompatActivity()
 
 	override fun onBackPressed()
 	{
-		if(floatingActionButton.isExpanded)
+		if(binding.floatingActionButton.isExpanded)
 		{
 			expandFloatingActionButton(false)
 			return
@@ -151,7 +153,7 @@ class MainActivity : AppCompatActivity()
 	private fun addManualConsole()
 	{
 		Intent(this, EditManualConsoleActivity::class.java).also {
-			it.putRevealExtra(addManualButton, rootLayout)
+			it.putRevealExtra(binding.addManualButton, binding.rootLayout)
 			startActivity(it, ActivityOptions.makeSceneTransitionAnimation(this).toBundle())
 		}
 	}
@@ -159,7 +161,7 @@ class MainActivity : AppCompatActivity()
 	private fun showRegistration()
 	{
 		Intent(this, RegistActivity::class.java).also {
-			it.putRevealExtra(registerButton, rootLayout)
+			it.putRevealExtra(binding.registerButton, binding.rootLayout)
 			startActivity(it, ActivityOptions.makeSceneTransitionAnimation(this).toBundle())
 		}
 	}
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/manualconsole/EditManualConsoleActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/manualconsole/EditManualConsoleActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/manualconsole/EditManualConsoleActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/manualconsole/EditManualConsoleActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -16,10 +16,10 @@ import com.metallic.chiaki.common.Regist
 import com.metallic.chiaki.common.ext.RevealActivity
 import com.metallic.chiaki.common.ext.viewModelFactory
 import com.metallic.chiaki.common.getDatabase
+import com.metallic.chiaki.databinding.ActivityEditManualBinding
 import io.reactivex.android.schedulers.AndroidSchedulers
 import io.reactivex.disposables.CompositeDisposable
 import io.reactivex.rxkotlin.addTo
-import kotlinx.android.synthetic.main.activity_edit_manual.*
 
 class EditManualConsoleActivity: AppCompatActivity(), RevealActivity
 {
@@ -28,18 +28,20 @@ class EditManualConsoleActivity: AppComp
 		const val EXTRA_MANUAL_HOST_ID = "manual_host_id"
 	}
 
+	private lateinit var viewModel: EditManualConsoleViewModel
+	private lateinit var binding: ActivityEditManualBinding
+
 	override val revealIntent: Intent get() = intent
-	override val revealRootLayout: View get() = rootLayout
+	override val revealRootLayout: View get() = binding.rootLayout
 	override val revealWindow: Window get() = window
 
-	private lateinit var viewModel: EditManualConsoleViewModel
-
 	private val disposable = CompositeDisposable()
 
 	override fun onCreate(savedInstanceState: Bundle?)
 	{
 		super.onCreate(savedInstanceState)
-		setContentView(R.layout.activity_edit_manual)
+		binding = ActivityEditManualBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 		handleReveal()
 
 		viewModel = ViewModelProvider(this, viewModelFactory {
@@ -52,17 +54,17 @@ class EditManualConsoleActivity: AppComp
 			.get(EditManualConsoleViewModel::class.java)
 
 		viewModel.existingHost?.observe(this, Observer {
-			hostEditText.setText(it.host)
+			binding.hostEditText.setText(it.host)
 		})
 
 		viewModel.selectedRegisteredHost.observe(this, Observer {
-			registeredHostTextView.setText(titleForRegisteredHost(it))
+			binding.registeredHostTextView.setText(titleForRegisteredHost(it))
 		})
 
 		viewModel.registeredHosts.observe(this, Observer { hosts ->
-			registeredHostTextView.setAdapter(ArrayAdapter<String>(this, R.layout.dropdown_menu_popup_item,
+			binding.registeredHostTextView.setAdapter(ArrayAdapter<String>(this, R.layout.dropdown_menu_popup_item,
 				hosts.map { titleForRegisteredHost(it) }))
-			registeredHostTextView.onItemClickListener = object: AdapterView.OnItemClickListener {
+			binding.registeredHostTextView.onItemClickListener = object: AdapterView.OnItemClickListener {
 				override fun onItemClick(parent: AdapterView<*>?, view: View?, position: Int, id: Long)
 				{
 					if(position >= hosts.size)
@@ -73,8 +75,7 @@ class EditManualConsoleActivity: AppComp
 			}
 		})
 
-
-		saveButton.setOnClickListener { saveHost() }
+		binding.saveButton.setOnClickListener { saveHost() }
 	}
 
 	private fun titleForRegisteredHost(registeredHost: RegisteredHost?) =
@@ -85,14 +86,14 @@ class EditManualConsoleActivity: AppComp
 
 	private fun saveHost()
 	{
-		val host = hostEditText.text.toString().trim()
+		val host = binding.hostEditText.text.toString().trim()
 		if(host.isEmpty())
 		{
-			hostEditText.error = getString(R.string.entered_host_invalid)
+			binding.hostEditText.error = getString(R.string.entered_host_invalid)
 			return
 		}
 
-		saveButton.isEnabled = false
+		binding.saveButton.isEnabled = false
 		viewModel.saveHost(host)
 			.observeOn(AndroidSchedulers.mainThread())
 			.subscribe {
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -12,9 +12,9 @@ import androidx.lifecycle.Observer
 import androidx.lifecycle.ViewModelProvider
 import com.metallic.chiaki.R
 import com.metallic.chiaki.common.ext.RevealActivity
+import com.metallic.chiaki.databinding.ActivityRegistBinding
 import com.metallic.chiaki.lib.RegistInfo
 import com.metallic.chiaki.lib.Target
-import kotlinx.android.synthetic.main.activity_regist.*
 import java.lang.IllegalArgumentException
 
 class RegistActivity: AppCompatActivity(), RevealActivity
@@ -30,33 +30,35 @@ class RegistActivity: AppCompatActivity(
 		private const val REQUEST_REGIST = 1
 	}
 
+	private lateinit var viewModel: RegistViewModel
+	private lateinit var binding: ActivityRegistBinding
+
 	override val revealWindow: Window get() = window
 	override val revealIntent: Intent get() = intent
-	override val revealRootLayout: View get() = rootLayout
-
-	private lateinit var viewModel: RegistViewModel
+	override val revealRootLayout: View get() = binding.rootLayout
 
 	override fun onCreate(savedInstanceState: Bundle?)
 	{
 		super.onCreate(savedInstanceState)
-		setContentView(R.layout.activity_regist)
+		binding = ActivityRegistBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 		handleReveal()
 
 		viewModel = ViewModelProvider(this).get(RegistViewModel::class.java)
 
-		hostEditText.setText(intent.getStringExtra(EXTRA_HOST) ?: "255.255.255.255")
-		broadcastCheckBox.isChecked = intent.getBooleanExtra(EXTRA_BROADCAST, true)
+		binding.hostEditText.setText(intent.getStringExtra(EXTRA_HOST) ?: "255.255.255.255")
+		binding.broadcastCheckBox.isChecked = intent.getBooleanExtra(EXTRA_BROADCAST, true)
 
-		registButton.setOnClickListener { doRegist() }
+		binding.registButton.setOnClickListener { doRegist() }
 
-		ps4VersionRadioGroup.check(when(viewModel.ps4Version.value ?: RegistViewModel.ConsoleVersion.PS5) {
+		binding.ps4VersionRadioGroup.check(when(viewModel.ps4Version.value ?: RegistViewModel.ConsoleVersion.PS5) {
 			RegistViewModel.ConsoleVersion.PS5 -> R.id.ps5RadioButton
 			RegistViewModel.ConsoleVersion.PS4_GE_8 -> R.id.ps4VersionGE8RadioButton
 			RegistViewModel.ConsoleVersion.PS4_GE_7 -> R.id.ps4VersionGE7RadioButton
 			RegistViewModel.ConsoleVersion.PS4_LT_7 -> R.id.ps4VersionLT7RadioButton
 		})
 
-		ps4VersionRadioGroup.setOnCheckedChangeListener { _, checkedId ->
+		binding.ps4VersionRadioGroup.setOnCheckedChangeListener { _, checkedId ->
 			viewModel.ps4Version.value = when(checkedId)
 			{
 				R.id.ps5RadioButton -> RegistViewModel.ConsoleVersion.PS5
@@ -68,14 +70,14 @@ class RegistActivity: AppCompatActivity(
 		}
 
 		viewModel.ps4Version.observe(this, Observer {
-			psnAccountIdHelpGroup.visibility = if(it == RegistViewModel.ConsoleVersion.PS4_LT_7) View.GONE else View.VISIBLE
-			psnIdTextInputLayout.hint = getString(when(it!!)
+			binding.psnAccountIdHelpGroup.visibility = if(it == RegistViewModel.ConsoleVersion.PS4_LT_7) View.GONE else View.VISIBLE
+			binding.psnIdTextInputLayout.hint = getString(when(it!!)
 			{
 				RegistViewModel.ConsoleVersion.PS4_LT_7 -> R.string.hint_regist_psn_online_id
 				else -> R.string.hint_regist_psn_account_id
 			})
-			pinHelpBeforeTextView.setText(if(it.isPS5) R.string.regist_pin_instructions_ps5_before else R.string.regist_pin_instructions_ps4_before)
-			pinHelpNavigationTextView.setText(if(it.isPS5) R.string.regist_pin_instructions_ps5_navigation else R.string.regist_pin_instructions_ps4_navigation)
+			binding.pinHelpBeforeTextView.setText(if(it.isPS5) R.string.regist_pin_instructions_ps5_before else R.string.regist_pin_instructions_ps4_before)
+			binding.pinHelpNavigationTextView.setText(if(it.isPS5) R.string.regist_pin_instructions_ps5_navigation else R.string.regist_pin_instructions_ps4_navigation)
 		})
 	}
 
@@ -83,11 +85,11 @@ class RegistActivity: AppCompatActivity(
 	{
 		val ps4Version = viewModel.ps4Version.value ?: RegistViewModel.ConsoleVersion.PS5
 
-		val host = hostEditText.text.toString().trim()
+		val host = binding.hostEditText.text.toString().trim()
 		val hostValid = host.isNotEmpty()
-		val broadcast = broadcastCheckBox.isChecked
+		val broadcast = binding.broadcastCheckBox.isChecked
 
-		val psnId = psnIdEditText.text.toString().trim()
+		val psnId = binding.psnIdEditText.text.toString().trim()
 		val psnOnlineId: String? = if(ps4Version == RegistViewModel.ConsoleVersion.PS4_LT_7) psnId else null
 		val psnAccountId: ByteArray? =
 			if(ps4Version != RegistViewModel.ConsoleVersion.PS4_LT_7)
@@ -101,11 +103,11 @@ class RegistActivity: AppCompatActivity(
 		}
 
 
-		val pin = pinEditText.text.toString()
+		val pin = binding.pinEditText.text.toString()
 		val pinValid = pin.length == PIN_LENGTH
 
-		hostEditText.error = if(!hostValid) getString(R.string.entered_host_invalid) else null
-		psnIdEditText.error =
+		binding.hostEditText.error = if(!hostValid) getString(R.string.entered_host_invalid) else null
+		binding.psnIdEditText.error =
 			if(!psnIdValid)
 				getString(when(ps4Version)
 				{
@@ -114,7 +116,7 @@ class RegistActivity: AppCompatActivity(
 				})
 			else
 				null
-		pinEditText.error = if(!pinValid) getString(R.string.regist_pin_invalid, PIN_LENGTH) else null
+		binding.pinEditText.error = if(!pinValid) getString(R.string.regist_pin_invalid, PIN_LENGTH) else null
 
 		if(!hostValid || !psnIdValid || !pinValid)
 			return
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistExecuteActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistExecuteActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistExecuteActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/regist/RegistExecuteActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -16,8 +16,8 @@ import com.metallic.chiaki.R
 import com.metallic.chiaki.common.MacAddress
 import com.metallic.chiaki.common.ext.viewModelFactory
 import com.metallic.chiaki.common.getDatabase
+import com.metallic.chiaki.databinding.ActivityRegistExecuteBinding
 import com.metallic.chiaki.lib.RegistInfo
-import kotlinx.android.synthetic.main.activity_regist_execute.*
 import kotlin.math.max
 
 class RegistExecuteActivity: AppCompatActivity()
@@ -31,55 +31,57 @@ class RegistExecuteActivity: AppCompatAc
 	}
 
 	private lateinit var viewModel: RegistExecuteViewModel
+	private lateinit var binding: ActivityRegistExecuteBinding
 
 	override fun onCreate(savedInstanceState: Bundle?)
 	{
 		super.onCreate(savedInstanceState)
-		setContentView(R.layout.activity_regist_execute)
+		binding = ActivityRegistExecuteBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 
 		viewModel = ViewModelProvider(this, viewModelFactory { RegistExecuteViewModel(getDatabase(this)) })
 			.get(RegistExecuteViewModel::class.java)
 
-		logTextView.setHorizontallyScrolling(true)
-		logTextView.movementMethod = ScrollingMovementMethod()
+		binding.logTextView.setHorizontallyScrolling(true)
+		binding.logTextView.movementMethod = ScrollingMovementMethod()
 		viewModel.logText.observe(this, Observer {
-			val textLayout = logTextView.layout ?: return@Observer
+			val textLayout = binding.logTextView.layout ?: return@Observer
 			val lineCount = textLayout.lineCount
 			if(lineCount < 1)
 				return@Observer
-			logTextView.text = it
-			val scrollY = textLayout.getLineBottom(lineCount - 1) - logTextView.height + logTextView.paddingTop + logTextView.paddingBottom
-			logTextView.scrollTo(0, max(scrollY, 0))
+			binding.logTextView.text = it
+			val scrollY = textLayout.getLineBottom(lineCount - 1) - binding.logTextView.height + binding.logTextView.paddingTop + binding.logTextView.paddingBottom
+			binding.logTextView.scrollTo(0, max(scrollY, 0))
 		})
 
 		viewModel.state.observe(this, Observer {
-			progressBar.visibility = if(it == RegistExecuteViewModel.State.RUNNING) View.VISIBLE else View.GONE
+			binding.progressBar.visibility = if(it == RegistExecuteViewModel.State.RUNNING) View.VISIBLE else View.GONE
 			when(it)
 			{
 				RegistExecuteViewModel.State.FAILED ->
 				{
-					infoTextView.visibility = View.VISIBLE
-					infoTextView.setText(R.string.regist_info_failed)
+					binding.infoTextView.visibility = View.VISIBLE
+					binding.infoTextView.setText(R.string.regist_info_failed)
 					setResult(RESULT_FAILED)
 				}
 				RegistExecuteViewModel.State.SUCCESSFUL, RegistExecuteViewModel.State.SUCCESSFUL_DUPLICATE ->
 				{
-					infoTextView.visibility = View.VISIBLE
-					infoTextView.setText(R.string.regist_info_success)
+					binding.infoTextView.visibility = View.VISIBLE
+					binding.infoTextView.setText(R.string.regist_info_success)
 					setResult(RESULT_OK)
 					if(it == RegistExecuteViewModel.State.SUCCESSFUL_DUPLICATE)
 						showDuplicateDialog()
 				}
 				RegistExecuteViewModel.State.STOPPED ->
 				{
-					infoTextView.visibility = View.GONE
+					binding.infoTextView.visibility = View.GONE
 					setResult(Activity.RESULT_CANCELED)
 				}
-				else -> infoTextView.visibility = View.GONE
+				else -> binding.infoTextView.visibility = View.GONE
 			}
 		})
 
-		shareLogButton.setOnClickListener {
+		binding.shareLogButton.setOnClickListener {
 			val log = viewModel.logText.value ?: ""
 			Intent(Intent.ACTION_SEND).also {
 				it.type = "text/plain"
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/session/StreamInput.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/session/StreamInput.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/session/StreamInput.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/session/StreamInput.kt	2021-01-15 21:35:50.000000000 +0000
@@ -1,19 +1,37 @@
 package com.metallic.chiaki.session
 
-import android.util.Log
-import android.view.InputDevice
-import android.view.KeyEvent
-import android.view.MotionEvent
+import android.content.Context
+import android.hardware.*
+import android.view.*
+import androidx.lifecycle.Lifecycle
+import androidx.lifecycle.LifecycleObserver
+import androidx.lifecycle.LifecycleOwner
+import androidx.lifecycle.OnLifecycleEvent
 import com.metallic.chiaki.common.Preferences
 import com.metallic.chiaki.lib.ControllerState
 
-class StreamInput(val preferences: Preferences)
+class StreamInput(val context: Context, val preferences: Preferences)
 {
 	var controllerStateChangedCallback: ((ControllerState) -> Unit)? = null
 
 	val controllerState: ControllerState get()
 	{
-		val controllerState = keyControllerState or motionControllerState
+		val controllerState = sensorControllerState or keyControllerState or motionControllerState
+
+		val windowManager = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
+		@Suppress("DEPRECATION")
+		when(windowManager.defaultDisplay.rotation)
+		{
+			Surface.ROTATION_90 -> {
+				controllerState.accelX *= -1.0f
+				controllerState.accelZ *= -1.0f
+				controllerState.gyroX *= -1.0f
+				controllerState.gyroZ *= -1.0f
+				controllerState.orientX *= -1.0f
+				controllerState.orientZ *= -1.0f
+			}
+			else -> {}
+		}
 
 		// prioritize motion controller's l2 and r2 over key
 		// (some controllers send only key, others both but key earlier than full press)
@@ -25,6 +43,7 @@ class StreamInput(val preferences: Prefe
 		return controllerState or touchControllerState
 	}
 
+	private val sensorControllerState = ControllerState() // from Motion Sensors
 	private val keyControllerState = ControllerState() // from KeyEvents
 	private val motionControllerState = ControllerState() // from MotionEvents
 	var touchControllerState = ControllerState()
@@ -36,6 +55,66 @@ class StreamInput(val preferences: Prefe
 
 	private val swapCrossMoon = preferences.swapCrossMoon
 
+	private val sensorEventListener = object: SensorEventListener {
+		override fun onSensorChanged(event: SensorEvent)
+		{
+			when(event.sensor.type)
+			{
+				Sensor.TYPE_ACCELEROMETER -> {
+					sensorControllerState.accelX = event.values[1] / SensorManager.GRAVITY_EARTH
+					sensorControllerState.accelY = event.values[2] / SensorManager.GRAVITY_EARTH
+					sensorControllerState.accelZ = event.values[0] / SensorManager.GRAVITY_EARTH
+				}
+				Sensor.TYPE_GYROSCOPE -> {
+					sensorControllerState.gyroX = event.values[1]
+					sensorControllerState.gyroY = event.values[2]
+					sensorControllerState.gyroZ = event.values[0]
+				}
+				Sensor.TYPE_ROTATION_VECTOR -> {
+					val q = floatArrayOf(0f, 0f, 0f, 0f)
+					SensorManager.getQuaternionFromVector(q, event.values)
+					sensorControllerState.orientX = q[2]
+					sensorControllerState.orientY = q[3]
+					sensorControllerState.orientZ = q[1]
+					sensorControllerState.orientW = q[0]
+				}
+				else -> return
+			}
+			controllerStateUpdated()
+		}
+
+		override fun onAccuracyChanged(sensor: Sensor, accuracy: Int) {}
+	}
+
+	private val motionLifecycleObserver = object: LifecycleObserver {
+		@OnLifecycleEvent(Lifecycle.Event.ON_RESUME)
+		fun onResume()
+		{
+			val samplingPeriodUs = 4000
+			val sensorManager = context.getSystemService(Context.SENSOR_SERVICE) as SensorManager
+			listOfNotNull(
+				sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
+				sensorManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE),
+				sensorManager.getDefaultSensor(Sensor.TYPE_ROTATION_VECTOR)
+			).forEach {
+				sensorManager.registerListener(sensorEventListener, it, samplingPeriodUs)
+			}
+		}
+
+		@OnLifecycleEvent(Lifecycle.Event.ON_PAUSE)
+		fun onPause()
+		{
+			val sensorManager = context.getSystemService(Context.SENSOR_SERVICE) as SensorManager
+			sensorManager.unregisterListener(sensorEventListener)
+		}
+	}
+
+	fun observe(lifecycleOwner: LifecycleOwner)
+	{
+		if(preferences.motionEnabled)
+			lifecycleOwner.lifecycle.addObserver(motionLifecycleObserver)
+	}
+
 	private fun controllerStateUpdated()
 	{
 		controllerStateChangedCallback?.let { it(controllerState) }
@@ -98,7 +177,7 @@ class StreamInput(val preferences: Prefe
 	{
 		if(event.source and InputDevice.SOURCE_CLASS_JOYSTICK != InputDevice.SOURCE_CLASS_JOYSTICK)
 			return false
-		fun Float.signedAxis() = (this * Short.MAX_VALUE).toShort()
+		fun Float.signedAxis() = (this * Short.MAX_VALUE).toInt().toShort()
 		fun Float.unsignedAxis() = (this * UByte.MAX_VALUE.toFloat()).toUInt().toUByte()
 		motionControllerState.leftX = event.getAxisValue(MotionEvent.AXIS_X).signedAxis()
 		motionControllerState.leftY = event.getAxisValue(MotionEvent.AXIS_Y).signedAxis()
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/session/StreamSession.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/session/StreamSession.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/session/StreamSession.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/session/StreamSession.kt	2021-01-15 21:35:50.000000000 +0000
@@ -25,8 +25,11 @@ class StreamSession(val connectInfo: Con
 
 	private val _state = MutableLiveData<StreamState>(StreamStateIdle)
 	val state: LiveData<StreamState> get() = _state
+	private val _rumbleState = MutableLiveData<RumbleEvent>(RumbleEvent(0U, 0U))
+	val rumbleState: LiveData<RumbleEvent> get() = _rumbleState
 
-	var surfaceTexture: SurfaceTexture? = null
+	private var surfaceTexture: SurfaceTexture? = null
+	private var surface: Surface? = null
 
 	init
 	{
@@ -59,9 +62,9 @@ class StreamSession(val connectInfo: Con
 			_state.value = StreamStateConnecting
 			session.eventCallback = this::eventCallback
 			session.start()
-			val surfaceTexture = surfaceTexture
-			if(surfaceTexture != null)
-				session.setSurface(Surface(surfaceTexture))
+			val surface = surface
+			if(surface != null)
+				session.setSurface(surface)
 			this.session = session
 		}
 		catch(e: CreateError)
@@ -86,9 +89,30 @@ class StreamSession(val connectInfo: Con
 					event.pinIncorrect
 				)
 			)
+			is RumbleEvent -> _rumbleState.postValue(event)
 		}
 	}
 
+	fun attachToSurfaceView(surfaceView: SurfaceView)
+	{
+		surfaceView.holder.addCallback(object: SurfaceHolder.Callback {
+			override fun surfaceCreated(holder: SurfaceHolder) { }
+
+			override fun surfaceChanged(holder: SurfaceHolder, format: Int, width: Int, height: Int)
+			{
+				val surface = holder.surface
+				this@StreamSession.surface = surface
+				session?.setSurface(surface)
+			}
+
+			override fun surfaceDestroyed(holder: SurfaceHolder)
+			{
+				this@StreamSession.surface = null
+				session?.setSurface(null)
+			}
+		})
+	}
+
 	fun attachToTextureView(textureView: TextureView)
 	{
 		textureView.surfaceTextureListener = object: TextureView.SurfaceTextureListener {
@@ -97,6 +121,7 @@ class StreamSession(val connectInfo: Con
 				if(surfaceTexture != null)
 					return
 				surfaceTexture = surface
+				this@StreamSession.surface = Surface(surfaceTexture)
 				session?.setSurface(Surface(surface))
 			}
 
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -9,7 +9,7 @@ import androidx.fragment.app.Fragment
 import androidx.preference.Preference
 import androidx.preference.PreferenceFragmentCompat
 import com.metallic.chiaki.R
-import kotlinx.android.synthetic.main.activity_settings.*
+import com.metallic.chiaki.databinding.ActivitySettingsBinding
 
 interface TitleFragment
 {
@@ -18,20 +18,23 @@ interface TitleFragment
 
 class SettingsActivity: AppCompatActivity(), PreferenceFragmentCompat.OnPreferenceStartFragmentCallback
 {
+	private lateinit var binding: ActivitySettingsBinding
+
 	override fun onCreate(savedInstanceState: Bundle?)
 	{
 		super.onCreate(savedInstanceState)
-		setContentView(R.layout.activity_settings)
+		binding = ActivitySettingsBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 		title = ""
-		setSupportActionBar(toolbar)
+		setSupportActionBar(binding.toolbar)
 
 		val rootFragment = SettingsFragment()
 		replaceFragment(rootFragment, false)
 		supportFragmentManager.addOnBackStackChangedListener {
 			val titleFragment = supportFragmentManager.findFragmentById(R.id.settingsFragment) as? TitleFragment ?: return@addOnBackStackChangedListener
-			titleTextView.text = titleFragment.getTitle(resources)
+			binding.titleTextView.text = titleFragment.getTitle(resources)
 		}
-		titleTextView.text = rootFragment.getTitle(resources)
+		binding.titleTextView.text = rootFragment.getTitle(resources)
 	}
 
 	override fun onPreferenceStartFragment(caller: PreferenceFragmentCompat, pref: Preference) = when(pref.fragment)
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsFragment.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsFragment.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsFragment.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsFragment.kt	2021-01-15 21:35:50.000000000 +0000
@@ -16,7 +16,6 @@ import com.metallic.chiaki.common.export
 import com.metallic.chiaki.common.ext.viewModelFactory
 import com.metallic.chiaki.common.getDatabase
 import com.metallic.chiaki.common.importSettingsFromUri
-import com.metallic.chiaki.lib.Codec
 import io.reactivex.disposables.CompositeDisposable
 import io.reactivex.rxkotlin.addTo
 
@@ -26,6 +25,9 @@ class DataStore(val preferences: Prefere
 	{
 		preferences.logVerboseKey -> preferences.logVerbose
 		preferences.swapCrossMoonKey -> preferences.swapCrossMoon
+		preferences.rumbleEnabledKey -> preferences.rumbleEnabled
+		preferences.motionEnabledKey -> preferences.motionEnabled
+		preferences.buttonHapticEnabledKey -> preferences.buttonHapticEnabled
 		else -> defValue
 	}
 
@@ -35,6 +37,9 @@ class DataStore(val preferences: Prefere
 		{
 			preferences.logVerboseKey -> preferences.logVerbose = value
 			preferences.swapCrossMoonKey -> preferences.swapCrossMoon = value
+			preferences.rumbleEnabledKey -> preferences.rumbleEnabled = value
+			preferences.motionEnabledKey -> preferences.motionEnabled = value
+			preferences.buttonHapticEnabledKey -> preferences.buttonHapticEnabled = value
 		}
 	}
 
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsAdapter.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsAdapter.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsAdapter.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsAdapter.kt	2021-01-15 21:35:50.000000000 +0000
@@ -2,13 +2,13 @@
 
 package com.metallic.chiaki.settings
 
-import android.view.View
+import android.view.LayoutInflater
 import android.view.ViewGroup
 import androidx.recyclerview.widget.RecyclerView
 import com.metallic.chiaki.R
 import com.metallic.chiaki.common.LogFile
 import com.metallic.chiaki.common.ext.inflate
-import kotlinx.android.synthetic.main.item_log_file.view.*
+import com.metallic.chiaki.databinding.ItemLogFileBinding
 import java.text.DateFormat
 import java.text.SimpleDateFormat
 import java.util.*
@@ -20,7 +20,7 @@ class SettingsLogsAdapter: RecyclerView.
 	private val dateFormat: DateFormat = DateFormat.getDateInstance(DateFormat.SHORT)
 	private val timeFormat = SimpleDateFormat("HH:mm:ss:SSS", Locale.getDefault())
 
-	class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView)
+	class ViewHolder(val binding: ItemLogFileBinding): RecyclerView.ViewHolder(binding.root)
 
 	var logFiles: List<LogFile> = listOf()
 		set(value)
@@ -29,16 +29,16 @@ class SettingsLogsAdapter: RecyclerView.
 			notifyDataSetChanged()
 		}
 
-	override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) = ViewHolder(parent.inflate(R.layout.item_log_file))
+	override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) =
+		ViewHolder(ItemLogFileBinding.inflate(LayoutInflater.from(parent.context), parent, false))
 
 	override fun getItemCount() = logFiles.size
 
 	override fun onBindViewHolder(holder: ViewHolder, position: Int)
 	{
-		val view = holder.itemView
 		val logFile = logFiles[position]
-		view.nameTextView.text = "${dateFormat.format(logFile.date)} ${timeFormat.format(logFile.date)}"
-		view.summaryTextView.text = logFile.filename
-		view.shareButton.setOnClickListener { shareCallback?.let { it(logFile) } }
+		holder.binding.nameTextView.text = "${dateFormat.format(logFile.date)} ${timeFormat.format(logFile.date)}"
+		holder.binding.summaryTextView.text = logFile.filename
+		holder.binding.shareButton.setOnClickListener { shareCallback?.let { it(logFile) } }
 	}
 }
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsFragment.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsFragment.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsFragment.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsLogsFragment.kt	2021-01-15 21:35:50.000000000 +0000
@@ -21,29 +21,35 @@ import com.metallic.chiaki.common.LogFil
 import com.metallic.chiaki.common.LogManager
 import com.metallic.chiaki.common.ext.viewModelFactory
 import com.metallic.chiaki.common.fileProviderAuthority
-import kotlinx.android.synthetic.main.fragment_settings_logs.*
+import com.metallic.chiaki.databinding.FragmentSettingsLogsBinding
 
 class SettingsLogsFragment: AppCompatDialogFragment(), TitleFragment
 {
 	private lateinit var viewModel: SettingsLogsViewModel
 
+	private var _binding: FragmentSettingsLogsBinding? = null
+	private val binding get() = _binding!!
+
 	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View =
-		inflater.inflate(R.layout.fragment_settings_logs, container, false)
+		FragmentSettingsLogsBinding.inflate(inflater, container, false).let {
+			_binding = it
+			it.root
+		}
 
 	override fun onViewCreated(view: View, savedInstanceState: Bundle?)
 	{
-		val context = context!!
+		val context = requireContext()
 
 		viewModel = ViewModelProvider(this, viewModelFactory { SettingsLogsViewModel(LogManager(context)) })
 			.get(SettingsLogsViewModel::class.java)
 
 		val adapter = SettingsLogsAdapter()
-		logsRecyclerView.layoutManager = LinearLayoutManager(context)
-		logsRecyclerView.adapter = adapter
+		binding.logsRecyclerView.layoutManager = LinearLayoutManager(context)
+		binding.logsRecyclerView.adapter = adapter
 		adapter.shareCallback = this::shareLogFile
 		viewModel.sessionLogs.observe(viewLifecycleOwner, Observer {
 			adapter.logFiles = it
-			emptyInfoGroup.visibility = if(it.isEmpty()) View.VISIBLE else View.GONE
+			binding.emptyInfoGroup.visibility = if(it.isEmpty()) View.VISIBLE else View.GONE
 		})
 
 		val itemTouchSwipeCallback = object : ItemTouchSwipeCallback(context)
@@ -55,7 +61,7 @@ class SettingsLogsFragment: AppCompatDia
 				viewModel.deleteLog(file)
 			}
 		}
-		ItemTouchHelper(itemTouchSwipeCallback).attachToRecyclerView(logsRecyclerView)
+		ItemTouchHelper(itemTouchSwipeCallback).attachToRecyclerView(binding.logsRecyclerView)
 	}
 
 	override fun getTitle(resources: Resources): String = resources.getString(R.string.preferences_logs_title)
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsAdapter.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsAdapter.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsAdapter.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsAdapter.kt	2021-01-15 21:35:50.000000000 +0000
@@ -2,17 +2,15 @@
 
 package com.metallic.chiaki.settings
 
-import android.view.View
+import android.view.LayoutInflater
 import android.view.ViewGroup
 import androidx.recyclerview.widget.RecyclerView
-import com.metallic.chiaki.R
 import com.metallic.chiaki.common.RegisteredHost
-import com.metallic.chiaki.common.ext.inflate
-import kotlinx.android.synthetic.main.item_registered_host.view.*
+import com.metallic.chiaki.databinding.ItemRegisteredHostBinding
 
 class SettingsRegisteredHostsAdapter: RecyclerView.Adapter<SettingsRegisteredHostsAdapter.ViewHolder>()
 {
-	class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView)
+	class ViewHolder(val binding: ItemRegisteredHostBinding): RecyclerView.ViewHolder(binding.root)
 
 	var hosts: List<RegisteredHost> = listOf()
 		set(value)
@@ -21,15 +19,15 @@ class SettingsRegisteredHostsAdapter: Re
 			notifyDataSetChanged()
 		}
 
-	override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) = ViewHolder(parent.inflate(R.layout.item_registered_host))
+	override fun onCreateViewHolder(parent: ViewGroup, viewType: Int)
+		= ViewHolder(ItemRegisteredHostBinding.inflate(LayoutInflater.from(parent.context), parent, false))
 
 	override fun getItemCount() = hosts.size
 
 	override fun onBindViewHolder(holder: ViewHolder, position: Int)
 	{
-		val view = holder.itemView
 		val host = hosts[position]
-		view.nameTextView.text = "${host.serverNickname} (${if(host.target.isPS5) "PS5" else "PS4"})"
-		view.summaryTextView.text = host.serverMac.toString()
+		holder.binding.nameTextView.text = "${host.serverNickname} (${if(host.target.isPS5) "PS5" else "PS4"})"
+		holder.binding.summaryTextView.text = host.serverMac.toString()
 	}
 }
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsFragment.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsFragment.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsFragment.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/settings/SettingsRegisteredHostsFragment.kt	2021-01-15 21:35:50.000000000 +0000
@@ -20,25 +20,32 @@ import com.metallic.chiaki.R
 import com.metallic.chiaki.common.ext.putRevealExtra
 import com.metallic.chiaki.common.ext.viewModelFactory
 import com.metallic.chiaki.common.getDatabase
+import com.metallic.chiaki.databinding.FragmentSettingsRegisteredHostsBinding
 import com.metallic.chiaki.regist.RegistActivity
-import kotlinx.android.synthetic.main.fragment_settings_registered_hosts.*
 
 class SettingsRegisteredHostsFragment: AppCompatDialogFragment(), TitleFragment
 {
 	private lateinit var viewModel: SettingsRegisteredHostsViewModel
 
+	private var _binding: FragmentSettingsRegisteredHostsBinding? = null
+	private val binding get() = _binding!!
+
 	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View =
-		inflater.inflate(R.layout.fragment_settings_registered_hosts, container, false)
+		FragmentSettingsRegisteredHostsBinding.inflate(inflater, container, false).let {
+			_binding = it
+			it.root
+		}
 
 	override fun onViewCreated(view: View, savedInstanceState: Bundle?)
 	{
-		viewModel = ViewModelProvider(this, viewModelFactory { SettingsRegisteredHostsViewModel(getDatabase(context!!)) })
+		val context = requireContext()
+		viewModel = ViewModelProvider(this, viewModelFactory { SettingsRegisteredHostsViewModel(getDatabase(context)) })
 			.get(SettingsRegisteredHostsViewModel::class.java)
 
 		val adapter = SettingsRegisteredHostsAdapter()
-		hostsRecyclerView.layoutManager = LinearLayoutManager(context)
-		hostsRecyclerView.adapter = adapter
-		val itemTouchSwipeCallback = object : ItemTouchSwipeCallback(context!!)
+		binding.hostsRecyclerView.layoutManager = LinearLayoutManager(context)
+		binding.hostsRecyclerView.adapter = adapter
+		val itemTouchSwipeCallback = object : ItemTouchSwipeCallback(context)
 		{
 			override fun onSwiped(viewHolder: RecyclerView.ViewHolder, direction: Int)
 			{
@@ -56,15 +63,15 @@ class SettingsRegisteredHostsFragment: A
 					.show()
 			}
 		}
-		ItemTouchHelper(itemTouchSwipeCallback).attachToRecyclerView(hostsRecyclerView)
+		ItemTouchHelper(itemTouchSwipeCallback).attachToRecyclerView(binding.hostsRecyclerView)
 		viewModel.registeredHosts.observe(this, Observer {
 			adapter.hosts = it
-			emptyInfoGroup.visibility = if(it.isEmpty()) View.VISIBLE else View.GONE
+			binding.emptyInfoGroup.visibility = if(it.isEmpty()) View.VISIBLE else View.GONE
 		})
 
-		floatingActionButton.setOnClickListener {
+		binding.floatingActionButton.setOnClickListener {
 			Intent(context, RegistActivity::class.java).also {
-				it.putRevealExtra(floatingActionButton, rootLayout)
+				it.putRevealExtra(binding.floatingActionButton, binding.rootLayout)
 				startActivity(it, ActivityOptions.makeSceneTransitionAnimation(activity).toBundle())
 			}
 		}
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/AspectRatioFrameLayout.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/AspectRatioFrameLayout.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/AspectRatioFrameLayout.kt	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/AspectRatioFrameLayout.kt	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,68 @@
+package com.metallic.chiaki.stream
+
+import android.content.Context
+import android.util.AttributeSet
+import android.widget.FrameLayout
+
+// see ExoPlayer's AspectRatioFrameLayout
+class AspectRatioFrameLayout @JvmOverloads constructor(context: Context, attrs: AttributeSet? = null): FrameLayout(context, attrs)
+{
+	companion object
+	{
+		private const val MAX_ASPECT_RATIO_DEFORMATION_FRACTION = 0.01f
+	}
+
+	var aspectRatio = 0f
+		set(value)
+		{
+			if(field != value)
+			{
+				field = value
+				requestLayout()
+			}
+		}
+
+	var mode: TransformMode = TransformMode.FIT
+		set(value)
+		{
+			if(field != value)
+			{
+				field = value
+				requestLayout()
+			}
+		}
+
+	override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int)
+	{
+		super.onMeasure(widthMeasureSpec, heightMeasureSpec)
+		if(aspectRatio <= 0)
+		{
+			// Aspect ratio not set.
+			return
+		}
+		var width = measuredWidth
+		var height = measuredHeight
+		val viewAspectRatio = width.toFloat() / height
+		val aspectDeformation = aspectRatio / viewAspectRatio - 1
+		if(Math.abs(aspectDeformation) <= MAX_ASPECT_RATIO_DEFORMATION_FRACTION)
+			return
+		when(mode)
+		{
+			TransformMode.ZOOM -> 
+				if(aspectDeformation > 0)
+					width = (height * aspectRatio).toInt()
+				else
+					height = (width / aspectRatio).toInt()
+			TransformMode.FIT ->
+				if(aspectDeformation > 0)
+					height = (width / aspectRatio).toInt()
+				else
+					width = (height * aspectRatio).toInt()
+			TransformMode.STRETCH -> {}
+		}
+		super.onMeasure(
+			MeasureSpec.makeMeasureSpec(width, MeasureSpec.EXACTLY),
+			MeasureSpec.makeMeasureSpec(height, MeasureSpec.EXACTLY)
+		)
+	}
+}
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamActivity.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamActivity.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamActivity.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamActivity.kt	2021-01-15 21:35:50.000000000 +0000
@@ -6,12 +6,8 @@ import android.animation.Animator
 import android.animation.AnimatorListenerAdapter
 import android.app.AlertDialog
 import android.graphics.Matrix
-import android.os.Bundle
-import android.os.Handler
-import android.view.KeyEvent
-import android.view.MotionEvent
-import android.view.TextureView
-import android.view.View
+import android.os.*
+import android.view.*
 import android.widget.EditText
 import androidx.appcompat.app.AppCompatActivity
 import androidx.core.view.isGone
@@ -20,15 +16,18 @@ import androidx.fragment.app.Fragment
 import androidx.lifecycle.*
 import com.google.android.material.dialog.MaterialAlertDialogBuilder
 import com.metallic.chiaki.R
-import com.metallic.chiaki.common.LogManager
 import com.metallic.chiaki.common.Preferences
 import com.metallic.chiaki.common.ext.viewModelFactory
+import com.metallic.chiaki.databinding.ActivityStreamBinding
 import com.metallic.chiaki.lib.ConnectInfo
 import com.metallic.chiaki.lib.ConnectVideoProfile
 import com.metallic.chiaki.session.*
-import com.metallic.chiaki.touchcontrols.TouchpadOnlyFragment
+import com.metallic.chiaki.touchcontrols.DefaultTouchControlsFragment
 import com.metallic.chiaki.touchcontrols.TouchControlsFragment
-import kotlinx.android.synthetic.main.activity_stream.*
+import com.metallic.chiaki.touchcontrols.TouchpadOnlyFragment
+import io.reactivex.disposables.CompositeDisposable
+import io.reactivex.rxkotlin.addTo
+import kotlin.math.min
 
 private sealed class DialogContents
 private object StreamQuitDialog: DialogContents()
@@ -44,6 +43,8 @@ class StreamActivity : AppCompatActivity
 	}
 
 	private lateinit var viewModel: StreamViewModel
+	private lateinit var binding: ActivityStreamBinding
+
 	private val uiVisibilityHandler = Handler()
 
 	override fun onCreate(savedInstanceState: Bundle?)
@@ -58,64 +59,76 @@ class StreamActivity : AppCompatActivity
 		}
 
 		viewModel = ViewModelProvider(this, viewModelFactory {
-			StreamViewModel(Preferences(this), LogManager(this), connectInfo)
+			StreamViewModel(application, connectInfo)
 		})[StreamViewModel::class.java]
 
-		setContentView(R.layout.activity_stream)
+		viewModel.input.observe(this)
+
+		binding = ActivityStreamBinding.inflate(layoutInflater)
+		setContentView(binding.root)
 		window.decorView.setOnSystemUiVisibilityChangeListener(this)
 
 		viewModel.onScreenControlsEnabled.observe(this, Observer {
-			if(onScreenControlsSwitch.isChecked != it)
-				onScreenControlsSwitch.isChecked = it
-			if(onScreenControlsSwitch.isChecked)
-				touchpadOnlySwitch.isChecked = false
+			if(binding.onScreenControlsSwitch.isChecked != it)
+				binding.onScreenControlsSwitch.isChecked = it
+			if(binding.onScreenControlsSwitch.isChecked)
+				binding.touchpadOnlySwitch.isChecked = false
 		})
-		onScreenControlsSwitch.setOnCheckedChangeListener { _, isChecked ->
+		binding.onScreenControlsSwitch.setOnCheckedChangeListener { _, isChecked ->
 			viewModel.setOnScreenControlsEnabled(isChecked)
 			showOverlay()
 		}
 
 		viewModel.touchpadOnlyEnabled.observe(this, Observer {
-			if(touchpadOnlySwitch.isChecked != it)
-				touchpadOnlySwitch.isChecked = it
-			if(touchpadOnlySwitch.isChecked)
-				onScreenControlsSwitch.isChecked = false
+			if(binding.touchpadOnlySwitch.isChecked != it)
+				binding.touchpadOnlySwitch.isChecked = it
+			if(binding.touchpadOnlySwitch.isChecked)
+				binding.onScreenControlsSwitch.isChecked = false
 		})
-		touchpadOnlySwitch.setOnCheckedChangeListener { _, isChecked ->
+		binding.touchpadOnlySwitch.setOnCheckedChangeListener { _, isChecked ->
 			viewModel.setTouchpadOnlyEnabled(isChecked)
 			showOverlay()
 		}
 
-		displayModeToggle.addOnButtonCheckedListener { _, checkedId, _ ->
-			// following 'if' is a workaround until selectionRequired for MaterialButtonToggleGroup
-			// comes out of alpha.
-			// See https://stackoverflow.com/questions/56164004/required-single-selection-on-materialbuttontogglegroup
-			if (displayModeToggle.checkedButtonId == -1)
-				displayModeToggle.check(checkedId)
-
-			adjustTextureViewAspect()
+		binding.displayModeToggle.addOnButtonCheckedListener { _, _, _ ->
+			adjustStreamViewAspect()
 			showOverlay()
 		}
 
-		viewModel.session.attachToTextureView(textureView)
+		//viewModel.session.attachToTextureView(textureView)
+		viewModel.session.attachToSurfaceView(binding.surfaceView)
 		viewModel.session.state.observe(this, Observer { this.stateChanged(it) })
-		textureView.addOnLayoutChangeListener { _, _, _, _, _, _, _, _, _ ->
-			adjustTextureViewAspect()
+		adjustStreamViewAspect()
+
+		if(Preferences(this).rumbleEnabled)
+		{
+			val vibrator = getSystemService(VIBRATOR_SERVICE) as Vibrator
+			viewModel.session.rumbleState.observe(this, Observer {
+				val amplitude = min(255, (it.left.toInt() + it.right.toInt()) / 2)
+				vibrator.cancel()
+				if(amplitude == 0)
+					return@Observer
+				if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.O)
+					vibrator.vibrate(VibrationEffect.createOneShot(1000, amplitude))
+				else
+					vibrator.vibrate(1000)
+			})
 		}
 	}
 
+	private val controlsDisposable = CompositeDisposable()
+
 	override fun onAttachFragment(fragment: Fragment)
 	{
 		super.onAttachFragment(fragment)
 		if(fragment is TouchControlsFragment)
 		{
-			fragment.controllerStateCallback = { viewModel.input.touchControllerState = it }
+			fragment.controllerState
+				.subscribe { viewModel.input.touchControllerState = it }
+				.addTo(controlsDisposable)
 			fragment.onScreenControlsEnabled = viewModel.onScreenControlsEnabled
-		}
-		if(fragment is TouchpadOnlyFragment)
-		{
-			fragment.controllerStateCallback = { viewModel.input.touchControllerState = it }
-			fragment.touchpadOnlyEnabled = viewModel.touchpadOnlyEnabled
+			if(fragment is TouchpadOnlyFragment)
+				fragment.touchpadOnlyEnabled = viewModel.touchpadOnlyEnabled
 		}
 	}
 
@@ -132,6 +145,12 @@ class StreamActivity : AppCompatActivity
 		viewModel.session.pause()
 	}
 
+	override fun onDestroy()
+	{
+		super.onDestroy()
+		controlsDisposable.dispose()
+	}
+
 	private fun reconnect()
 	{
 		viewModel.session.shutdown()
@@ -150,14 +169,14 @@ class StreamActivity : AppCompatActivity
 
 	private fun showOverlay()
 	{
-		overlay.isVisible = true
-		overlay.animate()
+		binding.overlay.isVisible = true
+		binding.overlay.animate()
 			.alpha(1.0f)
 			.setListener(object: AnimatorListenerAdapter()
 			{
 				override fun onAnimationEnd(animation: Animator?)
 				{
-					overlay.alpha = 1.0f
+					binding.overlay.alpha = 1.0f
 				}
 			})
 		uiVisibilityHandler.removeCallbacks(hideSystemUIRunnable)
@@ -166,13 +185,13 @@ class StreamActivity : AppCompatActivity
 
 	private fun hideOverlay()
 	{
-		overlay.animate()
+		binding.overlay.animate()
 			.alpha(0.0f)
 			.setListener(object: AnimatorListenerAdapter()
 			{
 				override fun onAnimationEnd(animation: Animator?)
 				{
-					overlay.isGone = true
+					binding.overlay.isGone = true
 				}
 			})
 	}
@@ -205,7 +224,7 @@ class StreamActivity : AppCompatActivity
 
 	private fun stateChanged(state: StreamState)
 	{
-		progressBar.visibility = if(state == StreamStateConnecting) View.VISIBLE else View.GONE
+		binding.progressBar.visibility = if(state == StreamStateConnecting) View.VISIBLE else View.GONE
 
 		when(state)
 		{
@@ -290,74 +309,84 @@ class StreamActivity : AppCompatActivity
 		}
 	}
 
-	private fun adjustTextureViewAspect()
+	private fun adjustTextureViewAspect(textureView: TextureView)
 	{
-		val displayInfo = DisplayInfo(viewModel.session.connectInfo.videoProfile, textureView)
-		val resolution = displayInfo.computeResolutionFor(displayModeToggle.checkedButtonId)
-
+		val trans = TextureViewTransform(viewModel.session.connectInfo.videoProfile, textureView)
+		val resolution = trans.resolutionFor(TransformMode.fromButton(binding.displayModeToggle.checkedButtonId))
 		Matrix().also {
 			textureView.getTransform(it)
-			it.setScale(resolution.width / displayInfo.viewWidth, resolution.height / displayInfo.viewHeight)
-			it.postTranslate((displayInfo.viewWidth - resolution.width) * 0.5f, (displayInfo.viewHeight - resolution.height) * 0.5f)
+			it.setScale(resolution.width / trans.viewWidth, resolution.height / trans.viewHeight)
+			it.postTranslate((trans.viewWidth - resolution.width) * 0.5f, (trans.viewHeight - resolution.height) * 0.5f)
 			textureView.setTransform(it)
 		}
 	}
 
+	private fun adjustSurfaceViewAspect()
+	{
+		val videoProfile = viewModel.session.connectInfo.videoProfile
+		binding.aspectRatioLayout.aspectRatio = videoProfile.width.toFloat() / videoProfile.height.toFloat()
+		binding.aspectRatioLayout.mode = TransformMode.fromButton(binding.displayModeToggle.checkedButtonId)
+	}
+
+	private fun adjustStreamViewAspect() = adjustSurfaceViewAspect()
+
 	override fun dispatchKeyEvent(event: KeyEvent) = viewModel.input.dispatchKeyEvent(event) || super.dispatchKeyEvent(event)
 	override fun onGenericMotionEvent(event: MotionEvent) = viewModel.input.onGenericMotionEvent(event) || super.onGenericMotionEvent(event)
-
 }
 
+enum class TransformMode
+{
+	FIT,
+	STRETCH,
+	ZOOM;
 
-class DisplayInfo constructor(val videoProfile: ConnectVideoProfile, val textureView: TextureView)
+	companion object
+	{
+		fun fromButton(displayModeButtonId: Int)
+			= when (displayModeButtonId)
+			{
+				R.id.display_mode_stretch_button -> STRETCH
+				R.id.display_mode_zoom_button -> ZOOM
+				else -> FIT
+			}
+	}
+}
+
+class TextureViewTransform(private val videoProfile: ConnectVideoProfile, private val textureView: TextureView)
 {
-	val contentWidth : Float get() = videoProfile.width.toFloat()
-	val contentHeight : Float get() = videoProfile.height.toFloat()
+	private val contentWidth : Float get() = videoProfile.width.toFloat()
+	private val contentHeight : Float get() = videoProfile.height.toFloat()
 	val viewWidth : Float get() = textureView.width.toFloat()
 	val viewHeight : Float get() = textureView.height.toFloat()
-	val contentAspect : Float get() =  contentHeight / contentWidth
+	private val contentAspect : Float get() =  contentHeight / contentWidth
 
-	fun computeResolutionFor(displayModeButtonId: Int) : Resolution
-	{
-		when (displayModeButtonId)
+	fun resolutionFor(mode: TransformMode): Resolution
+		= when(mode)
 		{
-			R.id.display_mode_stretch_button -> return computeStrechedResolution()
-			R.id.display_mode_zoom_button -> return computeZoomedResolution()
-			else -> return computeNormalResolution()
+			TransformMode.STRETCH -> strechedResolution
+			TransformMode.ZOOM -> zoomedResolution
+			TransformMode.FIT -> normalResolution
 		}
-	}
 
-	private fun computeStrechedResolution(): Resolution
-	{
-		return Resolution(viewWidth, viewHeight)
-	}
+	private val strechedResolution get() = Resolution(viewWidth, viewHeight)
 
-	private fun computeZoomedResolution(): Resolution
-	{
-		if (viewHeight > viewWidth * contentAspect)
+	private val zoomedResolution get() =
+		if(viewHeight > viewWidth * contentAspect)
 		{
 			val zoomFactor = viewHeight / contentHeight
-			return Resolution(contentWidth * zoomFactor, viewHeight)
+			Resolution(contentWidth * zoomFactor, viewHeight)
 		}
 		else
 		{
 			val zoomFactor = viewWidth / contentWidth
-			return Resolution(viewWidth, contentHeight * zoomFactor)
+			Resolution(viewWidth, contentHeight * zoomFactor)
 		}
-	}
 
-	private fun computeNormalResolution(): Resolution
-	{
-		if (viewHeight > viewWidth * contentAspect)
-		{
-			return Resolution(viewWidth, viewWidth * contentAspect)
-		}
+	private val normalResolution get() =
+		if(viewHeight > viewWidth * contentAspect)
+			Resolution(viewWidth, viewWidth * contentAspect)
 		else
-		{
-			return Resolution(viewHeight / contentAspect, viewHeight)
-		}
-	}
-
+			Resolution(viewHeight / contentAspect, viewHeight)
 }
 
 
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamViewModel.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamViewModel.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamViewModel.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/stream/StreamViewModel.kt	2021-01-15 21:35:50.000000000 +0000
@@ -2,19 +2,22 @@
 
 package com.metallic.chiaki.stream
 
-import androidx.lifecycle.LiveData
-import androidx.lifecycle.MutableLiveData
-import androidx.lifecycle.ViewModel
+import android.app.Application
+import android.content.Context
+import androidx.lifecycle.*
 import com.metallic.chiaki.common.LogManager
 import com.metallic.chiaki.session.StreamSession
 import com.metallic.chiaki.common.Preferences
 import com.metallic.chiaki.lib.*
 import com.metallic.chiaki.session.StreamInput
 
-class StreamViewModel(val preferences: Preferences, val logManager: LogManager, val connectInfo: ConnectInfo): ViewModel()
+class StreamViewModel(val application: Application, val connectInfo: ConnectInfo): ViewModel()
 {
+	val preferences = Preferences(application)
+	val logManager = LogManager(application)
+
 	private var _session: StreamSession? = null
-	val input = StreamInput(preferences)
+	val input = StreamInput(application, preferences)
 	val session = StreamSession(connectInfo, logManager, preferences.logVerbose, input)
 
 	private var _onScreenControlsEnabled = MutableLiveData<Boolean>(preferences.onScreenControlsEnabled)
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonHaptics.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonHaptics.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonHaptics.kt	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonHaptics.kt	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,29 @@
+package com.metallic.chiaki.touchcontrols
+
+import android.content.Context
+import android.os.Build
+import android.os.VibrationEffect
+import android.os.Vibrator
+import androidx.appcompat.app.AppCompatActivity
+import com.metallic.chiaki.common.Preferences
+
+class ButtonHaptics(val context: Context)
+{
+	private val enabled = Preferences(context).buttonHapticEnabled
+
+	fun trigger(harder: Boolean = false)
+	{
+		if(!enabled)
+			return
+		val vibrator = context.getSystemService(AppCompatActivity.VIBRATOR_SERVICE) as Vibrator
+		if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.O)
+			vibrator.vibrate(
+				if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q)
+					VibrationEffect.createPredefined(if(harder) VibrationEffect.EFFECT_CLICK else VibrationEffect.EFFECT_TICK)
+				else
+					VibrationEffect.createOneShot(10, if(harder) 200 else 100)
+			)
+		else
+			vibrator.vibrate(10)
+	}
+}
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonView.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonView.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonView.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/ButtonView.kt	2021-01-15 21:35:50.000000000 +0000
@@ -6,14 +6,19 @@ import android.content.Context
 import android.graphics.Canvas
 import android.graphics.drawable.Drawable
 import android.util.AttributeSet
+import android.util.Log
 import android.view.MotionEvent
 import android.view.View
+import android.view.ViewGroup
+import androidx.core.view.children
 import com.metallic.chiaki.R
 
 class ButtonView @JvmOverloads constructor(
 	context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0
 ) : View(context, attrs, defStyleAttr)
 {
+	private val haptics = ButtonHaptics(context)
+
 	var buttonPressed = false
 		private set(value)
 		{
@@ -21,6 +26,8 @@ class ButtonView @JvmOverloads construct
 			field = value
 			if(diff)
 			{
+				if(value)
+					haptics.trigger()
 				invalidate()
 				buttonPressedCallback?.let { it(field) }
 			}
@@ -46,16 +53,39 @@ class ButtonView @JvmOverloads construct
 	{
 		super.onDraw(canvas)
 		val drawable = if(buttonPressed) drawablePressed else drawableIdle
-		drawable?.setBounds(0, 0, width, height)
+		drawable?.setBounds(paddingLeft, paddingTop, width - paddingRight, height - paddingBottom)
 		drawable?.draw(canvas)
 	}
 
+	/**
+	 * If this button overlaps with others in the same layout,
+	 * let the one whose center is closest to the touch handle it.
+	 */
+	private fun bestFittingTouchView(x: Float, y: Float): View
+	{
+		val loc = locationOnScreen + Vector(x, y)
+		return (parent as? ViewGroup)?.children?.filter {
+			it is ButtonView
+		}?.filter {
+			val pos = it.locationOnScreen
+			loc.x >= pos.x && loc.x < pos.x + it.width && loc.y >= pos.y && loc.y < pos.y + it.height
+		}?.sortedBy {
+			(loc - (it.locationOnScreen + Vector(it.width.toFloat(), it.height.toFloat()) * 0.5f)).lengthSq
+		}?.firstOrNull() ?: this
+	}
+
 	override fun onTouchEvent(event: MotionEvent): Boolean
 	{
-		when(event.action)
+		when(event.actionMasked)
 		{
-			MotionEvent.ACTION_DOWN -> buttonPressed = true
-			MotionEvent.ACTION_UP -> buttonPressed = false
+			MotionEvent.ACTION_DOWN, MotionEvent.ACTION_POINTER_DOWN -> {
+				if(bestFittingTouchView(event.getX(event.actionIndex), event.getY(event.actionIndex)) != this)
+					return false
+				buttonPressed = true
+			}
+			MotionEvent.ACTION_UP, MotionEvent.ACTION_POINTER_UP -> {
+				buttonPressed = false
+			}
 		}
 		return true
 	}
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/DPadView.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/DPadView.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/DPadView.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/DPadView.kt	2021-01-15 21:35:50.000000000 +0000
@@ -16,6 +16,8 @@ class DPadView @JvmOverloads constructor
 	context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0
 ) : View(context, attrs, defStyleAttr)
 {
+	private val haptics = ButtonHaptics(context)
+
 	enum class Direction {
 		LEFT,
 		RIGHT,
@@ -71,7 +73,7 @@ class DPadView @JvmOverloads constructor
 		else
 			drawable = dpadIdleDrawable
 
-		drawable?.setBounds(0, 0, width, height)
+		drawable?.setBounds(paddingLeft, paddingTop, width - paddingRight, height - paddingBottom)
 		//drawable?.alpha = 127
 		drawable?.draw(canvas)
 	}
@@ -113,6 +115,8 @@ class DPadView @JvmOverloads constructor
 
 		if(state != newState)
 		{
+			if(newState != null)
+				haptics.trigger()
 			state = newState
 			invalidate()
 			stateChangeCallback?.let { it(state) }
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchControlsFragment.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchControlsFragment.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchControlsFragment.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchControlsFragment.kt	2021-01-15 21:35:50.000000000 +0000
@@ -3,74 +3,97 @@
 package com.metallic.chiaki.touchcontrols
 
 import android.os.Bundle
-import android.util.Log
 import android.view.LayoutInflater
 import android.view.View
 import android.view.ViewGroup
 import androidx.fragment.app.Fragment
 import androidx.lifecycle.LiveData
 import androidx.lifecycle.Observer
-import com.metallic.chiaki.R
+import com.metallic.chiaki.databinding.FragmentControlsBinding
 import com.metallic.chiaki.lib.ControllerState
-import kotlinx.android.synthetic.main.fragment_controls.*
+import io.reactivex.Observable
+import io.reactivex.rxkotlin.Observables.combineLatest
+import io.reactivex.subjects.BehaviorSubject
+import io.reactivex.subjects.Subject
 
-class TouchControlsFragment : Fragment()
+abstract class TouchControlsFragment : Fragment()
 {
-	private var controllerState = ControllerState()
-		private set(value)
+	protected var ownControllerState = ControllerState()
+		set(value)
 		{
 			val diff = field != value
 			field = value
 			if(diff)
-				controllerStateCallback?.let { it(value) }
+				ownControllerStateSubject.onNext(ownControllerState)
 		}
 
-	var controllerStateCallback: ((ControllerState) -> Unit)? = null
+	protected val ownControllerStateSubject: Subject<ControllerState>
+			= BehaviorSubject.create<ControllerState>().also { it.onNext(ownControllerState) }
+
+	// to delay attaching to the touchpadView until it's available
+	protected val controllerStateProxy: Subject<Observable<ControllerState>>
+			= BehaviorSubject.create<Observable<ControllerState>>().also { it.onNext(ownControllerStateSubject) }
+	val controllerState: Observable<ControllerState> get() =
+		controllerStateProxy.flatMap { it }
+
 	var onScreenControlsEnabled: LiveData<Boolean>? = null
+}
 
-	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View
-		= inflater.inflate(R.layout.fragment_controls, container, false)
+class DefaultTouchControlsFragment : TouchControlsFragment()
+{
+	private var _binding: FragmentControlsBinding? = null
+	private val binding get() = _binding!!
+
+	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View =
+		FragmentControlsBinding.inflate(inflater, container, false).let {
+			_binding = it
+			controllerStateProxy.onNext(
+				combineLatest(ownControllerStateSubject, binding.touchpadView.controllerState) { a, b -> a or b }
+			)
+			it.root
+		}
 
 	override fun onViewCreated(view: View, savedInstanceState: Bundle?)
 	{
 		super.onViewCreated(view, savedInstanceState)
-		dpadView.stateChangeCallback = this::dpadStateChanged
-		crossButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_CROSS)
-		moonButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_MOON)
-		pyramidButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_PYRAMID)
-		boxButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_BOX)
-		l1ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_L1)
-		r1ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_R1)
-		optionsButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_OPTIONS)
-		shareButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_SHARE)
-		psButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_PS)
-		touchpadButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_TOUCHPAD)
+		binding.dpadView.stateChangeCallback = this::dpadStateChanged
+		binding.crossButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_CROSS)
+		binding.moonButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_MOON)
+		binding.pyramidButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_PYRAMID)
+		binding.boxButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_BOX)
+		binding.l1ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_L1)
+		binding.r1ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_R1)
+		binding.l3ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_L3)
+		binding.r3ButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_R3)
+		binding.optionsButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_OPTIONS)
+		binding.shareButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_SHARE)
+		binding.psButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_PS)
 
-		l2ButtonView.buttonPressedCallback = { controllerState = controllerState.copy().apply { l2State = if(it) 255U else 0U } }
-		r2ButtonView.buttonPressedCallback = { controllerState = controllerState.copy().apply { r2State = if(it) 255U else 0U } }
+		binding.l2ButtonView.buttonPressedCallback = { ownControllerState = ownControllerState.copy().apply { l2State = if(it) 255U else 0U } }
+		binding.r2ButtonView.buttonPressedCallback = { ownControllerState = ownControllerState.copy().apply { r2State = if(it) 255U else 0U } }
 
 		val quantizeStick = { f: Float ->
-			(Short.MAX_VALUE * f).toShort()
+			(Short.MAX_VALUE * f).toInt().toShort()
 		}
 
-		leftAnalogStickView.stateChangedCallback = { controllerState = controllerState.copy().apply {
+		binding.leftAnalogStickView.stateChangedCallback = { ownControllerState = ownControllerState.copy().apply {
 			leftX = quantizeStick(it.x)
 			leftY = quantizeStick(it.y)
 		}}
 
-		rightAnalogStickView.stateChangedCallback = { controllerState = controllerState.copy().apply {
+		binding.rightAnalogStickView.stateChangedCallback = { ownControllerState = ownControllerState.copy().apply {
 			rightX = quantizeStick(it.x)
 			rightY = quantizeStick(it.y)
 		}}
 
-		onScreenControlsEnabled?.observe(this, Observer {
+		onScreenControlsEnabled?.observe(viewLifecycleOwner, Observer {
 			view.visibility = if(it) View.VISIBLE else View.GONE
 		})
 	}
 
 	private fun dpadStateChanged(direction: DPadView.Direction?)
 	{
-		controllerState = controllerState.copy().apply {
+		ownControllerState = ownControllerState.copy().apply {
 			buttons = ((buttons
 						and ControllerState.BUTTON_DPAD_LEFT.inv()
 						and ControllerState.BUTTON_DPAD_RIGHT.inv()
@@ -92,7 +115,7 @@ class TouchControlsFragment : Fragment()
 	}
 
 	private fun buttonStateChanged(buttonMask: UInt) = { pressed: Boolean ->
-		controllerState = controllerState.copy().apply {
+		ownControllerState = ownControllerState.copy().apply {
 			buttons =
 				if(pressed)
 					buttons or buttonMask
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadOnlyFragment.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadOnlyFragment.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadOnlyFragment.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadOnlyFragment.kt	2021-01-15 21:35:50.000000000 +0000
@@ -6,49 +6,42 @@ import android.os.Bundle
 import android.view.LayoutInflater
 import android.view.View
 import android.view.ViewGroup
-import androidx.fragment.app.Fragment
 import androidx.lifecycle.LiveData
 import androidx.lifecycle.Observer
-import com.metallic.chiaki.R
-import com.metallic.chiaki.lib.ControllerState
-import kotlinx.android.synthetic.main.fragment_controls.*
+import com.metallic.chiaki.databinding.FragmentTouchpadOnlyBinding
+import io.reactivex.rxkotlin.Observables.combineLatest
 
-class TouchpadOnlyFragment : Fragment()
+class TouchpadOnlyFragment : TouchControlsFragment()
 {
-	private var controllerState = ControllerState()
-		private set(value)
-		{
-			val diff = field != value
-			field = value
-			if(diff)
-				controllerStateCallback?.let { it(value) }
-		}
-
-	var controllerStateCallback: ((ControllerState) -> Unit)? = null
 	var touchpadOnlyEnabled: LiveData<Boolean>? = null
 
-	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View
-			= inflater.inflate(R.layout.fragment_touchpad_only, container, false)
+	private var _binding: FragmentTouchpadOnlyBinding? = null
+	private val binding get() = _binding!!
+
+	override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View =
+		FragmentTouchpadOnlyBinding.inflate(inflater, container, false).let {
+			_binding = it
+			controllerStateProxy.onNext(
+				combineLatest(ownControllerStateSubject, binding.touchpadView.controllerState) { a, b -> a or b }
+			)
+			it.root
+		}
 
 	override fun onViewCreated(view: View, savedInstanceState: Bundle?)
 	{
 		super.onViewCreated(view, savedInstanceState)
-
-		touchpadButtonView.buttonPressedCallback = buttonStateChanged(ControllerState.BUTTON_TOUCHPAD)
-
-		touchpadOnlyEnabled?.observe(this, Observer {
+		touchpadOnlyEnabled?.observe(viewLifecycleOwner, Observer {
 			view.visibility = if(it) View.VISIBLE else View.GONE
 		})
 	}
 
 	private fun buttonStateChanged(buttonMask: UInt) = { pressed: Boolean ->
-		controllerState = controllerState.copy().apply {
+		ownControllerState = ownControllerState.copy().apply {
 			buttons =
 				if(pressed)
 					buttons or buttonMask
 				else
 					buttons and buttonMask.inv()
-
 		}
 	}
 }
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadView.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadView.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadView.kt	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchpadView.kt	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,168 @@
+// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
+
+package com.metallic.chiaki.touchcontrols
+
+import android.content.Context
+import android.graphics.Canvas
+import android.graphics.drawable.Drawable
+import android.util.AttributeSet
+import android.view.MotionEvent
+import android.view.View
+import com.metallic.chiaki.R
+import com.metallic.chiaki.lib.ControllerState
+import io.reactivex.Observable
+import io.reactivex.subjects.BehaviorSubject
+import io.reactivex.subjects.Subject
+import kotlin.math.max
+
+class TouchpadView @JvmOverloads constructor(
+	context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0
+) : View(context, attrs, defStyleAttr)
+{
+	companion object
+	{
+		private const val BUTTON_PRESS_MAX_MOVE_DIST_DP = 32.0f
+		private const val SHORT_BUTTON_PRESS_DURATION_MS = 200L
+		private const val BUTTON_HOLD_DELAY_MS = 500L
+	}
+
+	private val haptics = ButtonHaptics(context)
+
+	private val drawableIdle: Drawable?
+	private val drawablePressed: Drawable?
+
+	private val state: ControllerState = ControllerState()
+
+	inner class Touch(
+		val stateId: UByte,
+		private val startX: Float,
+		private val startY: Float)
+	{
+		var lifted = false // will be true but touch still in list when only relevant for short touch
+		private var maxDist: Float = 0.0f
+		val moveInsignificant: Boolean get() = maxDist < BUTTON_PRESS_MAX_MOVE_DIST_DP
+
+		fun onMove(x: Float, y: Float)
+		{
+			val d = (Vector(x, y) - Vector(startX, startY)).length / resources.displayMetrics.density
+			maxDist = max(d, maxDist)
+		}
+
+		val startButtonHoldRunnable = Runnable {
+			if(!moveInsignificant || buttonHeld)
+				return@Runnable
+			haptics.trigger(true)
+			state.buttons = state.buttons or ControllerState.BUTTON_TOUCHPAD
+			buttonHeld = true
+			triggerStateChanged()
+		}
+	}
+	private val pointerTouches = mutableMapOf<Int, Touch>()
+
+	private val stateSubject: Subject<ControllerState>
+		= BehaviorSubject.create<ControllerState>().also { it.onNext(state) }
+	val controllerState: Observable<ControllerState> get() = stateSubject
+
+	private var shortPressingTouches = listOf<Touch>()
+	private val shortButtonPressLiftRunnable = Runnable {
+		state.buttons = state.buttons and ControllerState.BUTTON_TOUCHPAD.inv()
+		shortPressingTouches.forEach {
+			state.stopTouch(it.stateId)
+		}
+		shortPressingTouches = listOf()
+		triggerStateChanged()
+	}
+
+	private var buttonHeld = false
+
+	init
+	{
+		context.theme.obtainStyledAttributes(attrs, R.styleable.TouchpadView, 0, 0).apply {
+			drawableIdle = getDrawable(R.styleable.TouchpadView_drawableIdle)
+			drawablePressed = getDrawable(R.styleable.TouchpadView_drawablePressed)
+			recycle()
+		}
+		isClickable = true
+	}
+
+	override fun onDraw(canvas: Canvas)
+	{
+		super.onDraw(canvas)
+		if(pointerTouches.values.find { !it.lifted } == null)
+			return
+		val drawable = if(state.buttons and ControllerState.BUTTON_TOUCHPAD != 0U) drawablePressed else drawableIdle
+		drawable?.setBounds(paddingLeft, paddingTop, width - paddingRight, height - paddingBottom)
+		drawable?.draw(canvas)
+	}
+
+	private fun touchX(event: MotionEvent, index: Int): UShort =
+		maxOf(0U.toUShort(), minOf((ControllerState.TOUCHPAD_WIDTH - 1u).toUShort(),
+			(ControllerState.TOUCHPAD_WIDTH.toFloat() * event.getX(index) / width.toFloat()).toUInt().toUShort()))
+
+	private fun touchY(event: MotionEvent, index: Int): UShort =
+		maxOf(0U.toUShort(), minOf((ControllerState.TOUCHPAD_HEIGHT - 1u).toUShort(),
+			(ControllerState.TOUCHPAD_HEIGHT.toFloat() * event.getY(index) / height.toFloat()).toUInt().toUShort()))
+
+	override fun onTouchEvent(event: MotionEvent): Boolean
+	{
+		when(event.actionMasked)
+		{
+			MotionEvent.ACTION_DOWN, MotionEvent.ACTION_POINTER_DOWN -> {
+				state.startTouch(touchX(event, event.actionIndex), touchY(event, event.actionIndex))?.let {
+					haptics.trigger()
+					val touch = Touch(it, event.getX(event.actionIndex), event.getY(event.actionIndex))
+					pointerTouches[event.getPointerId(event.actionIndex)] = touch
+					if(!buttonHeld)
+						postDelayed(touch.startButtonHoldRunnable, BUTTON_HOLD_DELAY_MS)
+					triggerStateChanged()
+				}
+			}
+			MotionEvent.ACTION_UP, MotionEvent.ACTION_POINTER_UP -> {
+				pointerTouches.remove(event.getPointerId(event.actionIndex))?.let {
+					removeCallbacks(it.startButtonHoldRunnable)
+					when
+					{
+						buttonHeld ->
+						{
+							buttonHeld = false
+							state.buttons = state.buttons and ControllerState.BUTTON_TOUCHPAD.inv()
+							state.stopTouch(it.stateId)
+						}
+						it.moveInsignificant -> triggerShortButtonPress(it)
+						else -> state.stopTouch(it.stateId)
+					}
+					triggerStateChanged()
+				}
+			}
+			MotionEvent.ACTION_MOVE -> {
+				val changed = pointerTouches.entries.fold(false) { acc, it ->
+					val index = event.findPointerIndex(it.key)
+					if(index < 0)
+						acc
+					else
+					{
+						it.value.onMove(event.getX(event.actionIndex), event.getY(event.actionIndex))
+						acc || state.setTouchPos(it.value.stateId, touchX(event, index), touchY(event, index))
+					}
+				}
+				if(changed)
+					triggerStateChanged()
+			}
+		}
+		return true
+	}
+
+	private fun triggerShortButtonPress(touch: Touch)
+	{
+		shortPressingTouches = shortPressingTouches + listOf(touch)
+		removeCallbacks(shortButtonPressLiftRunnable)
+		state.buttons = state.buttons or ControllerState.BUTTON_TOUCHPAD
+		postDelayed(shortButtonPressLiftRunnable, SHORT_BUTTON_PRESS_DURATION_MS)
+	}
+
+	private fun triggerStateChanged()
+	{
+		invalidate()
+		stateSubject.onNext(state)
+	}
+}
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchTracker.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchTracker.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchTracker.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/TouchTracker.kt	2021-01-15 21:35:50.000000000 +0000
@@ -26,7 +26,7 @@ class TouchTracker
 				if(pointerId == null)
 				{
 					pointerId = event.getPointerId(event.actionIndex)
-					currentPosition = Vector(event.x, event.y)
+					currentPosition = Vector(event.getX(event.actionIndex), event.getY(event.actionIndex))
 				}
 			}
 
diff -pruN 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/Vector.kt 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/Vector.kt
--- 2.0.1-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/Vector.kt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/java/com/metallic/chiaki/touchcontrols/Vector.kt	2021-01-15 21:35:50.000000000 +0000
@@ -2,6 +2,7 @@
 
 package com.metallic.chiaki.touchcontrols
 
+import android.view.View
 import kotlin.math.sqrt
 
 data class Vector(val x: Float, val y: Float)
@@ -18,4 +19,10 @@ data class Vector(val x: Float, val y: F
 	val lengthSq get() = x*x + y*y
 	val length get() = sqrt(lengthSq)
 	val normalized get() = this / length
+}
+
+val View.locationOnScreen: Vector get() {
+	val v = intArrayOf(0, 0)
+	this.getLocationOnScreen(v)
+	return Vector(v[0].toFloat(), v[1].toFloat())
 }
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l1_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l1_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l1_pressed.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l1_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM21.7852,8.2563l2.3337,0L24.1189,23.6745L31.89,23.6745L31.89,25.8299L21.7852,25.8299ZM40.6771,8.2563l2.3342,0L43.0113,25.8299l-2.3342,0L40.6771,11.5512l-3.1853,3.1853 -1.6474,-1.6474z"
+      android:pathData="M39.2255,0 L0,39.2255 20.3838,59.6093a27.7366,27.7366 88.4859,0 0,39.2255 0,27.7366 27.7366,88.4859 0,0 0,-39.2255zM25.4129,29.4287l2.7735,0l0,18.1643l9.9818,0l0,2.3342L25.4129,49.9272ZM46.3098,29.4287l2.7735,0l0,18.1643l4.5305,0l0,2.3342l-11.8076,0l0,-2.3342l4.531,0l0,-15.6383l-4.9289,0.9886l0,-2.5259z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_pressed"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l1.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l1.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l1.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l1.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM21.7852,8.2563l2.3337,0L24.1189,23.6745L31.89,23.6745L31.89,25.8299L21.7852,25.8299ZM40.6771,8.2563l2.3342,0L43.0113,25.8299l-2.3342,0L40.6771,11.5512l-3.1853,3.1853 -1.6474,-1.6474z"
+      android:pathData="M39.2255,0 L0,39.2255 20.3838,59.6093a27.7366,27.7366 88.4859,0 0,39.2255 0,27.7366 27.7366,88.4859 0,0 0,-39.2255zM25.4129,29.4287l2.7735,0l0,18.1643l9.9818,0l0,2.3342L25.4129,49.9272ZM46.3098,29.4287l2.7735,0l0,18.1643l4.5305,0l0,2.3342l-11.8076,0l0,-2.3342l4.531,0l0,-15.6383l-4.9289,0.9886l0,-2.5259z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_primary"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l2_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l2_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l2_pressed.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l2_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM40.6771,8.0367c1.556,0 2.7872,0.3659 3.6933,1.0981 0.9062,0.7322 1.3591,1.7348 1.3591,3.0071 0,0.4027 -0.0139,0.7136 -0.0413,0.9333 -0.0183,0.2105 -0.0867,0.4989 -0.2057,0.8651 -0.1098,0.357 -0.3021,0.7506 -0.5767,1.1808 -0.2746,0.421 -0.6453,0.9242 -1.1121,1.51l-5.6291,7.0435l7.7845,0L45.9491,25.8299l-10.5441,0l0,-2.1554l6.6999,-8.3886c0.4119,-0.5126 0.7142,-0.9612 0.9064,-1.3457 0.1922,-0.3936 0.3017,-0.6911 0.3292,-0.8925 0.0366,-0.2105 0.0548,-0.5123 0.0548,-0.9059 0,-0.6041 -0.2425,-1.0805 -0.7276,-1.4283 -0.4851,-0.3478 -1.1485,-0.5214 -1.9906,-0.5214 -0.8421,0 -1.506,0.1736 -1.9911,0.5214 -0.4851,0.3478 -0.7276,0.8242 -0.7276,1.4283l-2.3337,-0.371c0,-1.1533 0.4529,-2.064 1.3591,-2.7321 0.9062,-0.6682 2.1373,-1.002 3.6933,-1.002zM21.7852,8.2563l2.3337,0L24.1189,23.6745L31.89,23.6745L31.89,25.8299L21.7852,25.8299Z"
+      android:pathData="m27.6526,0a27.7366,27.7366 88.4859,0 0,-19.5285 8.1241,27.7366 27.7366,88.4859 0,0 0,39.2255L28.5078,67.7333 67.7333,28.5078 47.3496,8.1241A27.7366,27.7366 88.4859,0 0,27.6526 0ZM34.9017,15.1846c2.1235,0 3.8172,0.5309 5.0803,1.5927 1.2631,1.0618 1.8945,2.4804 1.8945,4.2561 0,0.8421 -0.1602,1.6432 -0.4806,2.403 -0.3112,0.7506 -0.8832,1.6383 -1.7162,2.6634 -0.2288,0.2654 -0.9563,1.034 -2.1828,2.3063 -1.2265,1.2631 -2.9565,3.0342 -5.1899,5.3134l9.6795,0l0,2.3342l-13.0157,0l0,-2.3342c1.0526,-1.0892 2.4851,-2.549 4.2974,-4.3796 1.8215,-1.8398 2.9655,-3.025 3.4323,-3.5559 0.8879,-0.9977 1.5058,-1.84 1.8536,-2.5265 0.357,-0.6956 0.5354,-1.3777 0.5354,-2.0459 0,-1.0892 -0.3846,-1.9769 -1.1534,-2.6634 -0.7597,-0.6865 -1.7526,-1.0299 -2.9791,-1.0299 -0.8695,-0 -1.7898,0.1511 -2.76,0.4532 -0.9611,0.3021 -1.9908,0.7598 -3.0892,1.373L29.1078,16.5437c1.1167,-0.4485 2.1603,-0.7871 3.1306,-1.016 0.9702,-0.2288 1.8579,-0.3431 2.6634,-0.3431zM14.0053,15.5551l2.7735,0l0,18.1643l9.9813,0l0,2.3342L14.0053,36.0536Z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_pressed"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l2.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l2.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l2.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l2.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM40.6771,8.0367c1.556,0 2.7872,0.3659 3.6933,1.0981 0.9062,0.7322 1.3591,1.7348 1.3591,3.0071 0,0.4027 -0.0139,0.7136 -0.0413,0.9333 -0.0183,0.2105 -0.0867,0.4989 -0.2057,0.8651 -0.1098,0.357 -0.3021,0.7506 -0.5767,1.1808 -0.2746,0.421 -0.6453,0.9242 -1.1121,1.51l-5.6291,7.0435l7.7845,0L45.9491,25.8299l-10.5441,0l0,-2.1554l6.6999,-8.3886c0.4119,-0.5126 0.7142,-0.9612 0.9064,-1.3457 0.1922,-0.3936 0.3017,-0.6911 0.3292,-0.8925 0.0366,-0.2105 0.0548,-0.5123 0.0548,-0.9059 0,-0.6041 -0.2425,-1.0805 -0.7276,-1.4283 -0.4851,-0.3478 -1.1485,-0.5214 -1.9906,-0.5214 -0.8421,0 -1.506,0.1736 -1.9911,0.5214 -0.4851,0.3478 -0.7276,0.8242 -0.7276,1.4283l-2.3337,-0.371c0,-1.1533 0.4529,-2.064 1.3591,-2.7321 0.9062,-0.6682 2.1373,-1.002 3.6933,-1.002zM21.7852,8.2563l2.3337,0L24.1189,23.6745L31.89,23.6745L31.89,25.8299L21.7852,25.8299Z"
+      android:pathData="m27.6526,0a27.7366,27.7366 88.4859,0 0,-19.5285 8.1241,27.7366 27.7366,88.4859 0,0 0,39.2255L28.5078,67.7333 67.7333,28.5078 47.3496,8.1241A27.7366,27.7366 88.4859,0 0,27.6526 0ZM34.9017,15.1846c2.1235,0 3.8172,0.5309 5.0803,1.5927 1.2631,1.0618 1.8945,2.4804 1.8945,4.2561 0,0.8421 -0.1602,1.6432 -0.4806,2.403 -0.3112,0.7506 -0.8832,1.6383 -1.7162,2.6634 -0.2288,0.2654 -0.9563,1.034 -2.1828,2.3063 -1.2265,1.2631 -2.9565,3.0342 -5.1899,5.3134l9.6795,0l0,2.3342l-13.0157,0l0,-2.3342c1.0526,-1.0892 2.4851,-2.549 4.2974,-4.3796 1.8215,-1.8398 2.9655,-3.025 3.4323,-3.5559 0.8879,-0.9977 1.5058,-1.84 1.8536,-2.5265 0.357,-0.6956 0.5354,-1.3777 0.5354,-2.0459 0,-1.0892 -0.3846,-1.9769 -1.1534,-2.6634 -0.7597,-0.6865 -1.7526,-1.0299 -2.9791,-1.0299 -0.8695,-0 -1.7898,0.1511 -2.76,0.4532 -0.9611,0.3021 -1.9908,0.7598 -3.0892,1.373L29.1078,16.5437c1.1167,-0.4485 2.1603,-0.7871 3.1306,-1.016 0.9702,-0.2288 1.8579,-0.3431 2.6634,-0.3431zM14.0053,15.5551l2.7735,0l0,18.1643l9.9813,0l0,2.3342L14.0053,36.0536Z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_primary"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l3_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l3_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l3_pressed.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l3_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="256dp"
+    android:height="256dp"
+    android:viewportWidth="67.73333"
+    android:viewportHeight="67.73334">
+  <path
+      android:pathData="M0,0 L-41.939,102.093 67.7333,67.7333C67.7333,30.3253 37.4081,0 0,0ZM33.6093,31.3252c2.1052,0 3.7711,0.4807 4.9976,1.4418 1.2265,0.9519 1.8397,2.2423 1.8397,3.8716 0,1.135 -0.3253,2.0964 -0.9751,2.8835 -0.6499,0.778 -1.5739,1.318 -2.773,1.6201 1.3272,0.2837 2.3613,0.8739 3.1027,1.771 0.7506,0.897 1.126,2.0047 1.126,3.3228 0,2.0228 -0.6959,3.5878 -2.0872,4.6953 -1.3913,1.1075 -3.368,1.6614 -5.9309,1.6614 -0.8604,0 -1.7486,-0.0871 -2.6639,-0.261 -0.9062,-0.1648 -1.8441,-0.4163 -2.8143,-0.755l0,-2.6774c0.7689,0.4485 1.6106,0.7871 2.5259,1.016 0.9153,0.2288 1.8719,0.3431 2.8696,0.3431 1.7391,0 3.0621,-0.3434 3.9682,-1.0299 0.9153,-0.6865 1.3725,-1.6837 1.3725,-2.9926 0,-1.2082 -0.4252,-2.1514 -1.2764,-2.8288 -0.8421,-0.6865 -2.0187,-1.0294 -3.529,-1.0294l-2.3885,0l0,-2.2794l2.4986,0c1.3638,0 2.4075,-0.2697 3.1306,-0.8098 0.7231,-0.5492 1.0847,-1.3365 1.0847,-2.3616 0,-1.0526 -0.3755,-1.858 -1.126,-2.4164 -0.7414,-0.5675 -1.808,-0.8511 -3.1993,-0.8511 -0.7597,0 -1.5742,0.0823 -2.4438,0.247 -0.8695,0.1648 -1.8261,0.4211 -2.8696,0.7689l0,-2.4717c1.0526,-0.2929 2.037,-0.5124 2.9523,-0.6589 0.9245,-0.1464 1.794,-0.2196 2.6086,-0.2196zM12.3832,31.6957l2.7735,0l0,18.1648l9.9813,0l0,2.3337L12.3832,52.1942Z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="11.0688"
+      android:fillColor="@color/control_pressed"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_l3.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_l3.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_l3.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_l3.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="256dp"
+    android:height="256dp"
+    android:viewportWidth="67.73333"
+    android:viewportHeight="67.73334">
+  <path
+      android:pathData="M0,0 L-41.939,102.093 67.7333,67.7333C67.7333,30.3253 37.4081,0 0,0ZM33.6093,31.3252c2.1052,0 3.7711,0.4807 4.9976,1.4418 1.2265,0.9519 1.8397,2.2423 1.8397,3.8716 0,1.135 -0.3253,2.0964 -0.9751,2.8835 -0.6499,0.778 -1.5739,1.318 -2.773,1.6201 1.3272,0.2837 2.3613,0.8739 3.1027,1.771 0.7506,0.897 1.126,2.0047 1.126,3.3228 0,2.0228 -0.6959,3.5878 -2.0872,4.6953 -1.3913,1.1075 -3.368,1.6614 -5.9309,1.6614 -0.8604,0 -1.7486,-0.0871 -2.6639,-0.261 -0.9062,-0.1648 -1.8441,-0.4163 -2.8143,-0.755l0,-2.6774c0.7689,0.4485 1.6106,0.7871 2.5259,1.016 0.9153,0.2288 1.8719,0.3431 2.8696,0.3431 1.7391,0 3.0621,-0.3434 3.9682,-1.0299 0.9153,-0.6865 1.3725,-1.6837 1.3725,-2.9926 0,-1.2082 -0.4252,-2.1514 -1.2764,-2.8288 -0.8421,-0.6865 -2.0187,-1.0294 -3.529,-1.0294l-2.3885,0l0,-2.2794l2.4986,0c1.3638,0 2.4075,-0.2697 3.1306,-0.8098 0.7231,-0.5492 1.0847,-1.3365 1.0847,-2.3616 0,-1.0526 -0.3755,-1.858 -1.126,-2.4164 -0.7414,-0.5675 -1.808,-0.8511 -3.1993,-0.8511 -0.7597,0 -1.5742,0.0823 -2.4438,0.247 -0.8695,0.1648 -1.8261,0.4211 -2.8696,0.7689l0,-2.4717c1.0526,-0.2929 2.037,-0.5124 2.9523,-0.6589 0.9245,-0.1464 1.794,-0.2196 2.6086,-0.2196zM12.3832,31.6957l2.7735,0l0,18.1648l9.9813,0l0,2.3337L12.3832,52.1942Z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="11.0688"
+      android:fillColor="@color/control_primary"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r1_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r1_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r1_pressed.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r1_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM21.3455,8.2563L27.4417,8.2563c1.5286,0 2.6865,0.352 3.4737,1.0568 0.7963,0.7048 1.1942,1.8814 1.1942,3.529 -0,2.2517 -1.034,3.6703 -3.1027,4.2561L32.7685,25.8299L30.2286,25.8299L26.618,17.4413L23.6797,17.4413L23.6797,25.8299l-2.3342,0zM40.6771,8.2563l2.3342,0L43.0113,25.8299l-2.3342,0L40.6771,11.5512l-3.1853,3.1853 -1.6474,-1.6474zM23.6797,10.4118l0,4.8741l2.3342,0c1.2265,0 2.1601,-0.188 2.8009,-0.5633 0.6407,-0.3753 0.9607,-1.0018 0.9607,-1.8805 0,-0.8695 -0.2014,-1.4923 -0.6041,-1.8676 -0.3936,-0.3753 -0.9699,-0.5628 -1.7296,-0.5628z"
+      android:pathData="M28.5078,0 L8.1241,20.3838a27.7366,27.7366 88.4859,0 0,0 39.2255,27.7366 27.7366,88.4859 0,0 39.2255,0L67.7333,39.2255ZM12.4178,29.4287l6.2606,0c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7301,2.4573 1.7301,4.4344 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.442 -2.6086,1.7715 0.595,0.2014 1.1713,0.6313 1.7296,1.2904 0.5675,0.659 1.1352,1.5654 1.7027,2.7187L28.3853,49.9272L25.4062,49.9272l-2.6226,-5.2586C22.1063,43.2956 21.4472,42.385 20.8065,41.9365c-0.6316,-0.4485 -1.4963,-0.6728 -2.5947,-0.6728L15.1913,41.2636l0,8.6636L12.4178,49.9272ZM37.1864,29.4287l2.7735,0l0,18.1643l4.5305,0l0,2.3342l-11.8075,0l0,-2.3342l4.531,0l0,-15.6383l-4.9289,0.9886l0,-2.5259zM15.1913,31.7076l0,7.2766l3.4871,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0299,-1.5331 1.0299,-2.7321 0,-1.1991 -0.3434,-2.1006 -1.0299,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_pressed"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r1.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r1.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r1.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r1.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM21.3455,8.2563L27.4417,8.2563c1.5286,0 2.6865,0.352 3.4737,1.0568 0.7963,0.7048 1.1942,1.8814 1.1942,3.529 -0,2.2517 -1.034,3.6703 -3.1027,4.2561L32.7685,25.8299L30.2286,25.8299L26.618,17.4413L23.6797,17.4413L23.6797,25.8299l-2.3342,0zM40.6771,8.2563l2.3342,0L43.0113,25.8299l-2.3342,0L40.6771,11.5512l-3.1853,3.1853 -1.6474,-1.6474zM23.6797,10.4118l0,4.8741l2.3342,0c1.2265,0 2.1601,-0.188 2.8009,-0.5633 0.6407,-0.3753 0.9607,-1.0018 0.9607,-1.8805 0,-0.8695 -0.2014,-1.4923 -0.6041,-1.8676 -0.3936,-0.3753 -0.9699,-0.5628 -1.7296,-0.5628z"
+      android:pathData="M28.5078,0 L8.1241,20.3838a27.7366,27.7366 88.4859,0 0,0 39.2255,27.7366 27.7366,88.4859 0,0 39.2255,0L67.7333,39.2255ZM12.4178,29.4287l6.2606,0c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7301,2.4573 1.7301,4.4344 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.442 -2.6086,1.7715 0.595,0.2014 1.1713,0.6313 1.7296,1.2904 0.5675,0.659 1.1352,1.5654 1.7027,2.7187L28.3853,49.9272L25.4062,49.9272l-2.6226,-5.2586C22.1063,43.2956 21.4472,42.385 20.8065,41.9365c-0.6316,-0.4485 -1.4963,-0.6728 -2.5947,-0.6728L15.1913,41.2636l0,8.6636L12.4178,49.9272ZM37.1864,29.4287l2.7735,0l0,18.1643l4.5305,0l0,2.3342l-11.8075,0l0,-2.3342l4.531,0l0,-15.6383l-4.9289,0.9886l0,-2.5259zM15.1913,31.7076l0,7.2766l3.4871,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0299,-1.5331 1.0299,-2.7321 0,-1.1991 -0.3434,-2.1006 -1.0299,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_primary"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r2_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r2_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r2_pressed.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r2_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM40.6771,8.0367c1.556,0 2.7872,0.3659 3.6933,1.0981 0.9062,0.7322 1.3591,1.7348 1.3591,3.0071 0,0.4027 -0.0139,0.7136 -0.0413,0.9333 -0.0183,0.2105 -0.0867,0.4989 -0.2057,0.8651 -0.1098,0.357 -0.3021,0.7506 -0.5767,1.1808 -0.2746,0.421 -0.6453,0.9242 -1.1121,1.51l-5.6291,7.0435l7.7845,0L45.9491,25.8299l-10.5441,0l0,-2.1554l6.6999,-8.3886c0.4119,-0.5126 0.7142,-0.9612 0.9064,-1.3457 0.1922,-0.3936 0.3017,-0.6911 0.3292,-0.8925 0.0366,-0.2105 0.0548,-0.5123 0.0548,-0.9059 0,-0.6041 -0.2425,-1.0805 -0.7276,-1.4283 -0.4851,-0.3478 -1.1485,-0.5214 -1.9906,-0.5214 -0.8421,0 -1.506,0.1736 -1.9911,0.5214 -0.4851,0.3478 -0.7276,0.8242 -0.7276,1.4283l-2.3337,-0.371c0,-1.1533 0.4529,-2.064 1.3591,-2.7321C37.8899,8.3705 39.1211,8.0367 40.6771,8.0367ZM21.3455,8.2563L27.4417,8.2563c1.5286,0 2.6865,0.352 3.4737,1.0568 0.7963,0.7048 1.1942,1.8814 1.1942,3.529 -0,2.2517 -1.034,3.6703 -3.1027,4.2561L32.7685,25.8299L30.2286,25.8299L26.618,17.4413L23.6797,17.4413L23.6797,25.8299l-2.3342,0zM23.6797,10.4118l0,4.8741l2.3342,0c1.2265,0 2.1601,-0.188 2.8009,-0.5633 0.6407,-0.3753 0.9607,-1.0018 0.9607,-1.8805 0,-0.8695 -0.2014,-1.4923 -0.6041,-1.8676 -0.3936,-0.3753 -0.9699,-0.5628 -1.7296,-0.5628z"
+      android:pathData="M20.3838,8.1241 L0,28.5078 39.2255,67.7333 59.6093,47.3496a27.7366,27.7366 88.4859,0 0,0 -39.2255,27.7366 27.7366,88.4859 0,0 -39.2255,0zM48.9278,15.1846c2.1235,0 3.8167,0.5309 5.0798,1.5927 1.2631,1.0618 1.895,2.4804 1.895,4.2561 0,0.8421 -0.1602,1.6432 -0.4806,2.403 -0.3112,0.7506 -0.8832,1.6383 -1.7162,2.6634 -0.2288,0.2654 -0.9568,1.034 -2.1833,2.3063 -1.2265,1.2631 -2.956,3.0342 -5.1893,5.3134l9.679,0l0,2.3342l-13.0157,0l0,-2.3342c1.0526,-1.0892 2.4851,-2.549 4.2974,-4.3796 1.8215,-1.8398 2.9655,-3.025 3.4323,-3.5559 0.8879,-0.9977 1.5058,-1.84 1.8536,-2.5265 0.357,-0.6956 0.5354,-1.3777 0.5354,-2.0459 0,-1.0892 -0.384,-1.9769 -1.1529,-2.6634 -0.7597,-0.6865 -1.7531,-1.0299 -2.9797,-1.0299 -0.8695,-0 -1.7893,0.1511 -2.7595,0.4532 -0.9611,0.3021 -1.9908,0.7598 -3.0892,1.373L43.1338,16.5437c1.1167,-0.4485 2.1603,-0.7871 3.1306,-1.016 0.9702,-0.2288 1.8579,-0.3431 2.6634,-0.3431zM24.1593,15.5551l6.2611,0c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7296,2.4578 1.7296,4.4349 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.4414 -2.6086,1.771 0.595,0.2014 1.1713,0.6313 1.7296,1.2904 0.5675,0.659 1.1352,1.5654 1.7027,2.7187l2.8148,5.6017l-2.9797,0l-2.6221,-5.2586c-0.6773,-1.373 -1.3364,-2.2836 -1.9771,-2.7321 -0.6316,-0.4485 -1.4968,-0.6728 -2.5952,-0.6728l-3.0205,0l0,8.6636L24.1593,36.0536ZM26.9327,17.8346l0,7.2766l3.4876,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0294,-1.5331 1.0294,-2.7321 0,-1.1991 -0.3429,-2.1006 -1.0294,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_pressed"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r2.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r2.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r2.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r2.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,13 +1,12 @@
 <vector xmlns:android="http://schemas.android.com/apk/res/android"
     android:width="256dp"
-    android:height="128dp"
+    android:height="256dp"
     android:viewportWidth="67.73333"
-    android:viewportHeight="33.86667">
+    android:viewportHeight="67.73334">
   <path
-      android:pathData="M0,0L0,33.8667L67.7333,33.8667L67.7333,0ZM40.6771,8.0367c1.556,0 2.7872,0.3659 3.6933,1.0981 0.9062,0.7322 1.3591,1.7348 1.3591,3.0071 0,0.4027 -0.0139,0.7136 -0.0413,0.9333 -0.0183,0.2105 -0.0867,0.4989 -0.2057,0.8651 -0.1098,0.357 -0.3021,0.7506 -0.5767,1.1808 -0.2746,0.421 -0.6453,0.9242 -1.1121,1.51l-5.6291,7.0435l7.7845,0L45.9491,25.8299l-10.5441,0l0,-2.1554l6.6999,-8.3886c0.4119,-0.5126 0.7142,-0.9612 0.9064,-1.3457 0.1922,-0.3936 0.3017,-0.6911 0.3292,-0.8925 0.0366,-0.2105 0.0548,-0.5123 0.0548,-0.9059 0,-0.6041 -0.2425,-1.0805 -0.7276,-1.4283 -0.4851,-0.3478 -1.1485,-0.5214 -1.9906,-0.5214 -0.8421,0 -1.506,0.1736 -1.9911,0.5214 -0.4851,0.3478 -0.7276,0.8242 -0.7276,1.4283l-2.3337,-0.371c0,-1.1533 0.4529,-2.064 1.3591,-2.7321C37.8899,8.3705 39.1211,8.0367 40.6771,8.0367ZM21.3455,8.2563L27.4417,8.2563c1.5286,0 2.6865,0.352 3.4737,1.0568 0.7963,0.7048 1.1942,1.8814 1.1942,3.529 -0,2.2517 -1.034,3.6703 -3.1027,4.2561L32.7685,25.8299L30.2286,25.8299L26.618,17.4413L23.6797,17.4413L23.6797,25.8299l-2.3342,0zM23.6797,10.4118l0,4.8741l2.3342,0c1.2265,0 2.1601,-0.188 2.8009,-0.5633 0.6407,-0.3753 0.9607,-1.0018 0.9607,-1.8805 0,-0.8695 -0.2014,-1.4923 -0.6041,-1.8676 -0.3936,-0.3753 -0.9699,-0.5628 -1.7296,-0.5628z"
+      android:pathData="M20.3838,8.1241 L0,28.5078 39.2255,67.7333 59.6093,47.3496a27.7366,27.7366 88.4859,0 0,0 -39.2255,27.7366 27.7366,88.4859 0,0 -39.2255,0zM48.9278,15.1846c2.1235,0 3.8167,0.5309 5.0798,1.5927 1.2631,1.0618 1.895,2.4804 1.895,4.2561 0,0.8421 -0.1602,1.6432 -0.4806,2.403 -0.3112,0.7506 -0.8832,1.6383 -1.7162,2.6634 -0.2288,0.2654 -0.9568,1.034 -2.1833,2.3063 -1.2265,1.2631 -2.956,3.0342 -5.1893,5.3134l9.679,0l0,2.3342l-13.0157,0l0,-2.3342c1.0526,-1.0892 2.4851,-2.549 4.2974,-4.3796 1.8215,-1.8398 2.9655,-3.025 3.4323,-3.5559 0.8879,-0.9977 1.5058,-1.84 1.8536,-2.5265 0.357,-0.6956 0.5354,-1.3777 0.5354,-2.0459 0,-1.0892 -0.384,-1.9769 -1.1529,-2.6634 -0.7597,-0.6865 -1.7531,-1.0299 -2.9797,-1.0299 -0.8695,-0 -1.7893,0.1511 -2.7595,0.4532 -0.9611,0.3021 -1.9908,0.7598 -3.0892,1.373L43.1338,16.5437c1.1167,-0.4485 2.1603,-0.7871 3.1306,-1.016 0.9702,-0.2288 1.8579,-0.3431 2.6634,-0.3431zM24.1593,15.5551l6.2611,0c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7296,2.4578 1.7296,4.4349 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.4414 -2.6086,1.771 0.595,0.2014 1.1713,0.6313 1.7296,1.2904 0.5675,0.659 1.1352,1.5654 1.7027,2.7187l2.8148,5.6017l-2.9797,0l-2.6221,-5.2586c-0.6773,-1.373 -1.3364,-2.2836 -1.9771,-2.7321 -0.6316,-0.4485 -1.4968,-0.6728 -2.5952,-0.6728l-3.0205,0l0,8.6636L24.1593,36.0536ZM26.9327,17.8346l0,7.2766l3.4876,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0294,-1.5331 1.0294,-2.7321 0,-1.1991 -0.3429,-2.1006 -1.0294,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
       android:strokeLineJoin="round"
-      android:strokeWidth="23.7399"
+      android:strokeWidth="5.54109"
       android:fillColor="@color/control_primary"
-      android:strokeColor="#00000000"
       android:strokeLineCap="round"/>
 </vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r3_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r3_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r3_pressed.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r3_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="256dp"
+    android:height="256dp"
+    android:viewportWidth="67.73333"
+    android:viewportHeight="67.73334">
+  <path
+      android:pathData="M67.7333,0C30.3252,0 0,30.3252 0,67.7333l109.6724,34.3597zM50.2982,31.3252c2.1052,0 3.7711,0.4807 4.9976,1.4418 1.2265,0.9519 1.8402,2.2423 1.8402,3.8716 0,1.135 -0.3253,2.0964 -0.9751,2.8835 -0.6499,0.778 -1.5744,1.318 -2.7735,1.6201 1.3272,0.2837 2.3618,0.8739 3.1032,1.771 0.7506,0.897 1.1255,2.0047 1.1255,3.3228 0,2.0228 -0.6954,3.5878 -2.0867,4.6953 -1.3913,1.1075 -3.3685,1.6614 -5.9314,1.6614 -0.8604,0 -1.7481,-0.0871 -2.6634,-0.261 -0.9062,-0.1648 -1.8441,-0.4163 -2.8143,-0.755l0,-2.6774c0.7689,0.4485 1.6106,0.7871 2.5259,1.016 0.9153,0.2288 1.8719,0.3431 2.8696,0.3431 1.7391,0 3.0616,-0.3434 3.9677,-1.0299 0.9153,-0.6865 1.373,-1.6837 1.373,-2.9926 0,-1.2082 -0.4257,-2.1514 -1.2769,-2.8288 -0.8421,-0.6865 -2.0182,-1.0294 -3.5285,-1.0294l-2.389,0l0,-2.2794l2.4991,0c1.3638,0 2.4069,-0.2697 3.13,-0.8098 0.7231,-0.5492 1.0847,-1.3365 1.0847,-2.3616 0,-1.0526 -0.375,-1.858 -1.1255,-2.4164 -0.7414,-0.5675 -1.808,-0.8511 -3.1993,-0.8511 -0.7597,0 -1.5742,0.0823 -2.4438,0.247 -0.8695,0.1648 -1.8261,0.4211 -2.8696,0.7689l0,-2.4717c1.0526,-0.2929 2.0364,-0.5124 2.9518,-0.6589 0.9245,-0.1464 1.794,-0.2196 2.6086,-0.2196zM25.2005,31.6957L31.4611,31.6957c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7301,2.4578 1.7301,4.4349 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.4414 -2.6086,1.771 0.595,0.2014 1.1713,0.6319 1.7296,1.2909 0.5675,0.659 1.1352,1.5649 1.7027,2.7182l2.8143,5.6017l-2.9791,0l-2.6226,-5.2581c-0.6773,-1.373 -1.3364,-2.2841 -1.9771,-2.7326 -0.6316,-0.4485 -1.4963,-0.6723 -2.5947,-0.6723l-3.0205,0l0,8.663L25.2005,52.1942ZM27.974,33.9752l0,7.2766l3.4871,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0299,-1.5331 1.0299,-2.7321 0,-1.1991 -0.3434,-2.1006 -1.0299,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="11.0688"
+      android:fillColor="@color/control_pressed"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_r3.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_r3.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_r3.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_r3.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="256dp"
+    android:height="256dp"
+    android:viewportWidth="67.73333"
+    android:viewportHeight="67.73334">
+  <path
+      android:pathData="M67.7333,0C30.3252,0 0,30.3252 0,67.7333l109.6724,34.3597zM50.2982,31.3252c2.1052,0 3.7711,0.4807 4.9976,1.4418 1.2265,0.9519 1.8402,2.2423 1.8402,3.8716 0,1.135 -0.3253,2.0964 -0.9751,2.8835 -0.6499,0.778 -1.5744,1.318 -2.7735,1.6201 1.3272,0.2837 2.3618,0.8739 3.1032,1.771 0.7506,0.897 1.1255,2.0047 1.1255,3.3228 0,2.0228 -0.6954,3.5878 -2.0867,4.6953 -1.3913,1.1075 -3.3685,1.6614 -5.9314,1.6614 -0.8604,0 -1.7481,-0.0871 -2.6634,-0.261 -0.9062,-0.1648 -1.8441,-0.4163 -2.8143,-0.755l0,-2.6774c0.7689,0.4485 1.6106,0.7871 2.5259,1.016 0.9153,0.2288 1.8719,0.3431 2.8696,0.3431 1.7391,0 3.0616,-0.3434 3.9677,-1.0299 0.9153,-0.6865 1.373,-1.6837 1.373,-2.9926 0,-1.2082 -0.4257,-2.1514 -1.2769,-2.8288 -0.8421,-0.6865 -2.0182,-1.0294 -3.5285,-1.0294l-2.389,0l0,-2.2794l2.4991,0c1.3638,0 2.4069,-0.2697 3.13,-0.8098 0.7231,-0.5492 1.0847,-1.3365 1.0847,-2.3616 0,-1.0526 -0.375,-1.858 -1.1255,-2.4164 -0.7414,-0.5675 -1.808,-0.8511 -3.1993,-0.8511 -0.7597,0 -1.5742,0.0823 -2.4438,0.247 -0.8695,0.1648 -1.8261,0.4211 -2.8696,0.7689l0,-2.4717c1.0526,-0.2929 2.0364,-0.5124 2.9518,-0.6589 0.9245,-0.1464 1.794,-0.2196 2.6086,-0.2196zM25.2005,31.6957L31.4611,31.6957c2.3432,0 4.0913,0.4898 5.2446,1.4692 1.1533,0.9794 1.7301,2.4578 1.7301,4.4349 0,1.2906 -0.3018,2.3615 -0.9059,3.2127 -0.595,0.8512 -1.4645,1.4414 -2.6086,1.771 0.595,0.2014 1.1713,0.6319 1.7296,1.2909 0.5675,0.659 1.1352,1.5649 1.7027,2.7182l2.8143,5.6017l-2.9791,0l-2.6226,-5.2581c-0.6773,-1.373 -1.3364,-2.2841 -1.9771,-2.7326 -0.6316,-0.4485 -1.4963,-0.6723 -2.5947,-0.6723l-3.0205,0l0,8.663L25.2005,52.1942ZM27.974,33.9752l0,7.2766l3.4871,0c1.3364,0 2.3432,-0.3066 3.0205,-0.9198 0.6865,-0.6224 1.0299,-1.5331 1.0299,-2.7321 0,-1.1991 -0.3434,-2.1006 -1.0299,-2.7047 -0.6773,-0.6133 -1.6841,-0.9198 -3.0205,-0.9198z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="11.0688"
+      android:fillColor="@color/control_primary"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_touchpad_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_touchpad_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_touchpad_pressed.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_touchpad_pressed.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-<vector xmlns:android="http://schemas.android.com/apk/res/android"
-    android:width="256dp"
-    android:height="256dp"
-    android:viewportWidth="67.73333"
-    android:viewportHeight="67.73334">
-  <path
-      android:pathData="M16.9333,4.2333C7.5523,4.2333 0,10.8416 0,19.05l0,29.6333c0,8.2084 7.5523,14.8167 16.9333,14.8167l33.8667,0c9.3811,0 16.9333,-6.6082 16.9333,-14.8167L67.7333,19.05C67.7333,10.8416 60.1811,4.2333 50.8,4.2333ZM11.8701,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042A3.7042,3.7042 0,0 1,22.9826 19.05,3.7042 3.7042,0 0,1 26.6867,15.3458ZM41.5034,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM11.8701,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM41.5034,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM11.8701,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM41.5034,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042z"
-      android:strokeLineJoin="round"
-      android:strokeWidth="22.6959"
-      android:fillColor="@color/control_pressed"
-      android:strokeLineCap="round"/>
-</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_button_touchpad.xml 2.1.0-1/android/app/src/main/res/drawable/control_button_touchpad.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_button_touchpad.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_button_touchpad.xml	1970-01-01 00:00:00.000000000 +0000
@@ -1,12 +0,0 @@
-<vector xmlns:android="http://schemas.android.com/apk/res/android"
-    android:width="256dp"
-    android:height="256dp"
-    android:viewportWidth="67.73333"
-    android:viewportHeight="67.73334">
-  <path
-      android:pathData="M16.9333,4.2333C7.5523,4.2333 0,10.8416 0,19.05l0,29.6333c0,8.2084 7.5523,14.8167 16.9333,14.8167l33.8667,0c9.3811,0 16.9333,-6.6082 16.9333,-14.8167L67.7333,19.05C67.7333,10.8416 60.1811,4.2333 50.8,4.2333ZM11.8701,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042A3.7042,3.7042 0,0 1,22.9826 19.05,3.7042 3.7042,0 0,1 26.6867,15.3458ZM41.5034,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,15.3458a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM11.8701,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM41.5034,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,30.1625a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,135 0,1 -3.7042,3.7042 3.7042,3.7042 135,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM11.8701,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM26.6867,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM41.5034,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042zM56.3201,44.9792a3.7042,3.7042 0,0 1,3.7042 3.7042,3.7042 3.7042,0 0,1 -3.7042,3.7042 3.7042,3.7042 0,0 1,-3.7042 -3.7042,3.7042 3.7042,0 0,1 3.7042,-3.7042z"
-      android:strokeLineJoin="round"
-      android:strokeWidth="22.6959"
-      android:fillColor="@color/control_primary"
-      android:strokeLineCap="round"/>
-</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_touchpad_pressed.xml 2.1.0-1/android/app/src/main/res/drawable/control_touchpad_pressed.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_touchpad_pressed.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_touchpad_pressed.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="1920dp"
+    android:height="942dp"
+    android:viewportWidth="508"
+    android:viewportHeight="249.2375">
+  <path
+      android:pathData="M32,0L476,0A32,32 0,0 1,508 32L508,217.238A32,32 0,0 1,476 249.238L32,249.238A32,32 0,0 1,-0 217.238L-0,32A32,32 0,0 1,32 0z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="1.59637"
+      android:fillColor="@color/control_pressed"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/control_touchpad.xml 2.1.0-1/android/app/src/main/res/drawable/control_touchpad.xml
--- 2.0.1-1/android/app/src/main/res/drawable/control_touchpad.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/control_touchpad.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,12 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="1920dp"
+    android:height="942dp"
+    android:viewportWidth="508"
+    android:viewportHeight="249.2375">
+  <path
+      android:pathData="M32,0L476,0A32,32 0,0 1,508 32L508,217.238A32,32 0,0 1,476 249.238L32,249.238A32,32 0,0 1,-0 217.238L-0,32A32,32 0,0 1,32 0z"
+      android:strokeLineJoin="round"
+      android:strokeWidth="1.59637"
+      android:fillColor="@color/control_primary"
+      android:strokeLineCap="round"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/ic_button_haptic.xml 2.1.0-1/android/app/src/main/res/drawable/ic_button_haptic.xml
--- 2.0.1-1/android/app/src/main/res/drawable/ic_button_haptic.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/ic_button_haptic.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,9 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="24dp"
+    android:height="24dp"
+    android:viewportWidth="24"
+    android:viewportHeight="24">
+  <path
+      android:fillColor="?android:attr/textColorPrimary"
+      android:pathData="M9,11.24V7.5C9,6.12 10.12,5 11.5,5S14,6.12 14,7.5v3.74c1.21,-0.81 2,-2.18 2,-3.74C16,5.01 13.99,3 11.5,3S7,5.01 7,7.5C7,9.06 7.79,10.43 9,11.24zM18.84,15.87l-4.54,-2.26c-0.17,-0.07 -0.35,-0.11 -0.54,-0.11H13v-6C13,6.67 12.33,6 11.5,6S10,6.67 10,7.5v10.74c-3.6,-0.76 -3.54,-0.75 -3.67,-0.75c-0.31,0 -0.59,0.13 -0.79,0.33l-0.79,0.8l4.94,4.94C9.96,23.83 10.34,24 10.75,24h6.79c0.75,0 1.33,-0.55 1.44,-1.28l0.75,-5.27c0.01,-0.07 0.02,-0.14 0.02,-0.2C19.75,16.63 19.37,16.09 18.84,15.87z"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/ic_motion.xml 2.1.0-1/android/app/src/main/res/drawable/ic_motion.xml
--- 2.0.1-1/android/app/src/main/res/drawable/ic_motion.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/ic_motion.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,9 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="24dp"
+    android:height="24dp"
+    android:viewportWidth="24"
+    android:viewportHeight="24">
+  <path
+      android:fillColor="?android:attr/textColorPrimary"
+      android:pathData="M16.48,2.52c3.27,1.55 5.61,4.72 5.97,8.48h1.5C23.44,4.84 18.29,0 12,0l-0.66,0.03 3.81,3.81 1.33,-1.32zM10.23,1.75c-0.59,-0.59 -1.54,-0.59 -2.12,0L1.75,8.11c-0.59,0.59 -0.59,1.54 0,2.12l12.02,12.02c0.59,0.59 1.54,0.59 2.12,0l6.36,-6.36c0.59,-0.59 0.59,-1.54 0,-2.12L10.23,1.75zM14.83,21.19L2.81,9.17l6.36,-6.36 12.02,12.02 -6.36,6.36zM7.52,21.48C4.25,19.94 1.91,16.76 1.55,13L0.05,13C0.56,19.16 5.71,24 12,24l0.66,-0.03 -3.81,-3.81 -1.33,1.32z"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/drawable/ic_rumble.xml 2.1.0-1/android/app/src/main/res/drawable/ic_rumble.xml
--- 2.0.1-1/android/app/src/main/res/drawable/ic_rumble.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/drawable/ic_rumble.xml	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,9 @@
+<vector xmlns:android="http://schemas.android.com/apk/res/android"
+    android:width="24dp"
+    android:height="24dp"
+    android:viewportWidth="24"
+    android:viewportHeight="24">
+  <path
+      android:fillColor="?android:attr/textColorPrimary"
+      android:pathData="M0,15h2L2,9L0,9v6zM3,17h2L5,7L3,7v10zM22,9v6h2L24,9h-2zM19,17h2L21,7h-2v10zM16.5,3h-9C6.67,3 6,3.67 6,4.5v15c0,0.83 0.67,1.5 1.5,1.5h9c0.83,0 1.5,-0.67 1.5,-1.5v-15c0,-0.83 -0.67,-1.5 -1.5,-1.5zM16,19L8,19L8,5h8v14z"/>
+</vector>
diff -pruN 2.0.1-1/android/app/src/main/res/layout/activity_stream.xml 2.1.0-1/android/app/src/main/res/layout/activity_stream.xml
--- 2.0.1-1/android/app/src/main/res/layout/activity_stream.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/layout/activity_stream.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,16 +1,24 @@
 <?xml version="1.0" encoding="utf-8"?>
-<FrameLayout xmlns:android="http://schemas.android.com/apk/res/android"
+<FrameLayout
+    xmlns:android="http://schemas.android.com/apk/res/android"
     xmlns:tools="http://schemas.android.com/tools"
+    xmlns:app="http://schemas.android.com/apk/res-auto"
+    android:id="@+id/mainStreamLayout"
     android:layout_width="match_parent"
     android:layout_height="match_parent"
-    xmlns:app="http://schemas.android.com/apk/res-auto"
     tools:context=".stream.StreamActivity"
     android:keepScreenOn="true">
 
-    <TextureView
-        android:id="@+id/textureView"
+    <com.metallic.chiaki.stream.AspectRatioFrameLayout
+        android:id="@+id/aspectRatioLayout"
         android:layout_width="match_parent"
-        android:layout_height="match_parent"/>
+        android:layout_height="match_parent"
+        android:layout_gravity="center">
+        <SurfaceView
+            android:id="@+id/surfaceView"
+            android:layout_width="wrap_content"
+            android:layout_height="wrap_content"/>
+    </com.metallic.chiaki.stream.AspectRatioFrameLayout>
 
     <ProgressBar
         android:id="@+id/progressBar"
@@ -20,7 +28,7 @@
 
     <fragment
         android:id="@+id/controlsFragment"
-        android:name="com.metallic.chiaki.touchcontrols.TouchControlsFragment"
+        android:name="com.metallic.chiaki.touchcontrols.DefaultTouchControlsFragment"
         android:layout_width="match_parent"
         android:layout_height="match_parent"/>
 
@@ -34,7 +42,6 @@
         android:id="@+id/overlay"
         android:layout_width="match_parent"
         android:layout_height="match_parent"
-        android:layout_gravity="bottom"
         android:fitsSystemWindows="true">
 
         <androidx.constraintlayout.widget.ConstraintLayout
@@ -76,6 +83,7 @@
                 app:layout_constraintBottom_toBottomOf="parent"
                 app:layout_constraintEnd_toEndOf="parent"
                 app:singleSelection="true"
+                app:selectionRequired="true"
                 app:checkedButton="@id/display_mode_normal_button">
 
                 <com.google.android.material.button.MaterialButton
diff -pruN 2.0.1-1/android/app/src/main/res/layout/fragment_controls.xml 2.1.0-1/android/app/src/main/res/layout/fragment_controls.xml
--- 2.0.1-1/android/app/src/main/res/layout/fragment_controls.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/layout/fragment_controls.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,10 +1,12 @@
 <?xml version="1.0" encoding="utf-8"?>
 <androidx.constraintlayout.widget.ConstraintLayout
     xmlns:android="http://schemas.android.com/apk/res/android"
+    xmlns:tools="http://schemas.android.com/tools"
     android:layout_width="match_parent"
     android:layout_height="match_parent"
     xmlns:app="http://schemas.android.com/apk/res-auto"
-    android:clipChildren="false">
+    android:clipChildren="false"
+    tools:ignore="RtlHardcoded,RtlSymmetry">
 
     <com.metallic.chiaki.touchcontrols.ControlsBackgroundView
         android:layout_width="match_parent"
@@ -45,20 +47,34 @@
         app:drawableHandle="@drawable/control_analog_stick_handle"
         />
 
+    <com.metallic.chiaki.touchcontrols.TouchpadView
+        android:id="@+id/touchpadView"
+        android:layout_width="0dp"
+        android:layout_height="0dp"
+        app:drawableIdle="@drawable/control_touchpad"
+        app:drawablePressed="@drawable/control_touchpad_pressed"
+        android:layout_marginTop="32dp"
+        app:layout_constraintTop_toTopOf="parent"
+        app:layout_constraintWidth_max="300dp"
+        app:layout_constraintDimensionRatio="1920:942"
+        app:layout_constraintRight_toRightOf="parent"
+        app:layout_constraintLeft_toLeftOf="parent"/>
+
     <com.metallic.chiaki.touchcontrols.DPadView
         android:id="@+id/dpadView"
-        android:layout_width="128dp"
-        android:layout_height="128dp"
-        android:layout_marginLeft="32dp"
-        android:layout_marginBottom="32dp"
+        android:layout_width="160dp"
+        android:layout_height="160dp"
+        android:padding="16dp"
+        android:layout_marginLeft="16dp"
+        android:layout_marginBottom="16dp"
         app:layout_constraintLeft_toLeftOf="parent"
         app:layout_constraintTop_toTopOf="parent"
         app:layout_constraintBottom_toBottomOf="parent" />
 
     <androidx.constraintlayout.widget.ConstraintLayout
         android:id="@+id/faceButtonsLayout"
-        android:layout_width="144dp"
-        android:layout_height="144dp"
+        android:layout_width="@dimen/control_face_button_size_full"
+        android:layout_height="@dimen/control_face_button_size_full"
         app:layout_constraintRight_toRightOf="parent"
         app:layout_constraintTop_toTopOf="parent"
         app:layout_constraintBottom_toBottomOf="parent"
@@ -67,9 +83,12 @@
 
         <com.metallic.chiaki.touchcontrols.ButtonView
             android:id="@+id/crossButtonView"
-            android:layout_width="@dimen/control_face_button_size"
-            android:layout_height="@dimen/control_face_button_size"
-            android:padding="8dp"
+            android:layout_width="@dimen/control_face_button_size_full"
+            android:layout_height="@dimen/control_face_button_size_half"
+            android:paddingLeft="@dimen/control_face_button_padding_to_full"
+            android:paddingRight="@dimen/control_face_button_padding_to_full"
+            android:paddingTop="@dimen/control_face_button_padding_to_center"
+            android:paddingBottom="@dimen/control_face_button_padding_to_outside"
             app:drawableIdle="@drawable/control_button_cross"
             app:drawablePressed="@drawable/control_button_cross_pressed"
             app:layout_constraintLeft_toLeftOf="parent"
@@ -78,9 +97,12 @@
 
         <com.metallic.chiaki.touchcontrols.ButtonView
             android:id="@+id/moonButtonView"
-            android:layout_width="@dimen/control_face_button_size"
-            android:layout_height="@dimen/control_face_button_size"
-            android:padding="8dp"
+            android:layout_width="@dimen/control_face_button_size_half"
+            android:layout_height="@dimen/control_face_button_size_full"
+            android:paddingTop="@dimen/control_face_button_padding_to_full"
+            android:paddingBottom="@dimen/control_face_button_padding_to_full"
+            android:paddingLeft="@dimen/control_face_button_padding_to_center"
+            android:paddingRight="@dimen/control_face_button_padding_to_outside"
             app:drawableIdle="@drawable/control_button_moon"
             app:drawablePressed="@drawable/control_button_moon_pressed"
             app:layout_constraintRight_toRightOf="parent"
@@ -89,9 +111,12 @@
 
         <com.metallic.chiaki.touchcontrols.ButtonView
             android:id="@+id/pyramidButtonView"
-            android:layout_width="@dimen/control_face_button_size"
-            android:layout_height="@dimen/control_face_button_size"
-            android:padding="8dp"
+            android:layout_width="@dimen/control_face_button_size_full"
+            android:layout_height="@dimen/control_face_button_size_half"
+            android:paddingLeft="@dimen/control_face_button_padding_to_full"
+            android:paddingRight="@dimen/control_face_button_padding_to_full"
+            android:paddingBottom="@dimen/control_face_button_padding_to_center"
+            android:paddingTop="@dimen/control_face_button_padding_to_outside"
             app:drawableIdle="@drawable/control_button_pyramid"
             app:drawablePressed="@drawable/control_button_pyramid_pressed"
             app:layout_constraintLeft_toLeftOf="parent"
@@ -100,50 +125,60 @@
 
         <com.metallic.chiaki.touchcontrols.ButtonView
             android:id="@+id/boxButtonView"
-            android:layout_width="@dimen/control_face_button_size"
-            android:layout_height="@dimen/control_face_button_size"
-            android:padding="8dp"
+            android:layout_width="@dimen/control_face_button_size_half"
+            android:layout_height="@dimen/control_face_button_size_full"
+            android:paddingTop="@dimen/control_face_button_padding_to_full"
+            android:paddingBottom="@dimen/control_face_button_padding_to_full"
+            android:paddingRight="@dimen/control_face_button_padding_to_center"
+            android:paddingLeft="@dimen/control_face_button_padding_to_outside"
             app:drawableIdle="@drawable/control_button_box"
             app:drawablePressed="@drawable/control_button_box_pressed"
             app:layout_constraintLeft_toLeftOf="parent"
             app:layout_constraintTop_toTopOf="parent"
-            app:layout_constraintBottom_toBottomOf="parent"/>
+            app:layout_constraintBottom_toBottomOf="parent" />
 
     </androidx.constraintlayout.widget.ConstraintLayout>
 
 
     <com.metallic.chiaki.touchcontrols.ButtonView
-        android:id="@+id/psButtonView"
-        android:layout_width="32dp"
-        android:layout_height="32dp"
-        android:padding="8dp"
-        android:layout_marginBottom="8dp"
-        app:drawableIdle="@drawable/control_button_home"
-        app:drawablePressed="@drawable/control_button_home_pressed"
+        android:id="@+id/l3ButtonView"
+        android:layout_width="64dp"
+        android:layout_height="64dp"
+        app:drawableIdle="@drawable/control_button_l3"
+        app:drawablePressed="@drawable/control_button_l3_pressed"
         app:layout_constraintLeft_toLeftOf="parent"
+        app:layout_constraintBottom_toBottomOf="parent"/>
+
+    <com.metallic.chiaki.touchcontrols.ButtonView
+        android:id="@+id/r3ButtonView"
+        android:layout_width="64dp"
+        android:layout_height="64dp"
+        app:drawableIdle="@drawable/control_button_r3"
+        app:drawablePressed="@drawable/control_button_r3_pressed"
         app:layout_constraintRight_toRightOf="parent"
         app:layout_constraintBottom_toBottomOf="parent"/>
 
 
     <com.metallic.chiaki.touchcontrols.ButtonView
-        android:id="@+id/touchpadButtonView"
-        android:layout_width="32dp"
-        android:layout_height="32dp"
+        android:id="@+id/psButtonView"
+        android:layout_width="48dp"
+        android:layout_height="48dp"
         android:padding="8dp"
-        android:layout_marginTop="8dp"
-        app:drawableIdle="@drawable/control_button_touchpad"
-        app:drawablePressed="@drawable/control_button_touchpad_pressed"
+        app:drawableIdle="@drawable/control_button_home"
+        app:drawablePressed="@drawable/control_button_home_pressed"
         app:layout_constraintLeft_toLeftOf="parent"
         app:layout_constraintRight_toRightOf="parent"
-        app:layout_constraintTop_toTopOf="parent"/>
+        app:layout_constraintBottom_toBottomOf="parent"/>
+
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/l2ButtonView"
-        android:layout_width="64dp"
-        android:layout_height="32dp"
-        android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginLeft="8dp"
+        android:layout_width="88dp"
+        android:layout_height="80dp"
+        android:paddingTop="8dp"
+        android:paddingBottom="8dp"
+        android:paddingRight="8dp"
+        android:paddingLeft="16dp"
         app:drawableIdle="@drawable/control_button_l2"
         app:drawablePressed="@drawable/control_button_l2_pressed"
         app:layout_constraintLeft_toLeftOf="parent"
@@ -151,23 +186,22 @@
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/l1ButtonView"
-        android:layout_width="64dp"
-        android:layout_height="32dp"
+        android:layout_width="80dp"
+        android:layout_height="80dp"
         android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginLeft="8dp"
+        android:layout_marginTop="32dp"
+        android:layout_marginLeft="40dp"
         app:drawableIdle="@drawable/control_button_l1"
         app:drawablePressed="@drawable/control_button_l1_pressed"
         app:layout_constraintLeft_toLeftOf="parent"
-        app:layout_constraintTop_toBottomOf="@id/l2ButtonView"/>
+        app:layout_constraintTop_toTopOf="parent"/>
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/shareButtonView"
-        android:layout_width="32dp"
-        android:layout_height="32dp"
+        android:layout_width="48dp"
+        android:layout_height="48dp"
         android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginLeft="8dp"
+        android:layout_marginLeft="32dp"
         app:drawableIdle="@drawable/control_button_share"
         app:drawablePressed="@drawable/control_button_share_pressed"
         app:layout_constraintLeft_toRightOf="@id/l2ButtonView"
@@ -175,11 +209,12 @@
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/r2ButtonView"
-        android:layout_width="64dp"
-        android:layout_height="32dp"
-        android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginRight="8dp"
+        android:layout_width="88dp"
+        android:layout_height="80dp"
+        android:paddingTop="8dp"
+        android:paddingRight="16dp"
+        android:paddingLeft="8dp"
+        android:paddingBottom="8dp"
         app:drawableIdle="@drawable/control_button_r2"
         app:drawablePressed="@drawable/control_button_r2_pressed"
         app:layout_constraintRight_toRightOf="parent"
@@ -187,23 +222,22 @@
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/r1ButtonView"
-        android:layout_width="64dp"
-        android:layout_height="32dp"
+        android:layout_width="80dp"
+        android:layout_height="80dp"
         android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginRight="8dp"
+        android:layout_marginTop="32dp"
+        android:layout_marginRight="40dp"
         app:drawableIdle="@drawable/control_button_r1"
         app:drawablePressed="@drawable/control_button_r1_pressed"
         app:layout_constraintRight_toRightOf="parent"
-        app:layout_constraintTop_toBottomOf="@id/r2ButtonView"/>
+        app:layout_constraintTop_toTopOf="parent"/>
 
     <com.metallic.chiaki.touchcontrols.ButtonView
         android:id="@+id/optionsButtonView"
-        android:layout_width="32dp"
-        android:layout_height="32dp"
+        android:layout_width="48dp"
+        android:layout_height="48dp"
         android:padding="8dp"
-        android:layout_marginTop="8dp"
-        android:layout_marginRight="8dp"
+        android:layout_marginRight="32dp"
         app:drawableIdle="@drawable/control_button_options"
         app:drawablePressed="@drawable/control_button_options_pressed"
         app:layout_constraintRight_toLeftOf="@id/r2ButtonView"
diff -pruN 2.0.1-1/android/app/src/main/res/layout/fragment_touchpad_only.xml 2.1.0-1/android/app/src/main/res/layout/fragment_touchpad_only.xml
--- 2.0.1-1/android/app/src/main/res/layout/fragment_touchpad_only.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/layout/fragment_touchpad_only.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,5 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
-<androidx.constraintlayout.widget.ConstraintLayout xmlns:android="http://schemas.android.com/apk/res/android"
+<androidx.constraintlayout.widget.ConstraintLayout
+    xmlns:android="http://schemas.android.com/apk/res/android"
     xmlns:app="http://schemas.android.com/apk/res-auto"
     xmlns:tools="http://schemas.android.com/tools"
     android:layout_width="match_parent"
@@ -12,16 +13,18 @@
         tools:layout_editor_absoluteX="0dp"
         tools:layout_editor_absoluteY="90dp" />
 
-    <com.metallic.chiaki.touchcontrols.ButtonView
-        android:id="@+id/touchpadButtonView"
-        android:layout_width="32dp"
-        android:layout_height="32dp"
-        android:layout_marginEnd="32dp"
-        android:layout_marginBottom="8dp"
-        android:padding="8dp"
-        app:drawableIdle="@drawable/control_button_touchpad"
-        app:drawablePressed="@drawable/control_button_touchpad_pressed"
+    <com.metallic.chiaki.touchcontrols.TouchpadView
+        android:id="@+id/touchpadView"
+        android:layout_width="0dp"
+        android:layout_height="0dp"
+        app:drawableIdle="@drawable/control_touchpad"
+        app:drawablePressed="@drawable/control_touchpad_pressed"
+        app:layout_constraintDimensionRatio="1920:942"
+        app:layout_constraintLeft_toLeftOf="parent"
+        app:layout_constraintRight_toRightOf="parent"
+        app:layout_constraintTop_toTopOf="parent"
         app:layout_constraintBottom_toBottomOf="parent"
-        app:layout_constraintEnd_toEndOf="parent" />
+        android:layout_marginLeft="80dp"
+        android:layout_marginRight="80dp"/>
 
 </androidx.constraintlayout.widget.ConstraintLayout>
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/res/values/attrs.xml 2.1.0-1/android/app/src/main/res/values/attrs.xml
--- 2.0.1-1/android/app/src/main/res/values/attrs.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/values/attrs.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,8 +1,11 @@
 <?xml version="1.0" encoding="utf-8"?>
 <resources>
+    <attr name="drawableIdle" format="reference" />
+    <attr name="drawablePressed" format="reference" />
+
     <declare-styleable name="ButtonView">
-        <attr name="drawableIdle" format="reference" />
-        <attr name="drawablePressed" format="integer" />
+        <attr name="drawableIdle" />
+        <attr name="drawablePressed" />
     </declare-styleable>
 
     <declare-styleable name="AnalogStickView">
@@ -11,4 +14,9 @@
         <attr name="drawableBase" format="reference" />
         <attr name="drawableHandle" format="reference" />
     </declare-styleable>
+
+    <declare-styleable name="TouchpadView">
+        <attr name="drawableIdle" />
+        <attr name="drawablePressed" />
+    </declare-styleable>
 </resources>
\ No newline at end of file
diff -pruN 2.0.1-1/android/app/src/main/res/values/dimens.xml 2.1.0-1/android/app/src/main/res/values/dimens.xml
--- 2.0.1-1/android/app/src/main/res/values/dimens.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/values/dimens.xml	2021-01-15 21:35:50.000000000 +0000
@@ -1,6 +1,10 @@
 <?xml version="1.0" encoding="utf-8"?>
 <resources>
-    <dimen name="control_face_button_size">48dp</dimen>
+    <dimen name="control_face_button_size_half">88dp</dimen>
+    <dimen name="control_face_button_size_full">176dp</dimen>
+    <dimen name="control_face_button_padding_to_center">24dp</dimen>
+    <dimen name="control_face_button_padding_to_outside">16dp</dimen>
+    <dimen name="control_face_button_padding_to_full">64dp</dimen>
     <dimen name="control_analog_stick_radius">48dp</dimen>
     <dimen name="control_analog_stick_handle_radius">32dp</dimen>
     <dimen name="floating_action_button_speed_dial_anim_offset">48dp</dimen>
diff -pruN 2.0.1-1/android/app/src/main/res/values/strings.xml 2.1.0-1/android/app/src/main/res/values/strings.xml
--- 2.0.1-1/android/app/src/main/res/values/strings.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/values/strings.xml	2021-01-15 21:35:50.000000000 +0000
@@ -88,6 +88,12 @@
     <string name="preferences_codec_title_h265">H265 (PS5 only)</string>
     <string name="preferences_swap_cross_moon_title">Swap Cross/Moon and Box/Pyramid Buttons</string>
     <string name="preferences_swap_cross_moon_summary">Swap face buttons if default mapping is incorrect (e.g. for 8BitDo controllers)</string>
+    <string name="preferences_rumble_enabled_title">Rumble</string>
+    <string name="preferences_rumble_enabled_summary">Use phone vibration motor for rumble</string>
+    <string name="preferences_motion_enabled_title">Motion</string>
+    <string name="preferences_motion_enabled_summary">Use device\'s motion sensors for controller motion</string>
+    <string name="preferences_button_haptic_enabled_title">Touch Haptics</string>
+    <string name="preferences_button_haptic_enabled_summary">Use phone vibration motor for short haptic feedback on button touches</string>
     <string name="alert_message_delete_registered_host">Are you sure you want to delete the registered console %s with ID %s?</string>
     <string name="alert_message_delete_manual_host">Are you sure you want to delete the console entry for %s?</string>
     <string name="action_keep">Keep</string>
@@ -101,7 +107,10 @@
     <!-- Don't localize these -->
     <string name="preferences_discovery_enabled_key">discovery_enabled</string>
     <string name="preferences_on_screen_controls_enabled_key">on_screen_controls_enabled</string>
-    <string name="preferences_touchpad_only_key">touchpad_only_enabled</string>
+    <string name="preferences_touchpad_only_enabled_key">touchpad_only_enabled</string>
+    <string name="preferences_rumble_enabled_key">rumble_enabled</string>
+    <string name="preferences_motion_enabled_key">motion_enabled</string>
+    <string name="preferences_button_haptic_enabled_key">button_haptic_enabled</string>
     <string name="preferences_log_verbose_key">log_verbose</string>
     <string name="preferences_import_settings_key">import_settings</string>
     <string name="preferences_export_settings_key">export_settings</string>
diff -pruN 2.0.1-1/android/app/src/main/res/xml/preferences.xml 2.1.0-1/android/app/src/main/res/xml/preferences.xml
--- 2.0.1-1/android/app/src/main/res/xml/preferences.xml	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/app/src/main/res/xml/preferences.xml	2021-01-15 21:35:50.000000000 +0000
@@ -20,6 +20,24 @@
             app:icon="@drawable/ic_gamepad" />
 
         <SwitchPreference
+            app:key="@string/preferences_rumble_enabled_key"
+            app:title="@string/preferences_rumble_enabled_title"
+            app:summary="@string/preferences_rumble_enabled_summary"
+            app:icon="@drawable/ic_rumble" />
+
+        <SwitchPreference
+            app:key="@string/preferences_motion_enabled_key"
+            app:title="@string/preferences_motion_enabled_title"
+            app:summary="@string/preferences_motion_enabled_summary"
+            app:icon="@drawable/ic_motion" />
+
+        <SwitchPreference
+            app:key="@string/preferences_button_haptic_enabled_key"
+            app:title="@string/preferences_button_haptic_enabled_title"
+            app:summary="@string/preferences_button_haptic_enabled_summary"
+            app:icon="@drawable/ic_button_haptic" />
+
+        <SwitchPreference
             app:key="@string/preferences_log_verbose_key"
             app:title="@string/preferences_log_verbose_title"
             app:summary="@string/preferences_log_verbose_summary"
diff -pruN 2.0.1-1/android/build.gradle 2.1.0-1/android/build.gradle
--- 2.0.1-1/android/build.gradle	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/build.gradle	2021-01-15 21:35:50.000000000 +0000
@@ -1,14 +1,14 @@
 // Top-level build file where you can add configuration options common to all sub-projects/modules.
 
 buildscript {
-    ext.kotlin_version = '1.3.61'
+    ext.kotlin_version = '1.4.21'
     repositories {
         google()
         jcenter()
         
     }
     dependencies {
-        classpath 'com.android.tools.build:gradle:3.5.2'
+        classpath 'com.android.tools.build:gradle:4.1.1'
         classpath "org.jetbrains.kotlin:kotlin-gradle-plugin:$kotlin_version"
         // NOTE: Do not place your application dependencies here; they belong
         // in the individual module build.gradle files
diff -pruN 2.0.1-1/android/gradle/wrapper/gradle-wrapper.properties 2.1.0-1/android/gradle/wrapper/gradle-wrapper.properties
--- 2.0.1-1/android/gradle/wrapper/gradle-wrapper.properties	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/android/gradle/wrapper/gradle-wrapper.properties	2021-01-15 21:35:50.000000000 +0000
@@ -1,6 +1,6 @@
-#Wed Mar 11 18:48:31 CET 2020
+#Fri Jan 15 11:37:05 CET 2021
 distributionBase=GRADLE_USER_HOME
 distributionPath=wrapper/dists
 zipStoreBase=GRADLE_USER_HOME
 zipStorePath=wrapper/dists
-distributionUrl=https\://services.gradle.org/distributions/gradle-5.6.4-all.zip
+distributionUrl=https\://services.gradle.org/distributions/gradle-6.5-bin.zip
diff -pruN 2.0.1-1/assets/controls/l1.svg 2.1.0-1/assets/controls/l1.svg
--- 2.0.1-1/assets/controls/l1.svg	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/assets/controls/l1.svg	2021-01-15 21:35:50.000000000 +0000
@@ -5,37 +5,13 @@
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   sodipodi:docname="l1.svg"
-   inkscape:version="1.0beta1 (5c3063637d, 2019-10-15)"
    id="svg8"
    version="1.1"
-   viewBox="0 0 67.733332 33.866668"
-   height="128"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
    width="256">
   <defs
      id="defs2" />
-  <sodipodi:namedview
-     inkscape:window-maximized="1"
-     inkscape:window-y="15"
-     inkscape:window-x="1920"
-     inkscape:window-height="1048"
-     inkscape:window-width="1918"
-     units="px"
-     showgrid="false"
-     inkscape:document-rotation="0"
-     inkscape:current-layer="layer1"
-     inkscape:document-units="mm"
-     inkscape:cy="61.042937"
-     inkscape:cx="87.179174"
-     inkscape:zoom="2.8"
-     inkscape:pageshadow="2"
-     inkscape:pageopacity="0"
-     borderopacity="1.0"
-     bordercolor="#666666"
-     pagecolor="#000000"
-     id="base" />
   <metadata
      id="metadata5">
     <rdf:RDF>
@@ -49,28 +25,12 @@
     </rdf:RDF>
   </metadata>
   <g
-     style="display:inline"
-     id="layer1"
-     inkscape:groupmode="layer"
-     inkscape:label="Ebene 1">
-    <rect
-       y="0"
-       x="0"
-       height="33.866665"
-       width="67.73333"
-       id="rect1406"
-       style="display:none;fill:#ffffff;stroke:none;stroke-width:6.28119;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill" />
-    <text
-       id="text1404"
-       y="25.830172"
-       x="-3.9868231"
-       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:none;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
-       xml:space="preserve" />
+     id="g2115"
+     style="display:inline">
     <path
-       inkscape:connector-curvature="0"
-       transform="scale(0.26458333)"
-       d="M 0,0 V 128 H 256 V 0 Z m 82.337891,31.205078 h 8.820312 V 89.478516 H 120.5293 V 97.625 H 82.337891 Z m 71.402339,0 h 8.82227 V 97.625 h -8.82227 V 43.658203 l -12.03906,12.039063 -6.22656,-6.226563 z"
-       style="display:inline;fill:#ffffff;stroke:none;stroke-width:23.7399;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill"
-       id="rect1518" />
+       id="path2031"
+       style="fill:#ffffff;stroke-width:5.54109;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 148.25391,0 0,148.25391 77.041016,225.29492 a 104.83116,104.83117 0 0 0 148.253904,0 104.83116,104.83117 0 0 0 0,-148.253904 z M 96.048828,111.22656 h 10.482422 v 68.65235 h 37.72656 v 8.82226 H 96.048828 Z m 78.980472,0 h 10.48242 v 68.65235 h 17.12305 v 8.82226 h -44.62696 v -8.82226 h 17.125 v -59.10547 l -18.6289,3.73633 v -9.54688 z"
+       transform="scale(0.26458334)" />
   </g>
 </svg>
diff -pruN 2.0.1-1/assets/controls/l2.svg 2.1.0-1/assets/controls/l2.svg
--- 2.0.1-1/assets/controls/l2.svg	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/assets/controls/l2.svg	2021-01-15 21:35:50.000000000 +0000
@@ -5,37 +5,13 @@
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   sodipodi:docname="l2.svg"
-   inkscape:version="1.0beta1 (5c3063637d, 2019-10-15)"
    id="svg8"
    version="1.1"
-   viewBox="0 0 67.733332 33.866668"
-   height="128"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
    width="256">
   <defs
      id="defs2" />
-  <sodipodi:namedview
-     inkscape:window-maximized="1"
-     inkscape:window-y="15"
-     inkscape:window-x="1920"
-     inkscape:window-height="1048"
-     inkscape:window-width="1918"
-     units="px"
-     showgrid="false"
-     inkscape:document-rotation="0"
-     inkscape:current-layer="layer1"
-     inkscape:document-units="mm"
-     inkscape:cy="66.072659"
-     inkscape:cx="112.07001"
-     inkscape:zoom="2.8"
-     inkscape:pageshadow="2"
-     inkscape:pageopacity="0"
-     borderopacity="1.0"
-     bordercolor="#666666"
-     pagecolor="#000000"
-     id="base" />
   <metadata
      id="metadata5">
     <rdf:RDF>
@@ -49,28 +25,12 @@
     </rdf:RDF>
   </metadata>
   <g
-     style="display:inline"
-     id="layer1"
-     inkscape:groupmode="layer"
-     inkscape:label="Ebene 1">
-    <rect
-       y="0"
-       x="0"
-       height="33.866665"
-       width="67.73333"
-       id="rect1406"
-       style="display:none;fill:#ffffff;stroke:none;stroke-width:6.28119;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill" />
-    <text
-       id="text1404"
-       y="25.830172"
-       x="-3.9868231"
-       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:none;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
-       xml:space="preserve" />
+     id="g2135"
+     style="display:inline">
     <path
-       inkscape:connector-curvature="0"
-       transform="scale(0.26458333)"
-       d="M 0,0 V 128 H 256 V 0 Z m 153.74023,30.375 c 5.88107,0 10.53413,1.382832 13.95899,4.150391 3.42485,2.767558 5.13672,6.556599 5.13672,11.365234 0,1.522157 -0.0525,2.697075 -0.15625,3.527344 -0.0692,0.795671 -0.32762,1.88575 -0.77735,3.269531 -0.41513,1.349186 -1.14185,2.83695 -2.17968,4.462891 -1.03784,1.591347 -2.43881,3.492984 -4.20313,5.707031 l -21.27539,26.621094 h 29.42188 V 97.625 h -39.85157 v -8.146484 l 25.32227,-31.705078 c 1.55675,-1.937291 2.6993,-3.632969 3.42578,-5.085938 0.72648,-1.487564 1.14035,-2.611968 1.24414,-3.373047 0.13843,-0.795674 0.20703,-1.936266 0.20703,-3.423828 0,-2.283238 -0.91649,-4.083848 -2.75,-5.398437 -1.83351,-1.314591 -4.34074,-1.970704 -7.52344,-1.970704 -3.18269,0 -5.69188,0.656113 -7.52539,1.970704 -1.8335,1.314589 -2.75,3.115199 -2.75,5.398437 l -8.82031,-1.402344 c 0,-4.358904 1.71187,-7.800773 5.13672,-10.326172 3.42485,-2.525397 8.07792,-3.787109 13.95898,-3.787109 z m -71.402339,0.830078 h 8.820312 V 89.478516 H 120.5293 V 97.625 H 82.337891 Z"
-       style="fill:#ffffff;stroke:none;stroke-width:23.7399;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill"
-       id="rect1462" />
+       id="path2127"
+       style="fill:#ffffff;stroke-width:5.54109;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="m 104.51367,0 a 104.83116,104.83117 0 0 0 -73.808592,30.705078 104.83116,104.83117 0 0 0 0,148.253902 L 107.74609,256 256,107.74609 178.95898,30.705078 A 104.83116,104.83117 0 0 0 104.51367,0 Z m 27.39844,57.390625 c 8.02592,0 14.42713,2.00657 19.20117,6.019531 4.77404,4.012961 7.16016,9.374608 7.16016,16.085938 0,3.182692 -0.6056,6.210686 -1.81641,9.082031 -1.17621,2.836747 -3.33823,6.191824 -6.48633,10.066406 -0.86486,1.003241 -3.61434,3.908169 -8.25,8.716799 -4.63566,4.77404 -11.17418,11.468 -19.61523,20.08203 h 36.58398 v 8.82226 h -49.19336 v -8.82226 c 3.97837,-4.11675 9.39248,-9.63383 16.24219,-16.55274 6.8843,-6.95349 11.20834,-11.432968 12.97266,-13.439448 3.35566,-3.770799 5.69127,-6.954243 7.00586,-9.548828 1.34918,-2.629183 2.02343,-5.207025 2.02343,-7.732422 0,-4.116745 -1.45343,-7.471821 -4.35937,-10.066406 -2.87134,-2.594588 -6.62411,-3.892578 -11.25977,-3.892578 -3.28647,-10e-7 -6.76462,0.571271 -10.43164,1.71289 -3.63242,1.141619 -7.52444,2.871623 -11.67578,5.189453 V 62.527344 c 4.22053,-1.695131 8.16502,-2.974982 11.83203,-3.839844 3.66702,-0.864862 7.0221,-1.296875 10.06641,-1.296875 z m -78.978516,1.400391 h 10.482422 v 68.652344 h 37.724604 v 8.82226 H 52.933594 Z"
+       transform="scale(0.26458334)" />
   </g>
 </svg>
diff -pruN 2.0.1-1/assets/controls/l3_raw.svg 2.1.0-1/assets/controls/l3_raw.svg
--- 2.0.1-1/assets/controls/l3_raw.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/l3_raw.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,44 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   id="svg8"
+   version="1.1"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
+   width="256">
+  <defs
+     id="defs2" />
+  <metadata
+     id="metadata5">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     style="display:inline"
+     id="layer1">
+    <path
+       id="path1554"
+       style="fill:#ffffff;stroke-width:2.92862;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 0,0 C 37.408085,0 67.73333,30.325245 67.73333,67.73333 L -41.939116,102.09299 Z" />
+    <text
+       id="text1404"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="translate(13.609727,26.364208)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>L3</tspan></tspan></text>
+  </g>
+</svg>
diff -pruN 2.0.1-1/assets/controls/l3.svg 2.1.0-1/assets/controls/l3.svg
--- 2.0.1-1/assets/controls/l3.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/l3.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,36 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   id="svg8"
+   version="1.1"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
+   width="256">
+  <defs
+     id="defs2" />
+  <metadata
+     id="metadata5">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     style="display:inline"
+     id="layer1">
+    <path
+       id="path1554"
+       style="fill:#ffffff;stroke-width:11.0688;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 0,0 -158.50977,385.86328 256,256 C 256,114.61511 141.38489,0 0,0 Z m 127.02734,118.39453 c 7.95674,0 14.25301,1.8168 18.88868,5.44922 4.63566,3.59783 6.95312,8.47499 6.95312,14.63281 0,4.28972 -1.22934,7.92331 -3.68555,10.89844 -2.4562,2.94053 -5.94857,4.98143 -10.48047,6.12305 5.01622,1.07243 8.92441,3.30309 11.72657,6.69336 2.83674,3.39026 4.25586,7.57698 4.25586,12.55859 0,7.64538 -2.63031,13.56016 -7.88867,17.74609 -5.25838,4.18594 -12.72957,6.2793 -22.41602,6.2793 -3.25188,0 -6.60891,-0.32903 -10.06836,-0.98633 -3.42485,-0.6227 -6.9697,-1.57352 -10.63672,-2.85351 v -10.11914 c 2.90594,1.69512 6.08743,2.97498 9.54688,3.83984 3.45945,0.86486 7.0749,1.29689 10.8457,1.29687 6.57295,10e-6 11.57319,-1.29799 14.99805,-3.89257 3.45945,-2.59459 5.1875,-6.36354 5.1875,-11.31055 0,-4.56647 -1.60693,-8.13141 -4.82422,-10.69141 -3.18269,-2.59458 -7.6298,-3.89062 -13.33789,-3.89062 h -9.02735 v -8.61524 h 9.44336 c 5.15458,0 9.09907,-1.01947 11.83203,-3.06054 2.73297,-2.07567 4.09961,-5.0512 4.09961,-8.92578 0,-3.97837 -1.41911,-7.02255 -4.25586,-9.13282 -2.80215,-2.14486 -6.83343,-3.21679 -12.09179,-3.21679 -2.87135,0 -5.94986,0.31089 -9.23633,0.93359 -3.28648,0.6227 -6.90193,1.59166 -10.8457,2.90625 v -9.3418 c 3.97836,-1.10702 7.69875,-1.93672 11.1582,-2.49023 3.49404,-0.55351 6.78046,-0.83008 9.85937,-0.83008 z m -80.224606,1.40039 h 10.482422 v 68.6543 h 37.72461 v 8.82031 H 46.802734 Z"
+       transform="scale(0.26458334)" />
+  </g>
+</svg>
diff -pruN 2.0.1-1/assets/controls/lr12.svg 2.1.0-1/assets/controls/lr12.svg
--- 2.0.1-1/assets/controls/lr12.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/lr12.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,124 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   id="svg8"
+   version="1.1"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
+   width="256"
+   sodipodi:docname="lr12.svg"
+   inkscape:version="1.0.1 (3bc2e813f5, 2020-09-07)">
+  <sodipodi:namedview
+     pagecolor="#000000"
+     bordercolor="#666666"
+     borderopacity="1"
+     objecttolerance="10"
+     gridtolerance="10"
+     guidetolerance="10"
+     inkscape:pageopacity="0"
+     inkscape:pageshadow="2"
+     inkscape:window-width="1916"
+     inkscape:window-height="1031"
+     id="namedview1468"
+     showgrid="false"
+     inkscape:zoom="0.79980469"
+     inkscape:cx="101.38147"
+     inkscape:cy="95.943219"
+     inkscape:window-x="0"
+     inkscape:window-y="0"
+     inkscape:window-maximized="1"
+     inkscape:current-layer="svg8" />
+  <defs
+     id="defs2" />
+  <metadata
+     id="metadata5">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     id="g2115"
+     inkscape:label="l1"
+     style="display:inline">
+    <path
+       id="path2031"
+       style="fill:#ffffff;stroke-width:1.46608;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 39.225383,0 0,39.225383 20.383723,59.609106 a 27.736579,27.73658 0 0 0 39.225787,4.04e-4 27.736579,27.73658 0 0 0 -4.04e-4,-39.225787 z" />
+    <text
+       id="text1404-4"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="translate(26.639768,24.096855)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>L1</tspan></tspan></text>
+  </g>
+  <g
+     id="g2125"
+     inkscape:label="r1"
+     style="display:inline">
+    <path
+       id="path2117"
+       style="fill:#ffffff;stroke-width:1.46608;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 28.507951,0 67.733334,39.225383 47.349611,59.609106 a 27.736579,27.73658 0 0 1 -39.2257874,4.04e-4 27.736579,27.73658 0 0 1 4.04e-4,-39.225787 z" />
+    <text
+       id="text2123"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="translate(13.644494,24.096798)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>R1</tspan></tspan></text>
+  </g>
+  <g
+     id="g2135"
+     inkscape:label="l2"
+     style="display:inline">
+    <path
+       id="path2127"
+       style="fill:#ffffff;stroke-width:1.46608;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 28.507951,67.733335 67.733334,28.507952 47.349611,8.1242288 a 27.736579,27.73658 0 0 0 -39.2257874,-4.04e-4 27.736579,27.73658 0 0 0 4.04e-4,39.2257872 z" />
+    <text
+       id="text2133"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="translate(15.231995,10.223453)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>L2</tspan></tspan></text>
+  </g>
+  <g
+     id="g2145"
+     inkscape:label="r2"
+     style="display:inline"
+     transform="matrix(-1,0,0,1,67.733334,0)">
+    <path
+       id="path2137"
+       style="fill:#ffffff;stroke-width:1.46608;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 28.507951,67.733335 67.733334,28.507952 47.349611,8.1242288 a 27.736579,27.73658 0 0 0 -39.2257874,-4.04e-4 27.736579,27.73658 0 0 0 4.04e-4,39.2257872 z" />
+    <text
+       id="text2143"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="matrix(-1,0,0,1,42.347278,10.223453)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>R2</tspan></tspan></text>
+  </g>
+</svg>
diff -pruN 2.0.1-1/assets/controls/r1.svg 2.1.0-1/assets/controls/r1.svg
--- 2.0.1-1/assets/controls/r1.svg	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/assets/controls/r1.svg	2021-01-15 21:35:50.000000000 +0000
@@ -5,37 +5,13 @@
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   sodipodi:docname="r1.svg"
-   inkscape:version="1.0beta1 (5c3063637d, 2019-10-15)"
    id="svg8"
    version="1.1"
-   viewBox="0 0 67.733332 33.866668"
-   height="128"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
    width="256">
   <defs
      id="defs2" />
-  <sodipodi:namedview
-     inkscape:window-maximized="1"
-     inkscape:window-y="15"
-     inkscape:window-x="1920"
-     inkscape:window-height="1048"
-     inkscape:window-width="1918"
-     units="px"
-     showgrid="false"
-     inkscape:document-rotation="0"
-     inkscape:current-layer="layer1"
-     inkscape:document-units="mm"
-     inkscape:cy="56.825844"
-     inkscape:cx="96.071037"
-     inkscape:zoom="2.8"
-     inkscape:pageshadow="2"
-     inkscape:pageopacity="0"
-     borderopacity="1.0"
-     bordercolor="#666666"
-     pagecolor="#000000"
-     id="base" />
   <metadata
      id="metadata5">
     <rdf:RDF>
@@ -49,28 +25,12 @@
     </rdf:RDF>
   </metadata>
   <g
-     style="display:inline"
-     id="layer1"
-     inkscape:groupmode="layer"
-     inkscape:label="Ebene 1">
-    <rect
-       y="0"
-       x="0"
-       height="33.866665"
-       width="67.73333"
-       id="rect1406"
-       style="display:none;fill:#ffffff;stroke:none;stroke-width:6.28119;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill" />
-    <text
-       id="text1404"
-       y="25.830172"
-       x="-3.9868231"
-       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:none;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
-       xml:space="preserve" />
+     id="g2125"
+     style="display:inline">
     <path
-       inkscape:connector-curvature="0"
-       transform="scale(0.26458333)"
-       d="M 0,0 V 128 H 256 V 0 Z M 80.675781,31.205078 H 103.7168 c 5.77728,0 10.15378,1.330365 13.1289,3.994141 3.00972,2.663775 4.51367,7.110882 4.51368,13.33789 -1e-5,8.510244 -3.90821,13.871891 -11.72657,16.085938 L 123.84961,97.625 H 114.25 L 100.60352,65.919922 H 89.498047 V 97.625 h -8.822266 z m 73.064449,0 h 8.82227 V 97.625 h -8.82227 V 43.658203 l -12.03906,12.039063 -6.22656,-6.226563 z m -64.242183,8.146484 v 18.421876 h 8.822265 c 4.635658,0 8.164328,-0.710533 10.585938,-2.128907 2.42161,-1.418373 3.63086,-3.786351 3.63086,-7.107422 0,-3.286475 -0.76105,-5.640217 -2.2832,-7.058593 -1.48757,-1.418374 -3.66577,-2.126954 -6.53711,-2.126954 z"
-       style="display:inline;fill:#ffffff;stroke:none;stroke-width:23.7399;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill"
-       id="rect1556" />
+       id="path2117"
+       style="fill:#ffffff;stroke-width:5.54109;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 107.74609,0 30.705078,77.041016 a 104.83116,104.83117 0 0 0 0,148.253904 104.83116,104.83117 0 0 0 148.253902,0 L 256,148.25391 Z M 46.933594,111.22656 h 23.662109 c 8.856189,0 15.463362,1.85113 19.822266,5.55274 4.358906,3.70161 6.539062,9.28735 6.539062,16.75976 0,4.87783 -1.140593,8.92529 -3.423828,12.14258 -2.248642,3.21729 -5.535064,5.44991 -9.859375,6.69531 2.248643,0.76108 4.426845,2.38615 6.53711,4.87696 2.144856,2.4908 4.290687,5.91648 6.435546,10.27539 L 107.2832,188.70117 H 96.023438 l -9.91211,-19.875 C 83.551336,163.637 81.060286,160.19513 78.638672,158.5 c -2.387019,-1.69513 -5.655301,-2.54297 -9.806641,-2.54297 H 57.416016 v 32.74414 H 46.933594 Z m 93.613286,0 h 10.48242 v 68.65235 h 17.12304 v 8.82226 h -44.62695 v -8.82226 h 17.125 v -59.10547 l -18.62891,3.73633 v -9.54688 z m -83.130864,8.61328 v 27.50196 h 13.179687 c 5.050794,0 8.856023,-1.15874 11.416016,-3.47657 2.594587,-2.35242 3.892578,-5.79429 3.892578,-10.32617 0,-4.53188 -1.297991,-7.93942 -3.892578,-10.22265 -2.559993,-2.31783 -6.365222,-3.47657 -11.416016,-3.47657 z"
+       transform="scale(0.26458334)" />
   </g>
 </svg>
diff -pruN 2.0.1-1/assets/controls/r2.svg 2.1.0-1/assets/controls/r2.svg
--- 2.0.1-1/assets/controls/r2.svg	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/assets/controls/r2.svg	2021-01-15 21:35:50.000000000 +0000
@@ -5,37 +5,13 @@
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:svg="http://www.w3.org/2000/svg"
    xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   sodipodi:docname="r2.svg"
-   inkscape:version="1.0beta1 (5c3063637d, 2019-10-15)"
    id="svg8"
    version="1.1"
-   viewBox="0 0 67.733332 33.866668"
-   height="128"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
    width="256">
   <defs
      id="defs2" />
-  <sodipodi:namedview
-     inkscape:window-maximized="1"
-     inkscape:window-y="15"
-     inkscape:window-x="1920"
-     inkscape:window-height="1048"
-     inkscape:window-width="1918"
-     units="px"
-     showgrid="false"
-     inkscape:document-rotation="0"
-     inkscape:current-layer="layer1"
-     inkscape:document-units="mm"
-     inkscape:cy="56.825844"
-     inkscape:cx="96.071037"
-     inkscape:zoom="2.8"
-     inkscape:pageshadow="2"
-     inkscape:pageopacity="0"
-     borderopacity="1.0"
-     bordercolor="#666666"
-     pagecolor="#000000"
-     id="base" />
   <metadata
      id="metadata5">
     <rdf:RDF>
@@ -49,28 +25,13 @@
     </rdf:RDF>
   </metadata>
   <g
+     id="g2145"
      style="display:inline"
-     id="layer1"
-     inkscape:groupmode="layer"
-     inkscape:label="Ebene 1">
-    <rect
-       y="0"
-       x="0"
-       height="33.866665"
-       width="67.73333"
-       id="rect1406"
-       style="display:none;fill:#ffffff;stroke:none;stroke-width:6.28119;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill" />
-    <text
-       id="text1404"
-       y="25.830172"
-       x="-3.9868231"
-       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:none;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
-       xml:space="preserve" />
+     transform="matrix(-1,0,0,1,67.733334,0)">
     <path
-       inkscape:connector-curvature="0"
-       transform="scale(0.26458333)"
-       d="M 0,0 V 128 H 256 V 0 Z m 153.74023,30.375 c 5.88107,0 10.53413,1.382832 13.95899,4.150391 3.42485,2.767558 5.13672,6.556599 5.13672,11.365234 0,1.522157 -0.0525,2.697075 -0.15625,3.527344 -0.0692,0.795671 -0.32762,1.88575 -0.77735,3.269531 -0.41513,1.349186 -1.14185,2.83695 -2.17968,4.462891 -1.03784,1.591347 -2.43881,3.492984 -4.20313,5.707031 l -21.27539,26.621094 h 29.42188 V 97.625 h -39.85157 v -8.146484 l 25.32227,-31.705078 c 1.55675,-1.937291 2.6993,-3.632969 3.42578,-5.085938 0.72648,-1.487564 1.14035,-2.611968 1.24414,-3.373047 0.13843,-0.795674 0.20703,-1.936266 0.20703,-3.423828 0,-2.283238 -0.91649,-4.083848 -2.75,-5.398437 -1.83351,-1.314591 -4.34074,-1.970704 -7.52344,-1.970704 -3.18269,0 -5.69188,0.656113 -7.52539,1.970704 -1.8335,1.314589 -2.75,3.115199 -2.75,5.398437 l -8.82031,-1.402344 c 0,-4.358904 1.71187,-7.800773 5.13672,-10.326172 C 143.2061,31.636712 147.85917,30.375 153.74023,30.375 Z M 80.675781,31.205078 H 103.7168 c 5.77728,0 10.15378,1.330365 13.1289,3.994141 3.00972,2.663775 4.51367,7.110882 4.51368,13.33789 -1e-5,8.510244 -3.90821,13.871891 -11.72657,16.085938 L 123.84961,97.625 H 114.25 L 100.60352,65.919922 H 89.498047 V 97.625 h -8.822266 z m 8.822266,8.146484 v 18.421876 h 8.822265 c 4.635658,0 8.164328,-0.710533 10.585938,-2.128907 2.42161,-1.418373 3.63086,-3.786351 3.63086,-7.107422 0,-3.286475 -0.76105,-5.640217 -2.2832,-7.058593 -1.48757,-1.418374 -3.66577,-2.126954 -6.53711,-2.126954 z"
-       style="display:inline;fill:#ffffff;stroke:none;stroke-width:23.7399;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;paint-order:stroke markers fill"
-       id="rect1556" />
+       id="path2137"
+       style="fill:#ffffff;stroke-width:5.54109;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 77.041016,30.705078 0,107.74609 148.25391,256 225.29492,178.95898 a 104.83116,104.83117 0 0 0 0,-148.253902 104.83116,104.83117 0 0 0 -148.253904,0 z M 184.92383,57.390625 c 8.02592,0 14.42518,2.00657 19.19922,6.019531 4.77403,4.012961 7.16211,9.374608 7.16211,16.085938 0,3.182692 -0.6056,6.210686 -1.81641,9.082031 -1.17621,2.836747 -3.33823,6.191824 -6.48633,10.066406 -0.86486,1.003241 -3.61629,3.908169 -8.25195,8.716799 -4.63566,4.77404 -11.17223,11.468 -19.61328,20.08203 h 36.58203 v 8.82226 h -49.19336 v -8.82226 c 3.97837,-4.11675 9.39248,-9.63383 16.24219,-16.55274 6.8843,-6.95349 11.20833,-11.432968 12.97265,-13.439448 3.35567,-3.770799 5.69127,-6.954243 7.00586,-9.548828 1.34919,-2.629183 2.02344,-5.207025 2.02344,-7.732422 0,-4.116745 -1.45148,-7.471821 -4.35742,-10.066406 -2.87134,-2.594588 -6.62606,-3.892578 -11.26172,-3.892578 -3.28648,-10e-7 -6.76267,0.571271 -10.42969,1.71289 -3.63242,1.141619 -7.52444,2.871623 -11.67578,5.189453 V 62.527344 c 4.22053,-1.695131 8.16502,-2.974982 11.83203,-3.839844 3.66702,-0.864862 7.02209,-1.296875 10.06641,-1.296875 z m -93.613283,1.400391 h 23.664063 c 8.85619,0 15.46335,1.851125 19.82227,5.552734 4.3589,3.701611 6.5371,9.289311 6.5371,16.761719 0,4.877823 -1.14059,8.92529 -3.42382,12.142578 -2.24865,3.217287 -5.53507,5.447957 -9.85938,6.693359 2.24864,0.761074 4.42685,2.386144 6.53711,4.876954 2.14486,2.4908 4.29069,5.91648 6.43555,10.27539 l 10.63867,21.17187 h -11.26172 l -9.91016,-19.875 c -2.55999,-5.18917 -5.05104,-8.63104 -7.47265,-10.32617 -2.38702,-1.69513 -5.65726,-2.54297 -9.8086,-2.54297 h -11.41601 v 32.74414 H 91.310547 Z m 10.482423,8.615234 v 27.501953 h 13.18164 c 5.05079,0 8.85602,-1.158732 11.41601,-3.476562 2.5946,-2.352424 3.89063,-5.794292 3.89063,-10.326172 0,-4.531878 -1.29603,-7.93942 -3.89063,-10.222657 -2.55999,-2.31783 -6.36522,-3.476562 -11.41601,-3.476562 z"
+       transform="matrix(-0.26458334,0,0,0.26458334,67.733334,0)" />
   </g>
 </svg>
diff -pruN 2.0.1-1/assets/controls/r3_raw.svg 2.1.0-1/assets/controls/r3_raw.svg
--- 2.0.1-1/assets/controls/r3_raw.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/r3_raw.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,44 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   id="svg8"
+   version="1.1"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
+   width="256">
+  <defs
+     id="defs2" />
+  <metadata
+     id="metadata5">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     style="display:inline"
+     id="layer1">
+    <path
+       id="path1554"
+       style="fill:#ffffff;stroke-width:2.92862;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 67.733333,0 C 30.325248,0 3.2333333e-6,30.325245 3.2333333e-6,67.73333 L 109.67245,102.09299 Z" />
+    <text
+       id="text1404"
+       y="25.830172"
+       x="-3.9868231"
+       style="font-style:normal;font-weight:normal;font-size:28.1184px;line-height:1.25;font-family:sans-serif;text-align:start;letter-spacing:0px;word-spacing:0px;text-anchor:start;inline-size:75.2671;display:inline;fill:#000000;fill-opacity:1;stroke:none;stroke-width:0.70296"
+       xml:space="preserve"
+       transform="translate(26.427202,26.364208)"><tspan
+         x="-3.9868231"
+         y="25.830172"><tspan>R3</tspan></tspan></text>
+  </g>
+</svg>
diff -pruN 2.0.1-1/assets/controls/r3.svg 2.1.0-1/assets/controls/r3.svg
--- 2.0.1-1/assets/controls/r3.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/r3.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,36 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   id="svg8"
+   version="1.1"
+   viewBox="0 0 67.733332 67.733336"
+   height="256"
+   width="256">
+  <defs
+     id="defs2" />
+  <metadata
+     id="metadata5">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     style="display:inline"
+     id="layer1">
+    <path
+       id="path1554"
+       style="fill:#ffffff;stroke-width:11.0688;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       d="M 256,0 C 114.61511,0 0,114.61511 0,256 l 414.50977,129.86328 z m -65.89648,118.39453 c 7.95673,0 14.25301,1.8168 18.88867,5.44922 4.63566,3.59783 6.95508,8.47499 6.95508,14.63281 0,4.28972 -1.22934,7.92331 -3.68555,10.89844 -2.45621,2.94053 -5.95055,4.98143 -10.48242,6.12305 5.0162,1.07243 8.92636,3.30309 11.72851,6.69336 2.83675,3.39026 4.25391,7.57698 4.25391,12.55859 0,7.64538 -2.62836,13.56016 -7.88672,17.74609 -5.25836,4.18594 -12.73151,6.2793 -22.41797,6.2793 -3.25188,0 -6.60695,-0.32903 -10.06641,-0.98633 -3.42484,-0.6227 -6.9697,-1.57352 -10.63671,-2.85351 v -10.11914 c 2.90592,1.69512 6.08742,2.97498 9.54687,3.83984 3.45945,0.86486 7.07492,1.29689 10.8457,1.29687 6.57297,2e-5 11.57124,-1.29799 14.9961,-3.89257 3.45945,-2.59459 5.18945,-6.36354 5.18945,-11.31055 0,-4.56647 -1.60888,-8.13141 -4.82617,-10.69141 -3.18269,-2.59458 -7.62785,-3.89062 -13.33594,-3.89062 h -9.0293 v -8.61524 h 9.44532 c 5.15458,0 9.09711,-1.01947 11.83008,-3.06054 2.73296,-2.07567 4.0996,-5.0512 4.0996,-8.92578 2e-5,-3.97838 -1.41715,-7.02255 -4.2539,-9.13282 -2.80215,-2.14485 -6.83343,-3.21679 -12.0918,-3.21679 -2.87134,0 -5.94985,0.31089 -9.23633,0.93359 -3.28647,0.6227 -6.90193,1.59166 -10.8457,2.90625 v -9.3418 c 3.97837,-1.10702 7.6968,-1.93672 11.15625,-2.49023 3.49404,-0.55349 6.78046,-0.83008 9.85938,-0.83008 z m -94.857426,1.40039 H 118.9082 c 8.85619,0 15.46336,1.85113 19.82227,5.55274 4.35891,3.70161 6.53906,9.28931 6.53906,16.76172 0,4.87782 -1.14059,8.92529 -3.42383,12.14257 -2.24864,3.21729 -5.53506,5.44796 -9.85937,6.69336 2.24864,0.76108 4.42684,2.3881 6.53711,4.87891 2.14485,2.4908 4.29069,5.91453 6.43554,10.27344 l 10.63672,21.17187 h -11.25976 l -9.91211,-19.87305 c -2.55999,-5.18916 -5.05104,-8.63299 -7.47266,-10.32812 -2.38702,-1.69513 -5.6553,-2.54102 -9.80664,-2.54102 h -11.41601 v 32.74219 H 95.246094 Z m 10.482426,8.61524 v 27.50195 h 13.17968 c 5.0508,0 8.85603,-1.15873 11.41602,-3.47656 2.59459,-2.35243 3.89258,-5.79429 3.89258,-10.32617 0,-4.53189 -1.29799,-7.93942 -3.89258,-10.22266 -2.55999,-2.31783 -6.36522,-3.47656 -11.41602,-3.47656 z"
+       transform="scale(0.26458333)" />
+  </g>
+</svg>
diff -pruN 2.0.1-1/assets/controls/touchpad_surface.svg 2.1.0-1/assets/controls/touchpad_surface.svg
--- 2.0.1-1/assets/controls/touchpad_surface.svg	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/assets/controls/touchpad_surface.svg	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,65 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1920"
+   height="942"
+   viewBox="0 0 507.99999 249.23751"
+   version="1.1"
+   id="svg981"
+   inkscape:version="1.0.1 (3bc2e813f5, 2020-09-07)"
+   sodipodi:docname="touchpad_surface.svg">
+  <defs
+     id="defs975" />
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#000000"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.24748737"
+     inkscape:cx="876.84187"
+     inkscape:cy="725.61319"
+     inkscape:document-units="mm"
+     inkscape:current-layer="layer1"
+     inkscape:document-rotation="0"
+     showgrid="false"
+     units="px"
+     inkscape:window-width="1916"
+     inkscape:window-height="1031"
+     inkscape:window-x="0"
+     inkscape:window-y="0"
+     inkscape:window-maximized="1" />
+  <metadata
+     id="metadata978">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title></dc:title>
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <rect
+       style="fill:#ffffff;stroke-width:1.59637;stroke-linecap:round;stroke-linejoin:round;paint-order:stroke markers fill"
+       id="rect1544"
+       width="508"
+       height="249.2375"
+       x="-1.7763568e-15"
+       y="0"
+       rx="32"
+       ry="32" />
+  </g>
+</svg>
diff -pruN 2.0.1-1/cmake/FindFFMPEG.cmake 2.1.0-1/cmake/FindFFMPEG.cmake
--- 2.0.1-1/cmake/FindFFMPEG.cmake	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/cmake/FindFFMPEG.cmake	2021-01-15 21:35:50.000000000 +0000
@@ -49,7 +49,11 @@ function (_ffmpeg_find component headern
 
   # Try pkg-config first
   if(PKG_CONFIG_FOUND)
-    pkg_check_modules(FFMPEG_${component} lib${component} IMPORTED_TARGET)
+    if(CMAKE_VERSION VERSION_LESS "3.6")
+      pkg_check_modules(FFMPEG_${component} lib${component})
+    else()
+      pkg_check_modules(FFMPEG_${component} lib${component} IMPORTED_TARGET)
+    endif()
     if(FFMPEG_${component}_FOUND)
       if((TARGET PkgConfig::FFMPEG_${component}) AND (NOT CMAKE_VERSION VERSION_LESS "3.11.0"))
         if(APPLE)
@@ -69,6 +73,9 @@ function (_ffmpeg_find component headern
         add_library(FFMPEG::${component} ALIAS PkgConfig::FFMPEG_${component})
       else()
         add_library("FFMPEG::${component}" INTERFACE IMPORTED)
+        if(CMAKE_VERSION VERSION_LESS "3.6")
+          link_directories("${FFMPEG_${component}_LIBRARY_DIRS}")
+        endif()
         set_target_properties("FFMPEG::${component}" PROPERTIES
           INTERFACE_LINK_DIRECTORIES "${FFMPEG_${component}_LIBRARY_DIRS}"
           INTERFACE_INCLUDE_DIRECTORIES "${FFMPEG_${component}_INCLUDE_DIRS}"
@@ -224,10 +231,14 @@ foreach (_ffmpeg_component IN LISTS FFMP
       list(APPEND _ffmpeg_required_vars
               "FFMPEG_${_ffmpeg_component}_LIBRARIES")
     else()
-      set(FFMPEG_${_ffmpeg_component}_INCLUDE_DIRS
-        "${FFMPEG_${_ffmpeg_component}_INCLUDE_DIR}")
-      set(FFMPEG_${_ffmpeg_component}_LIBRARIES
-        "${FFMPEG_${_ffmpeg_component}_LIBRARY}")
+      if(NOT FFMPEG_${_ffmpeg_component}_INCLUDE_DIRS)
+        set(FFMPEG_${_ffmpeg_component}_INCLUDE_DIRS
+          "${FFMPEG_${_ffmpeg_component}_INCLUDE_DIR}")
+      endif()
+      if(NOT FFMPEG_${_ffmpeg_component}_LIBRARIES)
+        set(FFMPEG_${_ffmpeg_component}_LIBRARIES
+          "${FFMPEG_${_ffmpeg_component}_LIBRARY}")
+      endif()
       list(APPEND FFMPEG_INCLUDE_DIRS
         "${FFMPEG_${_ffmpeg_component}_INCLUDE_DIRS}")
       list(APPEND FFMPEG_LIBRARIES
diff -pruN 2.0.1-1/CMakeLists.txt 2.1.0-1/CMakeLists.txt
--- 2.0.1-1/CMakeLists.txt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/CMakeLists.txt	2021-01-15 21:35:50.000000000 +0000
@@ -31,8 +31,8 @@ tri_option(CHIAKI_USE_SYSTEM_JERASURE "U
 tri_option(CHIAKI_USE_SYSTEM_NANOPB "Use system-provided nanopb instead of submodule" AUTO)
 
 set(CHIAKI_VERSION_MAJOR 2)
-set(CHIAKI_VERSION_MINOR 0)
-set(CHIAKI_VERSION_PATCH 1)
+set(CHIAKI_VERSION_MINOR 1)
+set(CHIAKI_VERSION_PATCH 0)
 set(CHIAKI_VERSION ${CHIAKI_VERSION_MAJOR}.${CHIAKI_VERSION_MINOR}.${CHIAKI_VERSION_PATCH})
 
 set(CPACK_PACKAGE_NAME "chiaki")
diff -pruN 2.0.1-1/debian/changelog 2.1.0-1/debian/changelog
--- 2.0.1-1/debian/changelog	2021-01-15 16:16:30.000000000 +0000
+++ 2.1.0-1/debian/changelog	2021-01-22 16:41:51.000000000 +0000
@@ -1,3 +1,10 @@
+chiaki (2.1.0-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Bumped Standards-Version (no changes needed) 
+
+ -- Bartosz Fenski <fenio@debian.org>  Fri, 22 Jan 2021 17:41:51 +0100
+
 chiaki (2.0.1-1) unstable; urgency=medium
 
   * New upstream version. 
diff -pruN 2.0.1-1/debian/control 2.1.0-1/debian/control
--- 2.0.1-1/debian/control	2021-01-15 16:16:30.000000000 +0000
+++ 2.1.0-1/debian/control	2021-01-22 16:40:54.000000000 +0000
@@ -3,7 +3,7 @@ Section: utils
 Priority: optional
 Maintainer: Bartosz Fenski <fenio@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libopus-dev, qtmultimedia5-dev, libqt5svg5-dev, libsdl2-dev, libavcodec-dev, libswscale-dev, libjerasure-dev, libnanopb-dev, libssl-dev, protobuf-compiler, python3-protobuf, libevdev-dev, libudev-dev, libqt5opengl5-dev, python3-dev, libgl1-mesa-dev, imagemagick, librsvg2-bin, libpthread-stubs0-dev, libpthreadpool-dev, nanopb
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://git.sr.ht/~thestr4ng3r/chiaki
 Rules-Requires-Root: no
 
diff -pruN 2.0.1-1/gui/include/controllermanager.h 2.1.0-1/gui/include/controllermanager.h
--- 2.0.1-1/gui/include/controllermanager.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/include/controllermanager.h	2021-01-15 21:35:50.000000000 +0000
@@ -73,6 +73,7 @@ class Controller : public QObject
 		int GetDeviceID();
 		QString GetName();
 		ChiakiControllerState GetState();
+		void SetRumble(uint8_t left, uint8_t right);
 
 	signals:
 		void StateChanged();
diff -pruN 2.0.1-1/gui/include/streamsession.h 2.1.0-1/gui/include/streamsession.h
--- 2.0.1-1/gui/include/streamsession.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/include/streamsession.h	2021-01-15 21:35:50.000000000 +0000
@@ -13,6 +13,7 @@
 
 #if CHIAKI_GUI_ENABLE_SETSU
 #include <setsu.h>
+#include <chiaki/orientation.h>
 #endif
 
 #include "exception.h"
@@ -74,6 +75,9 @@ class StreamSession : public QObject
 		Setsu *setsu;
 		QMap<QPair<QString, SetsuTrackingId>, uint8_t> setsu_ids;
 		ChiakiControllerState setsu_state;
+		SetsuDevice *setsu_motion_device;
+		ChiakiOrientationTracker orient_tracker;
+		bool orient_dirty;
 #endif
 
 		ChiakiControllerState keyboard_state;
@@ -92,13 +96,13 @@ class StreamSession : public QObject
 		QMap<Qt::Key, int> key_map;
 
 		void PushAudioFrame(int16_t *buf, size_t samples_count);
-		void Event(ChiakiEvent *event);
 #if CHIAKI_GUI_ENABLE_SETSU
 		void HandleSetsuEvent(SetsuEvent *event);
 #endif
 
 	private slots:
 		void InitAudio(unsigned int channels, unsigned int rate);
+		void Event(ChiakiEvent *event);
 
 	public:
 		explicit StreamSession(const StreamSessionConnectInfo &connect_info, QObject *parent = nullptr);
diff -pruN 2.0.1-1/gui/src/avopenglwidget.cpp 2.1.0-1/gui/src/avopenglwidget.cpp
--- 2.0.1-1/gui/src/avopenglwidget.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/avopenglwidget.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -109,7 +109,6 @@ static const float vert_pos[] = {
 	1.0f, 1.0f
 };
 
-
 QSurfaceFormat AVOpenGLWidget::CreateSurfaceFormat()
 {
 	QSurfaceFormat format;
@@ -129,7 +128,7 @@ AVOpenGLWidget::AVOpenGLWidget(StreamSes
 {
 	enum AVPixelFormat pixel_format = chiaki_ffmpeg_decoder_get_pixel_format(session->GetFfmpegDecoder());
 	conversion_config = nullptr;
-	for(auto &cc: conversion_configs)
+	for(auto &cc : conversion_configs)
 	{
 		if(pixel_format == cc.pixel_format)
 		{
diff -pruN 2.0.1-1/gui/src/controllermanager.cpp 2.1.0-1/gui/src/controllermanager.cpp
--- 2.0.1-1/gui/src/controllermanager.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/controllermanager.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -68,7 +68,6 @@ static QSet<QString> chiaki_motion_contr
 	"030000008f0e00001431000000000000",
 });
 
-
 static ControllerManager *instance = nullptr;
 
 #define UPDATE_INTERVAL_MS 4
@@ -252,7 +251,11 @@ QString Controller::GetName()
 #ifdef CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER
 	if(!controller)
 		return QString();
-	return SDL_GameControllerName(controller);
+	SDL_Joystick *js = SDL_GameControllerGetJoystick(controller);
+	SDL_JoystickGUID guid = SDL_JoystickGetGUID(js);
+	char guid_str[256];
+	SDL_JoystickGetGUIDString(guid, guid_str, sizeof(guid_str));
+	return QString("%1 (%2)").arg(SDL_JoystickName(js), guid_str);
 #else
 	return QString();
 #endif
@@ -291,3 +294,12 @@ ChiakiControllerState Controller::GetSta
 #endif
 	return state;
 }
+
+void Controller::SetRumble(uint8_t left, uint8_t right)
+{
+#ifdef CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER
+	if(!controller)
+		return;
+	SDL_GameControllerRumble(controller, (uint16_t)left << 8, (uint16_t)right << 8, 5000);
+#endif
+}
diff -pruN 2.0.1-1/gui/src/main.cpp 2.1.0-1/gui/src/main.cpp
--- 2.0.1-1/gui/src/main.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/main.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -111,7 +111,7 @@ int real_main(int argc, char *argv[])
 	if(args[0] == "list")
 	{
 		for(const auto &host : settings.GetRegisteredHosts())
-		printf("Host: %s \n", host.GetServerNickname().toLocal8Bit().constData());
+			printf("Host: %s \n", host.GetServerNickname().toLocal8Bit().constData());
 		return 0;
 	}
 	if(args[0] == "stream")
@@ -123,6 +123,7 @@ int real_main(int argc, char *argv[])
 		QString host = args[args.size()-1];
 		QByteArray morning;
 		QByteArray regist_key;
+		ChiakiTarget target = CHIAKI_TARGET_PS4_10;
 
 		if(parser.value(regist_key_option).isEmpty() && parser.value(morning_option).isEmpty())
 		{
@@ -134,6 +135,7 @@ int real_main(int argc, char *argv[])
 				{
 					morning = temphost.GetRPKey();
 					regist_key = temphost.GetRPRegistKey();
+					target = temphost.GetTarget();
 					break;
 				}
 				printf("No configuration found for '%s'\n", args[1].toLocal8Bit().constData());
@@ -142,6 +144,7 @@ int real_main(int argc, char *argv[])
 		}
 		else
 		{
+			// TODO: explicit option for target
 			regist_key = parser.value(regist_key_option).toUtf8();
 			if(regist_key.length() > sizeof(ChiakiConnectInfo::regist_key))
 			{
@@ -161,8 +164,7 @@ int real_main(int argc, char *argv[])
 				return 1;
 			}
 		}
-		// TODO: target here
-		StreamSessionConnectInfo connect_info(&settings, CHIAKI_TARGET_PS4_10, host, regist_key, morning, parser.isSet(fullscreen_option));
+		StreamSessionConnectInfo connect_info(&settings, target, host, regist_key, morning, parser.isSet(fullscreen_option));
 		return RunStream(app, connect_info);
 	}
 #ifdef CHIAKI_ENABLE_CLI
diff -pruN 2.0.1-1/gui/src/mainwindow.cpp 2.1.0-1/gui/src/mainwindow.cpp
--- 2.0.1-1/gui/src/mainwindow.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/mainwindow.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -167,7 +167,7 @@ MainWindow::MainWindow(Settings *setting
 	grid_widget->setContentsMargins(0, 0, 0, 0);
 
 	resize(800, 600);
-	
+
 	connect(&discovery_manager, &DiscoveryManager::HostsUpdated, this, &MainWindow::UpdateDisplayServers);
 	connect(settings, &Settings::RegisteredHostsUpdated, this, &MainWindow::UpdateDisplayServers);
 	connect(settings, &Settings::ManualHostsUpdated, this, &MainWindow::UpdateDisplayServers);
@@ -330,7 +330,7 @@ void MainWindow::UpdateDisplayServers()
 
 		display_servers.append(server);
 	}
-	
+
 	UpdateServerWidgets();
 }
 
diff -pruN 2.0.1-1/gui/src/settings.cpp 2.1.0-1/gui/src/settings.cpp
--- 2.0.1-1/gui/src/settings.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/settings.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -88,10 +88,10 @@ uint32_t Settings::GetLogLevelMask()
 }
 
 static const QMap<ChiakiVideoResolutionPreset, QString> resolutions = {
-	{ CHIAKI_VIDEO_RESOLUTION_PRESET_360p, "360p"},
-	{ CHIAKI_VIDEO_RESOLUTION_PRESET_540p, "540p"},
-	{ CHIAKI_VIDEO_RESOLUTION_PRESET_720p, "720p"},
-	{ CHIAKI_VIDEO_RESOLUTION_PRESET_1080p, "1080p"}
+	{ CHIAKI_VIDEO_RESOLUTION_PRESET_360p, "360p" },
+	{ CHIAKI_VIDEO_RESOLUTION_PRESET_540p, "540p" },
+	{ CHIAKI_VIDEO_RESOLUTION_PRESET_720p, "720p" },
+	{ CHIAKI_VIDEO_RESOLUTION_PRESET_1080p, "1080p" }
 };
 
 static const ChiakiVideoResolutionPreset resolution_default = CHIAKI_VIDEO_RESOLUTION_PRESET_720p;
@@ -136,8 +136,8 @@ void Settings::SetBitrate(unsigned int b
 }
 
 static const QMap<ChiakiCodec, QString> codecs = {
-	{ CHIAKI_CODEC_H264, "h264"},
-	{ CHIAKI_CODEC_H265, "h265"}
+	{ CHIAKI_CODEC_H264, "h264" },
+	{ CHIAKI_CODEC_H265, "h265" }
 };
 
 static const ChiakiCodec codec_default = CHIAKI_CODEC_H265;
diff -pruN 2.0.1-1/gui/src/settingsdialog.cpp 2.1.0-1/gui/src/settingsdialog.cpp
--- 2.0.1-1/gui/src/settingsdialog.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/settingsdialog.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -89,7 +89,7 @@ SettingsDialog::SettingsDialog(Settings
 	connect(disconnect_action_combo_box, SIGNAL(currentIndexChanged(int)), this, SLOT(DisconnectActionSelected()));
 
 	general_layout->addRow(tr("Action on Disconnect:"), disconnect_action_combo_box);
-	
+
 	audio_device_combo_box = new QComboBox(this);
 	audio_device_combo_box->addItem(tr("Auto"));
 	auto current_audio_device = settings->GetAudioOutDevice();
@@ -112,7 +112,7 @@ SettingsDialog::SettingsDialog(Settings
 		auto available_devices = audio_devices_future_watcher->result();
 		while(audio_device_combo_box->count() > 1) // remove all but "Auto"
 			audio_device_combo_box->removeItem(1);
-		for (QAudioDeviceInfo di : available_devices)
+		for(QAudioDeviceInfo di : available_devices)
 			audio_device_combo_box->addItem(di.deviceName(), di.deviceName());
 		int audio_out_device_index = audio_device_combo_box->findData(settings->GetAudioOutDevice());
 		audio_device_combo_box->setCurrentIndex(audio_out_device_index < 0 ? 0 : audio_out_device_index);
@@ -136,10 +136,10 @@ SettingsDialog::SettingsDialog(Settings
 
 	resolution_combo_box = new QComboBox(this);
 	static const QList<QPair<ChiakiVideoResolutionPreset, const char *>> resolution_strings = {
-		{ CHIAKI_VIDEO_RESOLUTION_PRESET_360p, "360p"},
-		{ CHIAKI_VIDEO_RESOLUTION_PRESET_540p, "540p"},
-		{ CHIAKI_VIDEO_RESOLUTION_PRESET_720p, "720p"},
-		{ CHIAKI_VIDEO_RESOLUTION_PRESET_1080p, "1080p (PS5 and PS4 Pro only)"}
+		{ CHIAKI_VIDEO_RESOLUTION_PRESET_360p, "360p" },
+		{ CHIAKI_VIDEO_RESOLUTION_PRESET_540p, "540p" },
+		{ CHIAKI_VIDEO_RESOLUTION_PRESET_720p, "720p" },
+		{ CHIAKI_VIDEO_RESOLUTION_PRESET_1080p, "1080p (PS5 and PS4 Pro only)" }
 	};
 	auto current_res = settings->GetResolution();
 	for(const auto &p : resolution_strings)
diff -pruN 2.0.1-1/gui/src/settingskeycapturedialog.cpp 2.1.0-1/gui/src/settingskeycapturedialog.cpp
--- 2.0.1-1/gui/src/settingskeycapturedialog.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/settingskeycapturedialog.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -7,7 +7,7 @@
 #include <QVBoxLayout>
 #include <QKeyEvent>
 
-SettingsKeyCaptureDialog::SettingsKeyCaptureDialog(QWidget* parent)
+SettingsKeyCaptureDialog::SettingsKeyCaptureDialog(QWidget *parent)
 {
 	setWindowTitle(tr("Key Capture"));
 
@@ -23,7 +23,7 @@ SettingsKeyCaptureDialog::SettingsKeyCap
 	connect(button, &QPushButton::clicked, this, &QDialog::accept);
 }
 
-void SettingsKeyCaptureDialog::keyReleaseEvent(QKeyEvent* event)
+void SettingsKeyCaptureDialog::keyReleaseEvent(QKeyEvent *event)
 {
 	KeyCaptured(Qt::Key(event->key()));
 	accept();
diff -pruN 2.0.1-1/gui/src/streamsession.cpp 2.1.0-1/gui/src/streamsession.cpp
--- 2.0.1-1/gui/src/streamsession.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/gui/src/streamsession.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -52,6 +52,7 @@ StreamSession::StreamSession(const Strea
 	audio_io(nullptr)
 {
 	connected = false;
+	ChiakiErrorCode err;
 
 #if CHIAKI_LIB_ENABLE_PI_DECODER
 	if(connect_info.decoder == Decoder::Pi)
@@ -66,7 +67,7 @@ StreamSession::StreamSession(const Strea
 		ffmpeg_decoder = new ChiakiFfmpegDecoder;
 		ChiakiLogSniffer sniffer;
 		chiaki_log_sniffer_init(&sniffer, CHIAKI_LOG_ALL, GetChiakiLog());
-		ChiakiErrorCode err = chiaki_ffmpeg_decoder_init(ffmpeg_decoder,
+		err = chiaki_ffmpeg_decoder_init(ffmpeg_decoder,
 				chiaki_log_sniffer_get_log(&sniffer),
 				chiaki_target_is_ps5(connect_info.target) ? connect_info.video_profile.codec : CHIAKI_CODEC_H264,
 				connect_info.hw_decoder.isEmpty() ? NULL : connect_info.hw_decoder.toUtf8().constData(),
@@ -101,11 +102,20 @@ StreamSession::StreamSession(const Strea
 
 	QByteArray host_str = connect_info.host.toUtf8();
 
-	ChiakiConnectInfo chiaki_connect_info;
+	ChiakiConnectInfo chiaki_connect_info = {};
 	chiaki_connect_info.ps5 = chiaki_target_is_ps5(connect_info.target);
 	chiaki_connect_info.host = host_str.constData();
 	chiaki_connect_info.video_profile = connect_info.video_profile;
 	chiaki_connect_info.video_profile_auto_downgrade = true;
+	chiaki_connect_info.enable_keyboard = false;
+
+#if CHIAKI_LIB_ENABLE_PI_DECODER
+	if(connect_info.decoder == Decoder::Pi && chiaki_connect_info.video_profile.codec != CHIAKI_CODEC_H264)
+	{
+		CHIAKI_LOGW(GetChiakiLog(), "A codec other than H264 was requested for Pi Decoder. Falling back to it.");
+		chiaki_connect_info.video_profile.codec = CHIAKI_CODEC_H264;
+	}
+#endif
 
 	if(connect_info.regist_key.size() != sizeof(chiaki_connect_info.regist_key))
 		throw ChiakiException("RegistKey invalid");
@@ -144,11 +154,20 @@ StreamSession::StreamSession(const Strea
 #endif
 
 #if CHIAKI_GUI_ENABLE_SETSU
+	setsu_motion_device = nullptr;
 	chiaki_controller_state_set_idle(&setsu_state);
+	orient_dirty = true;
+	chiaki_orientation_tracker_init(&orient_tracker);
 	setsu = setsu_new();
 	auto timer = new QTimer(this);
 	connect(timer, &QTimer::timeout, this, [this]{
 		setsu_poll(setsu, SessionSetsuCb, this);
+		if(orient_dirty)
+		{
+			chiaki_orientation_tracker_apply_to_controller_state(&orient_tracker, &setsu_state);
+			SendFeedbackState();
+			orient_dirty = false;
+		}
 	});
 	timer->start(SETSU_UPDATE_INTERVAL_MS);
 #endif
@@ -312,17 +331,16 @@ void StreamSession::SendFeedbackState()
 	ChiakiControllerState state;
 	chiaki_controller_state_set_idle(&state);
 
-#if CHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER
+#if CHIAKI_GUI_ENABLE_SETSU
+	// setsu is the one that potentially has gyro/accel/orient so copy that directly first
+	state = setsu_state;
+#endif
+
 	for(auto controller : controllers)
 	{
 		auto controller_state = controller->GetState();
 		chiaki_controller_state_or(&state, &state, &controller_state);
 	}
-#endif
-
-#if CHIAKI_GUI_ENABLE_SETSU
-	chiaki_controller_state_or(&state, &state, &setsu_state);
-#endif
 
 	chiaki_controller_state_or(&state, &state, &keyboard_state);
 	chiaki_session_set_controller_state(&session, &state);
@@ -380,6 +398,17 @@ void StreamSession::Event(ChiakiEvent *e
 		case CHIAKI_EVENT_LOGIN_PIN_REQUEST:
 			emit LoginPINRequested(event->login_pin_request.pin_incorrect);
 			break;
+		case CHIAKI_EVENT_RUMBLE: {
+			uint8_t left = event->rumble.left;
+			uint8_t right = event->rumble.right;
+			QMetaObject::invokeMethod(this, [this, left, right]() {
+				for(auto controller : controllers)
+					controller->SetRumble(left, right);
+			});
+			break;
+		}
+		default:
+			break;
 	}
 }
 
@@ -391,27 +420,64 @@ void StreamSession::HandleSetsuEvent(Set
 	switch(event->type)
 	{
 		case SETSU_EVENT_DEVICE_ADDED:
-			setsu_connect(setsu, event->path);
+			switch(event->dev_type)
+			{
+				case SETSU_DEVICE_TYPE_TOUCHPAD:
+					// connect all the touchpads!
+					if(setsu_connect(setsu, event->path, event->dev_type))
+						CHIAKI_LOGI(GetChiakiLog(), "Connected Setsu Touchpad Device %s", event->path);
+					else
+						CHIAKI_LOGE(GetChiakiLog(), "Failed to connect to Setsu Touchpad Device %s", event->path);
+					break;
+				case SETSU_DEVICE_TYPE_MOTION:
+					// connect only one motion since multiple make no sense
+					if(setsu_motion_device)
+					{
+						CHIAKI_LOGI(GetChiakiLog(), "Setsu Motion Device %s detected there is already one connected",
+								event->path);
+						break;
+					}
+					setsu_motion_device = setsu_connect(setsu, event->path, event->dev_type);
+					if(setsu_motion_device)
+						CHIAKI_LOGI(GetChiakiLog(), "Connected Setsu Motion Device %s", event->path);
+					else
+						CHIAKI_LOGE(GetChiakiLog(), "Failed to connect to Setsu Motion Device %s", event->path);
+					break;
+			}
 			break;
 		case SETSU_EVENT_DEVICE_REMOVED:
-			for(auto it=setsu_ids.begin(); it!=setsu_ids.end();)
+			switch(event->dev_type)
 			{
-				if(it.key().first == event->path)
-				{
-					chiaki_controller_state_stop_touch(&setsu_state, it.value());
-					setsu_ids.erase(it++);
-				}
-				else
-					it++;
+				case SETSU_DEVICE_TYPE_TOUCHPAD:
+					CHIAKI_LOGI(GetChiakiLog(), "Setsu Touchpad Device %s disconnected", event->path);
+					for(auto it=setsu_ids.begin(); it!=setsu_ids.end();)
+					{
+						if(it.key().first == event->path)
+						{
+							chiaki_controller_state_stop_touch(&setsu_state, it.value());
+							setsu_ids.erase(it++);
+						}
+						else
+							it++;
+					}
+					SendFeedbackState();
+					break;
+				case SETSU_DEVICE_TYPE_MOTION:
+					if(!setsu_motion_device || strcmp(setsu_device_get_path(setsu_motion_device), event->path))
+						break;
+					CHIAKI_LOGI(GetChiakiLog(), "Setsu Motion Device %s disconnected", event->path);
+					setsu_motion_device = nullptr;
+					chiaki_orientation_tracker_init(&orient_tracker);
+					orient_dirty = true;
+					break;
 			}
-			SendFeedbackState();
 			break;
 		case SETSU_EVENT_TOUCH_DOWN:
 			break;
 		case SETSU_EVENT_TOUCH_UP:
 			for(auto it=setsu_ids.begin(); it!=setsu_ids.end(); it++)
 			{
-				if(it.key().first == setsu_device_get_path(event->dev) && it.key().second == event->tracking_id)
+				if(it.key().first == setsu_device_get_path(event->dev) && it.key().second == event->touch.tracking_id)
 				{
 					chiaki_controller_state_stop_touch(&setsu_state, it.value());
 					setsu_ids.erase(it);
@@ -421,18 +487,18 @@ void StreamSession::HandleSetsuEvent(Set
 			SendFeedbackState();
 			break;
 		case SETSU_EVENT_TOUCH_POSITION: {
-			QPair<QString, SetsuTrackingId> k =  { setsu_device_get_path(event->dev), event->tracking_id };
+			QPair<QString, SetsuTrackingId> k =  { setsu_device_get_path(event->dev), event->touch.tracking_id };
 			auto it = setsu_ids.find(k);
 			if(it == setsu_ids.end())
 			{
-				int8_t cid = chiaki_controller_state_start_touch(&setsu_state, event->x, event->y);
+				int8_t cid = chiaki_controller_state_start_touch(&setsu_state, event->touch.x, event->touch.y);
 				if(cid >= 0)
 					setsu_ids[k] = (uint8_t)cid;
 				else
 					break;
 			}
 			else
-				chiaki_controller_state_set_touch_pos(&setsu_state, it.value(), event->x, event->y);
+				chiaki_controller_state_set_touch_pos(&setsu_state, it.value(), event->touch.x, event->touch.y);
 			SendFeedbackState();
 			break;
 		}
@@ -442,6 +508,13 @@ void StreamSession::HandleSetsuEvent(Set
 		case SETSU_EVENT_BUTTON_UP:
 			setsu_state.buttons &= ~CHIAKI_CONTROLLER_BUTTON_TOUCHPAD;
 			break;
+		case SETSU_EVENT_MOTION:
+			chiaki_orientation_tracker_update(&orient_tracker,
+					event->motion.gyro_x, event->motion.gyro_y, event->motion.gyro_z,
+					event->motion.accel_x, event->motion.accel_y, event->motion.accel_z,
+					event->motion.timestamp);
+			orient_dirty = true;
+			break;
 	}
 }
 #endif
diff -pruN 2.0.1-1/lib/CMakeLists.txt 2.1.0-1/lib/CMakeLists.txt
--- 2.0.1-1/lib/CMakeLists.txt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/CMakeLists.txt	2021-01-15 21:35:50.000000000 +0000
@@ -35,7 +35,8 @@ set(HEADER_FILES
 		include/chiaki/time.h
 		include/chiaki/fec.h
 		include/chiaki/regist.h
-		include/chiaki/opusdecoder.h)
+		include/chiaki/opusdecoder.h
+		include/chiaki/orientation.h)
 
 set(SOURCE_FILES
 		src/common.c
@@ -73,7 +74,8 @@ set(SOURCE_FILES
 		src/time.c
 		src/fec
 		src/regist.c
-		src/opusdecoder.c)
+		src/opusdecoder.c
+		src/orientation.c)
 
 if(CHIAKI_ENABLE_FFMPEG_DECODER)
 	list(APPEND HEADER_FILES include/chiaki/ffmpegdecoder.h)
diff -pruN 2.0.1-1/lib/include/chiaki/controller.h 2.1.0-1/lib/include/chiaki/controller.h
--- 2.0.1-1/lib/include/chiaki/controller.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/controller.h	2021-01-15 21:35:50.000000000 +0000
@@ -66,6 +66,10 @@ typedef struct chiaki_controller_state_t
 
 	uint8_t touch_id_next;
 	ChiakiControllerTouch touches[CHIAKI_CONTROLLER_TOUCHES_MAX];
+
+	float gyro_x, gyro_y, gyro_z;
+	float accel_x, accel_y, accel_z;
+	float orient_x, orient_y, orient_z, orient_w;
 } ChiakiControllerState;
 
 CHIAKI_EXPORT void chiaki_controller_state_set_idle(ChiakiControllerState *state);
@@ -79,27 +83,12 @@ CHIAKI_EXPORT void chiaki_controller_sta
 
 CHIAKI_EXPORT void chiaki_controller_state_set_touch_pos(ChiakiControllerState *state, uint8_t id, uint16_t x, uint16_t y);
 
-static inline bool chiaki_controller_state_equals(ChiakiControllerState *a, ChiakiControllerState *b)
-{
-	if(!(a->buttons == b->buttons
-		&& a->l2_state == b->l2_state
-		&& a->r2_state == b->r2_state
-		&& a->left_x == b->left_x
-		&& a->left_y == b->left_y
-		&& a->right_x == b->right_x
-		&& a->right_y == b->right_y))
-		return false;
-
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
-	{
-		if(a->touches[i].id != b->touches[i].id)
-			return false;
-		if(a->touches[i].id >= 0 && (a->touches[i].x != b->touches[i].x || a->touches[i].y != b->touches[i].y))
-			return false;
-	}
-	return true;
-}
+CHIAKI_EXPORT bool chiaki_controller_state_equals(ChiakiControllerState *a, ChiakiControllerState *b);
 
+/**
+ * Union of two controller states.
+ * Ignores gyro, accel and orient because it makes no sense there.
+ */
 CHIAKI_EXPORT void chiaki_controller_state_or(ChiakiControllerState *out, ChiakiControllerState *a, ChiakiControllerState *b);
 
 #ifdef __cplusplus
diff -pruN 2.0.1-1/lib/include/chiaki/discovery.h 2.1.0-1/lib/include/chiaki/discovery.h
--- 2.0.1-1/lib/include/chiaki/discovery.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/discovery.h	2021-01-15 21:35:50.000000000 +0000
@@ -25,6 +25,8 @@ extern "C" {
 #define CHIAKI_DISCOVERY_PROTOCOL_VERSION_PS4 "00020020"
 #define CHIAKI_DISCOVERY_PORT_PS5 9302
 #define CHIAKI_DISCOVERY_PROTOCOL_VERSION_PS5 "00030010"
+#define CHIAKI_DISCOVERY_PORT_LOCAL_MIN 9303
+#define CHIAKI_DISCOVERY_PORT_LOCAL_MAX 9319
 
 typedef enum chiaki_discovery_cmd_t
 {
diff -pruN 2.0.1-1/lib/include/chiaki/feedback.h 2.1.0-1/lib/include/chiaki/feedback.h
--- 2.0.1-1/lib/include/chiaki/feedback.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/feedback.h	2021-01-15 21:35:50.000000000 +0000
@@ -15,6 +15,9 @@ extern "C" {
 
 typedef struct chiaki_feedback_state_t
 {
+	float gyro_x, gyro_y, gyro_z;
+	float accel_x, accel_y, accel_z;
+	float orient_x, orient_y, orient_z, orient_w;
 	int16_t left_x;
 	int16_t left_y;
 	int16_t right_x;
diff -pruN 2.0.1-1/lib/include/chiaki/orientation.h 2.1.0-1/lib/include/chiaki/orientation.h
--- 2.0.1-1/lib/include/chiaki/orientation.h	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/orientation.h	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,49 @@
+// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
+
+#ifndef CHIAKI_ORIENTATION_H
+#define CHIAKI_ORIENTATION_H
+
+#include "common.h"
+#include "controller.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/**
+ * Quaternion orientation from accelerometer and gyroscope
+ * using Madgwick's algorithm.
+ * See: http://www.x-io.co.uk/node/8#open_source_ahrs_and_imu_algorithms
+ */
+typedef struct chiaki_orientation_t
+{
+	float x, y, z, w;
+} ChiakiOrientation;
+
+CHIAKI_EXPORT void chiaki_orientation_init(ChiakiOrientation *orient);
+CHIAKI_EXPORT void chiaki_orientation_update(ChiakiOrientation *orient,
+		float gx, float gy, float gz, float ax, float ay, float az, float beta, float time_step_sec);
+
+/**
+ * Extension of ChiakiOrientation, also tracking an absolute timestamp and the current gyro/accel state
+ */
+typedef struct chiaki_orientation_tracker_t
+{
+	float gyro_x, gyro_y, gyro_z;
+	float accel_x, accel_y, accel_z;
+	ChiakiOrientation orient;
+	uint32_t timestamp;
+	uint64_t sample_index;
+} ChiakiOrientationTracker;
+
+CHIAKI_EXPORT void chiaki_orientation_tracker_init(ChiakiOrientationTracker *tracker);
+CHIAKI_EXPORT void chiaki_orientation_tracker_update(ChiakiOrientationTracker *tracker,
+		float gx, float gy, float gz, float ax, float ay, float az, uint32_t timestamp_us);
+CHIAKI_EXPORT void chiaki_orientation_tracker_apply_to_controller_state(ChiakiOrientationTracker *tracker,
+		ChiakiControllerState *state);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // CHIAKI_ORIENTATION_H
diff -pruN 2.0.1-1/lib/include/chiaki/session.h 2.1.0-1/lib/include/chiaki/session.h
--- 2.0.1-1/lib/include/chiaki/session.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/session.h	2021-01-15 21:35:50.000000000 +0000
@@ -114,6 +114,12 @@ typedef struct chiaki_audio_stream_info_
 	ChiakiAudioHeader audio_header;
 } ChiakiAudioStreamInfoEvent;
 
+typedef struct chiaki_rumble_event_t
+{
+	uint8_t unknown;
+	uint8_t left; // low-frequency
+	uint8_t right; // high-frequency
+} ChiakiRumbleEvent;
 
 typedef enum {
 	CHIAKI_EVENT_CONNECTED,
@@ -121,6 +127,7 @@ typedef enum {
 	CHIAKI_EVENT_KEYBOARD_OPEN,
 	CHIAKI_EVENT_KEYBOARD_TEXT_CHANGE,
 	CHIAKI_EVENT_KEYBOARD_REMOTE_CLOSE,
+	CHIAKI_EVENT_RUMBLE,
 	CHIAKI_EVENT_QUIT,
 } ChiakiEventType;
 
@@ -131,6 +138,7 @@ typedef struct chiaki_event_t
 	{
 		ChiakiQuitEvent quit;
 		ChiakiKeyboardEvent keyboard;
+		ChiakiRumbleEvent rumble;
 		struct
 		{
 			bool pin_incorrect; // false on first request, true if the pin entered before was incorrect
@@ -155,7 +163,7 @@ typedef struct chiaki_session_t
 		bool ps5;
 		struct addrinfo *host_addrinfos;
 		struct addrinfo *host_addrinfo_selected;
-		char hostname[128];
+		char hostname[256];
 		char regist_key[CHIAKI_RPCRYPT_KEY_SIZE];
 		uint8_t morning[CHIAKI_RPCRYPT_KEY_SIZE];
 		uint8_t did[CHIAKI_RP_DID_SIZE];
diff -pruN 2.0.1-1/lib/include/chiaki/takion.h 2.1.0-1/lib/include/chiaki/takion.h
--- 2.0.1-1/lib/include/chiaki/takion.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/include/chiaki/takion.h	2021-01-15 21:35:50.000000000 +0000
@@ -26,6 +26,7 @@ extern "C" {
 
 typedef enum chiaki_takion_message_data_type_t {
 	CHIAKI_TAKION_MESSAGE_DATA_TYPE_PROTOBUF = 0,
+	CHIAKI_TAKION_MESSAGE_DATA_TYPE_RUMBLE = 7,
 	CHIAKI_TAKION_MESSAGE_DATA_TYPE_9 = 9
 } ChiakiTakionMessageDataType;
 
diff -pruN 2.0.1-1/lib/src/audioreceiver.c 2.1.0-1/lib/src/audioreceiver.c
--- 2.0.1-1/lib/src/audioreceiver.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/audioreceiver.c	2021-01-15 21:35:50.000000000 +0000
@@ -23,7 +23,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_aud
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 CHIAKI_EXPORT void chiaki_audio_receiver_fini(ChiakiAudioReceiver *audio_receiver)
 {
 #ifdef CHIAKI_LIB_ENABLE_OPUS
@@ -32,7 +31,6 @@ CHIAKI_EXPORT void chiaki_audio_receiver
 	chiaki_mutex_fini(&audio_receiver->mutex);
 }
 
-
 CHIAKI_EXPORT void chiaki_audio_receiver_stream_info(ChiakiAudioReceiver *audio_receiver, ChiakiAudioHeader *audio_header)
 {
 	chiaki_mutex_lock(&audio_receiver->mutex);
@@ -79,15 +77,15 @@ CHIAKI_EXPORT void chiaki_audio_receiver
 	if(packet->data_size != (size_t)unit_size * (size_t)packet->units_in_frame_total)
 	{
 		CHIAKI_LOGE(audio_receiver->log, "Audio AV Packet size mismatch %#llx vs %#llx",
-				(unsigned long long)packet->data_size,
-				(unsigned long long)(unit_size * packet->units_in_frame_total));
+			(unsigned long long)packet->data_size,
+			(unsigned long long)(unit_size * packet->units_in_frame_total));
 		return;
 	}
 
 	if(packet->frame_index > (1 << 15))
 		audio_receiver->frame_index_startup = false;
 
-	for(size_t i=0; i<source_units_count+fec_units_count; i++)
+	for(size_t i = 0; i < source_units_count + fec_units_count; i++)
 	{
 		ChiakiSeqNum16 frame_index;
 		if(i < source_units_count)
diff -pruN 2.0.1-1/lib/src/base64.c 2.1.0-1/lib/src/base64.c
--- 2.0.1-1/lib/src/base64.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/base64.c	2021-01-15 21:35:50.000000000 +0000
@@ -7,7 +7,6 @@
 // Implementations taken from
 // https://en.wikibooks.org/wiki/Algorithm_Implementation/Miscellaneous/Base64
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_base64_encode(const uint8_t *in, size_t in_size, char *out, size_t out_size)
 {
 	const char base64chars[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
@@ -23,11 +22,11 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 		// these three 8-bit (ASCII) characters become one 24-bit number
 		n = ((uint32_t)in[x]) << 16;
 
-		if((x+1) < in_size)
-			n += ((uint32_t)in[x+1]) << 8;
+		if((x + 1) < in_size)
+			n += ((uint32_t)in[x + 1]) << 8;
 
-		if((x+2) < in_size)
-			n += in[x+2];
+		if((x + 2) < in_size)
+			n += in[x + 2];
 
 		// this 24-bit number gets separated into four 6-bit numbers
 		n0 = (uint8_t)(n >> 18) & 63;
@@ -46,7 +45,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 
 		// if we have only two bytes available, then their encoding is
 		// spread out over three chars
-		if((x+1) < in_size)
+		if((x + 1) < in_size)
 		{
 			if(result_index >= out_size)
 				return CHIAKI_ERR_BUF_TOO_SMALL;
@@ -55,7 +54,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 
 		// if we have all three bytes available, then their encoding is spread
 		// out over four characters
-		if((x+2) < in_size)
+		if((x + 2) < in_size)
 		{
 			if(result_index >= out_size)
 				return CHIAKI_ERR_BUF_TOO_SMALL;
@@ -65,9 +64,9 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 
 	// create and add padding that is required if we did not have a multiple of 3
 	// number of characters available
-	if (pad_count > 0)
+	if(pad_count > 0)
 	{
-		for (; pad_count < 3; pad_count++)
+		for(; pad_count < 3; pad_count++)
 		{
 			if(result_index >= out_size)
 				return CHIAKI_ERR_BUF_TOO_SMALL;
@@ -80,25 +79,22 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
-
-
 #define WHITESPACE 64
-#define EQUALS     65
-#define INVALID    66
+#define EQUALS	   65
+#define INVALID	   66
 
 static const unsigned char d[] = {
-		66,66,66,66,66,66,66,66,66,66,64,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,62,66,66,66,63,52,53,
-		54,55,56,57,58,59,60,61,66,66,66,65,66,66,66, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
-		10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,66,66,66,66,66,66,26,27,28,
-		29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,66,
-		66,66,66,66,66,66
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 64, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 62, 66, 66, 66, 63, 52, 53,
+	54, 55, 56, 57, 58, 59, 60, 61, 66, 66, 66, 65, 66, 66, 66, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
+	10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 66, 66, 66, 66, 66, 66, 26, 27, 28,
+	29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66,
+	66, 66, 66, 66, 66, 66
 };
 
 CHIAKI_EXPORT ChiakiErrorCode chiaki_base64_decode(const char *in, size_t in_size, uint8_t *out, size_t *out_size)
@@ -108,17 +104,17 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 	uint32_t buf = 0;
 	size_t len = 0;
 
-	while (in < end)
+	while(in < end)
 	{
 		unsigned char c = d[(size_t)(*in++)];
 
 		switch(c)
 		{
 			case WHITESPACE:
-				continue;		// skip whitespace
+				continue; // skip whitespace
 			case INVALID:
-				return CHIAKI_ERR_INVALID_DATA;   // invalid input
-			case EQUALS:		// pad character, end of data
+				return CHIAKI_ERR_INVALID_DATA; // invalid input
+			case EQUALS:						// pad character, end of data
 				in = end;
 				continue;
 			default:
@@ -132,7 +128,8 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_bas
 					*(out++) = (unsigned char)((buf >> 16) & 0xff);
 					*(out++) = (unsigned char)((buf >> 8) & 0xff);
 					*(out++) = (unsigned char)(buf & 0xff);
-					buf = 0; iter = 0;
+					buf = 0;
+					iter = 0;
 				}
 		}
 	}
diff -pruN 2.0.1-1/lib/src/common.c 2.1.0-1/lib/src/common.c
--- 2.0.1-1/lib/src/common.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/common.c	2021-01-15 21:35:50.000000000 +0000
@@ -1,14 +1,14 @@
 // SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
 
 #include <chiaki/common.h>
-#include <chiaki/random.h>
 #include <chiaki/fec.h>
+#include <chiaki/random.h>
 
 #include <galois.h>
 
+#include <errno.h>
 #include <stdlib.h>
 #include <time.h>
-#include <errno.h>
 
 #ifdef _WIN32
 #include <winsock2.h>
@@ -98,7 +98,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_lib
 		WORD wsa_version = MAKEWORD(2, 2);
 		WSADATA wsa_data;
 		int err = WSAStartup(wsa_version, &wsa_data);
-		if (err != 0)
+		if(err != 0)
 			return CHIAKI_ERR_NETWORK;
 	}
 #endif
diff -pruN 2.0.1-1/lib/src/congestioncontrol.c 2.1.0-1/lib/src/congestioncontrol.c
--- 2.0.1-1/lib/src/congestioncontrol.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/congestioncontrol.c	2021-01-15 21:35:50.000000000 +0000
@@ -25,7 +25,7 @@ static void *congestion_control_thread_f
 		packet.received = (uint16_t)received;
 		packet.lost = (uint16_t)lost;
 		CHIAKI_LOGV(control->takion->log, "Sending Congestion Control Packet, received: %u, lost: %u",
-				(unsigned int)packet.received, (unsigned int)packet.lost);
+			(unsigned int)packet.received, (unsigned int)packet.lost);
 		chiaki_takion_send_congestion(control->takion, &packet);
 	}
 
diff -pruN 2.0.1-1/lib/src/controller.c 2.1.0-1/lib/src/controller.c
--- 2.0.1-1/lib/src/controller.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/controller.c	2021-01-15 21:35:50.000000000 +0000
@@ -14,17 +14,25 @@ CHIAKI_EXPORT void chiaki_controller_sta
 	state->right_x = 0;
 	state->right_y = 0;
 	state->touch_id_next = 0;
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
 	{
 		state->touches[i].id = -1;
 		state->touches[i].x = 0;
 		state->touches[i].y = 0;
 	}
+	state->gyro_x = state->gyro_y = state->gyro_z = 0.0f;
+	state->accel_x = 0.0f;
+	state->accel_y = 1.0f;
+	state->accel_z = 0.0f;
+	state->orient_x = 0.0f;
+	state->orient_y = 0.0f;
+	state->orient_z = 0.0f;
+	state->orient_w = 1.0f;
 }
 
 CHIAKI_EXPORT int8_t chiaki_controller_state_start_touch(ChiakiControllerState *state, uint16_t x, uint16_t y)
 {
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
 	{
 		if(state->touches[i].id < 0)
 		{
@@ -40,7 +48,7 @@ CHIAKI_EXPORT int8_t chiaki_controller_s
 
 CHIAKI_EXPORT void chiaki_controller_state_stop_touch(ChiakiControllerState *state, uint8_t id)
 {
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
 	{
 		if(state->touches[i].id == id)
 		{
@@ -53,7 +61,7 @@ CHIAKI_EXPORT void chiaki_controller_sta
 CHIAKI_EXPORT void chiaki_controller_state_set_touch_pos(ChiakiControllerState *state, uint8_t id, uint16_t x, uint16_t y)
 {
 	id &= TOUCH_ID_MASK;
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
 	{
 		if(state->touches[i].id == id)
 		{
@@ -64,8 +72,43 @@ CHIAKI_EXPORT void chiaki_controller_sta
 	}
 }
 
-#define MAX(a, b) ((a) > (b) ? (a) : (b))
-#define ABS(a) ((a) > 0 ? (a) : -(a))
+CHIAKI_EXPORT bool chiaki_controller_state_equals(ChiakiControllerState *a, ChiakiControllerState *b)
+{
+	if(!(a->buttons == b->buttons
+		&& a->l2_state == b->l2_state
+		&& a->r2_state == b->r2_state
+		&& a->left_x == b->left_x
+		&& a->left_y == b->left_y
+		&& a->right_x == b->right_x
+		&& a->right_y == b->right_y))
+		return false;
+
+	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	{
+		if(a->touches[i].id != b->touches[i].id)
+			return false;
+		if(a->touches[i].id >= 0 && (a->touches[i].x != b->touches[i].x || a->touches[i].y != b->touches[i].y))
+			return false;
+	}
+
+#define CHECKF(n) if(a->n < b->n - 0.0000001f || a->n > b->n + 0.0000001f) return false
+	CHECKF(gyro_x);
+	CHECKF(gyro_y);
+	CHECKF(gyro_z);
+	CHECKF(accel_x);
+	CHECKF(accel_y);
+	CHECKF(accel_z);
+	CHECKF(orient_x);
+	CHECKF(orient_y);
+	CHECKF(orient_z);
+	CHECKF(orient_w);
+#undef CHECKF
+
+	return true;
+}
+
+#define MAX(a, b)	  ((a) > (b) ? (a) : (b))
+#define ABS(a)		  ((a) > 0 ? (a) : -(a))
 #define MAX_ABS(a, b) (ABS(a) > ABS(b) ? (a) : (b))
 
 CHIAKI_EXPORT void chiaki_controller_state_or(ChiakiControllerState *out, ChiakiControllerState *a, ChiakiControllerState *b)
@@ -79,7 +122,7 @@ CHIAKI_EXPORT void chiaki_controller_sta
 	out->right_y = MAX_ABS(a->right_y, b->right_y);
 
 	out->touch_id_next = 0;
-	for(size_t i=0; i<CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	for(size_t i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
 	{
 		ChiakiControllerTouch *touch = a->touches[i].id >= 0 ? &a->touches[i] : (b->touches[i].id >= 0 ? &b->touches[i] : NULL);
 		if(!touch)
diff -pruN 2.0.1-1/lib/src/ctrl.c 2.1.0-1/lib/src/ctrl.c
--- 2.0.1-1/lib/src/ctrl.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/ctrl.c	2021-01-15 21:35:50.000000000 +0000
@@ -501,7 +501,6 @@ static void ctrl_enable_optional_feature
 	ctrl_message_send(ctrl, 0x36, pre_enable, 4);
 }
 
-
 static void ctrl_message_received_session_id(ChiakiCtrl *ctrl, uint8_t *payload, size_t payload_size)
 {
 	if(ctrl->session->ctrl_session_id_received)
@@ -652,7 +651,7 @@ static void ctrl_message_received_keyboa
 	chiaki_session_send_event(ctrl->session, &keyboard_event);
 }
 
-static void ctrl_message_received_keyboard_text_change(ChiakiCtrl* ctrl, uint8_t* payload, size_t payload_size)
+static void ctrl_message_received_keyboard_text_change(ChiakiCtrl *ctrl, uint8_t *payload, size_t payload_size)
 {
 	assert(payload_size >= sizeof(CtrlKeyboardTextResponseMessage));
 
@@ -676,7 +675,8 @@ static void ctrl_message_received_keyboa
 		free(buffer);
 }
 
-typedef struct ctrl_response_t {
+typedef struct ctrl_response_t
+{
 	bool server_type_valid;
 	uint8_t rp_server_type[0x10];
 	bool success;
@@ -742,7 +742,6 @@ static ChiakiErrorCode ctrl_connect(Chia
 	if(err != CHIAKI_ERR_SUCCESS)
 		CHIAKI_LOGE(session->log, "Failed to set ctrl socket to non-blocking: %s", chiaki_error_string(err));
 
-
 	chiaki_mutex_unlock(&ctrl->notif_mutex);
 	err = chiaki_stop_pipe_connect(&ctrl->notif_pipe, sock, sa, addr->ai_addrlen);
 	chiaki_mutex_lock(&ctrl->notif_mutex);
diff -pruN 2.0.1-1/lib/src/discovery.c 2.1.0-1/lib/src/discovery.c
--- 2.0.1-1/lib/src/discovery.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/discovery.c	2021-01-15 21:35:50.000000000 +0000
@@ -152,27 +152,48 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_dis
 		return CHIAKI_ERR_NETWORK;
 	}
 
-	memset(&discovery->local_addr, 0, sizeof(discovery->local_addr));
-	discovery->local_addr.sa_family = family;
-	if(family == AF_INET6)
+	// First try CHIAKI_DISCOVERY_PORT_LOCAL_MIN..<MAX, then 0 (random)
+	uint16_t port = CHIAKI_DISCOVERY_PORT_LOCAL_MIN;
+	int r;
+	while(true)
 	{
+		memset(&discovery->local_addr, 0, sizeof(discovery->local_addr));
+		discovery->local_addr.sa_family = family;
+		if(family == AF_INET6)
+		{
 #ifndef __SWITCH__
-		struct in6_addr anyaddr = IN6ADDR_ANY_INIT;
+			struct in6_addr anyaddr = IN6ADDR_ANY_INIT;
 #endif
-		struct sockaddr_in6 *addr = (struct sockaddr_in6 *)&discovery->local_addr;
+			struct sockaddr_in6 *addr = (struct sockaddr_in6 *)&discovery->local_addr;
 #ifndef __SWITCH__
-		addr->sin6_addr = anyaddr;
+			addr->sin6_addr = anyaddr;
 #endif
-		addr->sin6_port = htons(0);
-	}
-	else // AF_INET
-	{
-		struct sockaddr_in *addr = (struct sockaddr_in *)&discovery->local_addr;
-		addr->sin_addr.s_addr = htonl(INADDR_ANY);
-		addr->sin_port = htons(0);
+			addr->sin6_port = htons(port);
+		}
+		else // AF_INET
+		{
+			struct sockaddr_in *addr = (struct sockaddr_in *)&discovery->local_addr;
+			addr->sin_addr.s_addr = htonl(INADDR_ANY);
+			addr->sin_port = htons(port);
+		}
+
+		r = bind(discovery->socket, &discovery->local_addr, sizeof(discovery->local_addr));
+		if(r >= 0 || !port)
+			break;
+		if(port == CHIAKI_DISCOVERY_PORT_LOCAL_MAX)
+		{
+			port = 0;
+			CHIAKI_LOGI(discovery->log, "Discovery failed to bind port %u, trying random",
+					(unsigned int)port);
+		}
+		else
+		{
+			port++;
+			CHIAKI_LOGI(discovery->log, "Discovery failed to bind port %u, trying one higher",
+					(unsigned int)port);
+		}
 	}
 
-	int r = bind(discovery->socket, &discovery->local_addr, sizeof(discovery->local_addr));
 	if(r < 0)
 	{
 		CHIAKI_LOGE(discovery->log, "Discovery failed to bind");
diff -pruN 2.0.1-1/lib/src/discoveryservice.c 2.1.0-1/lib/src/discoveryservice.c
--- 2.0.1-1/lib/src/discoveryservice.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/discoveryservice.c	2021-01-15 21:35:50.000000000 +0000
@@ -238,7 +238,7 @@ static void discovery_service_host_recei
 		if(service->hosts_count == service->options.hosts_max)
 		{
 			CHIAKI_LOGE(service->log, "Discovery Service received new host, but no space available");
-			goto r2con;
+			goto rzcon;
 		}
 
 		CHIAKI_LOGI(service->log, "Discovery Service detected new host with id %s", host->host_id);
@@ -279,7 +279,7 @@ static void discovery_service_host_recei
 	if(change)
 		discovery_service_report_state(service);
 
-r2con:
+rzcon:
 	chiaki_mutex_unlock(&service->state_mutex);
 }
 
diff -pruN 2.0.1-1/lib/src/ecdh.c 2.1.0-1/lib/src/ecdh.c
--- 2.0.1-1/lib/src/ecdh.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/ecdh.c	2021-01-15 21:35:50.000000000 +0000
@@ -79,7 +79,6 @@ CHIAKI_EXPORT void chiaki_ecdh_fini(Chia
 #endif
 }
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_ecdh_set_local_key(ChiakiECDH *ecdh, const uint8_t *private_key, size_t private_key_size, const uint8_t *public_key, size_t public_key_size)
 {
 #ifdef CHIAKI_LIB_ENABLE_MBEDTLS
@@ -89,24 +88,19 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_ecd
 
 	// public
 	int r = 0;
-	r = mbedtls_ecp_point_read_binary(&ecdh->ctx.grp, &ecdh->ctx.Q,
-		public_key, public_key_size);
-	if(r != 0 ){
+	r = mbedtls_ecp_point_read_binary(&ecdh->ctx.grp, &ecdh->ctx.Q, public_key, public_key_size);
+	if(r != 0)
 		return CHIAKI_ERR_UNKNOWN;
-	}
 
 	// secret
 	r = mbedtls_mpi_read_binary(&ecdh->ctx.d, private_key, private_key_size);
-	if(r != 0 ){
+	if(r != 0)
 		return CHIAKI_ERR_UNKNOWN;
-	}
 
 	// regen key
-	r = mbedtls_ecdh_gen_public(&ecdh->ctx.grp, &ecdh->ctx.d,
-		&ecdh->ctx.Q, mbedtls_ctr_drbg_random, &ecdh->drbg);
-	if(r != 0 ){
+	r = mbedtls_ecdh_gen_public(&ecdh->ctx.grp, &ecdh->ctx.d, &ecdh->ctx.Q, mbedtls_ctr_drbg_random, &ecdh->drbg);
+	if(r != 0)
 		return CHIAKI_ERR_UNKNOWN;
-	}
 
 	return CHIAKI_ERR_SUCCESS;
 #else
diff -pruN 2.0.1-1/lib/src/feedback.c 2.1.0-1/lib/src/feedback.c
--- 2.0.1-1/lib/src/feedback.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/feedback.c	2021-01-15 21:35:50.000000000 +0000
@@ -1,5 +1,7 @@
 // SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
 
+#define _USE_MATH_DEFINES
+
 #include <chiaki/feedback.h>
 #include <chiaki/controller.h>
 
@@ -9,26 +11,65 @@
 #include <arpa/inet.h>
 #endif
 #include <string.h>
+#include <math.h>
+
+#define GYRO_MIN -30.0f
+#define GYRO_MAX 30.0f
+#define ACCEL_MIN -5.0f
+#define ACCEL_MAX 5.0f
+
+static uint32_t compress_quat(float *q)
+{
+	// very similar idea as https://github.com/jpreiss/quatcompress
+	size_t largest_i = 0;
+	for(size_t i = 1; i < 4; i++)
+	{
+		if(fabs(q[i]) > fabs(q[largest_i]))
+			largest_i = i;
+	}
+	uint32_t r = (q[largest_i] < 0.0 ? 1 : 0) | (largest_i << 1);
+	for(size_t i = 0; i < 3; i++)
+	{
+		size_t qi = i < largest_i ? i : i + 1;
+		float v = q[qi];
+		if(v < -M_SQRT1_2)
+			v = -M_SQRT1_2;
+		if(v > M_SQRT1_2)
+			v = M_SQRT1_2;
+		v += M_SQRT1_2;
+		v *= (float)0x1ff / (2.0f * M_SQRT1_2);
+		r |= (uint32_t)v << (3 + i * 9);
+	}
+	return r;
+}
 
 CHIAKI_EXPORT void chiaki_feedback_state_format_v9(uint8_t *buf, ChiakiFeedbackState *state)
 {
-	buf[0x0] = 0xa0; // TODO
-	buf[0x1] = 0xff; // TODO
-	buf[0x2] = 0x7f; // TODO
-	buf[0x3] = 0xff; // TODO
-	buf[0x4] = 0x7f; // TODO
-	buf[0x5] = 0xff; // TODO
-	buf[0x6] = 0x7f; // TODO
-	buf[0x7] = 0xff; // TODO
-	buf[0x8] = 0x7f; // TODO
-	buf[0x9] = 0x99; // TODO
-	buf[0xa] = 0x99; // TODO
-	buf[0xb] = 0xff; // TODO
-	buf[0xc] = 0x7f; // TODO
-	buf[0xd] = 0xfe; // TODO
-	buf[0xe] = 0xf7; // TODO
-	buf[0xf] = 0xef; // TODO
-	buf[0x10] = 0x1f; // TODO
+	buf[0x0] = 0xa0;
+	uint16_t v = (uint16_t)(0xffff * ((float)state->gyro_x - GYRO_MIN) / (GYRO_MAX - GYRO_MIN));
+	buf[0x1] = v;
+	buf[0x2] = v >> 8;
+	v = (uint16_t)(0xffff * ((float)state->gyro_y - GYRO_MIN) / (GYRO_MAX - GYRO_MIN));
+	buf[0x3] = v;
+	buf[0x4] = v >> 8;
+	v = (uint16_t)(0xffff * ((float)state->gyro_z - GYRO_MIN) / (GYRO_MAX - GYRO_MIN));
+	buf[0x5] = v;
+	buf[0x6] = v >> 8;
+	v = (uint16_t)(0xffff * ((float)state->accel_x - ACCEL_MIN) / (ACCEL_MAX - ACCEL_MIN));
+	buf[0x7] = v;
+	buf[0x8] = v >> 8;
+	v = (uint16_t)(0xffff * ((float)state->accel_y - ACCEL_MIN) / (ACCEL_MAX - ACCEL_MIN));
+	buf[0x9] = v;
+	buf[0xa] = v >> 8;
+	v = (uint16_t)(0xffff * ((float)state->accel_z - ACCEL_MIN) / (ACCEL_MAX - ACCEL_MIN));
+	buf[0xb] = v;
+	buf[0xc] = v >> 8;
+	float q[4] = { state->orient_x, state->orient_y, state->orient_z, state->orient_w };
+	uint32_t qc = compress_quat(q);
+	buf[0xd] = qc;
+	buf[0xe] = qc >> 0x8;
+	buf[0xf] = qc >> 0x10;
+	buf[0x10] = qc >> 0x18;
 	*((chiaki_unaligned_uint16_t *)(buf + 0x11)) = htons((uint16_t)state->left_x);
 	*((chiaki_unaligned_uint16_t *)(buf + 0x13)) = htons((uint16_t)state->left_y);
 	*((chiaki_unaligned_uint16_t *)(buf + 0x15)) = htons((uint16_t)state->right_x);
@@ -38,7 +79,7 @@ CHIAKI_EXPORT void chiaki_feedback_state
 CHIAKI_EXPORT void chiaki_feedback_state_format_v12(uint8_t *buf, ChiakiFeedbackState *state)
 {
 	chiaki_feedback_state_format_v9(buf, state);
-	buf[0x10] = 0x0;
+	buf[0x19] = 0x0;
 	buf[0x1a] = 0x0;
 	buf[0x1b] = 0x1; // 1 for Shock, 0 for Sense
 }
diff -pruN 2.0.1-1/lib/src/feedbacksender.c 2.1.0-1/lib/src/feedbacksender.c
--- 2.0.1-1/lib/src/feedbacksender.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/feedbacksender.c	2021-01-15 21:35:50.000000000 +0000
@@ -83,10 +83,24 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_fee
 
 static bool controller_state_equals_for_feedback_state(ChiakiControllerState *a, ChiakiControllerState *b)
 {
-	return a->left_x == b->left_x
+	if(!(a->left_x == b->left_x
 		&& a->left_y == b->left_y
 		&& a->right_x == b->right_x
-		&& a->right_y == b->right_y;
+		&& a->right_y == b->right_y))
+		return false;
+#define CHECKF(n) if(a->n < b->n - 0.0000001f || a->n > b->n + 0.0000001f) return false
+	CHECKF(gyro_x);
+	CHECKF(gyro_y);
+	CHECKF(gyro_z);
+	CHECKF(accel_x);
+	CHECKF(accel_y);
+	CHECKF(accel_z);
+	CHECKF(orient_x);
+	CHECKF(orient_y);
+	CHECKF(orient_z);
+	CHECKF(orient_w);
+#undef CHECKF
+	return true;
 }
 
 static void feedback_sender_send_state(ChiakiFeedbackSender *feedback_sender)
@@ -96,6 +110,18 @@ static void feedback_sender_send_state(C
 	state.left_y = feedback_sender->controller_state.left_y;
 	state.right_x = feedback_sender->controller_state.right_x;
 	state.right_y = feedback_sender->controller_state.right_y;
+	state.gyro_x = feedback_sender->controller_state.gyro_x;
+	state.gyro_y = feedback_sender->controller_state.gyro_y;
+	state.gyro_z = feedback_sender->controller_state.gyro_z;
+	state.accel_x = feedback_sender->controller_state.accel_x;
+	state.accel_y = feedback_sender->controller_state.accel_y;
+	state.accel_z = feedback_sender->controller_state.accel_z;
+
+	state.orient_x = feedback_sender->controller_state.orient_x;
+	state.orient_y = feedback_sender->controller_state.orient_y;
+	state.orient_z = feedback_sender->controller_state.orient_z;
+	state.orient_w = feedback_sender->controller_state.orient_w;
+
 	ChiakiErrorCode err = chiaki_takion_send_feedback_state(feedback_sender->takion, feedback_sender->state_seq_num++, &state);
 	if(err != CHIAKI_ERR_SUCCESS)
 		CHIAKI_LOGE(feedback_sender->log, "FeedbackSender failed to send Feedback State");
diff -pruN 2.0.1-1/lib/src/frameprocessor.c 2.1.0-1/lib/src/frameprocessor.c
--- 2.0.1-1/lib/src/frameprocessor.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/frameprocessor.c	2021-01-15 21:35:50.000000000 +0000
@@ -48,6 +48,8 @@ CHIAKI_EXPORT void chiaki_frame_processo
 	frame_processor->buf_stride_per_unit = 0;
 	frame_processor->units_source_expected = 0;
 	frame_processor->units_fec_expected = 0;
+	frame_processor->units_source_received = 0;
+	frame_processor->units_fec_received = 0;
 	frame_processor->unit_slots = NULL;
 	frame_processor->unit_slots_size = 0;
 	frame_processor->flushed = true;
@@ -150,7 +152,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_fra
 		CHIAKI_LOGE(frame_processor->log, "Packet's unit index is too high");
 		return CHIAKI_ERR_INVALID_DATA;
 	}
-	
+
 	if(!packet->data_size)
 	{
 		CHIAKI_LOGW(frame_processor->log, "Unit is empty");
@@ -162,7 +164,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_fra
 		CHIAKI_LOGW(frame_processor->log, "Unit is bigger than pre-calculated size!");
 		return CHIAKI_ERR_INVALID_DATA;
 	}
-	
+
 	ChiakiFrameUnit *unit = frame_processor->unit_slots + packet->unit_index;
 	if(unit->data_size)
 	{
diff -pruN 2.0.1-1/lib/src/gkcrypt.c 2.1.0-1/lib/src/gkcrypt.c
--- 2.0.1-1/lib/src/gkcrypt.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/gkcrypt.c	2021-01-15 21:35:50.000000000 +0000
@@ -19,10 +19,8 @@
 
 #include "utils.h"
 
-
 #define KEY_BUF_CHUNK_SIZE 0x1000
 
-
 static ChiakiErrorCode gkcrypt_gen_key_iv(ChiakiGKCrypt *gkcrypt, uint8_t index, const uint8_t *handshake_key, const uint8_t *ecdh_secret);
 
 static void *gkcrypt_thread_func(void *user);
@@ -110,7 +108,6 @@ CHIAKI_EXPORT void chiaki_gkcrypt_fini(C
 	}
 }
 
-
 static ChiakiErrorCode gkcrypt_gen_key_iv(ChiakiGKCrypt *gkcrypt, uint8_t index, const uint8_t *handshake_key, const uint8_t *ecdh_secret)
 {
 	uint8_t data[3 + CHIAKI_HANDSHAKE_KEY_SIZE + 2];
@@ -123,37 +120,41 @@ static ChiakiErrorCode gkcrypt_gen_key_i
 
 	uint8_t hmac[CHIAKI_GKCRYPT_BLOCK_SIZE*2];
 	size_t hmac_size = sizeof(hmac);
-	#ifdef CHIAKI_LIB_ENABLE_MBEDTLS
+#ifdef CHIAKI_LIB_ENABLE_MBEDTLS
 	mbedtls_md_context_t ctx;
 	mbedtls_md_init(&ctx);
 
-	if(mbedtls_md_setup(&ctx, mbedtls_md_info_from_type(MBEDTLS_MD_SHA256) , 1) != 0){
+	if(mbedtls_md_setup(&ctx, mbedtls_md_info_from_type(MBEDTLS_MD_SHA256), 1) != 0)
+	{
 		mbedtls_md_free(&ctx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
-	if(mbedtls_md_hmac_starts(&ctx, ecdh_secret, CHIAKI_ECDH_SECRET_SIZE) != 0){
+	if(mbedtls_md_hmac_starts(&ctx, ecdh_secret, CHIAKI_ECDH_SECRET_SIZE) != 0)
+	{
 		mbedtls_md_free(&ctx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
-	if(mbedtls_md_hmac_update(&ctx, data, sizeof(data)) != 0){
+	if(mbedtls_md_hmac_update(&ctx, data, sizeof(data)) != 0)
+	{
 		mbedtls_md_free(&ctx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
-	if(mbedtls_md_hmac_finish(&ctx, hmac) != 0){
+	if(mbedtls_md_hmac_finish(&ctx, hmac) != 0)
+	{
 		mbedtls_md_free(&ctx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
 	mbedtls_md_free(&ctx);
 
-	#else
+#else
 	if(!HMAC(EVP_sha256(), ecdh_secret, CHIAKI_ECDH_SECRET_SIZE, data, sizeof(data), hmac, (unsigned int *)&hmac_size))
 		return CHIAKI_ERR_UNKNOWN;
 
-	#endif
+#endif
 	assert(hmac_size == sizeof(hmac));
 
 	memcpy(gkcrypt->key_base, hmac, CHIAKI_GKCRYPT_BLOCK_SIZE);
@@ -220,7 +221,8 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_gkc
 	mbedtls_aes_context ctx;
 	mbedtls_aes_init(&ctx);
 
-	if(mbedtls_aes_setkey_enc(&ctx, gkcrypt->key_base, 128) != 0){
+	if(mbedtls_aes_setkey_enc(&ctx, gkcrypt->key_base, 128) != 0)
+	{
 		mbedtls_aes_free(&ctx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
@@ -248,9 +250,11 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_gkc
 		counter_add(cur, gkcrypt->iv, counter_offset++);
 
 #ifdef CHIAKI_LIB_ENABLE_MBEDTLS
-	for(int i=0; i<buf_size; i=i+16){
+	for(int i = 0; i < buf_size; i = i + 16)
+	{
 		// loop over all blocks of 16 bytes (128 bits)
-		if(mbedtls_aes_crypt_ecb(&ctx, MBEDTLS_AES_ENCRYPT, buf+i, buf+i) != 0){
+		if(mbedtls_aes_crypt_ecb(&ctx, MBEDTLS_AES_ENCRYPT, buf + i, buf + i) != 0)
+		{
 			mbedtls_aes_free(&ctx);
 			return CHIAKI_ERR_UNKNOWN;
 		}
@@ -373,13 +377,15 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_gkc
 	mbedtls_gcm_context actx;
 	mbedtls_gcm_init(&actx);
 	// set gmac_key 128 bits key
-	if(mbedtls_gcm_setkey(&actx, MBEDTLS_CIPHER_ID_AES, gmac_key, CHIAKI_GKCRYPT_BLOCK_SIZE*8) != 0){
+	if(mbedtls_gcm_setkey(&actx, MBEDTLS_CIPHER_ID_AES, gmac_key, CHIAKI_GKCRYPT_BLOCK_SIZE * 8) != 0)
+	{
 		mbedtls_gcm_free(&actx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
 	// encrypt without additional data
-	if(mbedtls_gcm_starts(&actx, MBEDTLS_GCM_ENCRYPT, iv, CHIAKI_GKCRYPT_BLOCK_SIZE, NULL, 0) != 0){
+	if(mbedtls_gcm_starts(&actx, MBEDTLS_GCM_ENCRYPT, iv, CHIAKI_GKCRYPT_BLOCK_SIZE, NULL, 0) != 0)
+	{
 		mbedtls_gcm_free(&actx);
 		return CHIAKI_ERR_UNKNOWN;
 	}
@@ -387,9 +393,10 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_gkc
 	// to get the same result as:
 	// EVP_EncryptUpdate(ctx, NULL, &len, buf, (int)buf_size)
 	if(mbedtls_gcm_crypt_and_tag(&actx, MBEDTLS_GCM_ENCRYPT,
-		0, iv, CHIAKI_GKCRYPT_BLOCK_SIZE,
-		buf, buf_size, NULL, NULL,
-		CHIAKI_GKCRYPT_GMAC_SIZE, gmac_out) != 0){
+		   0, iv, CHIAKI_GKCRYPT_BLOCK_SIZE,
+		   buf, buf_size, NULL, NULL,
+		   CHIAKI_GKCRYPT_GMAC_SIZE, gmac_out) != 0)
+	{
 
 		mbedtls_gcm_free(&actx);
 		return CHIAKI_ERR_UNKNOWN;
diff -pruN 2.0.1-1/lib/src/http.c 2.1.0-1/lib/src/http.c
--- 2.0.1-1/lib/src/http.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/http.c	2021-01-15 21:35:50.000000000 +0000
@@ -11,7 +11,6 @@
 #include <sys/socket.h>
 #endif
 
-
 CHIAKI_EXPORT void chiaki_http_header_free(ChiakiHttpHeader *header)
 {
 	while(header)
diff -pruN 2.0.1-1/lib/src/orientation.c 2.1.0-1/lib/src/orientation.c
--- 2.0.1-1/lib/src/orientation.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/lib/src/orientation.c	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,176 @@
+// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
+
+#include <chiaki/orientation.h>
+#include <math.h>
+
+#define SIN_1_4_PI      0.7071067811865475
+#define SIN_NEG_1_4_PI -0.7071067811865475
+#define COS_1_4_PI      0.7071067811865476
+#define COS_NEG_1_4_PI  0.7071067811865476
+
+#define WARMUP_SAMPLES_COUNT 30
+#define BETA_WARMUP 20.0f
+#define BETA_DEFAULT 0.05f
+
+CHIAKI_EXPORT void chiaki_orientation_init(ChiakiOrientation *orient)
+{
+	// 90 deg rotation around x for Madgwick
+	orient->x = SIN_1_4_PI;
+	orient->y = 0.0f;
+	orient->z = 0.0f;
+	orient->w = COS_1_4_PI;
+}
+
+static float inv_sqrt(float x);
+
+CHIAKI_EXPORT void chiaki_orientation_update(ChiakiOrientation *orient,
+		float gx, float gy, float gz, float ax, float ay, float az, float beta, float time_step_sec)
+{
+	float q0 = orient->w, q1 = orient->x, q2 = orient->y, q3 = orient->z;
+	// Madgwick's IMU algorithm.
+	// See: http://www.x-io.co.uk/node/8#open_source_ahrs_and_imu_algorithms
+	float recip_norm;
+	float s0, s1, s2, s3;
+	float q_dot1, q_dot2, q_dot3, q_dot4;
+	float _2q0, _2q1, _2q2, _2q3, _4q0, _4q1, _4q2 ,_8q1, _8q2, q0q0, q1q1, q2q2, q3q3;
+
+	// Rate of change of quaternion from gyroscope
+	q_dot1 = 0.5f * (-q1 * gx - q2 * gy - q3 * gz);
+	q_dot2 = 0.5f * (q0 * gx + q2 * gz - q3 * gy);
+	q_dot3 = 0.5f * (q0 * gy - q1 * gz + q3 * gx);
+	q_dot4 = 0.5f * (q0 * gz + q1 * gy - q2 * gx);
+
+	// Compute feedback only if accelerometer measurement valid (avoids NaN in accelerometer normalisation)
+	if(!((ax == 0.0f) && (ay == 0.0f) && (az == 0.0f)))
+	{
+		// Normalise accelerometer measurement
+		recip_norm = inv_sqrt(ax * ax + ay * ay + az * az);
+		ax *= recip_norm;
+		ay *= recip_norm;
+		az *= recip_norm;
+
+		// Auxiliary variables to avoid repeated arithmetic
+		_2q0 = 2.0f * q0;
+		_2q1 = 2.0f * q1;
+		_2q2 = 2.0f * q2;
+		_2q3 = 2.0f * q3;
+		_4q0 = 4.0f * q0;
+		_4q1 = 4.0f * q1;
+		_4q2 = 4.0f * q2;
+		_8q1 = 8.0f * q1;
+		_8q2 = 8.0f * q2;
+		q0q0 = q0 * q0;
+		q1q1 = q1 * q1;
+		q2q2 = q2 * q2;
+		q3q3 = q3 * q3;
+
+		// Gradient decent algorithm corrective step
+		s0 = _4q0 * q2q2 + _2q2 * ax + _4q0 * q1q1 - _2q1 * ay;
+		s1 = _4q1 * q3q3 - _2q3 * ax + 4.0f * q0q0 * q1 - _2q0 * ay - _4q1 + _8q1 * q1q1 + _8q1 * q2q2 + _4q1 * az;
+		s2 = 4.0f * q0q0 * q2 + _2q0 * ax + _4q2 * q3q3 - _2q3 * ay - _4q2 + _8q2 * q1q1 + _8q2 * q2q2 + _4q2 * az;
+		s3 = 4.0f * q1q1 * q3 - _2q1 * ax + 4.0f * q2q2 * q3 - _2q2 * ay;
+		recip_norm = s0 * s0 + s1 * s1 + s2 * s2 + s3 * s3; // normalise step magnitude
+		// avoid NaN when the orientation is already perfect or inverse to perfect
+		if(recip_norm > 0.000001f)
+		{
+			recip_norm = inv_sqrt(recip_norm);
+			s0 *= recip_norm;
+			s1 *= recip_norm;
+			s2 *= recip_norm;
+			s3 *= recip_norm;
+
+			// Apply feedback step
+			q_dot1 -= beta * s0;
+			q_dot2 -= beta * s1;
+			q_dot3 -= beta * s2;
+			q_dot4 -= beta * s3;
+		}
+	}
+
+	// Integrate rate of change of quaternion to yield quaternion
+	q0 += q_dot1 * time_step_sec;
+	q1 += q_dot2 * time_step_sec;
+	q2 += q_dot3 * time_step_sec;
+	q3 += q_dot4 * time_step_sec;
+
+	// Normalise quaternion
+	recip_norm = inv_sqrt(q0 * q0 + q1 * q1 + q2 * q2 + q3 * q3);
+	q0 *= recip_norm;
+	q1 *= recip_norm;
+	q2 *= recip_norm;
+	q3 *= recip_norm;
+
+	orient->x = q1;
+	orient->y = q2;
+	orient->z = q3;
+	orient->w = q0;
+}
+
+static float inv_sqrt(float x)
+{
+#if 1
+	return 1.0f / sqrt(x);
+#else
+	// Fast inverse square-root
+	// See: http://en.wikipedia.org/wiki/Fast_inverse_square_root
+	float halfx = 0.5f * x;
+	float y = x;
+	long i = *(long*)&y;
+	i = 0x5f3759df - (i>>1);
+	y = *(float*)&i;
+	y = y * (1.5f - (halfx * y * y));
+	return y;
+#endif
+}
+
+CHIAKI_EXPORT void chiaki_orientation_tracker_init(ChiakiOrientationTracker *tracker)
+{
+	tracker->accel_x = 0.0f;
+	tracker->accel_y = 1.0f;
+	tracker->accel_z = 0.0f;
+	tracker->gyro_x = tracker->gyro_y = tracker->gyro_z = 0.0f;
+	chiaki_orientation_init(&tracker->orient);
+	tracker->timestamp = 0;
+	tracker->sample_index = 0;
+}
+
+CHIAKI_EXPORT void chiaki_orientation_tracker_update(ChiakiOrientationTracker *tracker,
+		float gx, float gy, float gz, float ax, float ay, float az, uint32_t timestamp_us)
+{
+	tracker->gyro_x = gx;
+	tracker->gyro_y = gy;
+	tracker->gyro_z = gz;
+	tracker->accel_x = ax;
+	tracker->accel_y = ay;
+	tracker->accel_z = az;
+	tracker->sample_index++;
+	if(tracker->sample_index <= 1)
+	{
+		tracker->timestamp = timestamp_us;
+		return;
+	}
+	uint64_t delta_us = timestamp_us;
+	if(delta_us < tracker->timestamp)
+		delta_us += (1ULL << 32);
+	delta_us -= tracker->timestamp;
+	tracker->timestamp = timestamp_us;
+	chiaki_orientation_update(&tracker->orient, gx, gy, gz, ax, ay, az,
+			tracker->sample_index < WARMUP_SAMPLES_COUNT ? BETA_WARMUP : BETA_DEFAULT,
+			(float)delta_us / 1000000.0f);
+}
+
+CHIAKI_EXPORT void chiaki_orientation_tracker_apply_to_controller_state(ChiakiOrientationTracker *tracker,
+		ChiakiControllerState *state)
+{
+	state->gyro_x = tracker->gyro_x;
+	state->gyro_y = tracker->gyro_y;
+	state->gyro_z = tracker->gyro_z;
+	state->accel_x = tracker->accel_x;
+	state->accel_y = tracker->accel_y;
+	state->accel_z = tracker->accel_z;
+	// -90 deg rotation around x from Madgwick
+	state->orient_w = COS_NEG_1_4_PI * tracker->orient.w - SIN_NEG_1_4_PI * tracker->orient.x;
+	state->orient_x = COS_NEG_1_4_PI * tracker->orient.x + SIN_NEG_1_4_PI * tracker->orient.w;
+	state->orient_y = COS_NEG_1_4_PI * tracker->orient.y - SIN_NEG_1_4_PI * tracker->orient.z;
+	state->orient_z = COS_NEG_1_4_PI * tracker->orient.z + SIN_NEG_1_4_PI * tracker->orient.y;
+}
diff -pruN 2.0.1-1/lib/src/packetstats.c 2.1.0-1/lib/src/packetstats.c
--- 2.0.1-1/lib/src/packetstats.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/packetstats.c	2021-01-15 21:35:50.000000000 +0000
@@ -74,4 +74,3 @@ CHIAKI_EXPORT void chiaki_packet_stats_g
 		reset_stats(stats);
 	chiaki_mutex_unlock(&stats->mutex);
 }
-
diff -pruN 2.0.1-1/lib/src/pidecoder.c 2.1.0-1/lib/src/pidecoder.c
--- 2.0.1-1/lib/src/pidecoder.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/pidecoder.c	2021-01-15 21:35:50.000000000 +0000
@@ -8,7 +8,6 @@
 #include <string.h>
 #include <errno.h>
 
-#define MAX_DECODE_UNIT_SIZE 262144
 
 CHIAKI_EXPORT ChiakiErrorCode chiaki_pi_decoder_init(ChiakiPiDecoder *decoder, ChiakiLog *log)
 {
@@ -108,29 +107,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_pi_
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
-	OMX_PARAM_PORTDEFINITIONTYPE port;
-
-	memset(&port, 0, sizeof(OMX_PARAM_PORTDEFINITIONTYPE));
-	port.nSize = sizeof(OMX_PARAM_PORTDEFINITIONTYPE);
-	port.nVersion.nVersion = OMX_VERSION;
-	port.nPortIndex = 130;
-	if(OMX_GetParameter(ILC_GET_HANDLE(decoder->video_decode), OMX_IndexParamPortDefinition, &port) != OMX_ErrorNone)
-	{
-		CHIAKI_LOGE(decoder->log, "Failed to get decoder port definition\n");
-		chiaki_pi_decoder_fini(decoder);
-		return CHIAKI_ERR_UNKNOWN;
-	}
-
-	// Increase the buffer size to fit the largest possible frame
-	port.nBufferSize = MAX_DECODE_UNIT_SIZE;
-
-	if(OMX_SetParameter(ILC_GET_HANDLE(decoder->video_decode), OMX_IndexParamPortDefinition, &port) != OMX_ErrorNone)
-	{
-		CHIAKI_LOGE(decoder->log, "OMX_SetParameter failed for port");
-		chiaki_pi_decoder_fini(decoder);
-		return CHIAKI_ERR_UNKNOWN;
-	}
-
 	if(ilclient_enable_port_buffers(decoder->video_decode, 130, NULL, NULL, NULL) != 0)
 	{
 		CHIAKI_LOGE(decoder->log, "ilclient_enable_port_buffers failed");
@@ -180,50 +156,55 @@ CHIAKI_EXPORT void chiaki_pi_decoder_fin
 
 static bool push_buffer(ChiakiPiDecoder *decoder, uint8_t *buf, size_t buf_size)
 {
-	OMX_BUFFERHEADERTYPE *omx_buf = ilclient_get_input_buffer(decoder->video_decode, 130, 1);
-	if(!omx_buf)
+	while(buf_size)
 	{
-		CHIAKI_LOGE(decoder->log, "ilclient_get_input_buffer failed");
-		return false;
-	}
+		OMX_BUFFERHEADERTYPE *omx_buf = ilclient_get_input_buffer(decoder->video_decode, 130, 1);
+		if(!omx_buf)
+		{
+			CHIAKI_LOGE(decoder->log, "ilclient_get_input_buffer failed");
+			return false;
+		}
 
-	if(omx_buf->nAllocLen < buf_size)
-	{
-		CHIAKI_LOGE(decoder->log, "Buffer from omx is too small for frame");
-		return false;
-	}
+		size_t push_size = buf_size;
+		if(push_size > omx_buf->nAllocLen)
+		{
+			CHIAKI_LOGW(decoder->log, "OMX Buffer too small, fragmenting to multiple buffers.");
+			push_size = omx_buf->nAllocLen;
+		}
+		memcpy(omx_buf->pBuffer, buf, push_size);
+		buf_size -= push_size;
+		buf += push_size;
+		omx_buf->nFilledLen = push_size;
+		omx_buf->nOffset = 0;
+		omx_buf->nFlags = 0;
+		if(!buf_size)
+			omx_buf->nFlags |= OMX_BUFFERFLAG_ENDOFFRAME;
+		if(decoder->first_packet)
+		{
+			omx_buf->nFlags |= OMX_BUFFERFLAG_STARTTIME;
+			decoder->first_packet = false;
+		}
 
-	omx_buf->nFilledLen = 0;
-	omx_buf->nOffset = 0;
-	omx_buf->nFlags = OMX_BUFFERFLAG_ENDOFFRAME;
-	if(decoder->first_packet)
-	{
-		omx_buf->nFlags |= OMX_BUFFERFLAG_STARTTIME;
-		decoder->first_packet = false;
-	}
+		if(!decoder->port_settings_changed
+			&& ((omx_buf->nFilledLen > 0 && ilclient_remove_event(decoder->video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1) == 0)
+				|| (omx_buf->nFilledLen == 0 && ilclient_wait_for_event(decoder->video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1, ILCLIENT_EVENT_ERROR | ILCLIENT_PARAMETER_CHANGED, 10000) == 0)))
+		{
+			decoder->port_settings_changed = true;
 
-	memcpy(omx_buf->pBuffer + omx_buf->nFilledLen, buf, buf_size);
-	omx_buf->nFilledLen += buf_size;
+			if(ilclient_setup_tunnel(decoder->tunnel, 0, 0) != 0)
+			{
+				CHIAKI_LOGE(decoder->log, "ilclient_setup_tunnel failed");
+				return false;
+			}
 
-	if(!decoder->port_settings_changed
-		&& ((omx_buf->nFilledLen > 0 && ilclient_remove_event(decoder->video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1) == 0)
-			|| (omx_buf->nFilledLen == 0 && ilclient_wait_for_event(decoder->video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1, ILCLIENT_EVENT_ERROR | ILCLIENT_PARAMETER_CHANGED, 10000) == 0)))
-	{
-		decoder->port_settings_changed = true;
+			ilclient_change_component_state(decoder->video_render, OMX_StateExecuting);
+		}
 
-		if(ilclient_setup_tunnel(decoder->tunnel, 0, 0) != 0)
+		if(OMX_EmptyThisBuffer(ILC_GET_HANDLE(decoder->video_decode), omx_buf) != OMX_ErrorNone)
 		{
-			CHIAKI_LOGE(decoder->log, "ilclient_setup_tunnel failed");
+			CHIAKI_LOGE(decoder->log, "OMX_EmptyThisBuffer failed");
 			return false;
 		}
-
-		ilclient_change_component_state(decoder->video_render, OMX_StateExecuting);
-	}
-
-	if(OMX_EmptyThisBuffer(ILC_GET_HANDLE(decoder->video_decode), omx_buf) != OMX_ErrorNone)
-	{
-		CHIAKI_LOGE(decoder->log, "OMX_EmptyThisBuffer failed");
-		return false;
 	}
 	return true;
 }
diff -pruN 2.0.1-1/lib/src/random.c 2.1.0-1/lib/src/random.c
--- 2.0.1-1/lib/src/random.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/random.c	2021-01-15 21:35:50.000000000 +0000
@@ -28,10 +28,12 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_ran
 	mbedtls_entropy_init(&entropy);
 
 	mbedtls_ctr_drbg_set_prediction_resistance(&ctr_drbg, MBEDTLS_CTR_DRBG_PR_OFF);
-	if(mbedtls_ctr_drbg_seed(&ctr_drbg, mbedtls_entropy_func, &entropy, (const unsigned char *) "RANDOM_GEN", 10 ) != 0 ){
+	if(mbedtls_ctr_drbg_seed(&ctr_drbg, mbedtls_entropy_func, &entropy, (const unsigned char *)"RANDOM_GEN", 10) != 0)
+	{
 		return CHIAKI_ERR_UNKNOWN;
 	}
-	if(mbedtls_ctr_drbg_random(&ctr_drbg, buf, buf_size) != 0){
+	if(mbedtls_ctr_drbg_random(&ctr_drbg, buf, buf_size) != 0)
+	{
 		return CHIAKI_ERR_UNKNOWN;
 	}
 
diff -pruN 2.0.1-1/lib/src/regist.c 2.1.0-1/lib/src/regist.c
--- 2.0.1-1/lib/src/regist.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/regist.c	2021-01-15 21:35:50.000000000 +0000
@@ -160,7 +160,6 @@ static int request_header_format(char *b
 	return cur;
 }
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_regist_request_payload_format(ChiakiTarget target, const uint8_t *ambassador, uint8_t *buf, size_t *buf_size, ChiakiRPCrypt *crypt, const char *psn_online_id, const uint8_t *psn_account_id, uint32_t pin)
 {
 	size_t buf_size_val = *buf_size;
diff -pruN 2.0.1-1/lib/src/rpcrypt.c 2.1.0-1/lib/src/rpcrypt.c
--- 2.0.1-1/lib/src/rpcrypt.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/rpcrypt.c	2021-01-15 21:35:50.000000000 +0000
@@ -1488,7 +1488,7 @@ static ChiakiErrorCode bright_ambassador
 		0x20, 0x98, 0xfd, 0x34, 0xca, 0x7a, 0x66, 0x20, 0x58, 0xd2,
 		0x36, 0x7f, 0x2b, 0xa7, 0xd1, 0xde, 0x6f, 0x36, 0xb4, 0xf2,
 		0x3b, 0x20, 0x5d, 0x02
-	}; 
+	};
 
 	if(target < CHIAKI_TARGET_PS4_10)
 		return CHIAKI_ERR_INVALID_DATA;
@@ -1698,7 +1698,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_rpc
 CHIAKI_EXPORT void chiaki_rpcrypt_init_auth(ChiakiRPCrypt *rpcrypt, ChiakiTarget target, const uint8_t *nonce, const uint8_t *morning)
 {
 	rpcrypt->target = target;
-    chiaki_rpcrypt_bright_ambassador(target, rpcrypt->bright, rpcrypt->ambassador, nonce, morning);
+	chiaki_rpcrypt_bright_ambassador(target, rpcrypt->bright, rpcrypt->ambassador, nonce, morning);
 }
 
 CHIAKI_EXPORT void chiaki_rpcrypt_init_regist_ps4_pre10(ChiakiRPCrypt *rpcrypt, const uint8_t *ambassador, uint32_t pin)
@@ -1865,7 +1865,6 @@ static const uint8_t *rpcrypt_hmac_key(C
 	}
 }
 
-
 #ifdef CHIAKI_LIB_ENABLE_MBEDTLS
 CHIAKI_EXPORT ChiakiErrorCode chiaki_rpcrypt_generate_iv(ChiakiRPCrypt *rpcrypt, uint8_t *iv, uint64_t counter)
 {
@@ -1968,7 +1967,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_rpc
 	buf[CHIAKI_RPCRYPT_KEY_SIZE + 6] = (uint8_t)((counter >> 0x08) & 0xff);
 	buf[CHIAKI_RPCRYPT_KEY_SIZE + 7] = (uint8_t)((counter >> 0x00) & 0xff);
 
-
 	uint8_t hmac[32];
 	unsigned int hmac_len = 0;
 	if(!HMAC(EVP_sha256(), hmac_key, CHIAKI_RPCRYPT_KEY_SIZE, buf, sizeof(buf), hmac, &hmac_len))
diff -pruN 2.0.1-1/lib/src/senkusha.c 2.1.0-1/lib/src/senkusha.c
--- 2.0.1-1/lib/src/senkusha.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/senkusha.c	2021-01-15 21:35:50.000000000 +0000
@@ -361,7 +361,7 @@ static ChiakiErrorCode senkusha_run_mtu_
 			senkusha->state_failed = false;
 			senkusha->mtu_id = ++request_id;
 
-			tkproto_SenkushaMtuCommand mtu_cmd;
+			tkproto_SenkushaMtuCommand mtu_cmd = { 0 };
 			mtu_cmd.id = request_id;
 			mtu_cmd.mtu_req = cur;
 			mtu_cmd.num = 1;
@@ -645,7 +645,6 @@ static void senkusha_takion_data(ChiakiS
 			senkusha->state_finished = true;
 			chiaki_cond_signal(&senkusha->state_cond);
 		}
-
 	}
 	chiaki_mutex_unlock(&senkusha->state_mutex);
 }
@@ -878,4 +877,3 @@ static ChiakiErrorCode senkusha_send_dat
 
 	return err;
 }
-
diff -pruN 2.0.1-1/lib/src/session.c 2.1.0-1/lib/src/session.c
--- 2.0.1-1/lib/src/session.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/session.c	2021-01-15 21:35:50.000000000 +0000
@@ -540,10 +540,8 @@ quit:
 #undef QUIT
 }
 
-
-
-
-typedef struct session_response_t {
+typedef struct session_response_t
+{
 	uint32_t error_code;
 	const char *nonce;
 	const char *rp_version;
@@ -596,11 +594,11 @@ static ChiakiErrorCode session_thread_re
 		set_port(sa, htons(SESSION_PORT));
 
 		// TODO: this can block, make cancelable somehow
-		int r = getnameinfo(sa, (socklen_t)ai->ai_addrlen, session->connect_info.hostname, sizeof(session->connect_info.hostname), NULL, 0, 0);
+		int r = getnameinfo(sa, (socklen_t)ai->ai_addrlen, session->connect_info.hostname, sizeof(session->connect_info.hostname), NULL, 0, NI_NUMERICHOST);
 		if(r != 0)
 		{
-			free(sa);
-			continue;
+			CHIAKI_LOGE(session->log, "getnameinfo failed with %s, filling the hostname with fallback", gai_strerror(r));
+			memcpy(session->connect_info.hostname, "unknown", 8);
 		}
 
 		CHIAKI_LOGI(session->log, "Trying to request session from %s:%d", session->connect_info.hostname, SESSION_PORT);
@@ -611,7 +609,7 @@ static ChiakiErrorCode session_thread_re
 #ifdef _WIN32
 			CHIAKI_LOGE(session->log, "Failed to create socket to request session");
 #else
-            CHIAKI_LOGE(session->log, "Failed to create socket to request session: %s", strerror(errno));
+			CHIAKI_LOGE(session->log, "Failed to create socket to request session: %s", strerror(errno));
 #endif
 			free(sa);
 			continue;
@@ -652,7 +650,6 @@ static ChiakiErrorCode session_thread_re
 		break;
 	}
 
-
 	if(CHIAKI_SOCKET_IS_INVALID(session_sock))
 	{
 		CHIAKI_LOGE(session->log, "Session request connect failed eventually.");
diff -pruN 2.0.1-1/lib/src/stoppipe.c 2.1.0-1/lib/src/stoppipe.c
--- 2.0.1-1/lib/src/stoppipe.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/stoppipe.c	2021-01-15 21:35:50.000000000 +0000
@@ -27,9 +27,8 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_sto
 	int addr_size = sizeof(stop_pipe->addr);
 
 	stop_pipe->fd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
-	if(stop_pipe->fd < 0){
+	if(stop_pipe->fd < 0)
 		return CHIAKI_ERR_UNKNOWN;
-	}
 	stop_pipe->addr.sin_family = AF_INET;
 	// bind to localhost
 	stop_pipe->addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);
diff -pruN 2.0.1-1/lib/src/streamconnection.c 2.1.0-1/lib/src/streamconnection.c
--- 2.0.1-1/lib/src/streamconnection.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/streamconnection.c	2021-01-15 21:35:50.000000000 +0000
@@ -45,6 +45,8 @@ void chiaki_session_send_event(ChiakiSes
 
 static void stream_connection_takion_cb(ChiakiTakionEvent *event, void *user);
 static void stream_connection_takion_data(ChiakiStreamConnection *stream_connection, ChiakiTakionMessageDataType data_type, uint8_t *buf, size_t buf_size);
+static void stream_connection_takion_data_protobuf(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size);
+static void stream_connection_takion_data_rumble(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size);
 static ChiakiErrorCode stream_connection_send_big(ChiakiStreamConnection *stream_connection);
 static ChiakiErrorCode stream_connection_send_disconnect(ChiakiStreamConnection *stream_connection);
 static void stream_connection_takion_data_idle(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size);
@@ -54,7 +56,6 @@ static ChiakiErrorCode stream_connection
 static void stream_connection_takion_av(ChiakiStreamConnection *stream_connection, ChiakiTakionAVPacket *packet);
 static ChiakiErrorCode stream_connection_send_heartbeat(ChiakiStreamConnection *stream_connection);
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_stream_connection_init(ChiakiStreamConnection *stream_connection, ChiakiSession *session)
 {
 	stream_connection->session = session;
@@ -119,7 +120,6 @@ CHIAKI_EXPORT void chiaki_stream_connect
 	chiaki_mutex_fini(&stream_connection->state_mutex);
 }
 
-
 static bool state_finished_cond_check(void *user)
 {
 	ChiakiStreamConnection *stream_connection = user;
@@ -368,9 +368,21 @@ static void stream_connection_takion_cb(
 
 static void stream_connection_takion_data(ChiakiStreamConnection *stream_connection, ChiakiTakionMessageDataType data_type, uint8_t *buf, size_t buf_size)
 {
-	if(data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_PROTOBUF)
-		return;
+	switch(data_type)
+	{
+		case CHIAKI_TAKION_MESSAGE_DATA_TYPE_PROTOBUF:
+			stream_connection_takion_data_protobuf(stream_connection, buf, buf_size);
+			break;
+		case CHIAKI_TAKION_MESSAGE_DATA_TYPE_RUMBLE:
+			stream_connection_takion_data_rumble(stream_connection, buf, buf_size);
+			break;
+		default:
+			break;
+	}
+}
 
+static void stream_connection_takion_data_protobuf(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size)
+{
 	chiaki_mutex_lock(&stream_connection->state_mutex);
 	switch(stream_connection->state)
 	{
@@ -387,6 +399,22 @@ static void stream_connection_takion_dat
 	chiaki_mutex_unlock(&stream_connection->state_mutex);
 }
 
+static void stream_connection_takion_data_rumble(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size)
+{
+	if(buf_size < 3)
+	{
+		CHIAKI_LOGE(stream_connection->log, "StreamConnection got rumble packet with size %#llx < 3",
+				(unsigned long long)buf_size);
+		return;
+	}
+	ChiakiEvent event = { 0 };
+	event.type = CHIAKI_EVENT_RUMBLE;
+	event.rumble.unknown = buf[0];
+	event.rumble.left = buf[1];
+	event.rumble.right = buf[2];
+	chiaki_session_send_event(stream_connection->session, &event);
+}
+
 static void stream_connection_takion_data_handle_disconnect(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size)
 {
 	tkproto_TakionMessage msg;
@@ -609,7 +637,6 @@ static bool pb_decode_resolution(pb_istr
 	return true;
 }
 
-
 static void stream_connection_takion_data_expect_streaminfo(ChiakiStreamConnection *stream_connection, uint8_t *buf, size_t buf_size)
 {
 	tkproto_TakionMessage msg;
@@ -678,11 +705,9 @@ error:
 	chiaki_cond_signal(&stream_connection->state_cond);
 }
 
-
-
 static bool chiaki_pb_encode_zero_encrypted_key(pb_ostream_t *stream, const pb_field_t *field, void *const *arg)
 {
-	if (!pb_encode_tag_for_field(stream, field))
+	if(!pb_encode_tag_for_field(stream, field))
 		return false;
 	uint8_t data[] = { 0, 0, 0, 0 };
 	return pb_encode_string(stream, data, sizeof(data));
@@ -836,7 +861,6 @@ static ChiakiErrorCode stream_connection
 	return err;
 }
 
-
 static void stream_connection_takion_av(ChiakiStreamConnection *stream_connection, ChiakiTakionAVPacket *packet)
 {
 	chiaki_gkcrypt_decrypt(stream_connection->gkcrypt_remote, packet->key_pos + CHIAKI_GKCRYPT_BLOCK_SIZE, packet->data, packet->data_size);
@@ -847,7 +871,6 @@ static void stream_connection_takion_av(
 		chiaki_audio_receiver_av_packet(stream_connection->audio_receiver, packet);
 }
 
-
 static ChiakiErrorCode stream_connection_send_heartbeat(ChiakiStreamConnection *stream_connection)
 {
 	tkproto_TakionMessage msg = { 0 };
diff -pruN 2.0.1-1/lib/src/takion.c 2.1.0-1/lib/src/takion.c
--- 2.0.1-1/lib/src/takion.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/takion.c	2021-01-15 21:35:50.000000000 +0000
@@ -56,7 +56,6 @@ typedef enum takion_packet_type_t {
 	TAKION_PACKET_TYPE_HANDSHAKE = 4,
 	TAKION_PACKET_TYPE_CONGESTION = 5,
 	TAKION_PACKET_TYPE_FEEDBACK_STATE = 6,
-	TAKION_PACKET_TYPE_RUMBLE_EVENT = 7,
 	TAKION_PACKET_TYPE_CLIENT_INFO = 8,
 	TAKION_PACKET_TYPE_PAD_INFO_EVENT = 9
 } TakionPacketType;
@@ -108,7 +107,6 @@ typedef enum takion_chunk_type_t {
 	TAKION_CHUNK_TYPE_COOKIE_ACK = 0xb,
 } TakionChunkType;
 
-
 typedef struct takion_message_t
 {
 	uint32_t tag;
@@ -121,7 +119,6 @@ typedef struct takion_message_t
 	uint8_t *payload;
 } TakionMessage;
 
-
 typedef struct takion_message_payload_init_t
 {
 	uint32_t tag;
@@ -153,14 +150,12 @@ typedef struct
 	uint16_t channel;
 } TakionDataPacketEntry;
 
-
 typedef struct chiaki_takion_postponed_packet_t
 {
 	uint8_t *buf;
 	size_t buf_size;
 } ChiakiTakionPostponedPacket;
 
-
 static void *takion_thread_func(void *user);
 static void takion_handle_packet(ChiakiTakion *takion, uint8_t *buf, size_t buf_size);
 static ChiakiErrorCode takion_handle_packet_mac(ChiakiTakion *takion, uint8_t base_type, uint8_t *buf, size_t buf_size);
@@ -508,7 +503,7 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_tak
 		return err;
 
 	uint8_t buf[CHIAKI_TAKION_CONGESTION_PACKET_SIZE];
-	chiaki_takion_format_congestion(buf, packet, key_pos);	
+	chiaki_takion_format_congestion(buf, packet, key_pos);
 	return chiaki_takion_send(takion, buf, sizeof(buf), key_pos);
 }
 
@@ -604,7 +599,6 @@ static ChiakiErrorCode takion_handshake(
 
 	CHIAKI_LOGI(takion->log, "Takion sent init");
 
-
 	// INIT_ACK <-
 
 	TakionMessagePayloadInitAck init_ack_payload;
@@ -622,20 +616,17 @@ static ChiakiErrorCode takion_handshake(
 	}
 
 	CHIAKI_LOGI(takion->log, "Takion received init ack with remote tag %#x, outbound streams: %#x, inbound streams: %#x",
-				init_ack_payload.tag, init_ack_payload.outbound_streams, init_ack_payload.inbound_streams);
+		init_ack_payload.tag, init_ack_payload.outbound_streams, init_ack_payload.inbound_streams);
 
 	takion->tag_remote = init_ack_payload.tag;
 	*seq_num_remote_initial = takion->tag_remote; //init_ack_payload.initial_seq_num;
 
-	if(init_ack_payload.outbound_streams == 0 || init_ack_payload.inbound_streams == 0
-	   || init_ack_payload.outbound_streams > TAKION_INBOUND_STREAMS
-	   || init_ack_payload.inbound_streams < TAKION_OUTBOUND_STREAMS)
+	if(init_ack_payload.outbound_streams == 0 || init_ack_payload.inbound_streams == 0 || init_ack_payload.outbound_streams > TAKION_INBOUND_STREAMS || init_ack_payload.inbound_streams < TAKION_OUTBOUND_STREAMS)
 	{
 		CHIAKI_LOGE(takion->log, "Takion min/max check failed");
 		return CHIAKI_ERR_INVALID_RESPONSE;
 	}
 
-
 	// COOKIE ->
 
 	err = takion_send_message_cookie(takion, init_ack_payload.cookie);
@@ -781,7 +772,6 @@ beach:
 	return NULL;
 }
 
-
 static ChiakiErrorCode takion_recv(ChiakiTakion *takion, uint8_t *buf, size_t *buf_size, uint64_t timeout_ms)
 {
 	ChiakiErrorCode err = chiaki_stop_pipe_select_single(&takion->stop_pipe, takion->sock, false, timeout_ms);
@@ -806,7 +796,6 @@ static ChiakiErrorCode takion_recv(Chiak
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 static ChiakiErrorCode takion_handle_packet_mac(ChiakiTakion *takion, uint8_t base_type, uint8_t *buf, size_t buf_size)
 {
 	if(!takion->gkcrypt_remote)
@@ -867,7 +856,6 @@ static void takion_postpone_packet(Chiak
 	packet->buf_size = buf_size;
 }
 
-
 /**
  * @param buf ownership of this buf is taken.
  */
@@ -935,7 +923,6 @@ static void takion_handle_packet_message
 	}
 }
 
-
 static void takion_flush_data_queue(ChiakiTakion *takion)
 {
 	uint64_t seq_num = 0;
@@ -961,7 +948,9 @@ static void takion_flush_data_queue(Chia
 		if(zero_a != 0)
 			CHIAKI_LOGW(takion->log, "Takion received data with unexpected nonzero %#x at buf+6", zero_a);
 
-		if(data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_PROTOBUF && data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_9)
+		if(data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_PROTOBUF
+				&& data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_RUMBLE
+				&& data_type != CHIAKI_TAKION_MESSAGE_DATA_TYPE_9)
 		{
 			CHIAKI_LOGW(takion->log, "Takion received data with unexpected data type %#x", data_type);
 			chiaki_log_hexdump(takion->log, CHIAKI_LOG_WARNING, entry->packet_buf, entry->packet_size);
@@ -1103,7 +1092,6 @@ static ChiakiErrorCode takion_parse_mess
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 static ChiakiErrorCode takion_send_message_init(ChiakiTakion *takion, TakionMessagePayloadInit *payload)
 {
 	uint8_t message[1 + TAKION_MESSAGE_HEADER_SIZE + 0x10];
@@ -1120,8 +1108,6 @@ static ChiakiErrorCode takion_send_messa
 	return chiaki_takion_send_raw(takion, message, sizeof(message));
 }
 
-
-
 static ChiakiErrorCode takion_send_message_cookie(ChiakiTakion *takion, uint8_t *cookie)
 {
 	uint8_t message[1 + TAKION_MESSAGE_HEADER_SIZE + TAKION_COOKIE_SIZE];
@@ -1131,8 +1117,6 @@ static ChiakiErrorCode takion_send_messa
 	return chiaki_takion_send_raw(takion, message, sizeof(message));
 }
 
-
-
 static ChiakiErrorCode takion_recv_message_init_ack(ChiakiTakion *takion, TakionMessagePayloadInitAck *payload)
 {
 	uint8_t message[1 + TAKION_MESSAGE_HEADER_SIZE + 0x10 + TAKION_COOKIE_SIZE];
@@ -1180,7 +1164,6 @@ static ChiakiErrorCode takion_recv_messa
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 static ChiakiErrorCode takion_recv_message_cookie_ack(ChiakiTakion *takion)
 {
 	uint8_t message[1 + TAKION_MESSAGE_HEADER_SIZE];
@@ -1220,7 +1203,6 @@ static ChiakiErrorCode takion_recv_messa
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 static void takion_handle_packet_av(ChiakiTakion *takion, uint8_t base_type, uint8_t *buf, size_t buf_size)
 {
 	// HHIxIIx
@@ -1452,5 +1434,4 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_tak
 	packet->data_size = buf_size;
 
 	return CHIAKI_ERR_SUCCESS;
-
 }
diff -pruN 2.0.1-1/lib/src/thread.c 2.1.0-1/lib/src/thread.c
--- 2.0.1-1/lib/src/thread.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/thread.c	2021-01-15 21:35:50.000000000 +0000
@@ -23,7 +23,8 @@ static DWORD WINAPI win32_thread_func(LP
 #endif
 
 #ifdef __SWITCH__
-int64_t get_thread_limit(){
+int64_t get_thread_limit()
+{
 	uint64_t resource_limit_handle_value = INVALID_HANDLE;
 	svcGetInfo(&resource_limit_handle_value, InfoType_ResourceLimit, INVALID_HANDLE, 0);
 	int64_t thread_cur_value = 0, thread_lim_value = 0;
@@ -45,9 +46,8 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_thr
 		return CHIAKI_ERR_THREAD;
 #else
 #ifdef __SWITCH__
-	if(get_thread_limit() <= 1){
+	if(get_thread_limit() <= 1)
 		return CHIAKI_ERR_THREAD;
-	}
 #endif
 	int r = pthread_create(&thread->thread, NULL, func, arg);
 	if(r != 0)
@@ -90,13 +90,13 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_thr
 	if(r != 0)
 		return CHIAKI_ERR_THREAD;
 #else
-	(void)thread; (void)name;
+	(void)thread;
+	(void)name;
 #endif
 #endif
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_mutex_init(ChiakiMutex *mutex, bool rec)
 {
 #if _WIN32
@@ -172,9 +172,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_mut
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
-
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_cond_init(ChiakiCond *cond)
 {
 #if _WIN32
@@ -214,8 +211,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_con
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_cond_wait(ChiakiCond *cond, ChiakiMutex *mutex)
 {
 #if _WIN32
@@ -323,7 +318,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_con
 #endif
 	}
 	return CHIAKI_ERR_SUCCESS;
-
 }
 
 CHIAKI_EXPORT ChiakiErrorCode chiaki_cond_signal(ChiakiCond *cond)
@@ -350,9 +344,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_con
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
-
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_bool_pred_cond_init(ChiakiBoolPredCond *cond)
 {
 	cond->pred = false;
@@ -384,7 +375,6 @@ CHIAKI_EXPORT ChiakiErrorCode chiaki_boo
 	return CHIAKI_ERR_SUCCESS;
 }
 
-
 CHIAKI_EXPORT ChiakiErrorCode chiaki_bool_pred_cond_lock(ChiakiBoolPredCond *cond)
 {
 	return chiaki_mutex_lock(&cond->mutex);
diff -pruN 2.0.1-1/lib/src/videoreceiver.c 2.1.0-1/lib/src/videoreceiver.c
--- 2.0.1-1/lib/src/videoreceiver.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/lib/src/videoreceiver.c	2021-01-15 21:35:50.000000000 +0000
@@ -17,6 +17,7 @@ CHIAKI_EXPORT void chiaki_video_receiver
 
 	video_receiver->frame_index_cur = -1;
 	video_receiver->frame_index_prev = -1;
+	video_receiver->frame_index_prev_complete = 0;
 
 	chiaki_frame_processor_init(&video_receiver->frame_processor, video_receiver->log);
 	video_receiver->packet_stats = packet_stats;
diff -pruN 2.0.1-1/README.md 2.1.0-1/README.md
--- 2.0.1-1/README.md	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/README.md	2021-01-15 21:35:50.000000000 +0000
@@ -12,21 +12,18 @@ for Linux, FreeBSD, OpenBSD, Android, ma
 
 ![Screenshot](assets/screenshot.png)
 
-## Features
+## Project Status
 
-Everything necessary for a full streaming session, including the initial
-registration and wakeup of the console, is supported.
-The following features however are yet to be implemented:
-* Rumble
-* Accelerometer/Gyroscope
+As all relevant features are implemented, this project is considered to be finished and in maintenance mode only.
+No major updates are planned and contributions are only accepted in special cases.
 
 ## Installing
 
-You can either download a pre-built release (easier) or build Chiaki from source.
+You can either download a pre-built release or build Chiaki from source.
 
 ### Downloading a Release
 
-Builds are provided for Linux, Android, macOS and Windows.
+Builds are provided for Linux, Android, macOS, Nintendo Switch and Windows.
 
 You can download them [here](https://git.sr.ht/~thestr4ng3r/chiaki/refs).
 
@@ -34,7 +31,7 @@ You can download them [here](https://git
 * **Android**: Install from [Google Play](https://play.google.com/store/apps/details?id=com.metallic.chiaki), [F-Droid](https://f-droid.org/packages/com.metallic.chiaki/) or download the APK from Sourcehut.
 * **macOS**: Drag the application from the `.dmg` into your Applications folder.
 * **Windows**: Extract the `.zip` file and execute `chiaki.exe`.
-* **Switch**: Follow README specific [instructions](./switch/README.md)
+* **Switch**: Download the `.nro` file and copy it into the `switch/` directory on your SD card.
 
 ### Building from Source
 
@@ -47,8 +44,8 @@ cmake ..
 make
 ```
 
-For more detailed platform-specific instructions, see [doc/platform-build.md](doc/platform-build.md).
-in
+For more detailed platform-specific instructions, see [doc/platform-build.md](doc/platform-build.md) or [switch/](./switch/README.md) for Nintendo Switch.
+
 ## Usage
 
 If your Console is on your local network, is turned on or in standby mode and does not have Discovery explicitly disabled, Chiaki should find it.
@@ -71,13 +68,6 @@ Settings -> Remote Play -> Add Device, o
 
 You can now double-click your Console in Chiaki's main window to start Remote Play.
 
-## Joining the Community or Getting Help
-
-There are official groups for Chiaki on Telegram and IRC. They are bridged so you can join whichever you like:
-
-- **Telegram:** https://t.me/chiakitg
-- **IRC:** #chiaki on irc.freenode.net
-
 ## Acknowledgements
 
 This project has only been made possible because of the following Open Source projects:
diff -pruN 2.0.1-1/scripts/build-appimage.sh 2.1.0-1/scripts/build-appimage.sh
--- 2.0.1-1/scripts/build-appimage.sh	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/scripts/build-appimage.sh	2021-01-15 21:35:50.000000000 +0000
@@ -18,6 +18,8 @@ cmake \
 	"-DCMAKE_PREFIX_PATH=`pwd`/../appimage/ffmpeg-prefix;`pwd`/../appimage/sdl2-prefix;/opt/qt512" \
 	-DCHIAKI_ENABLE_TESTS=ON \
 	-DCHIAKI_ENABLE_CLI=OFF \
+	-DCHIAKI_ENABLE_GUI=ON \
+	-DCHIAKI_ENABLE_SETSU=ON \
 	-DCHIAKI_GUI_ENABLE_SDL_GAMECONTROLLER=ON \
 	-DCMAKE_INSTALL_PREFIX=/usr \
 	..
diff -pruN 2.0.1-1/scripts/build-ffmpeg.sh 2.1.0-1/scripts/build-ffmpeg.sh
--- 2.0.1-1/scripts/build-ffmpeg.sh	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/scripts/build-ffmpeg.sh	2021-01-15 21:35:50.000000000 +0000
@@ -9,6 +9,6 @@ TAG=n4.3.1
 
 git clone https://git.ffmpeg.org/ffmpeg.git --depth 1 -b $TAG && cd ffmpeg || exit 1
 
-./configure --disable-all --enable-avcodec --enable-decoder=h264 --enable-decoder=hevc --enable-hwaccel=h264_vaapi --prefix="$ROOT/ffmpeg-prefix" "$@" || exit 1
+./configure --disable-all --enable-avcodec --enable-decoder=h264 --enable-decoder=hevc --enable-hwaccel=h264_vaapi --enable-hwaccel=hevc_vaapi --prefix="$ROOT/ffmpeg-prefix" "$@" || exit 1
 make -j4 || exit 1
 make install || exit 1
diff -pruN 2.0.1-1/scripts/Dockerfile.xenial 2.1.0-1/scripts/Dockerfile.xenial
--- 2.0.1-1/scripts/Dockerfile.xenial	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/scripts/Dockerfile.xenial	2021-01-15 21:35:50.000000000 +0000
@@ -5,9 +5,9 @@ RUN apt-get update
 RUN apt-get install -y software-properties-common
 RUN add-apt-repository ppa:beineri/opt-qt-5.12.3-xenial
 RUN apt-get update
-RUN apt-get -y install git g++ cmake ninja-build curl unzip python3-pip \
+RUN apt-get -y install git g++ cmake ninja-build curl pkg-config unzip python3-pip \
 	libssl-dev libopus-dev qt512base qt512multimedia qt512svg \
-	libgl1-mesa-dev nasm libudev-dev libva-dev fuse
+	libgl1-mesa-dev nasm libudev-dev libva-dev fuse libevdev-dev libudev-dev
 
 CMD []
 
diff -pruN 2.0.1-1/scripts/flatpak/com.github.thestr4ng3r.Chiaki.json 2.1.0-1/scripts/flatpak/com.github.thestr4ng3r.Chiaki.json
--- 2.0.1-1/scripts/flatpak/com.github.thestr4ng3r.Chiaki.json	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/scripts/flatpak/com.github.thestr4ng3r.Chiaki.json	2021-01-15 21:35:50.000000000 +0000
@@ -89,8 +89,8 @@
                 {
                     "type": "git",
                     "url": "https://git.sr.ht/~thestr4ng3r/chiaki",
-		    "tag": "v1.3.0",
-		    "commit": "702d31eb01d37518e77f5c1be3ea493df9f18323"
+		    "tag": "v2.0.1",
+		    "commit": "9e698dd7c4e4011ff6e136741abef5cf4b32527c"
                 }
             ]
         }
diff -pruN 2.0.1-1/scripts/switch/push-docker-build-chiaki.sh 2.1.0-1/scripts/switch/push-docker-build-chiaki.sh
--- 2.0.1-1/scripts/switch/push-docker-build-chiaki.sh	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/scripts/switch/push-docker-build-chiaki.sh	2021-01-15 21:35:50.000000000 +0000
@@ -3,8 +3,10 @@
 cd "`dirname $(readlink -f ${0})`/../.."
 
 docker run \
-	-v "`pwd`:/build/chiaki" \
-	-p 28771:28771 -ti \
-	chiaki-switch \
-	-c "/opt/devkitpro/tools/bin/nxlink -a $@ -s /build/chiaki/build_switch/switch/chiaki.nro"
+    -v "`pwd`:/build/chiaki" \
+    -w "/build/chiaki" \
+    -ti -p 28771:28771 \
+    --entrypoint /opt/devkitpro/tools/bin/nxlink \
+    thestr4ng3r/chiaki-build-switch \
+    "$@" -s /build/chiaki/build_switch/switch/chiaki.nro
 
diff -pruN 2.0.1-1/setsu/cmake/FindEvdev.cmake 2.1.0-1/setsu/cmake/FindEvdev.cmake
--- 2.0.1-1/setsu/cmake/FindEvdev.cmake	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/cmake/FindEvdev.cmake	2021-01-15 21:35:50.000000000 +0000
@@ -5,7 +5,11 @@ set(_target "${_prefix}::libevdev")
 
 find_package(PkgConfig)
 if(PkgConfig_FOUND AND NOT TARGET ${_target})
-	pkg_check_modules("${_prefix}" libevdev IMPORTED_TARGET)
+	if(CMAKE_VERSION VERSION_LESS "3.6")
+		pkg_check_modules("${_prefix}" libevdev)
+	else()
+		pkg_check_modules("${_prefix}" libevdev IMPORTED_TARGET)
+	endif()
 	if((TARGET PkgConfig::${_prefix}) AND (NOT CMAKE_VERSION VERSION_LESS "3.11.0"))
 		set_target_properties(PkgConfig::${_prefix} PROPERTIES IMPORTED_GLOBAL ON)
 		add_library(${_target} ALIAS PkgConfig::${_prefix})
diff -pruN 2.0.1-1/setsu/cmake/FindUdev.cmake 2.1.0-1/setsu/cmake/FindUdev.cmake
--- 2.0.1-1/setsu/cmake/FindUdev.cmake	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/cmake/FindUdev.cmake	2021-01-15 21:35:50.000000000 +0000
@@ -5,7 +5,11 @@ set(_target "${_prefix}::libudev")
 
 find_package(PkgConfig)
 if(PkgConfig_FOUND AND NOT TARGET ${_target})
-	pkg_check_modules("${_prefix}" libudev IMPORTED_TARGET)
+	if(CMAKE_VERSION VERSION_LESS "3.6")
+		pkg_check_modules("${_prefix}" libudev)
+	else()
+		pkg_check_modules("${_prefix}" libudev IMPORTED_TARGET)
+	endif()
 	if((TARGET PkgConfig::${_prefix}) AND (NOT CMAKE_VERSION VERSION_LESS "3.11.0"))
 		set_target_properties(PkgConfig::${_prefix} PROPERTIES IMPORTED_GLOBAL ON)
 		add_library(${_target} ALIAS PkgConfig::${_prefix})
diff -pruN 2.0.1-1/setsu/CMakeLists.txt 2.1.0-1/setsu/CMakeLists.txt
--- 2.0.1-1/setsu/CMakeLists.txt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/CMakeLists.txt	2021-01-15 21:35:50.000000000 +0000
@@ -3,7 +3,7 @@ cmake_minimum_required(VERSION 3.2)
 
 project(libsetsu)
 
-option(SETSU_BUILD_DEMO "Build testing executable for libsetsu" OFF)
+option(SETSU_BUILD_DEMOS "Build testing executables for libsetsu" OFF)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -17,9 +17,10 @@ find_package(Udev REQUIRED)
 find_package(Evdev REQUIRED)
 target_link_libraries(setsu Udev::libudev Evdev::libevdev)
 
-if(SETSU_BUILD_DEMO)
-	add_executable(setsu-demo
-		demo/main.c)
-	target_link_libraries(setsu-demo setsu)
+if(SETSU_BUILD_DEMOS)
+	add_executable(setsu-demo-touchpad demo/touchpad.c)
+	target_link_libraries(setsu-demo-touchpad setsu)
+	add_executable(setsu-demo-motion demo/motion.c)
+	target_link_libraries(setsu-demo-motion setsu)
 endif()
 
diff -pruN 2.0.1-1/setsu/demo/main.c 2.1.0-1/setsu/demo/main.c
--- 2.0.1-1/setsu/demo/main.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/demo/main.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,168 +0,0 @@
-// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
-
-#include <setsu.h>
-
-#include <stdlib.h>
-#include <stdio.h>
-#include <stdbool.h>
-#include <string.h>
-#include <assert.h>
-#include <signal.h>
-
-Setsu *setsu;
-
-#define WIDTH 1920
-#define HEIGHT 942
-#define TOUCHES_MAX 8
-#define SCALE 16
-
-struct {
-	bool down;
-	unsigned int tracking_id;
-	unsigned int x, y;
-} touches[TOUCHES_MAX];
-
-bool dirty = false;
-bool log_mode;
-volatile bool should_quit;
-
-#define LOG(...) do { if(log_mode) fprintf(stderr, __VA_ARGS__); } while(0)
-
-void sigint(int s)
-{
-	should_quit = true;
-}
-
-void print_state()
-{
-	char buf[(1 + WIDTH/SCALE)*(HEIGHT/SCALE) + 1];
-	size_t i = 0;
-	for(size_t y=0; y<HEIGHT/SCALE; y++)
-	{
-		for(size_t x=0; x<WIDTH/SCALE; x++)
-		{
-			for(size_t t=0; t<TOUCHES_MAX; t++)
-			{
-				if(touches[t].down && touches[t].x / SCALE == x && touches[t].y / SCALE == y)
-				{
-					buf[i++] = 'X';
-					goto beach;
-				}
-			}
-			buf[i++] = '.';
-beach:
-			continue;
-		}
-		buf[i++] = '\n';
-	}
-	buf[i++] = '\0';
-	assert(i == sizeof(buf));
-	printf("\033[2J%s", buf);
-
-	fflush(stdout);
-}
-
-void event(SetsuEvent *event, void *user)
-{
-	dirty = true;
-	switch(event->type)
-	{
-		case SETSU_EVENT_DEVICE_ADDED: {
-			SetsuDevice *dev = setsu_connect(setsu, event->path);
-			LOG("Device added: %s, connect %s\n", event->path, dev ? "succeeded" : "FAILED!");
-			break;
-		}
-		case SETSU_EVENT_DEVICE_REMOVED:
-			LOG("Device removed: %s\n", event->path);
-			break;
-		case SETSU_EVENT_TOUCH_DOWN:
-			LOG("Down for %s, tracking id %d\n", setsu_device_get_path(event->dev), event->tracking_id);
-			for(size_t i=0; i<TOUCHES_MAX; i++)
-			{
-				if(!touches[i].down)
-				{
-					touches[i].down = true;
-					touches[i].tracking_id = event->tracking_id;
-					break;
-				}
-			}
-			break;
-		case SETSU_EVENT_TOUCH_POSITION:
-		case SETSU_EVENT_TOUCH_UP:
-			if(event->type == SETSU_EVENT_TOUCH_UP)
-				LOG("Up for %s, tracking id %d\n", setsu_device_get_path(event->dev), event->tracking_id);
-			else
-				LOG("Position for %s, tracking id %d: %u, %u\n", setsu_device_get_path(event->dev),
-						event->tracking_id, (unsigned int)event->x, (unsigned int)event->y);
-			for(size_t i=0; i<TOUCHES_MAX; i++)
-			{
-				if(touches[i].down && touches[i].tracking_id == event->tracking_id)
-				{
-					switch(event->type)
-					{
-						case SETSU_EVENT_TOUCH_POSITION:
-							touches[i].x = event->x;
-							touches[i].y = event->y;
-							break;
-						case SETSU_EVENT_TOUCH_UP:
-							touches[i].down = false;
-							break;
-						default:
-							break;
-					}
-				}
-			}
-			break;
-		case SETSU_EVENT_BUTTON_DOWN:
-		case SETSU_EVENT_BUTTON_UP:
-			LOG("Button for %s: %llu %s\n", setsu_device_get_path(event->dev),
-					(unsigned long long)event->button, event->type == SETSU_EVENT_BUTTON_DOWN ? "down" : "up");
-			break;
-	}
-}
-
-void usage(const char *prog)
-{
-	printf("usage: %s [-l]\n  -l log mode\n", prog);
-	exit(1);
-}
-
-int main(int argc, const char *argv[])
-{
-	log_mode = false;
-	if(argc == 2)
-	{
-		if(!strcmp(argv[1], "-l"))
-			log_mode = true;
-		else
-			usage(argv[0]);
-	}
-	else if(argc != 1)
-		usage(argv[0]);
-
-	memset(touches, 0, sizeof(touches));
-	setsu = setsu_new();
-	if(!setsu)
-	{
-		printf("Failed to init setsu\n");
-		return 1;
-	}
-
-	struct sigaction sa = {0};
-	sa.sa_handler = sigint;
-	sigemptyset(&sa.sa_mask);
-	sigaction(SIGINT, &sa, NULL);
-
-	dirty = true;
-	while(!should_quit)
-	{
-		if(dirty && !log_mode)
-			print_state();
-		dirty = false;
-		setsu_poll(setsu, event, NULL);
-	}
-	setsu_free(setsu);
-	printf("\nさよなら!\n");
-	return 0;
-}
-
diff -pruN 2.0.1-1/setsu/demo/motion.c 2.1.0-1/setsu/demo/motion.c
--- 2.0.1-1/setsu/demo/motion.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/setsu/demo/motion.c	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,163 @@
+// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
+
+#include <setsu.h>
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <stdbool.h>
+#include <string.h>
+#include <assert.h>
+#include <signal.h>
+#include <math.h>
+
+Setsu *setsu;
+
+#define NAME_LEN 8
+const char * const names[] = {
+	"accel x ",
+	"accel y ",
+	"accel z ",
+	" gyro x ",
+	" gyro y ",
+	" gyro z "
+};
+union
+{
+	struct
+	{
+		float accel_x, accel_y, accel_z;
+		float gyro_x, gyro_y, gyro_z;
+	};
+	float v[6];
+} vals;
+uint32_t timestamp;
+bool dirty = false;
+bool log_mode;
+volatile bool should_quit;
+
+#define LOG(...) do { if(log_mode) fprintf(stderr, __VA_ARGS__); } while(0)
+
+void sigint(int s)
+{
+	should_quit = true;
+}
+
+#define BAR_LENGTH 100
+#define BAR_MAX 2.0f
+#define BAR_MAX_GYRO M_PI
+
+void print_state()
+{
+	char buf[6 * (1 + NAME_LEN + BAR_LENGTH) + 1];
+	size_t i = 0;
+	for(size_t b=0; b<6; b++)
+	{
+		buf[i++] = '\n';
+		memcpy(buf + i, names[b], NAME_LEN);
+		i += NAME_LEN;
+		buf[i++] = '[';
+		size_t max = BAR_LENGTH-2;
+		for(size_t bi=0; bi<max; bi++)
+		{
+#define BAR_VAL(x) ((b > 2 ? BAR_MAX_GYRO : BAR_MAX) * (2.0f * (float)(x) / (float)max - 1.0f))
+			float cur = BAR_VAL(bi);
+			float prev = BAR_VAL((int)bi - 1);
+			if(prev < 0.0f && cur >= 0.0f)
+			{
+				buf[i++] = '|';
+				continue;
+			}
+			bool cov = ((vals.v[b] < 0.0f) == (cur < 0.0f)) && fabsf(vals.v[b]) > fabsf(cur);
+			float next = BAR_VAL(bi + 1);
+#define MARK_VAL (b > 2 ? 0.5f * M_PI : 1.0f)
+			bool mark = cur < -MARK_VAL && next >= -MARK_VAL || prev < MARK_VAL && cur >= MARK_VAL;
+			buf[i++] = cov ? (mark ? '#' : '=') : (mark ? '.' : ' ');
+#undef BAR_VAL
+		}
+		buf[i++] = ']';
+	}
+	buf[i++] = '\0';
+	assert(i == sizeof(buf));
+	printf("\033[2J%s", buf);
+	fflush(stdout);
+}
+
+void event(SetsuEvent *event, void *user)
+{
+	dirty = true;
+	switch(event->type)
+	{
+		case SETSU_EVENT_DEVICE_ADDED: {
+			if(event->dev_type != SETSU_DEVICE_TYPE_MOTION)
+				break;
+			SetsuDevice *dev = setsu_connect(setsu, event->path, SETSU_DEVICE_TYPE_MOTION);
+			LOG("Device added: %s, connect %s\n", event->path, dev ? "succeeded" : "FAILED!");
+			break;
+		}
+		case SETSU_EVENT_DEVICE_REMOVED:
+			if(event->dev_type != SETSU_DEVICE_TYPE_MOTION)
+				break;
+			LOG("Device removed: %s\n", event->path);
+			break;
+		case SETSU_EVENT_MOTION:
+			LOG("Motion: %f, %f, %f / %f, %f, %f / %u\n",
+					event->motion.accel_x, event->motion.accel_y, event->motion.accel_z,
+					event->motion.gyro_x, event->motion.gyro_y, event->motion.gyro_z,
+					(unsigned int)event->motion.timestamp);
+			vals.accel_x = event->motion.accel_x;
+			vals.accel_y = event->motion.accel_y;
+			vals.accel_z = event->motion.accel_z;
+			vals.gyro_x = event->motion.gyro_x;
+			vals.gyro_y = event->motion.gyro_y;
+			vals.gyro_z = event->motion.gyro_z;
+			timestamp = event->motion.timestamp;
+			dirty = true;
+		default:
+			break;
+	}
+}
+
+void usage(const char *prog)
+{
+	printf("usage: %s [-l]\n  -l log mode\n", prog);
+	exit(1);
+}
+
+int main(int argc, const char *argv[])
+{
+	log_mode = false;
+	if(argc == 2)
+	{
+		if(!strcmp(argv[1], "-l"))
+			log_mode = true;
+		else
+			usage(argv[0]);
+	}
+	else if(argc != 1)
+		usage(argv[0]);
+
+	setsu = setsu_new();
+	if(!setsu)
+	{
+		printf("Failed to init setsu\n");
+		return 1;
+	}
+
+	struct sigaction sa = {0};
+	sa.sa_handler = sigint;
+	sigemptyset(&sa.sa_mask);
+	sigaction(SIGINT, &sa, NULL);
+
+	dirty = true;
+	while(!should_quit)
+	{
+		if(dirty && !log_mode)
+			print_state();
+		dirty = false;
+		setsu_poll(setsu, event, NULL);
+	}
+	setsu_free(setsu);
+	printf("\nさよなら!\n");
+	return 0;
+}
+
diff -pruN 2.0.1-1/setsu/demo/touchpad.c 2.1.0-1/setsu/demo/touchpad.c
--- 2.0.1-1/setsu/demo/touchpad.c	1970-01-01 00:00:00.000000000 +0000
+++ 2.1.0-1/setsu/demo/touchpad.c	2021-01-15 21:35:50.000000000 +0000
@@ -0,0 +1,174 @@
+// SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
+
+#include <setsu.h>
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <stdbool.h>
+#include <string.h>
+#include <assert.h>
+#include <signal.h>
+
+Setsu *setsu;
+
+#define WIDTH 1920
+#define HEIGHT 942
+#define TOUCHES_MAX 8
+#define SCALE 16
+
+struct {
+	bool down;
+	unsigned int tracking_id;
+	unsigned int x, y;
+} touches[TOUCHES_MAX];
+
+bool dirty = false;
+bool log_mode;
+volatile bool should_quit;
+
+#define LOG(...) do { if(log_mode) fprintf(stderr, __VA_ARGS__); } while(0)
+
+void sigint(int s)
+{
+	should_quit = true;
+}
+
+void print_state()
+{
+	char buf[(1 + WIDTH/SCALE)*(HEIGHT/SCALE) + 1];
+	size_t i = 0;
+	for(size_t y=0; y<HEIGHT/SCALE; y++)
+	{
+		for(size_t x=0; x<WIDTH/SCALE; x++)
+		{
+			for(size_t t=0; t<TOUCHES_MAX; t++)
+			{
+				if(touches[t].down && touches[t].x / SCALE == x && touches[t].y / SCALE == y)
+				{
+					buf[i++] = 'X';
+					goto beach;
+				}
+			}
+			buf[i++] = '.';
+beach:
+			continue;
+		}
+		buf[i++] = '\n';
+	}
+	buf[i++] = '\0';
+	assert(i == sizeof(buf));
+	printf("\033[2J%s", buf);
+
+	fflush(stdout);
+}
+
+void event(SetsuEvent *event, void *user)
+{
+	dirty = true;
+	switch(event->type)
+	{
+		case SETSU_EVENT_DEVICE_ADDED: {
+			if(event->dev_type != SETSU_DEVICE_TYPE_TOUCHPAD)
+				break;
+			SetsuDevice *dev = setsu_connect(setsu, event->path, SETSU_DEVICE_TYPE_TOUCHPAD);
+			LOG("Device added: %s, connect %s\n", event->path, dev ? "succeeded" : "FAILED!");
+			break;
+		}
+		case SETSU_EVENT_DEVICE_REMOVED:
+			if(event->dev_type != SETSU_DEVICE_TYPE_TOUCHPAD)
+				break;
+			LOG("Device removed: %s\n", event->path);
+			break;
+		case SETSU_EVENT_TOUCH_DOWN:
+			LOG("Down for %s, tracking id %d\n", setsu_device_get_path(event->dev), event->touch.tracking_id);
+			for(size_t i=0; i<TOUCHES_MAX; i++)
+			{
+				if(!touches[i].down)
+				{
+					touches[i].down = true;
+					touches[i].tracking_id = event->touch.tracking_id;
+					break;
+				}
+			}
+			break;
+		case SETSU_EVENT_TOUCH_POSITION:
+		case SETSU_EVENT_TOUCH_UP:
+			if(event->type == SETSU_EVENT_TOUCH_UP)
+				LOG("Up for %s, tracking id %d\n", setsu_device_get_path(event->dev), event->touch.tracking_id);
+			else
+				LOG("Position for %s, tracking id %d: %u, %u\n", setsu_device_get_path(event->dev),
+						event->touch.tracking_id, (unsigned int)event->touch.x, (unsigned int)event->touch.y);
+			for(size_t i=0; i<TOUCHES_MAX; i++)
+			{
+				if(touches[i].down && touches[i].tracking_id == event->touch.tracking_id)
+				{
+					switch(event->type)
+					{
+						case SETSU_EVENT_TOUCH_POSITION:
+							touches[i].x = event->touch.x;
+							touches[i].y = event->touch.y;
+							break;
+						case SETSU_EVENT_TOUCH_UP:
+							touches[i].down = false;
+							break;
+						default:
+							break;
+					}
+				}
+			}
+			break;
+		case SETSU_EVENT_BUTTON_DOWN:
+		case SETSU_EVENT_BUTTON_UP:
+			LOG("Button for %s: %llu %s\n", setsu_device_get_path(event->dev),
+					(unsigned long long)event->button, event->type == SETSU_EVENT_BUTTON_DOWN ? "down" : "up");
+			break;
+		default:
+			break;
+	}
+}
+
+void usage(const char *prog)
+{
+	printf("usage: %s [-l]\n  -l log mode\n", prog);
+	exit(1);
+}
+
+int main(int argc, const char *argv[])
+{
+	log_mode = false;
+	if(argc == 2)
+	{
+		if(!strcmp(argv[1], "-l"))
+			log_mode = true;
+		else
+			usage(argv[0]);
+	}
+	else if(argc != 1)
+		usage(argv[0]);
+
+	memset(touches, 0, sizeof(touches));
+	setsu = setsu_new();
+	if(!setsu)
+	{
+		printf("Failed to init setsu\n");
+		return 1;
+	}
+
+	struct sigaction sa = {0};
+	sa.sa_handler = sigint;
+	sigemptyset(&sa.sa_mask);
+	sigaction(SIGINT, &sa, NULL);
+
+	dirty = true;
+	while(!should_quit)
+	{
+		if(dirty && !log_mode)
+			print_state();
+		dirty = false;
+		setsu_poll(setsu, event, NULL);
+	}
+	setsu_free(setsu);
+	printf("\nさよなら!\n");
+	return 0;
+}
+
diff -pruN 2.0.1-1/setsu/include/setsu.h 2.1.0-1/setsu/include/setsu.h
--- 2.0.1-1/setsu/include/setsu.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/include/setsu.h	2021-01-15 21:35:50.000000000 +0000
@@ -14,12 +14,17 @@ typedef struct setsu_device_t SetsuDevic
 typedef int SetsuTrackingId;
 
 typedef enum {
+	SETSU_DEVICE_TYPE_TOUCHPAD,
+	SETSU_DEVICE_TYPE_MOTION
+} SetsuDeviceType;
+
+typedef enum {
 	/* New device available to connect.
-	 * Event will have path set to the new device. */
+	 * Event will have path and type set to the new device. */
 	SETSU_EVENT_DEVICE_ADDED,
 
 	/* Previously available device removed.
-	 * Event will have path set to the new device.
+	 * Event will have path and type set to the removed device.
 	 * Any SetsuDevice connected to this path will automatically
 	 * be disconnected and their pointers will be invalid immediately
 	 * after the callback for this event returns. */
@@ -41,7 +46,10 @@ typedef enum {
 	SETSU_EVENT_BUTTON_DOWN,
 
 	/* Event will have dev and button set. */
-	SETSU_EVENT_BUTTON_UP
+	SETSU_EVENT_BUTTON_UP,
+
+	/* Event will have motion set. */
+	SETSU_EVENT_MOTION
 } SetsuEventType;
 
 #define SETSU_BUTTON_0 (1u << 0)
@@ -53,7 +61,11 @@ typedef struct setsu_event_t
 	SetsuEventType type;
 	union
 	{
-		const char *path;
+		struct
+		{
+			const char *path;
+			SetsuDeviceType dev_type;
+		};
 		struct
 		{
 			SetsuDevice *dev;
@@ -63,8 +75,14 @@ typedef struct setsu_event_t
 				{
 					SetsuTrackingId tracking_id;
 					uint32_t x, y;
-				};
+				} touch;
 				SetsuButton button;
+				struct
+				{
+					float accel_x, accel_y, accel_z; // unit is 1G
+					float gyro_x, gyro_y, gyro_z; // unit is rad/sec
+					uint32_t timestamp; // microseconds
+				} motion;
 			};
 		};
 	};
@@ -75,11 +93,12 @@ typedef void (*SetsuEventCb)(SetsuEvent
 Setsu *setsu_new();
 void setsu_free(Setsu *setsu);
 void setsu_poll(Setsu *setsu, SetsuEventCb cb, void *user);
-SetsuDevice *setsu_connect(Setsu *setsu, const char *path);
+SetsuDevice *setsu_connect(Setsu *setsu, const char *path, SetsuDeviceType type);
 void setsu_disconnect(Setsu *setsu, SetsuDevice *dev);
 const char *setsu_device_get_path(SetsuDevice *dev);
-uint32_t setsu_device_get_width(SetsuDevice *dev);
-uint32_t setsu_device_get_height(SetsuDevice *dev);
+uint32_t setsu_device_touchpad_get_width(SetsuDevice *dev);
+uint32_t setsu_device_touchpad_get_height(SetsuDevice *dev);
+
 
 #ifdef __cplusplus
 }
diff -pruN 2.0.1-1/setsu/src/setsu.c 2.1.0-1/setsu/src/setsu.c
--- 2.0.1-1/setsu/src/setsu.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/setsu/src/setsu.c	2021-01-15 21:35:50.000000000 +0000
@@ -11,6 +11,7 @@
 #include <unistd.h>
 #include <fcntl.h>
 #include <errno.h>
+#include <math.h>
 
 #include <stdio.h>
 
@@ -22,9 +23,12 @@
 #define SETSU_LOG(...) do {} while(0)
 #endif
 
+#define DEG2RAD (2.0f * M_PI / 360.0f)
+
 typedef struct setsu_avail_device_t
 {
 	struct setsu_avail_device_t *next;
+	SetsuDeviceType type;
 	char *path;
 	bool connect_dirty; // whether the connect has not been sent as an event yet
 	bool disconnect_dirty; // whether the disconnect has not been sent as an event yet
@@ -36,27 +40,44 @@ typedef struct setsu_device_t
 {
 	struct setsu_device_t *next;
 	char *path;
+	SetsuDeviceType type;
 	int fd;
 	struct libevdev *evdev;
-	int min_x, min_y, max_x, max_y;
 
-	struct {
-		/* Saves the old tracking id that was just up-ed.
-		 * also for handling "atomic" up->down
-		 * i.e. when there is an up, then down with a different tracking id
-		 * in a single frame (before SYN_REPORT), this saves the old
-		 * tracking id that must be reported as up. */
-		int tracking_id_prev;
-
-		int tracking_id;
-		int x, y;
-		bool downed;
-		bool pos_dirty;
-	} slots[SLOTS_COUNT];
-	unsigned int slot_cur;
+	union
+	{
+		struct
+		{
+			int min_x, min_y, max_x, max_y;
 
-	uint64_t buttons_prev;
-	uint64_t buttons_cur;
+			struct
+			{
+				/* Saves the old tracking id that was just up-ed.
+				 * also for handling "atomic" up->down
+				 * i.e. when there is an up, then down with a different tracking id
+				 * in a single frame (before SYN_REPORT), this saves the old
+				 * tracking id that must be reported as up. */
+				int tracking_id_prev;
+
+				int tracking_id;
+				int x, y;
+				bool downed;
+				bool pos_dirty;
+			} slots[SLOTS_COUNT];
+			unsigned int slot_cur;
+			uint64_t buttons_prev;
+			uint64_t buttons_cur;
+		} touchpad;
+		struct
+		{
+			int accel_res_x, accel_res_y, accel_res_z;
+			int gyro_res_x, gyro_res_y, gyro_res_z;
+			int accel_x, accel_y, accel_z;
+			int gyro_x, gyro_y, gyro_z;
+			uint32_t timestamp;
+			bool dirty;
+		} motion;
+	};
 } SetsuDevice;
 
 struct setsu_t
@@ -131,8 +152,8 @@ static void scan_udev(Setsu *setsu)
 	if(udev_enumerate_add_match_subsystem(udev_enum, "input") < 0)
 		goto beach;
 
-	if(udev_enumerate_add_match_property(udev_enum, "ID_INPUT_TOUCHPAD", "1") < 0)
-		goto beach;
+	//if(udev_enumerate_add_match_property(udev_enum, "ID_INPUT_TOUCHPAD", "1") < 0)
+	//	goto beach;
 	
 	if(udev_enumerate_scan_devices(udev_enum) < 0)
 		goto beach;
@@ -153,16 +174,32 @@ beach:
 	udev_enumerate_unref(udev_enum);
 }
 
-static bool is_device_interesting(struct udev_device *dev)
+static bool is_device_interesting(struct udev_device *dev, SetsuDeviceType *type)
 {
 	static const uint32_t device_ids[] = {
 		// vendor id, model id
-		0x054c,       0x05c4, // DualShock 4 Gen 1 USB
-		0x054c,       0x09cc // DualShock 4 Gen 2 USB
+		0x054c,       0x05c4, // DualShock 4 Gen 1
+		0x054c,       0x09cc, // DualShock 4 Gen 2
+		0x54c,        0x0ce6 // DualSense
 	};
 
-	// Filter mouse-device (/dev/input/mouse*) away and only keep the evdev (/dev/input/event*) one: 
-	if(!udev_device_get_property_value(dev, "ID_INPUT_TOUCHPAD_INTEGRATION"))
+	const char *touchpad_str = udev_device_get_property_value(dev, "ID_INPUT_TOUCHPAD");
+	const char *accel_str = udev_device_get_property_value(dev, "ID_INPUT_ACCELEROMETER");
+	if(touchpad_str && !strcmp(touchpad_str, "1"))
+	{
+		// Filter mouse-device (/dev/input/mouse*) away and only keep the evdev (/dev/input/event*) one:
+		if(!udev_device_get_property_value(dev, "ID_INPUT_TOUCHPAD_INTEGRATION"))
+			return false;
+		*type = SETSU_DEVICE_TYPE_TOUCHPAD;
+	}
+	else if(accel_str && !strcmp(accel_str, "1"))
+	{
+		// Filter /dev/input/js* away and keep /dev/input/event*
+		if(!udev_device_get_property_value(dev, "ID_INPUT_WIDTH_MM"))
+			return false;
+		*type = SETSU_DEVICE_TYPE_MOTION;
+	}
+	else
 		return false;
 
 	uint32_t vendor;
@@ -220,12 +257,14 @@ static void update_udev_device(Setsu *se
 	}
 
 	// not yet added
-	if(!is_device_interesting(dev))
+	SetsuDeviceType type;
+	if(!is_device_interesting(dev, &type))
 		return;
 
 	SetsuAvailDevice *adev = calloc(1, sizeof(SetsuAvailDevice));
 	if(!adev)
 		return;
+	adev->type = type;
 	adev->path = strdup(path);
 	if(!adev->path)
 	{
@@ -271,7 +310,7 @@ bool get_dev_ids(const char *path, uint3
 	return true;
 }
 
-SetsuDevice *setsu_connect(Setsu *setsu, const char *path)
+SetsuDevice *setsu_connect(Setsu *setsu, const char *path, SetsuDeviceType type)
 {
 	SetsuDevice *dev = calloc(1, sizeof(SetsuDevice));
 	if(!dev)
@@ -280,10 +319,15 @@ SetsuDevice *setsu_connect(Setsu *setsu,
 	dev->path = strdup(path);
 	if(!dev->path)
 		goto error;
+	dev->type = type;
 
 	dev->fd = open(dev->path, O_RDONLY | O_NONBLOCK);
 	if(dev->fd == -1)
+	{
+		SETSU_LOG("Failed to open %s\n", dev->path);
+		perror("setsu_connect");
 		goto error;
+	}
 
 	if(libevdev_new_from_fd(dev->fd, &dev->evdev) < 0)
 	{
@@ -291,15 +335,29 @@ SetsuDevice *setsu_connect(Setsu *setsu,
 		goto error;
 	}
 
-	dev->min_x = libevdev_get_abs_minimum(dev->evdev, ABS_X);
-	dev->min_y = libevdev_get_abs_minimum(dev->evdev, ABS_Y);
-	dev->max_x = libevdev_get_abs_maximum(dev->evdev, ABS_X);
-	dev->max_y = libevdev_get_abs_maximum(dev->evdev, ABS_Y);
-
-	for(size_t i=0; i<SLOTS_COUNT; i++)
+	switch(type)
 	{
-		dev->slots[i].tracking_id_prev = -1;
-		dev->slots[i].tracking_id = -1;
+		case SETSU_DEVICE_TYPE_TOUCHPAD:
+			dev->touchpad.min_x = libevdev_get_abs_minimum(dev->evdev, ABS_X);
+			dev->touchpad.min_y = libevdev_get_abs_minimum(dev->evdev, ABS_Y);
+			dev->touchpad.max_x = libevdev_get_abs_maximum(dev->evdev, ABS_X);
+			dev->touchpad.max_y = libevdev_get_abs_maximum(dev->evdev, ABS_Y);
+
+			for(size_t i=0; i<SLOTS_COUNT; i++)
+			{
+				dev->touchpad.slots[i].tracking_id_prev = -1;
+				dev->touchpad.slots[i].tracking_id = -1;
+			}
+			break;
+		case SETSU_DEVICE_TYPE_MOTION:
+			dev->motion.accel_res_x = libevdev_get_abs_resolution(dev->evdev, ABS_X);
+			dev->motion.accel_res_y = libevdev_get_abs_resolution(dev->evdev, ABS_Y);
+			dev->motion.accel_res_z = libevdev_get_abs_resolution(dev->evdev, ABS_Z);
+			dev->motion.gyro_res_x = libevdev_get_abs_resolution(dev->evdev, ABS_RX);
+			dev->motion.gyro_res_y = libevdev_get_abs_resolution(dev->evdev, ABS_RY);
+			dev->motion.gyro_res_z = libevdev_get_abs_resolution(dev->evdev, ABS_RZ);
+			dev->motion.accel_y = dev->motion.accel_res_y; // 1G down
+			break;
 	}
 
 	dev->next = setsu->dev;
@@ -341,14 +399,18 @@ const char *setsu_device_get_path(SetsuD
 	return dev->path;
 }
 
-uint32_t setsu_device_get_width(SetsuDevice *dev)
+uint32_t setsu_device_touchpad_get_width(SetsuDevice *dev)
 {
-	return dev->max_x - dev->min_x;
+	if(dev->type != SETSU_DEVICE_TYPE_TOUCHPAD)
+		return 0;
+	return dev->touchpad.max_x - dev->touchpad.min_x;
 }
 
-uint32_t setsu_device_get_height(SetsuDevice *dev)
+uint32_t setsu_device_touchpad_get_height(SetsuDevice *dev)
 {
-	return dev->max_y - dev->min_y;
+	if(dev->type != SETSU_DEVICE_TYPE_TOUCHPAD)
+		return 0;
+	return dev->touchpad.max_y - dev->touchpad.min_y;
 }
 
 void kill_avail_device(Setsu *setsu, SetsuAvailDevice *adev)
@@ -393,6 +455,7 @@ void setsu_poll(Setsu *setsu, SetsuEvent
 			SetsuEvent event = { 0 };
 			event.type = SETSU_EVENT_DEVICE_ADDED;
 			event.path = adev->path;
+			event.dev_type = adev->type;
 			cb(&event, user);
 			adev->connect_dirty = false;
 		}
@@ -401,6 +464,7 @@ void setsu_poll(Setsu *setsu, SetsuEvent
 			SetsuEvent event = { 0 };
 			event.type = SETSU_EVENT_DEVICE_REMOVED;
 			event.path = adev->path;
+			event.dev_type = adev->type;
 			cb(&event, user);
 			// kill the device only after sending the event
 			SetsuAvailDevice *next = adev->next;
@@ -465,59 +529,106 @@ static void device_event(Setsu *setsu, S
 		libevdev_event_code_get_name(ev->type, ev->code),
 		ev->value);
 #endif
-#define S dev->slots[dev->slot_cur]
-	switch(ev->type)
+	if(ev->type == EV_SYN && ev->code == SYN_REPORT)
+	{
+		device_drain(setsu, dev, cb, user);
+		return;
+	}
+	switch(dev->type)
 	{
-		case EV_ABS:
-			switch(ev->code)
+		case SETSU_DEVICE_TYPE_TOUCHPAD:
+			switch(ev->type)
 			{
-				case ABS_MT_SLOT:
-					if((unsigned int)ev->value >= SLOTS_COUNT)
+				case EV_ABS:
+#define S dev->touchpad.slots[dev->touchpad.slot_cur]
+					switch(ev->code)
 					{
-						SETSU_LOG("slot too high\n");
-						break;
+						case ABS_MT_SLOT:
+							if((unsigned int)ev->value >= SLOTS_COUNT)
+							{
+								SETSU_LOG("slot too high\n");
+								break;
+							}
+							dev->touchpad.slot_cur = ev->value;
+							break;
+						case ABS_MT_TRACKING_ID:
+							if(S.tracking_id != -1 && S.tracking_id_prev == -1)
+							{
+								// up the tracking id
+								S.tracking_id_prev = S.tracking_id;
+								// reset the rest
+								S.x = S.y = 0;
+								S.pos_dirty = false;
+							}
+							S.tracking_id = ev->value;
+							if(ev->value != -1)
+								S.downed = true;
+							break;
+						case ABS_MT_POSITION_X:
+							S.x = ev->value;
+							S.pos_dirty = true;
+							break;
+						case ABS_MT_POSITION_Y:
+							S.y = ev->value;
+							S.pos_dirty = true;
+							break;
 					}
-					dev->slot_cur = ev->value;
 					break;
-				case ABS_MT_TRACKING_ID:
-					if(S.tracking_id != -1 && S.tracking_id_prev == -1)
+#undef S
+				case EV_KEY: {
+					uint64_t button = button_from_evdev(ev->code);
+					if(!button)
+						break;
+					if(ev->value)
+						dev->touchpad.buttons_cur |= button;
+					else
+						dev->touchpad.buttons_cur &= ~button;
+					break;
+				}
+			}
+			break;
+		case SETSU_DEVICE_TYPE_MOTION:
+			switch(ev->type)
+			{
+				case EV_ABS:
+					switch(ev->code)
 					{
-						// up the tracking id
-						S.tracking_id_prev = S.tracking_id;
-						// reset the rest
-						S.x = S.y = 0;
-						S.pos_dirty = false;
+						case ABS_X:
+							dev->motion.accel_x = ev->value;
+							dev->motion.dirty = true;
+							break;
+						case ABS_Y:
+							dev->motion.accel_y = ev->value;
+							dev->motion.dirty = true;
+							break;
+						case ABS_Z:
+							dev->motion.accel_z = ev->value;
+							dev->motion.dirty = true;
+							break;
+						case ABS_RX:
+							dev->motion.gyro_x = ev->value;
+							dev->motion.dirty = true;
+							break;
+						case ABS_RY:
+							dev->motion.gyro_y = ev->value;
+							dev->motion.dirty = true;
+							break;
+						case ABS_RZ:
+							dev->motion.gyro_z = ev->value;
+							dev->motion.dirty = true;
+							break;
 					}
-					S.tracking_id = ev->value;
-					if(ev->value != -1)
-						S.downed = true;
 					break;
-				case ABS_MT_POSITION_X:
-					S.x = ev->value;
-					S.pos_dirty = true;
-					break;
-				case ABS_MT_POSITION_Y:
-					S.y = ev->value;
-					S.pos_dirty = true;
+				case EV_MSC:
+					if(ev->code == MSC_TIMESTAMP)
+					{
+						dev->motion.timestamp = ev->value;
+						dev->motion.dirty = true;
+					}
 					break;
 			}
 			break;
-		case EV_KEY: {
-			uint64_t button = button_from_evdev(ev->code);
-			if(!button)
-				break;
-			if(ev->value)
-				dev->buttons_cur |= button;
-			else
-				dev->buttons_cur &= ~button;
-			break;
-		}
-		case EV_SYN:
-			if(ev->code == SYN_REPORT)
-				device_drain(setsu, dev, cb, user);
-			break;
 	}
-#undef S
 }
 
 static void device_drain(Setsu *setsu, SetsuDevice *dev, SetsuEventCb cb, void *user)
@@ -525,48 +636,68 @@ static void device_drain(Setsu *setsu, S
 	SetsuEvent event;
 #define BEGIN_EVENT(tp) do { memset(&event, 0, sizeof(event)); event.dev = dev; event.type = tp; } while(0)
 #define SEND_EVENT() do { cb(&event, user); } while (0)
-	for(size_t i=0; i<SLOTS_COUNT; i++)
+	switch(dev->type)
 	{
-		if(dev->slots[i].tracking_id_prev != -1)
-		{
-			BEGIN_EVENT(SETSU_EVENT_TOUCH_UP);
-			event.tracking_id = dev->slots[i].tracking_id_prev;
-			SEND_EVENT();
-			dev->slots[i].tracking_id_prev = -1;
-		}
-		if(dev->slots[i].downed)
-		{
-			BEGIN_EVENT(SETSU_EVENT_TOUCH_DOWN);
-			event.tracking_id = dev->slots[i].tracking_id;
-			SEND_EVENT();
-			dev->slots[i].downed = false;
-		}
-		if(dev->slots[i].pos_dirty)
-		{
-			BEGIN_EVENT(SETSU_EVENT_TOUCH_POSITION);
-			event.tracking_id = dev->slots[i].tracking_id;
-			event.x = (uint32_t)(dev->slots[i].x - dev->min_x);
-			event.y = (uint32_t)(dev->slots[i].y - dev->min_y);
-			SEND_EVENT();
-			dev->slots[i].pos_dirty = false;
-		}
-	}
+		case SETSU_DEVICE_TYPE_TOUCHPAD:
+			for(size_t i=0; i<SLOTS_COUNT; i++)
+			{
+				if(dev->touchpad.slots[i].tracking_id_prev != -1)
+				{
+					BEGIN_EVENT(SETSU_EVENT_TOUCH_UP);
+					event.touch.tracking_id = dev->touchpad.slots[i].tracking_id_prev;
+					SEND_EVENT();
+					dev->touchpad.slots[i].tracking_id_prev = -1;
+				}
+				if(dev->touchpad.slots[i].downed)
+				{
+					BEGIN_EVENT(SETSU_EVENT_TOUCH_DOWN);
+					event.touch.tracking_id = dev->touchpad.slots[i].tracking_id;
+					SEND_EVENT();
+					dev->touchpad.slots[i].downed = false;
+				}
+				if(dev->touchpad.slots[i].pos_dirty)
+				{
+					BEGIN_EVENT(SETSU_EVENT_TOUCH_POSITION);
+					event.touch.tracking_id = dev->touchpad.slots[i].tracking_id;
+					event.touch.x = (uint32_t)(dev->touchpad.slots[i].x - dev->touchpad.min_x);
+					event.touch.y = (uint32_t)(dev->touchpad.slots[i].y - dev->touchpad.min_y);
+					SEND_EVENT();
+					dev->touchpad.slots[i].pos_dirty = false;
+				}
+			}
 
-	uint64_t buttons_diff = dev->buttons_prev ^ dev->buttons_cur;
-	for(uint64_t i=0; i<64; i++)
-	{
-		if(buttons_diff & 1)
-		{
-			uint64_t button = 1 << i;
-			BEGIN_EVENT((dev->buttons_cur & button) ? SETSU_EVENT_BUTTON_DOWN : SETSU_EVENT_BUTTON_UP);
-			event.button = button;
-			SEND_EVENT();
-		}
-		buttons_diff >>= 1;
-		if(!buttons_diff)
+			uint64_t buttons_diff = dev->touchpad.buttons_prev ^ dev->touchpad.buttons_cur;
+			for(uint64_t i=0; i<64; i++)
+			{
+				if(buttons_diff & 1)
+				{
+					uint64_t button = 1 << i;
+					BEGIN_EVENT((dev->touchpad.buttons_cur & button) ? SETSU_EVENT_BUTTON_DOWN : SETSU_EVENT_BUTTON_UP);
+					event.button = button;
+					SEND_EVENT();
+				}
+				buttons_diff >>= 1;
+				if(!buttons_diff)
+					break;
+			}
+			dev->touchpad.buttons_prev = dev->touchpad.buttons_cur;
+			break;
+		case SETSU_DEVICE_TYPE_MOTION:
+			if(dev->motion.dirty)
+			{
+				BEGIN_EVENT(SETSU_EVENT_MOTION);
+				event.motion.accel_x = (float)dev->motion.accel_x / (float)dev->motion.accel_res_x;
+				event.motion.accel_y = (float)dev->motion.accel_y / (float)dev->motion.accel_res_y;
+				event.motion.accel_z = (float)dev->motion.accel_z / (float)dev->motion.accel_res_z;
+				event.motion.gyro_x = DEG2RAD * (float)dev->motion.gyro_x / (float)dev->motion.gyro_res_x;
+				event.motion.gyro_y = DEG2RAD * (float)dev->motion.gyro_y / (float)dev->motion.gyro_res_y;
+				event.motion.gyro_z = DEG2RAD * (float)dev->motion.gyro_z / (float)dev->motion.gyro_res_z;
+				event.motion.timestamp = dev->motion.timestamp;
+				SEND_EVENT();
+				dev->motion.dirty = false;
+			}
 			break;
 	}
-	dev->buttons_prev = dev->buttons_cur;
 #undef BEGIN_EVENT
 #undef SEND_EVENT
 }
diff -pruN 2.0.1-1/switch/CMakeLists.txt 2.1.0-1/switch/CMakeLists.txt
--- 2.0.1-1/switch/CMakeLists.txt	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/CMakeLists.txt	2021-01-15 21:35:50.000000000 +0000
@@ -126,9 +126,9 @@ install(TARGETS chiaki-borealis
 if(CHIAKI_IS_SWITCH)
 	add_nro_target(chiaki
 		chiaki-borealis
-		"chiaki"
-		"Chiaki team"
+		"Chiaki"
+		"H0neyBadger and thestr4ng3r"
 		"${CHIAKI_VERSION}"
-		"${CMAKE_SOURCE_DIR}/switch/res/icon.jpg"
-		"${CMAKE_SOURCE_DIR}/switch/res")
+		"${CMAKE_CURRENT_SOURCE_DIR}/nro_icon.jpg"
+		"${CMAKE_CURRENT_SOURCE_DIR}/res")
 endif()
diff -pruN 2.0.1-1/switch/include/discoverymanager.h 2.1.0-1/switch/include/discoverymanager.h
--- 2.0.1-1/switch/include/discoverymanager.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/include/discoverymanager.h	2021-01-15 21:35:50.000000000 +0000
@@ -24,7 +24,7 @@ class DiscoveryManager
 		struct sockaddr * host_addr = nullptr;
 		size_t host_addr_len = 0;
 		uint32_t GetIPv4BroadcastAddr();
-		bool service_enable;
+		bool service_enable = false;
 
 	public:
 		typedef enum hoststate
diff -pruN 2.0.1-1/switch/include/gui.h 2.1.0-1/switch/include/gui.h
--- 2.0.1-1/switch/include/gui.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/include/gui.h	2021-01-15 21:35:50.000000000 +0000
@@ -50,10 +50,6 @@ class MainApplication
 		IO *io;
 		brls::TabFrame *rootFrame;
 		std::map<Host *, HostInterface *> host_menuitems;
-		// add_host local settings
-		std::string remote_display_name = "";
-		std::string remote_addr = "";
-		ChiakiTarget remote_ps_version = CHIAKI_TARGET_PS5_1;
 
 		bool BuildConfigurationMenu(brls::List *, Host *host = nullptr);
 		void BuildAddHostConfigurationMenu(brls::List *);
@@ -73,12 +69,6 @@ class PSRemotePlay : public brls::View
 		// to send gamepad inputs
 		Host *host;
 		brls::Label *label;
-		ChiakiControllerState state = {0};
-		// FPS calculation
-		// double base_time;
-		// int frame_counter = 0;
-		// int fps = 0;
-
 	public:
 		PSRemotePlay(Host *host);
 		~PSRemotePlay();
diff -pruN 2.0.1-1/switch/include/host.h 2.1.0-1/switch/include/host.h
--- 2.0.1-1/switch/include/host.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/include/host.h	2021-01-15 21:35:50.000000000 +0000
@@ -54,7 +54,9 @@ class Host
 		std::function<void()> chiaki_regist_event_type_finished_success = nullptr;
 		std::function<void()> chiaki_event_connected_cb = nullptr;
 		std::function<void(bool)> chiaki_even_login_pin_request_cb = nullptr;
+		std::function<void(uint8_t, uint8_t)> chiaki_event_rumble_cb = nullptr;
 		std::function<void(ChiakiQuitEvent *)> chiaki_event_quit_cb = nullptr;
+		std::function<void(ChiakiControllerState *, std::map<uint32_t, int8_t> *)> io_read_controller_cb = nullptr;
 
 		// internal state
 		bool discovered = false;
@@ -73,6 +75,8 @@ class Host
 		std::string server_nickname;
 		ChiakiTarget target = CHIAKI_TARGET_PS4_UNKNOWN;
 		ChiakiDiscoveryHostState state = CHIAKI_DISCOVERY_HOST_STATE_UNKNOWN;
+		ChiakiControllerState controller_state = {0};
+		std::map<uint32_t, int8_t> finger_id_touch_id;
 
 		// mac address = 48 bits
 		uint8_t server_mac[6] = {0};
@@ -90,13 +94,13 @@ class Host
 	public:
 		Host(std::string host_name);
 		~Host();
-		int Register(std::string pin);
+		int Register(int pin);
 		int Wakeup();
 		int InitSession(IO *);
 		int FiniSession();
 		void StopSession();
 		void StartSession();
-		void SendFeedbackState(ChiakiControllerState *);
+		void SendFeedbackState();
 		void RegistCB(ChiakiRegistEvent *);
 		void ConnectionEventCB(ChiakiEvent *);
 		bool GetVideoResolution(int *ret_width, int *ret_height);
@@ -110,7 +114,9 @@ class Host
 		void SetRegistEventTypeFinishedSuccess(std::function<void()> chiaki_regist_event_type_finished_success);
 		void SetEventConnectedCallback(std::function<void()> chiaki_event_connected_cb);
 		void SetEventLoginPinRequestCallback(std::function<void(bool)> chiaki_even_login_pin_request_cb);
+		void SetEventRumbleCallback(std::function<void(uint8_t, uint8_t)> chiaki_event_rumble_cb);
 		void SetEventQuitCallback(std::function<void(ChiakiQuitEvent *)> chiaki_event_quit_cb);
+		void SetReadControllerCallback(std::function<void(ChiakiControllerState *, std::map<uint32_t, int8_t> *)> io_read_controller_cb);
 		bool IsRegistered();
 		bool IsDiscovered();
 		bool IsReady();
diff -pruN 2.0.1-1/switch/include/io.h 2.1.0-1/switch/include/io.h
--- 2.0.1-1/switch/include/io.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/include/io.h	2021-01-15 21:35:50.000000000 +0000
@@ -28,7 +28,15 @@ Omit khrplatform: False
 Reproducible: False
 */
 
+#ifdef __SWITCH__
+#include <switch.h>
+#else
+#include <iostream>
+#endif
+
 #include <mutex>
+#include <map>
+
 extern "C"
 {
 #include <libavcodec/avcodec.h>
@@ -65,6 +73,11 @@ class IO
 		SDL_AudioDeviceID sdl_audio_device_id = 0;
 		SDL_Event sdl_event;
 		SDL_Joystick *sdl_joystick_ptr[SDL_JOYSTICK_COUNT] = {0};
+#ifdef __SWITCH__
+		PadState pad;
+		HidSixAxisSensorHandle sixaxis_handles[4];
+		HidVibrationDeviceHandle vibration_handles[2][2];
+#endif
 		GLuint vao;
 		GLuint vbo;
 		GLuint tex[PLANES_COUNT];
@@ -85,8 +98,8 @@ class IO
 		GLuint CreateAndCompileShader(GLenum type, const char *source);
 		void SetOpenGlYUVPixels(AVFrame *frame);
 		bool ReadGameKeys(SDL_Event *event, ChiakiControllerState *state);
-		bool ReadGameTouchScreen(ChiakiControllerState *state);
-
+		bool ReadGameTouchScreen(ChiakiControllerState *state, std::map<uint32_t, int8_t> *finger_id_touch_id);
+		bool ReadGameSixAxis(ChiakiControllerState *state);
 	public:
 		// singleton configuration
 		IO(const IO&) = delete;
@@ -100,10 +113,11 @@ class IO
 		void AudioCB(int16_t *buf, size_t samples_count);
 		bool InitVideo(int video_width, int video_height, int screen_width, int screen_height);
 		bool FreeVideo();
-		bool InitJoystick();
-		bool FreeJoystick();
-		bool ReadUserKeyboard(char *buffer, size_t buffer_size);
-		bool MainLoop(ChiakiControllerState *state);
+		bool InitController();
+		bool FreeController();
+		bool MainLoop();
+		void UpdateControllerState(ChiakiControllerState *state, std::map<uint32_t, int8_t> *finger_id_touch_id);
+		void SetRumble(uint8_t left, uint8_t right);
 };
 
 #endif //CHIAKI_IO_H
diff -pruN 2.0.1-1/switch/include/settings.h 2.1.0-1/switch/include/settings.h
--- 2.0.1-1/switch/include/settings.h	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/include/settings.h	2021-01-15 21:35:50.000000000 +0000
@@ -50,7 +50,7 @@ class Settings
 		const std::map<Settings::ConfigurationItem, std::regex> re_map = {
 			{HOST_NAME, std::regex("^\\[\\s*(.+)\\s*\\]")},
 			{HOST_ADDR, std::regex("^\\s*host_(?:ip|addr)\\s*=\\s*\"?((\\d+\\.\\d+\\.\\d+\\.\\d+)|([A-Za-z0-9-]{1,255}))\"?")},
-			{PSN_ONLINE_ID, std::regex("^\\s*psn_online_id\\s*=\\s*\"?(\\w+)\"?")},
+			{PSN_ONLINE_ID, std::regex("^\\s*psn_online_id\\s*=\\s*\"?([\\w_-]+)\"?")},
 			{PSN_ACCOUNT_ID, std::regex("^\\s*psn_account_id\\s*=\\s*\"?([\\w/=+]+)\"?")},
 			{RP_KEY, std::regex("^\\s*rp_key\\s*=\\s*\"?([\\w/=+]+)\"?")},
 			{RP_KEY_TYPE, std::regex("^\\s*rp_key_type\\s*=\\s*\"?(\\d)\"?")},
Binary files 2.0.1-1/switch/nro_icon.jpg and 2.1.0-1/switch/nro_icon.jpg differ
Binary files 2.0.1-1/switch/nro_icon.png and 2.1.0-1/switch/nro_icon.png differ
diff -pruN 2.0.1-1/switch/README.md 2.1.0-1/switch/README.md
--- 2.0.1-1/switch/README.md	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/README.md	2021-01-15 21:35:50.000000000 +0000
@@ -4,22 +4,6 @@ this project requires the devkitpro tool
 you can use your personal computer to install devkitpro
 but the easiest way is to use the following container.
 
-Build container image
----------------------
-```
-bash scripts/switch/build-docker-image.sh
-```
-
-Run container
--------------
-from the project's [root folder](../)
-```
-docker run -it --rm \
-	-v "$(pwd):/build" \
-	-p 28771:28771 \
-	chiaki-switch
-```
-
 Build Project
 -------------
 ```
@@ -31,7 +15,7 @@ tools
 Push to homebrew Netloader
 ```
 # where X.X.X.X is the IP of your switch
-scripts/switch/push-docker-build-chiaki.sh 192.168.0.200
+bash scripts/switch/push-docker-build-chiaki.sh -a 192.168.0.200
 ```
 
 Troubleshoot
@@ -52,7 +36,7 @@ this file contains sensitive data. (do n
 [PS*-***]
 # required: lan PlayStation IP address
 # IP from Settings > System > system information
-host_ip = *.*.*.*
+host_addr = *.*.*.*
 # required: sony oline id (login)
 psn_online_id = ps_online_id
 # required (PS4>7.0 Only): https://git.sr.ht/~thestr4ng3r/chiaki/tree/master/item/README.md#obtaining-your-psn-accountid
Binary files 2.0.1-1/switch/res/icon.jpg and 2.1.0-1/switch/res/icon.jpg differ
Binary files 2.0.1-1/switch/res/icon.png and 2.1.0-1/switch/res/icon.png differ
diff -pruN 2.0.1-1/switch/src/discoverymanager.cpp 2.1.0-1/switch/src/discoverymanager.cpp
--- 2.0.1-1/switch/src/discoverymanager.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/discoverymanager.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -16,9 +16,9 @@
 #define HOSTS_MAX 16
 #define DROP_PINGS 3
 
-static void Discovery(ChiakiDiscoveryHost * discovered_hosts, size_t hosts_count, void * user)
+static void Discovery(ChiakiDiscoveryHost *discovered_hosts, size_t hosts_count, void *user)
 {
-	DiscoveryManager * dm = (DiscoveryManager *)user;
+	DiscoveryManager *dm = (DiscoveryManager *)user;
 	for(size_t i = 0; i < hosts_count; i++)
 	{
 		dm->DiscoveryCB(discovered_hosts + i);
@@ -35,19 +35,13 @@ DiscoveryManager::~DiscoveryManager()
 {
 	// join discovery thread
 	if(this->service_enable)
-	{
 		SetService(false);
-	}
-
-	chiaki_discovery_fini(&this->discovery);
 }
 
 void DiscoveryManager::SetService(bool enable)
 {
 	if(this->service_enable == enable)
-	{
 		return;
-	}
 
 	this->service_enable = enable;
 
@@ -105,7 +99,7 @@ uint32_t DiscoveryManager::GetIPv4Broadc
 #endif
 }
 
-int DiscoveryManager::Send(struct sockaddr * host_addr, size_t host_addr_len)
+int DiscoveryManager::Send(struct sockaddr *host_addr, size_t host_addr_len)
 {
 	if(!host_addr)
 	{
@@ -120,9 +114,9 @@ int DiscoveryManager::Send(struct sockad
 	return 0;
 }
 
-int DiscoveryManager::Send(const char * discover_ip_dest)
+int DiscoveryManager::Send(const char *discover_ip_dest)
 {
-	struct addrinfo * host_addrinfos;
+	struct addrinfo *host_addrinfos;
 	int r = getaddrinfo(discover_ip_dest, NULL, NULL, &host_addrinfos);
 	if(r != 0)
 	{
@@ -130,10 +124,10 @@ int DiscoveryManager::Send(const char *
 		return 1;
 	}
 
-	struct sockaddr * host_addr = nullptr;
+	struct sockaddr *host_addr = nullptr;
 	socklen_t host_addr_len = 0;
 
-	for(struct addrinfo * ai = host_addrinfos; ai; ai = ai->ai_next)
+	for(struct addrinfo *ai = host_addrinfos; ai; ai = ai->ai_next)
 	{
 		if(ai->ai_protocol != IPPROTO_UDP)
 			continue;
@@ -170,13 +164,13 @@ int DiscoveryManager::Send()
 	return DiscoveryManager::Send(this->host_addr, this->host_addr_len);
 }
 
-void DiscoveryManager::DiscoveryCB(ChiakiDiscoveryHost * discovered_host)
+void DiscoveryManager::DiscoveryCB(ChiakiDiscoveryHost *discovered_host)
 {
 	// the user ptr is passed as
 	// chiaki_discovery_thread_start arg
 
 	std::string key = discovered_host->host_name;
-	Host * host = this->settings->GetOrCreateHost(&key);
+	Host *host = this->settings->GetOrCreateHost(&key);
 
 	CHIAKI_LOGI(this->log, "--");
 	CHIAKI_LOGI(this->log, "Discovered Host:");
diff -pruN 2.0.1-1/switch/src/gui.cpp 2.1.0-1/switch/src/gui.cpp
--- 2.0.1-1/switch/src/gui.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/gui.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -42,6 +42,9 @@ HostInterface::HostInterface(Host *host)
 	// when the host is connected
 	this->host->SetEventConnectedCallback(std::bind(&HostInterface::Stream, this));
 	this->host->SetEventQuitCallback(std::bind(&HostInterface::CloseStream, this, std::placeholders::_1));
+	// allow host to update controller state
+	this->host->SetEventRumbleCallback(std::bind(&IO::SetRumble, this->io, std::placeholders::_1, std::placeholders::_2));
+	this->host->SetReadControllerCallback(std::bind(&IO::UpdateControllerState, this->io, std::placeholders::_1, std::placeholders::_2));
 }
 
 HostInterface::~HostInterface()
@@ -97,42 +100,31 @@ void HostInterface::Register(Host *host,
 	host->SetRegistEventTypeFinishedFailed(event_type_finished_failed_cb);
 
 	// the host is not registered yet
-	brls::Dialog *peprpc = new brls::Dialog("Please enter your PlayStation registration PIN code");
-	brls::GenericEvent::Callback cb_peprpc = [host, io, peprpc](brls::View *view) {
-		bool pin_provided = false;
-		char pin_input[9] = {0};
-		std::string error_message;
-
-		// use callback to ensure that the message is showed on screen
-		// before the the ReadUserKeyboard
-		peprpc->close();
-
-		pin_provided = io->ReadUserKeyboard(pin_input, sizeof(pin_input));
-		if(pin_provided)
-		{
-			// prevent users form messing with the gui
-			brls::Application::blockInputs();
-			int ret = host->Register(pin_input);
-			if(ret != HOST_REGISTER_OK)
+	// use callback to ensure that the message is showed on screen
+	// before the Swkbd
+	auto pin_input_cb = [host](int pin) {
+		// prevent users form messing with the gui
+		brls::Application::blockInputs();
+		int ret = host->Register(pin);
+		if(ret != HOST_REGISTER_OK)
+		{
+			switch(ret)
 			{
-				switch(ret)
-				{
-					// account not configured
-					case HOST_REGISTER_ERROR_SETTING_PSNACCOUNTID:
-						brls::Application::notify("No PSN Account ID provided");
-						brls::Application::unblockInputs();
-						break;
-					case HOST_REGISTER_ERROR_SETTING_PSNONLINEID:
-						brls::Application::notify("No PSN Online ID provided");
-						brls::Application::unblockInputs();
-						break;
-				}
+				// account not configured
+				case HOST_REGISTER_ERROR_SETTING_PSNACCOUNTID:
+					brls::Application::notify("No PSN Account ID provided");
+					brls::Application::unblockInputs();
+					break;
+				case HOST_REGISTER_ERROR_SETTING_PSNONLINEID:
+					brls::Application::notify("No PSN Online ID provided");
+					brls::Application::unblockInputs();
+					break;
 			}
 		}
 	};
-	peprpc->addButton("Ok", cb_peprpc);
-	peprpc->setCancelable(false);
-	peprpc->open();
+	// the pin is 8 digit
+	bool success = brls::Swkbd::openForNumber(pin_input_cb,
+		"Please enter your PlayStation registration PIN code", "8 digits without spaces", 8, "", "", "");
 }
 
 void HostInterface::Register()
@@ -256,7 +248,7 @@ MainApplication::MainApplication(Discove
 MainApplication::~MainApplication()
 {
 	this->discoverymanager->SetService(false);
-	//this->io->FreeJoystick();
+	this->io->FreeController();
 	this->io->FreeVideo();
 }
 
@@ -275,22 +267,21 @@ bool MainApplication::Load()
 
 	// init chiaki gl after borealis
 	// let borealis manage the main screen/window
-
 	if(!io->InitVideo(0, 0, SCREEN_W, SCREEN_H))
 	{
 		brls::Logger::error("Failed to initiate Video");
 	}
 
-	brls::Logger::info("Load sdl joysticks");
-	if(!io->InitJoystick())
+	brls::Logger::info("Load sdl/hid controller");
+	if(!io->InitController())
 	{
-		brls::Logger::error("Faled to initiate Joysticks");
+		brls::Logger::error("Faled to initiate Controller");
 	}
 
 	// Create a view
 	this->rootFrame = new brls::TabFrame();
 	this->rootFrame->setTitle("Chiaki: Open Source PlayStation Remote Play Client");
-	this->rootFrame->setIcon(BOREALIS_ASSET("icon.jpg"));
+	this->rootFrame->setIcon(BOREALIS_ASSET("icon.png"));
 
 	brls::List *config = new brls::List();
 	brls::List *add_host = new brls::List();
@@ -327,39 +318,36 @@ bool MainApplication::Load()
 bool MainApplication::BuildConfigurationMenu(brls::List *ls, Host *host)
 {
 	std::string psn_account_id_string = this->settings->GetPSNAccountID(host);
-	brls::ListItem *psn_account_id = new brls::ListItem("PSN Account ID", "PS5 or PS4 v7.0 and greater (base64 account_id)");
-	psn_account_id->setValue(psn_account_id_string.c_str());
+	brls::InputListItem *psn_account_id = new brls::InputListItem("PSN Account ID", psn_account_id_string,
+		"Account ID in base64 format", "PS5 or PS4 v7.0 and greater", CHIAKI_PSN_ACCOUNT_ID_SIZE * 2,
+		brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_SPACE |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_AT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_PERCENT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_BACKSLASH);
+
 	auto psn_account_id_cb = [this, host, psn_account_id](brls::View *view) {
-		char account_id[CHIAKI_PSN_ACCOUNT_ID_SIZE * 2] = {0};
-		bool input = this->io->ReadUserKeyboard(account_id, sizeof(account_id));
-		if(input)
-		{
-			// update gui
-			psn_account_id->setValue(account_id);
-			// push in setting
-			this->settings->SetPSNAccountID(host, account_id);
-			// write on disk
-			this->settings->WriteFile();
-		}
+		// retrieve, push and save setting
+		this->settings->SetPSNAccountID(host, psn_account_id->getValue());
+		// write on disk
+		this->settings->WriteFile();
 	};
 	psn_account_id->getClickEvent()->subscribe(psn_account_id_cb);
 	ls->addView(psn_account_id);
 
 	std::string psn_online_id_string = this->settings->GetPSNOnlineID(host);
-	brls::ListItem *psn_online_id = new brls::ListItem("PSN Online ID");
-	psn_online_id->setValue(psn_online_id_string.c_str());
+	brls::InputListItem *psn_online_id = new brls::InputListItem("PSN Online ID",
+		psn_online_id_string, "", "", 16,
+		brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_SPACE |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_AT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_PERCENT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_FORWSLASH |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_BACKSLASH);
+
 	auto psn_online_id_cb = [this, host, psn_online_id](brls::View *view) {
-		char online_id[256] = {0};
-		bool input = this->io->ReadUserKeyboard(online_id, sizeof(online_id));
-		if(input)
-		{
-			// update gui
-			psn_online_id->setValue(online_id);
-			// push in setting
-			this->settings->SetPSNOnlineID(host, online_id);
-			// write on disk
-			this->settings->WriteFile();
-		}
+		// retrieve, push and save setting
+		this->settings->SetPSNOnlineID(host, psn_online_id->getValue());
+		// write on disk
+		this->settings->WriteFile();
 	};
 	psn_online_id->getClickEvent()->subscribe(psn_online_id_cb);
 	ls->addView(psn_online_id);
@@ -380,7 +368,7 @@ bool MainApplication::BuildConfiguration
 	}
 
 	brls::SelectListItem *resolution = new brls::SelectListItem(
-		"Resolution", {"720p", "540p", "360p"}, value);
+		"Resolution", { "720p", "540p", "360p" }, value);
 
 	auto resolution_cb = [this, host](int result) {
 		ChiakiVideoResolutionPreset value = CHIAKI_VIDEO_RESOLUTION_PRESET_720p;
@@ -414,7 +402,7 @@ bool MainApplication::BuildConfiguration
 	}
 
 	brls::SelectListItem *fps = new brls::SelectListItem(
-		"FPS", {"60", "30"}, value);
+		"FPS", { "60", "30" }, value);
 
 	auto fps_cb = [this, host](int result) {
 		ChiakiVideoFPSPreset value = CHIAKI_VIDEO_FPS_PRESET_60;
@@ -465,34 +453,24 @@ void MainApplication::BuildAddHostConfig
 	// brls::Label* add_host_label = new brls::Label(brls::LabelStyle::REGULAR,
 	// 	"Add Host configuration", true);
 
-	brls::ListItem *display_name = new brls::ListItem("Display name");
-	auto display_name_cb = [this, display_name](brls::View *view) {
-		char name[16] = {0};
-		bool input = this->io->ReadUserKeyboard(name, sizeof(name));
-		if(input)
-		{
-			// update gui
-			display_name->setValue(name);
-			// set internal value
-			this->remote_display_name = name;
-		}
-	};
-	display_name->getClickEvent()->subscribe(display_name_cb);
+	brls::InputListItem *display_name = new brls::InputListItem("Display name",
+		"default", "configuration name", "", 16,
+		brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_SPACE |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_AT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_PERCENT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_FORWSLASH |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_BACKSLASH);
+
 	add_host->addView(display_name);
 
-	brls::ListItem *address = new brls::ListItem("Remote IP/name");
-	auto address_cb = [this, address](brls::View *view) {
-		char addr[256] = {0};
-		bool input = this->io->ReadUserKeyboard(addr, sizeof(addr));
-		if(input)
-		{
-			// update gui
-			address->setValue(addr);
-			// set internal value
-			this->remote_addr = addr;
-		}
-	};
-	address->getClickEvent()->subscribe(address_cb);
+	brls::InputListItem *address = new brls::InputListItem("Remote IP/name",
+		"", "IP address or fqdn", "", 255,
+		brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_SPACE |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_AT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_PERCENT |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_FORWSLASH |
+			brls::KeyboardKeyDisableBitmask::KEYBOARD_DISABLE_BACKSLASH);
+
 	add_host->addView(address);
 
 	// TODO
@@ -500,47 +478,49 @@ void MainApplication::BuildAddHostConfig
 	// brls::ListItem* port = new brls::ListItem("Remote stream port",  "udp 9296");
 	// brls::ListItem* port = new brls::ListItem("Remote Senkusha port",  "udp 9297");
 	brls::SelectListItem *ps_version = new brls::SelectListItem("PlayStation Version",
-		{"PS5", "PS4 > 8", "7 < PS4 < 8", "PS4 < 7"});
-	auto ps_version_cb = [this, ps_version](int result) {
-		switch(result)
+		{ "PS5", "PS4 > 8", "7 < PS4 < 8", "PS4 < 7" });
+	add_host->addView(ps_version);
+
+	brls::ListItem *register_host = new brls::ListItem("Register");
+	auto register_host_cb = [this, display_name, address, ps_version](brls::View *view) {
+		bool err = false;
+		std::string dn = display_name->getValue();
+		std::string addr = address->getValue();
+		ChiakiTarget version = CHIAKI_TARGET_PS4_UNKNOWN;
+
+		switch(ps_version->getSelectedValue())
 		{
 			case 0:
 				// ps5 v1
-				this->remote_ps_version = CHIAKI_TARGET_PS5_1;
+				version = CHIAKI_TARGET_PS5_1;
 				break;
 			case 1:
 				// ps4 v8
-				this->remote_ps_version = CHIAKI_TARGET_PS4_10;
+				version = CHIAKI_TARGET_PS4_10;
 				break;
 			case 2:
 				// ps4 v7
-				this->remote_ps_version = CHIAKI_TARGET_PS4_9;
+				version = CHIAKI_TARGET_PS4_9;
 				break;
 			case 3:
 				// ps4 v6
-				this->remote_ps_version = CHIAKI_TARGET_PS4_8;
+				version = CHIAKI_TARGET_PS4_8;
 				break;
 		}
-	};
-	ps_version->getValueSelectedEvent()->subscribe(ps_version_cb);
-	add_host->addView(ps_version);
 
-	brls::ListItem *register_host = new brls::ListItem("Register");
-	auto register_host_cb = [this](brls::View *view) {
-		bool err = false;
-		if(this->remote_display_name.length() <= 0)
+		if(dn.length() <= 0)
 		{
 			brls::Application::notify("No Display name defined");
 			err = true;
 		}
 
-		if(this->remote_addr.length() <= 0)
+		if(addr.length() <= 0)
 		{
 			brls::Application::notify("No Remote address provided");
 			err = true;
 		}
 
-		if(this->remote_ps_version < 0)
+		if(version <= CHIAKI_TARGET_PS4_UNKNOWN)
 		{
 			brls::Application::notify("No PlayStation Version provided");
 			err = true;
@@ -549,10 +529,9 @@ void MainApplication::BuildAddHostConfig
 		if(err)
 			return;
 
-		Host *host = this->settings->GetOrCreateHost(&this->remote_display_name);
-		host->SetHostAddr(this->remote_addr);
-		host->SetChiakiTarget(this->remote_ps_version);
-
+		Host *host = this->settings->GetOrCreateHost(&dn);
+		host->SetHostAddr(addr);
+		host->SetChiakiTarget(version);
 		HostInterface::Register(host);
 	};
 	register_host->getClickEvent()->subscribe(register_host_cb);
@@ -564,38 +543,12 @@ PSRemotePlay::PSRemotePlay(Host *host)
 	: host(host)
 {
 	this->io = IO::GetInstance();
-
-	// store joycon/touchpad keys
-	for(int x = 0; x < CHIAKI_CONTROLLER_TOUCHES_MAX; x++)
-		// start touchpad as "untouched"
-		this->state.touches[x].id = -1;
-
-	// this->base_time=glfwGetTime();
 }
 
 void PSRemotePlay::draw(NVGcontext *vg, int x, int y, unsigned width, unsigned height, brls::Style *style, brls::FrameContext *ctx)
 {
-	this->io->MainLoop(&this->state);
-	this->host->SendFeedbackState(&this->state);
-
-	// FPS calculation
-	// this->frame_counter += 1;
-	// double frame_time = glfwGetTime();
-	// if((frame_time - base_time) >= 1.0)
-	// {
-	// 	base_time += 1;
-	// 	//printf("FPS: %d\n", this->frame_counter);
-	// 	this->fps = this->frame_counter;
-	// 	this->frame_counter = 0;
-	// }
-	// nvgBeginPath(vg);
-	// nvgFillColor(vg, nvgRGBA(255,192,0,255));
-	// nvgFontFaceId(vg, ctx->fontStash->regular);
-	// nvgFontSize(vg, style->Label.smallFontSize);
-	// nvgTextAlign(vg, NVG_ALIGN_LEFT | NVG_ALIGN_MIDDLE);
-	// char fps_str[9] = {0};
-	// sprintf(fps_str, "FPS: %000d", this->fps);
-	// nvgText(vg, 5,10, fps_str, NULL);
+	this->io->MainLoop();
+	this->host->SendFeedbackState();
 }
 
 PSRemotePlay::~PSRemotePlay()
diff -pruN 2.0.1-1/switch/src/host.cpp 2.1.0-1/switch/src/host.cpp
--- 2.0.1-1/switch/src/host.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/host.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -72,7 +72,7 @@ int Host::Wakeup()
 	return ret;
 }
 
-int Host::Register(std::string pin)
+int Host::Register(int pin)
 {
 	// use pin and accont_id to negociate secrets for session
 	//
@@ -103,7 +103,7 @@ int Host::Register(std::string pin)
 		if(online_id.length() > 0)
 		{
 			regist_info.psn_online_id = this->psn_online_id.c_str();
-			// regist_info.psn_account_id = {0};
+			// regist_info.psn_account_id = '\0';
 		}
 		else
 		{
@@ -117,16 +117,15 @@ int Host::Register(std::string pin)
 		throw Exception("Undefined PS4 system version (please run discover first)");
 	}
 
-	this->regist_info.pin = atoi(pin.c_str());
 	this->regist_info.host = this->host_addr.c_str();
 	this->regist_info.broadcast = false;
 
 	if(this->target >= CHIAKI_TARGET_PS4_9)
-		CHIAKI_LOGI(this->log, "Registering to host `%s` `%s` with PSN AccountID `%s` pin `%s`",
-			this->host_name.c_str(), this->host_addr.c_str(), account_id.c_str(), pin.c_str());
+		CHIAKI_LOGI(this->log, "Registering to host `%s` `%s` with PSN AccountID `%s` pin `%d`",
+			this->host_name.c_str(), this->host_addr.c_str(), account_id.c_str(), pin);
 	else
-		CHIAKI_LOGI(this->log, "Registering to host `%s` `%s` with PSN OnlineID `%s` pin `%s`",
-			this->host_name.c_str(), this->host_addr.c_str(), online_id.c_str(), pin.c_str());
+		CHIAKI_LOGI(this->log, "Registering to host `%s` `%s` with PSN OnlineID `%s` pin `%d`",
+			this->host_name.c_str(), this->host_addr.c_str(), online_id.c_str(), pin);
 
 	chiaki_regist_start(&this->regist, this->log, &this->regist_info, RegistEventCB, this);
 	return HOST_REGISTER_OK;
@@ -157,9 +156,13 @@ int Host::InitSession(IO *user)
 	// audio setting_cb and frame_cb
 	chiaki_opus_decoder_set_cb(&this->opus_decoder, InitAudioCB, AudioCB, user);
 	chiaki_opus_decoder_get_sink(&this->opus_decoder, &audio_sink);
-	chiaki_session_set_audio_sink(&(this->session), &audio_sink);
-	chiaki_session_set_video_sample_cb(&(this->session), VideoCB, user);
-	chiaki_session_set_event_cb(&(this->session), EventCB, this);
+	chiaki_session_set_audio_sink(&this->session, &audio_sink);
+	chiaki_session_set_video_sample_cb(&this->session, VideoCB, user);
+	chiaki_session_set_event_cb(&this->session, EventCB, this);
+
+	// init controller states
+	chiaki_controller_state_set_idle(&this->controller_state);
+
 	return 0;
 }
 
@@ -190,10 +193,13 @@ void Host::StartSession()
 	}
 }
 
-void Host::SendFeedbackState(ChiakiControllerState *state)
+void Host::SendFeedbackState()
 {
 	// send controller/joystick key
-	chiaki_session_set_controller_state(&this->session, state);
+	if(this->io_read_controller_cb != nullptr)
+		this->io_read_controller_cb(&this->controller_state, &finger_id_touch_id);
+
+	chiaki_session_set_controller_state(&this->session, &this->controller_state);
 }
 
 void Host::ConnectionEventCB(ChiakiEvent *event)
@@ -210,6 +216,11 @@ void Host::ConnectionEventCB(ChiakiEvent
 			if(this->chiaki_even_login_pin_request_cb != nullptr)
 				this->chiaki_even_login_pin_request_cb(event->login_pin_request.pin_incorrect);
 			break;
+		case CHIAKI_EVENT_RUMBLE:
+			CHIAKI_LOGD(this->log, "EventCB CHIAKI_EVENT_RUMBLE");
+			if(this->chiaki_event_rumble_cb != nullptr)
+				this->chiaki_event_rumble_cb(event->rumble.left, event->rumble.right);
+			break;
 		case CHIAKI_EVENT_QUIT:
 			CHIAKI_LOGI(this->log, "EventCB CHIAKI_EVENT_QUIT");
 			if(this->chiaki_event_quit_cb != nullptr)
@@ -353,6 +364,16 @@ void Host::SetEventQuitCallback(std::fun
 	this->chiaki_event_quit_cb = chiaki_event_quit_cb;
 }
 
+void Host::SetEventRumbleCallback(std::function<void(uint8_t, uint8_t)> chiaki_event_rumble_cb)
+{
+	this->chiaki_event_rumble_cb = chiaki_event_rumble_cb;
+}
+
+void Host::SetReadControllerCallback(std::function<void(ChiakiControllerState *, std::map<uint32_t, int8_t> *)> io_read_controller_cb)
+{
+	this->io_read_controller_cb = io_read_controller_cb;
+}
+
 bool Host::IsRegistered()
 {
 	return this->registered;
diff -pruN 2.0.1-1/switch/src/io.cpp 2.1.0-1/switch/src/io.cpp
--- 2.0.1-1/switch/src/io.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/io.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -1,11 +1,5 @@
 // SPDX-License-Identifier: LicenseRef-AGPL-3.0-only-OpenSSL
 
-#ifdef __SWITCH__
-#include <switch.h>
-#else
-#include <iostream>
-#endif
-
 #include "io.h"
 #include "settings.h"
 
@@ -291,6 +285,16 @@ void IO::AudioCB(int16_t *buf, size_t sa
 		else
 			buf[x] = (int16_t)sample;
 	}
+
+	int audio_queued_size = SDL_GetQueuedAudioSize(this->sdl_audio_device_id);
+	if(audio_queued_size > 16000)
+	{
+		// clear audio queue to avoid big audio delay
+		// average values are close to 13000 bytes
+		CHIAKI_LOGW(this->log, "Triggering SDL_ClearQueuedAudio with queue size = %d", audio_queued_size);
+		SDL_ClearQueuedAudio(this->sdl_audio_device_id);
+	}
+
 	int success = SDL_QueueAudio(this->sdl_audio_device_id, buf, sizeof(int16_t) * samples_count * 2);
 	if(success != 0)
 		CHIAKI_LOGE(this->log, "SDL_QueueAudio failed: %s\n", SDL_GetError());
@@ -335,94 +339,187 @@ bool IO::FreeVideo()
 	return ret;
 }
 
-bool IO::ReadUserKeyboard(char *buffer, size_t buffer_size)
+bool IO::ReadGameTouchScreen(ChiakiControllerState *chiaki_state, std::map<uint32_t, int8_t> *finger_id_touch_id)
 {
-#ifndef __SWITCH__
-	// use cin to get user input from linux
-	std::cin.getline(buffer, buffer_size);
-	CHIAKI_LOGI(this->log, "Got user input: %s\n", buffer);
-#else
-	// https://kvadevack.se/post/nintendo-switch-virtual-keyboard/
-	SwkbdConfig kbd;
-	Result rc = swkbdCreate(&kbd, 0);
+#ifdef __SWITCH__
+	HidTouchScreenState sw_state = {0};
 
-	if(R_SUCCEEDED(rc))
-	{
-		swkbdConfigMakePresetDefault(&kbd);
-		rc = swkbdShow(&kbd, buffer, buffer_size);
+	bool ret = false;
+	hidGetTouchScreenStates(&sw_state, 1);
+	// scale switch screen to the PS trackpad
+	chiaki_state->buttons &= ~CHIAKI_CONTROLLER_BUTTON_TOUCHPAD; // touchscreen release
 
-		if(R_SUCCEEDED(rc))
-		{
-			CHIAKI_LOGI(this->log, "Got user input: %s\n", buffer);
-		}
-		else
+	// un-touch all old touches
+	for(auto it = finger_id_touch_id->begin(); it != finger_id_touch_id->end();)
+	{
+		auto cur = it;
+		it++;
+		for(int i = 0; i < sw_state.count; i++)
 		{
-			CHIAKI_LOGE(this->log, "swkbdShow() error: %u\n", rc);
-			return false;
+			if(sw_state.touches[i].finger_id == cur->first)
+				goto cont;
 		}
-		swkbdClose(&kbd);
+		if(cur->second >= 0)
+			chiaki_controller_state_stop_touch(chiaki_state, (uint8_t)cur->second);
+		finger_id_touch_id->erase(cur);
+cont:
+		continue;
 	}
-	else
+
+
+	// touch or update all current touches
+	for(int i = 0; i < sw_state.count; i++)
 	{
-		CHIAKI_LOGE(this->log, "swkbdCreate() error: %u\n", rc);
-		return false;
+		uint16_t x = sw_state.touches[i].x * ((float)DS4_TRACKPAD_MAX_X / (float)SWITCH_TOUCHSCREEN_MAX_X);
+		uint16_t y = sw_state.touches[i].y * ((float)DS4_TRACKPAD_MAX_Y / (float)SWITCH_TOUCHSCREEN_MAX_Y);
+		// use nintendo switch border's 5% to trigger the touchpad button
+		if(x <= (DS4_TRACKPAD_MAX_X * 0.05) || x >= (DS4_TRACKPAD_MAX_X * 0.95) || y <= (DS4_TRACKPAD_MAX_Y * 0.05) || y >= (DS4_TRACKPAD_MAX_Y * 0.95))
+			chiaki_state->buttons |= CHIAKI_CONTROLLER_BUTTON_TOUCHPAD; // touchscreen
+
+		auto it = finger_id_touch_id->find(sw_state.touches[i].finger_id);
+		if(it == finger_id_touch_id->end())
+		{
+			// new touch
+			(*finger_id_touch_id)[sw_state.touches[i].finger_id] =
+				chiaki_controller_state_start_touch(chiaki_state, x, y);
+		}
+		else if(it->second >= 0)
+			chiaki_controller_state_set_touch_pos(chiaki_state, (uint8_t)it->second, x, y);
+		// it->second < 0 ==> touch ignored because there were already too many multi-touches
+		ret = true;
 	}
+	return ret;
+#else
+	return false;
 #endif
-	return true;
 }
 
-bool IO::ReadGameTouchScreen(ChiakiControllerState *state)
+void IO::SetRumble(uint8_t left, uint8_t right)
 {
 #ifdef __SWITCH__
-	hidScanInput();
-	int touch_count = hidTouchCount();
-	bool ret = false;
-	if(!touch_count)
+	Result rc = 0;
+	HidVibrationValue vibration_values[] = {
+		{
+			.amp_low = 0.0f,
+			.freq_low = 160.0f,
+			.amp_high = 0.0f,
+			.freq_high = 320.0f,
+		},
+		{
+			.amp_low = 0.0f,
+			.freq_low = 160.0f,
+			.amp_high = 0.0f,
+			.freq_high = 320.0f,
+		}};
+
+	int target_device = padIsHandheld(&pad) ? 0 : 1;
+	if(left > 0)
+	{
+		// SDL_HapticRumblePlay(this->sdl_haptic_ptr[0], left / 100, 5000);
+		vibration_values[0].amp_low = (float)left / (float)100;
+		vibration_values[0].amp_high = (float)left / (float)100;
+		vibration_values[0].freq_low *= (float)left / (float)100;
+		vibration_values[0].freq_high *= (float)left / (float)100;
+	}
+
+	if(right > 0)
+	{
+		// SDL_HapticRumblePlay(this->sdl_haptic_ptr[1], right / 100, 5000);
+		vibration_values[1].amp_low = (float)right / (float)100;
+		vibration_values[1].amp_high = (float)right / (float)100;
+		vibration_values[1].freq_low *= (float)left / (float)100;
+		vibration_values[1].freq_high *= (float)left / (float)100;
+	}
+
+	// printf("left ptr %p amp_low %f amp_high %f freq_low %f freq_high %f\n",
+	// 	&vibration_values[0],
+	// 	vibration_values[0].amp_low,
+	// 	vibration_values[0].amp_high,
+	// 	vibration_values[0].freq_low,
+	// 	vibration_values[0].freq_high);
+
+	// printf("right ptr %p amp_low %f amp_high %f freq_low %f freq_high %f\n",
+	// 	&vibration_values[1],
+	// 	vibration_values[1].amp_low,
+	// 	vibration_values[1].amp_high,
+	// 	vibration_values[1].freq_low,
+	// 	vibration_values[1].freq_high);
+
+	rc = hidSendVibrationValues(this->vibration_handles[target_device], vibration_values, 2);
+	if(R_FAILED(rc))
+		CHIAKI_LOGE(this->log, "hidSendVibrationValues() returned: 0x%x", rc);
+
+#endif
+}
+
+bool IO::ReadGameSixAxis(ChiakiControllerState *state)
+{
+#ifdef __SWITCH__
+	// Read from the correct sixaxis handle depending on the current input style
+	HidSixAxisSensorState sixaxis = {0};
+	uint64_t style_set = padGetStyleSet(&pad);
+	if(style_set & HidNpadStyleTag_NpadHandheld)
+		hidGetSixAxisSensorStates(this->sixaxis_handles[0], &sixaxis, 1);
+	else if(style_set & HidNpadStyleTag_NpadFullKey)
+		hidGetSixAxisSensorStates(this->sixaxis_handles[1], &sixaxis, 1);
+	else if(style_set & HidNpadStyleTag_NpadJoyDual)
+	{
+		// For JoyDual, read from either the Left or Right Joy-Con depending on which is/are connected
+		u64 attrib = padGetAttributes(&pad);
+		if(attrib & HidNpadAttribute_IsLeftConnected)
+			hidGetSixAxisSensorStates(this->sixaxis_handles[2], &sixaxis, 1);
+		else if(attrib & HidNpadAttribute_IsRightConnected)
+			hidGetSixAxisSensorStates(this->sixaxis_handles[3], &sixaxis, 1);
+	}
+
+	state->gyro_x = sixaxis.angular_velocity.x * 2.0f * M_PI;
+	state->gyro_y = sixaxis.angular_velocity.z * 2.0f * M_PI;
+	state->gyro_z = -sixaxis.angular_velocity.y * 2.0f * M_PI;
+	state->accel_x = -sixaxis.acceleration.x;
+	state->accel_y = -sixaxis.acceleration.z;
+	state->accel_z = sixaxis.acceleration.y;
+
+	// https://d3cw3dd2w32x2b.cloudfront.net/wp-content/uploads/2015/01/matrix-to-quat.pdf
+	float (*dm)[3] = sixaxis.direction.direction;
+	float m[3][3] = {
+		{ dm[0][0], dm[2][0], dm[1][0] },
+		{ dm[0][2], dm[2][2], dm[1][2] },
+		{ dm[0][1], dm[2][1], dm[1][1] }
+	};
+	std::array<float, 4> q;
+	float t;
+	if(m[2][2] < 0)
 	{
-		for(int i = 0; i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+		if (m[0][0] > m[1][1])
 		{
-			if(state->touches[i].id != -1)
-			{
-				state->touches[i].x = 0;
-				state->touches[i].y = 0;
-				state->touches[i].id = -1;
-				state->buttons &= ~CHIAKI_CONTROLLER_BUTTON_TOUCHPAD; // touchscreen release
-				// the state changed
-				ret = true;
-			}
+			t = 1 + m[0][0] - m[1][1] - m[2][2];
+			q = { t, m[0][1] + m[1][0], m[2][0] + m[0][2], m[1][2] - m[2][1] };
+		}
+		else
+		{
+			t = 1 - m[0][0] + m[1][1] -m[2][2];
+			q = { m[0][1] + m[1][0], t, m[1][2] + m[2][1], m[2][0] - m[0][2] };
 		}
-		return ret;
 	}
-
-	touchPosition touch;
-	for(int i = 0; i < touch_count && i < CHIAKI_CONTROLLER_TOUCHES_MAX; i++)
+	else
 	{
-		hidTouchRead(&touch, i);
-
-		// 1280×720 px (16:9)
-		// ps4 controller aspect ratio looks closer to 29:10
-		uint16_t x = touch.px * (DS4_TRACKPAD_MAX_X / SWITCH_TOUCHSCREEN_MAX_X);
-		uint16_t y = touch.py * (DS4_TRACKPAD_MAX_Y / SWITCH_TOUCHSCREEN_MAX_Y);
-
-		// use nintendo switch border's 5% to
-		if(x <= (SWITCH_TOUCHSCREEN_MAX_X * 0.05) || x >= (SWITCH_TOUCHSCREEN_MAX_X * 0.95) || y <= (SWITCH_TOUCHSCREEN_MAX_Y * 0.05) || y >= (SWITCH_TOUCHSCREEN_MAX_Y * 0.95))
+		if(m[0][0] < -m[1][1])
 		{
-			state->buttons |= CHIAKI_CONTROLLER_BUTTON_TOUCHPAD; // touchscreen
-																 // printf("CHIAKI_CONTROLLER_BUTTON_TOUCHPAD\n");
+			t = 1 - m[0][0] - m[1][1] + m[2][2];
+			q = { m[2][0] + m[0][2], m[1][2] + m[2][1], t, m[0][1] - m[1][0] };
 		}
 		else
 		{
-			state->buttons &= ~CHIAKI_CONTROLLER_BUTTON_TOUCHPAD; // touchscreen release
+			t = 1 + m[0][0] + m[1][1] + m[2][2];
+			q = { m[1][2] - m[2][1], m[2][0] - m[0][2], m[0][1] - m[1][0], t };
 		}
-
-		state->touches[i].x = x;
-		state->touches[i].y = y;
-		state->touches[i].id = i;
-		// printf("[point_id=%d] px=%03d, py=%03d, dx=%03d, dy=%03d, angle=%03d\n",
-		// i, touch.px, touch.py, touch.dx, touch.dy, touch.angle);
-		ret = true;
 	}
-	return ret;
+	float fac = 0.5f / sqrt(t);
+	state->orient_x = q[0] * fac;
+	state->orient_y = q[1] * fac;
+	state->orient_z = -q[2] * fac;
+	state->orient_w = q[3] * fac;
+	return true;
 #else
 	return false;
 #endif
@@ -434,8 +531,6 @@ bool IO::ReadGameKeys(SDL_Event *event,
 
 	// TODO
 	// share vs PS button
-	// Gyro ?
-	// rumble ?
 	bool ret = true;
 	switch(event->type)
 	{
@@ -812,7 +907,7 @@ inline void IO::OpenGlDraw()
 	D(glFinish());
 }
 
-bool IO::InitJoystick()
+bool IO::InitController()
 {
 	// https://github.com/switchbrew/switch-examples/blob/master/graphics/sdl2/sdl2-simple/source/main.cpp#L57
 	// open CONTROLLER_PLAYER_1 and CONTROLLER_PLAYER_2
@@ -826,24 +921,64 @@ bool IO::InitJoystick()
 			CHIAKI_LOGE(this->log, "SDL_JoystickOpen: %s\n", SDL_GetError());
 			return false;
 		}
+		// this->sdl_haptic_ptr[i] = SDL_HapticOpenFromJoystick(sdl_joystick_ptr[i]);
+		// SDL_HapticRumbleInit(this->sdl_haptic_ptr[i]);
+		// if(sdl_haptic_ptr[i] == nullptr)
+		// {
+		// 	CHIAKI_LOGE(this->log, "SDL_HapticRumbleInit: %s\n", SDL_GetError());
+		// }
 	}
+#ifdef __SWITCH__
+Result rc = 0;
+	// Configure our supported input layout: a single player with standard controller styles
+	padConfigureInput(1, HidNpadStyleSet_NpadStandard);
+
+	// Initialize the default gamepad (which reads handheld mode inputs as well as the first connected controller)
+	padInitializeDefault(&this->pad);
+	// touchpad
+	hidInitializeTouchScreen();
+	// It's necessary to initialize these separately as they all have different handle values
+	hidGetSixAxisSensorHandles(&this->sixaxis_handles[0], 1, HidNpadIdType_Handheld, HidNpadStyleTag_NpadHandheld);
+	hidGetSixAxisSensorHandles(&this->sixaxis_handles[1], 1, HidNpadIdType_No1, HidNpadStyleTag_NpadFullKey);
+	hidGetSixAxisSensorHandles(&this->sixaxis_handles[2], 2, HidNpadIdType_No1, HidNpadStyleTag_NpadJoyDual);
+	hidStartSixAxisSensor(this->sixaxis_handles[0]);
+	hidStartSixAxisSensor(this->sixaxis_handles[1]);
+	hidStartSixAxisSensor(this->sixaxis_handles[2]);
+	hidStartSixAxisSensor(this->sixaxis_handles[3]);
+
+    rc = hidInitializeVibrationDevices(this->vibration_handles[0], 2, HidNpadIdType_Handheld, HidNpadStyleTag_NpadHandheld);
+	if(R_FAILED(rc))
+		CHIAKI_LOGE(this->log, "hidInitializeVibrationDevices() HidNpadIdType_Handheld returned: 0x%x", rc);
+
+    rc = hidInitializeVibrationDevices(this->vibration_handles[1], 2, HidNpadIdType_No1, HidNpadStyleTag_NpadJoyDual);
+	if(R_FAILED(rc))
+		CHIAKI_LOGE(this->log, "hidInitializeVibrationDevices() HidNpadIdType_No1 returned: 0x%x", rc);
+
+#endif
 	return true;
 }
 
-bool IO::FreeJoystick()
+bool IO::FreeController()
 {
 	for(int i = 0; i < SDL_JOYSTICK_COUNT; i++)
 	{
-		if(SDL_JoystickGetAttached(sdl_joystick_ptr[i]))
-			SDL_JoystickClose(sdl_joystick_ptr[i]);
+		SDL_JoystickClose(this->sdl_joystick_ptr[i]);
+		// SDL_HapticClose(this->sdl_haptic_ptr[i]);
 	}
+#ifdef __SWITCH__
+	hidStopSixAxisSensor(this->sixaxis_handles[0]);
+	hidStopSixAxisSensor(this->sixaxis_handles[1]);
+	hidStopSixAxisSensor(this->sixaxis_handles[2]);
+	hidStopSixAxisSensor(this->sixaxis_handles[3]);
+#endif
 	return true;
 }
 
-bool IO::MainLoop(ChiakiControllerState *state)
+void IO::UpdateControllerState(ChiakiControllerState *state, std::map<uint32_t, int8_t> *finger_id_touch_id)
 {
-	D(glUseProgram(this->prog));
-
+#ifdef __SWITCH__
+	padUpdate(&this->pad);
+#endif
 	// handle SDL events
 	while(SDL_PollEvent(&this->sdl_event))
 	{
@@ -851,11 +986,17 @@ bool IO::MainLoop(ChiakiControllerState
 		switch(this->sdl_event.type)
 		{
 			case SDL_QUIT:
-				return false;
+				this->quit = true;
 		}
 	}
 
-	ReadGameTouchScreen(state);
+	ReadGameTouchScreen(state, finger_id_touch_id);
+	ReadGameSixAxis(state);
+}
+
+bool IO::MainLoop()
+{
+	D(glUseProgram(this->prog));
 
 	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
diff -pruN 2.0.1-1/switch/src/main.cpp 2.1.0-1/switch/src/main.cpp
--- 2.0.1-1/switch/src/main.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/main.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -83,12 +83,6 @@ extern "C" void userAppInit()
 	// load socket custom config
 	socketInitialize(&g_chiakiSocketInitConfig);
 	setsysInitialize();
-
-    // padConfigureInput(1, HidNpadStyleSet_NpadStandard);
-    // PadState pad;
-    // padInitializeDefault(&pad);
-
-    //hidInitializeTouchScreen();
 }
 
 extern "C" void userAppExit()
@@ -111,11 +105,11 @@ extern "C" void userAppExit()
 }
 #endif // __SWITCH__
 
-int main(int argc, char * argv[])
+int main(int argc, char *argv[])
 {
 	// load chiaki lib
-	Settings * settings = Settings::GetInstance();
-	ChiakiLog * log = settings->GetLogger();
+	Settings *settings = Settings::GetInstance();
+	ChiakiLog *log = settings->GetLogger();
 
 	CHIAKI_LOGI(log, "Loading chaki lib");
 
@@ -126,7 +120,7 @@ int main(int argc, char * argv[])
 		return 1;
 	}
 
-	CHIAKI_LOGI(log, "Loading SDL audio / joystick");
+	CHIAKI_LOGI(log, "Loading SDL audio / joystick / haptic");
 	if(SDL_Init(SDL_INIT_AUDIO | SDL_INIT_JOYSTICK))
 	{
 		CHIAKI_LOGE(log, "SDL initialization failed: %s", SDL_GetError());
@@ -135,8 +129,11 @@ int main(int argc, char * argv[])
 
 	// build sdl OpenGl and AV decoders graphical interface
 	DiscoveryManager discoverymanager = DiscoveryManager();
-	MainApplication app = MainApplication(&discoverymanager);
-	app.Load();
+	{
+		// scope to delete MainApplication before SDL_Quit()
+		MainApplication app(&discoverymanager);
+		app.Load();
+	}
 
 	CHIAKI_LOGI(log, "Quit applet");
 	SDL_Quit();
diff -pruN 2.0.1-1/switch/src/settings.cpp 2.1.0-1/switch/src/settings.cpp
--- 2.0.1-1/switch/src/settings.cpp	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/switch/src/settings.cpp	2021-01-15 21:35:50.000000000 +0000
@@ -13,7 +13,7 @@ Settings::Settings()
 #endif
 }
 
-Settings::ConfigurationItem Settings::ParseLine(std::string * line, std::string * value)
+Settings::ConfigurationItem Settings::ParseLine(std::string *line, std::string *value)
 {
 	Settings::ConfigurationItem ci;
 	std::smatch m;
@@ -35,9 +35,9 @@ size_t Settings::GetB64encodeSize(size_t
 	return ((4 * in / 3) + 3) & ~3;
 }
 
-Settings * Settings::instance = nullptr;
+Settings *Settings::instance = nullptr;
 
-Settings * Settings::GetInstance()
+Settings *Settings::GetInstance()
 {
 	if(instance == nullptr)
 	{
@@ -47,17 +47,17 @@ Settings * Settings::GetInstance()
 	return instance;
 }
 
-ChiakiLog * Settings::GetLogger()
+ChiakiLog *Settings::GetLogger()
 {
 	return &this->log;
 }
 
-std::map<std::string, Host> * Settings::GetHostsMap()
+std::map<std::string, Host> *Settings::GetHostsMap()
 {
 	return &this->hosts;
 }
 
-Host * Settings::GetOrCreateHost(std::string * host_name)
+Host *Settings::GetOrCreateHost(std::string *host_name)
 {
 	bool created = false;
 	// update of create Host instance
@@ -69,7 +69,7 @@ Host * Settings::GetOrCreateHost(std::st
 		created = true;
 	}
 
-	Host * host = &(this->hosts.at(*host_name));
+	Host *host = &(this->hosts.at(*host_name));
 	if(created)
 	{
 		// copy default settings
@@ -90,7 +90,7 @@ void Settings::ParseFile()
 	std::string line;
 	std::string value;
 	bool rp_key_b = false, rp_regist_key_b = false, rp_key_type_b = false;
-	Host * current_host = nullptr;
+	Host *current_host = nullptr;
 	if(config_file.is_open())
 	{
 		CHIAKI_LOGV(&this->log, "Config file opened");
@@ -102,63 +102,63 @@ void Settings::ParseFile()
 			ci = this->ParseLine(&line, &value);
 			switch(ci)
 			{
-			// got to next line
-			case UNKNOWN:
-				CHIAKI_LOGV(&this->log, "UNKNOWN config");
-				break;
-			case HOST_NAME:
-				CHIAKI_LOGV(&this->log, "HOST_NAME %s", value.c_str());
-				// current host is in context
-				current_host = this->GetOrCreateHost(&value);
-				// all following case will edit the current_host config
-
-				rp_key_b = false;
-				rp_regist_key_b = false;
-				rp_key_type_b = false;
-				break;
-			case HOST_ADDR:
-				CHIAKI_LOGV(&this->log, "HOST_ADDR %s", value.c_str());
-				if(current_host != nullptr)
-					current_host->host_addr = value;
-				break;
-			case PSN_ONLINE_ID:
-				CHIAKI_LOGV(&this->log, "PSN_ONLINE_ID %s", value.c_str());
-				// current_host == nullptr
-				// means we are in global ini section
-				// update default setting
-				this->SetPSNOnlineID(current_host, value);
-				break;
-			case PSN_ACCOUNT_ID:
-				CHIAKI_LOGV(&this->log, "PSN_ACCOUNT_ID %s", value.c_str());
-				this->SetPSNAccountID(current_host, value);
-				break;
-			case RP_KEY:
-				CHIAKI_LOGV(&this->log, "RP_KEY %s", value.c_str());
-				if(current_host != nullptr)
-					rp_key_b = this->SetHostRPKey(current_host, value);
-				break;
-			case RP_KEY_TYPE:
-				CHIAKI_LOGV(&this->log, "RP_KEY_TYPE %s", value.c_str());
-				if(current_host != nullptr)
-					// TODO Check possible rp_type values
-					rp_key_type_b = this->SetHostRPKeyType(current_host, value);
-				break;
-			case RP_REGIST_KEY:
-				CHIAKI_LOGV(&this->log, "RP_REGIST_KEY %s", value.c_str());
-				if(current_host != nullptr)
-					rp_regist_key_b = this->SetHostRPRegistKey(current_host, value);
-				break;
-			case VIDEO_RESOLUTION:
-				this->SetVideoResolution(current_host, value);
-				break;
-			case VIDEO_FPS:
-				this->SetVideoFPS(current_host, value);
-				break;
-			case TARGET:
-				CHIAKI_LOGV(&this->log, "TARGET %s", value.c_str());
-				if(current_host != nullptr)
-					this->SetChiakiTarget(current_host, value);
-				break;
+				// got to next line
+				case UNKNOWN:
+					CHIAKI_LOGV(&this->log, "UNKNOWN config");
+					break;
+				case HOST_NAME:
+					CHIAKI_LOGV(&this->log, "HOST_NAME %s", value.c_str());
+					// current host is in context
+					current_host = this->GetOrCreateHost(&value);
+					// all following case will edit the current_host config
+
+					rp_key_b = false;
+					rp_regist_key_b = false;
+					rp_key_type_b = false;
+					break;
+				case HOST_ADDR:
+					CHIAKI_LOGV(&this->log, "HOST_ADDR %s", value.c_str());
+					if(current_host != nullptr)
+						current_host->host_addr = value;
+					break;
+				case PSN_ONLINE_ID:
+					CHIAKI_LOGV(&this->log, "PSN_ONLINE_ID %s", value.c_str());
+					// current_host == nullptr
+					// means we are in global ini section
+					// update default setting
+					this->SetPSNOnlineID(current_host, value);
+					break;
+				case PSN_ACCOUNT_ID:
+					CHIAKI_LOGV(&this->log, "PSN_ACCOUNT_ID %s", value.c_str());
+					this->SetPSNAccountID(current_host, value);
+					break;
+				case RP_KEY:
+					CHIAKI_LOGV(&this->log, "RP_KEY %s", value.c_str());
+					if(current_host != nullptr)
+						rp_key_b = this->SetHostRPKey(current_host, value);
+					break;
+				case RP_KEY_TYPE:
+					CHIAKI_LOGV(&this->log, "RP_KEY_TYPE %s", value.c_str());
+					if(current_host != nullptr)
+						// TODO Check possible rp_type values
+						rp_key_type_b = this->SetHostRPKeyType(current_host, value);
+					break;
+				case RP_REGIST_KEY:
+					CHIAKI_LOGV(&this->log, "RP_REGIST_KEY %s", value.c_str());
+					if(current_host != nullptr)
+						rp_regist_key_b = this->SetHostRPRegistKey(current_host, value);
+					break;
+				case VIDEO_RESOLUTION:
+					this->SetVideoResolution(current_host, value);
+					break;
+				case VIDEO_FPS:
+					this->SetVideoFPS(current_host, value);
+					break;
+				case TARGET:
+					CHIAKI_LOGV(&this->log, "TARGET %s", value.c_str());
+					if(current_host != nullptr)
+						this->SetChiakiTarget(current_host, value);
+					break;
 			} // ci switch
 			if(rp_key_b && rp_regist_key_b && rp_key_type_b)
 				// the current host contains rp key data
@@ -210,9 +210,8 @@ int Settings::WriteFile()
 
 			config_file << "[" << it->first << "]\n"
 						<< "host_addr = \"" << it->second.GetHostAddr() << "\"\n"
-						<< "target = " << it->second.GetChiakiTarget() << "\"\n";
+						<< "target = \"" << it->second.GetChiakiTarget() << "\"\n";
 
-			config_file << "target = \"" << it->second.psn_account_id << "\"\n";
 			if(it->second.video_resolution)
 				config_file << "video_resolution = \""
 							<< this->ResolutionPresetToString(this->GetVideoResolution(&it->second))
@@ -231,7 +230,7 @@ int Settings::WriteFile()
 
 			if(it->second.rp_key_data || it->second.registered)
 			{
-				char rp_key_type[33] = {0};
+				char rp_key_type[33] = { 0 };
 				snprintf(rp_key_type, sizeof(rp_key_type), "%d", it->second.rp_key_type);
 				// save registered rp key for auto login
 				config_file << "rp_key = \"" << this->GetHostRPKey(&it->second) << "\"\n"
@@ -250,14 +249,14 @@ std::string Settings::ResolutionPresetTo
 {
 	switch(resolution)
 	{
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_360p:
-		return "360p";
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_540p:
-		return "540p";
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_720p:
-		return "720p";
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_1080p:
-		return "1080p";
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_360p:
+			return "360p";
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_540p:
+			return "540p";
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_720p:
+			return "720p";
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_1080p:
+			return "1080p";
 	}
 	return "UNKNOWN";
 }
@@ -266,14 +265,14 @@ int Settings::ResolutionPresetToInt(Chia
 {
 	switch(resolution)
 	{
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_360p:
-		return 360;
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_540p:
-		return 540;
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_720p:
-		return 720;
-	case CHIAKI_VIDEO_RESOLUTION_PRESET_1080p:
-		return 1080;
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_360p:
+			return 360;
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_540p:
+			return 540;
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_720p:
+			return 720;
+		case CHIAKI_VIDEO_RESOLUTION_PRESET_1080p:
+			return 1080;
 	}
 	return 0;
 }
@@ -300,10 +299,10 @@ std::string Settings::FPSPresetToString(
 {
 	switch(fps)
 	{
-	case CHIAKI_VIDEO_FPS_PRESET_30:
-		return "30";
-	case CHIAKI_VIDEO_FPS_PRESET_60:
-		return "60";
+		case CHIAKI_VIDEO_FPS_PRESET_30:
+			return "30";
+		case CHIAKI_VIDEO_FPS_PRESET_60:
+			return "60";
 	}
 	return "UNKNOWN";
 }
@@ -312,10 +311,10 @@ int Settings::FPSPresetToInt(ChiakiVideo
 {
 	switch(fps)
 	{
-	case CHIAKI_VIDEO_FPS_PRESET_30:
-		return 30;
-	case CHIAKI_VIDEO_FPS_PRESET_60:
-		return 60;
+		case CHIAKI_VIDEO_FPS_PRESET_30:
+			return 30;
+		case CHIAKI_VIDEO_FPS_PRESET_60:
+			return 60;
 	}
 	return 0;
 }
@@ -334,7 +333,7 @@ ChiakiVideoFPSPreset Settings::StringToF
 	return CHIAKI_VIDEO_FPS_PRESET_30;
 }
 
-std::string Settings::GetHostName(Host * host)
+std::string Settings::GetHostName(Host *host)
 {
 	if(host != nullptr)
 		return host->GetHostName();
@@ -343,7 +342,7 @@ std::string Settings::GetHostName(Host *
 	return "";
 }
 
-std::string Settings::GetHostAddr(Host * host)
+std::string Settings::GetHostAddr(Host *host)
 {
 	if(host != nullptr)
 		return host->GetHostAddr();
@@ -352,7 +351,7 @@ std::string Settings::GetHostAddr(Host *
 	return "";
 }
 
-std::string Settings::GetPSNOnlineID(Host * host)
+std::string Settings::GetPSNOnlineID(Host *host)
 {
 	if(host == nullptr || host->psn_online_id.length() == 0)
 		return this->global_psn_online_id;
@@ -360,7 +359,7 @@ std::string Settings::GetPSNOnlineID(Hos
 		return host->psn_online_id;
 }
 
-void Settings::SetPSNOnlineID(Host * host, std::string psn_online_id)
+void Settings::SetPSNOnlineID(Host *host, std::string psn_online_id)
 {
 	if(host == nullptr)
 		this->global_psn_online_id = psn_online_id;
@@ -368,7 +367,7 @@ void Settings::SetPSNOnlineID(Host * hos
 		host->psn_online_id = psn_online_id;
 }
 
-std::string Settings::GetPSNAccountID(Host * host)
+std::string Settings::GetPSNAccountID(Host *host)
 {
 	if(host == nullptr || host->psn_account_id.length() == 0)
 		return this->global_psn_account_id;
@@ -376,7 +375,7 @@ std::string Settings::GetPSNAccountID(Ho
 		return host->psn_account_id;
 }
 
-void Settings::SetPSNAccountID(Host * host, std::string psn_account_id)
+void Settings::SetPSNAccountID(Host *host, std::string psn_account_id)
 {
 	if(host == nullptr)
 		this->global_psn_account_id = psn_account_id;
@@ -384,7 +383,7 @@ void Settings::SetPSNAccountID(Host * ho
 		host->psn_account_id = psn_account_id;
 }
 
-ChiakiVideoResolutionPreset Settings::GetVideoResolution(Host * host)
+ChiakiVideoResolutionPreset Settings::GetVideoResolution(Host *host)
 {
 	if(host == nullptr)
 		return this->global_video_resolution;
@@ -392,7 +391,7 @@ ChiakiVideoResolutionPreset Settings::Ge
 		return host->video_resolution;
 }
 
-void Settings::SetVideoResolution(Host * host, ChiakiVideoResolutionPreset value)
+void Settings::SetVideoResolution(Host *host, ChiakiVideoResolutionPreset value)
 {
 	if(host == nullptr)
 		this->global_video_resolution = value;
@@ -400,13 +399,13 @@ void Settings::SetVideoResolution(Host *
 		host->video_resolution = value;
 }
 
-void Settings::SetVideoResolution(Host * host, std::string value)
+void Settings::SetVideoResolution(Host *host, std::string value)
 {
 	ChiakiVideoResolutionPreset p = StringToResolutionPreset(value);
 	this->SetVideoResolution(host, p);
 }
 
-ChiakiVideoFPSPreset Settings::GetVideoFPS(Host * host)
+ChiakiVideoFPSPreset Settings::GetVideoFPS(Host *host)
 {
 	if(host == nullptr)
 		return this->global_video_fps;
@@ -414,7 +413,7 @@ ChiakiVideoFPSPreset Settings::GetVideoF
 		return host->video_fps;
 }
 
-void Settings::SetVideoFPS(Host * host, ChiakiVideoFPSPreset value)
+void Settings::SetVideoFPS(Host *host, ChiakiVideoFPSPreset value)
 {
 	if(host == nullptr)
 		this->global_video_fps = value;
@@ -422,18 +421,18 @@ void Settings::SetVideoFPS(Host * host,
 		host->video_fps = value;
 }
 
-void Settings::SetVideoFPS(Host * host, std::string value)
+void Settings::SetVideoFPS(Host *host, std::string value)
 {
 	ChiakiVideoFPSPreset p = StringToFPSPreset(value);
 	this->SetVideoFPS(host, p);
 }
 
-ChiakiTarget Settings::GetChiakiTarget(Host * host)
+ChiakiTarget Settings::GetChiakiTarget(Host *host)
 {
 	return host->GetChiakiTarget();
 }
 
-bool Settings::SetChiakiTarget(Host * host, ChiakiTarget target)
+bool Settings::SetChiakiTarget(Host *host, ChiakiTarget target)
 {
 	if(host != nullptr)
 	{
@@ -447,20 +446,20 @@ bool Settings::SetChiakiTarget(Host * ho
 	}
 }
 
-bool Settings::SetChiakiTarget(Host * host, std::string value)
+bool Settings::SetChiakiTarget(Host *host, std::string value)
 {
 	// TODO Check possible target values
 	return this->SetChiakiTarget(host, static_cast<ChiakiTarget>(std::atoi(value.c_str())));
 }
 
-std::string Settings::GetHostRPKey(Host * host)
+std::string Settings::GetHostRPKey(Host *host)
 {
 	if(host != nullptr)
 	{
 		if(host->rp_key_data || host->registered)
 		{
 			size_t rp_key_b64_sz = this->GetB64encodeSize(0x10);
-			char rp_key_b64[rp_key_b64_sz + 1] = {0};
+			char rp_key_b64[rp_key_b64_sz + 1] = { 0 };
 			ChiakiErrorCode err;
 			err = chiaki_base64_encode(
 				host->rp_key, 0x10,
@@ -478,7 +477,7 @@ std::string Settings::GetHostRPKey(Host
 	return "";
 }
 
-bool Settings::SetHostRPKey(Host * host, std::string rp_key_b64)
+bool Settings::SetHostRPKey(Host *host, std::string rp_key_b64)
 {
 	if(host != nullptr)
 	{
@@ -497,14 +496,14 @@ bool Settings::SetHostRPKey(Host * host,
 	return false;
 }
 
-std::string Settings::GetHostRPRegistKey(Host * host)
+std::string Settings::GetHostRPRegistKey(Host *host)
 {
 	if(host != nullptr)
 	{
 		if(host->rp_key_data || host->registered)
 		{
 			size_t rp_regist_key_b64_sz = this->GetB64encodeSize(CHIAKI_SESSION_AUTH_SIZE);
-			char rp_regist_key_b64[rp_regist_key_b64_sz + 1] = {0};
+			char rp_regist_key_b64[rp_regist_key_b64_sz + 1] = { 0 };
 			ChiakiErrorCode err;
 			err = chiaki_base64_encode(
 				(uint8_t *)host->rp_regist_key, CHIAKI_SESSION_AUTH_SIZE,
@@ -522,7 +521,7 @@ std::string Settings::GetHostRPRegistKey
 	return "";
 }
 
-bool Settings::SetHostRPRegistKey(Host * host, std::string rp_regist_key_b64)
+bool Settings::SetHostRPRegistKey(Host *host, std::string rp_regist_key_b64)
 {
 	if(host != nullptr)
 	{
@@ -541,7 +540,7 @@ bool Settings::SetHostRPRegistKey(Host *
 	return false;
 }
 
-int Settings::GetHostRPKeyType(Host * host)
+int Settings::GetHostRPKeyType(Host *host)
 {
 	if(host != nullptr)
 		return host->rp_key_type;
@@ -550,7 +549,7 @@ int Settings::GetHostRPKeyType(Host * ho
 	return 0;
 }
 
-bool Settings::SetHostRPKeyType(Host * host, std::string value)
+bool Settings::SetHostRPKeyType(Host *host, std::string value)
 {
 	if(host != nullptr)
 	{
@@ -562,7 +561,7 @@ bool Settings::SetHostRPKeyType(Host * h
 }
 
 #ifdef CHIAKI_ENABLE_SWITCH_OVERCLOCK
-int Settings::GetCPUOverclock(Host * host)
+int Settings::GetCPUOverclock(Host *host)
 {
 	if(host == nullptr)
 		return this->global_cpu_overclock;
@@ -570,7 +569,7 @@ int Settings::GetCPUOverclock(Host * hos
 		return host->cpu_overclock;
 }
 
-void Settings::SetCPUOverclock(Host * host, int value)
+void Settings::SetCPUOverclock(Host *host, int value)
 {
 	int oc = OC_1326;
 	if(value > OC_1580)
@@ -592,11 +591,9 @@ void Settings::SetCPUOverclock(Host * ho
 		host->cpu_overclock = oc;
 }
 
-void Settings::SetCPUOverclock(Host * host, std::string value)
+void Settings::SetCPUOverclock(Host *host, std::string value)
 {
 	int v = atoi(value.c_str());
 	this->SetCPUOverclock(host, v);
 }
 #endif
-
-
diff -pruN 2.0.1-1/test/reorderqueue.c 2.1.0-1/test/reorderqueue.c
--- 2.0.1-1/test/reorderqueue.c	2020-12-29 19:12:12.000000000 +0000
+++ 2.1.0-1/test/reorderqueue.c	2021-01-15 21:35:50.000000000 +0000
@@ -16,7 +16,7 @@ typedef struct drop_record_t
 static void drop(uint64_t seq_num, void *elem_user, void *cb_user)
 {
 	DropRecord *record = cb_user;
-	uint64_t v = (uint64_t)elem_user;
+	uint64_t v = (uint64_t)(size_t)elem_user;
 	if(v > DROP_RECORD_MAX)
 	{
 		record->failed = true;
@@ -58,7 +58,7 @@ static MunitResult test_reorder_queue_16
 	munit_assert_uint64(chiaki_reorder_queue_count(&queue), ==, 0);
 	munit_assert(!drop_record.failed);
 	munit_assert_uint64(drop_record.count[0], ==, 0);
-	munit_assert_uint64((uint64_t)user, ==, 0);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 0);
 	munit_assert_uint64(seq_num, ==, 42);
 
 	// push outdated
@@ -105,22 +105,22 @@ static MunitResult test_reorder_queue_16
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 44);
-	munit_assert_uint64((uint64_t)user, ==, 3);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 3);
 
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 45);
-	munit_assert_uint64((uint64_t)user, ==, 2);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 2);
 
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 46);
-	munit_assert_uint64((uint64_t)user, ==, 1);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 1);
 
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 47);
-	munit_assert_uint64((uint64_t)user, ==, 5);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 5);
 
 	// should be empty now again
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
@@ -142,7 +142,7 @@ static MunitResult test_reorder_queue_16
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 1337);
-	munit_assert_uint64((uint64_t)user, ==, 6);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 6);
 	munit_assert_uint64(chiaki_reorder_queue_count(&queue), ==, 0);
 
 	// same as before, but with an element in the queue that will be dropped
@@ -163,7 +163,7 @@ static MunitResult test_reorder_queue_16
 	pulled = chiaki_reorder_queue_pull(&queue, &seq_num, &user);
 	munit_assert(pulled);
 	munit_assert_uint64(seq_num, ==, 2000);
-	munit_assert_uint64((uint64_t)user, ==, 8);
+	munit_assert_uint64((uint64_t)(size_t)user, ==, 8);
 	munit_assert_uint64(chiaki_reorder_queue_count(&queue), ==, 0);
 
 	chiaki_reorder_queue_fini(&queue);
@@ -182,4 +182,4 @@ MunitTest tests_reorder_queue[] = {
 		NULL
 	},
 	{ NULL, NULL, NULL, NULL, MUNIT_TEST_OPTION_NONE, NULL }
-};
\ No newline at end of file
+};
